SystemOrganization addCategory: #'Cog-Bootstrapping'!
SystemOrganization addCategory: #'Cog-Morphing Bytecode Set'!
SystemOrganization addCategory: #'Cog-ProcessorPlugins'!
SystemOrganization addCategory: #'Cog-Processors'!
SystemOrganization addCategory: #'Cog-Processors-Tests'!
SystemOrganization addCategory: #'Cog-Scripting'!
SystemOrganization addCategory: #'Cog-Scripts'!
SystemOrganization addCategory: #'Cog-Tests'!

!BlockClosure methodsFor: '*Cog-method prototypes' stamp: 'EstebanLorenzano 8/27/2014 13:00'!
BlockClosurePHAROPROTOTYPEsimulateValueWithArguments: anArray caller: aContext
	"Simulate the valueWithArguments: primitive. Fail if anArray is not an array of the right arity."
	| newContext sz |
	newContext := (Context newForMethod: outerContext method)
						setSender: aContext
						receiver: outerContext receiver
						method: outerContext method
						closure: self
						startpc: startpc.
	((newContext objectClass: anArray) ~~ Array
	 or: [numArgs ~= anArray size]) ifTrue:
		[^Context primitiveFailTokenFor: nil].
	sz := self basicSize.
	newContext stackp: sz + numArgs.
	1 to: numArgs do:
		[:i| newContext at: i put: (anArray at: i)].
	1 to: sz do:
		[:i| newContext at: i + numArgs put: (self at: i)].
	^newContext! !

!BlockClosure methodsFor: '*Cog-method prototypes' stamp: 'eem 8/11/2014 13:41'!
BlockClosurePROTOTYPEsimulateValueWithArguments: anArray caller: aContext
	"Simulate the valueWithArguments: primitive. Fail if anArray is not an array of the right arity."
	| newContext sz |
	newContext := (MethodContext newForMethod: outerContext method)
						setSender: aContext
						receiver: outerContext receiver
						method: outerContext method
						closure: self
						startpc: startpc.
	((newContext objectClass: anArray) ~~ Array
	 or: [numArgs ~= anArray size]) ifTrue:
		[^ContextPart primitiveFailTokenFor: nil].
	sz := self basicSize.
	newContext stackp: sz + numArgs.
	1 to: numArgs do:
		[:i| newContext at: i put: (anArray at: i)].
	1 to: sz do:
		[:i| newContext at: i + numArgs put: (self at: i)].
	^newContext! !

TestCase subclass: #BochsIA32AlienTests
	instanceVariableNames: 'processor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Processors-Tests'!

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 5/7/2010 10:43'!
callTrapPerformance: n
	"Call a function that is out-of-range.  Ensure the call is trapped."
	"self new testCallTrap"
	| memory |
	 "The address is out of range of memory every which way (whether relative or absolute and whether big-endian or little."
	memory := ByteArray new: 1024.
	memory replaceFrom: 1 to: 5 with: { self processor callOpcode. 0. 16r80. 16r80. 0. } asByteArray.
	self processor
			eip: 0;
			esp: (memory size - 4). "Room for return address"
	1 to: n do:
		[:ign|
		[self processor singleStepIn: memory]
			on: ProcessorSimulationTrap
			do: [:ex|]].

	"QSystemProfiler spyOn: [BochsIA32AlienTests new callTrapPerformance: 1024*128]"
	"Time millisecondsToRun: [BochsIA32AlienTests new callTrapPerformance: 1024*128] 2463"
	"Time millisecondsToRun: [1 to: 1024*1024*64 do: [:ign| nil yourself]] 636"
	"Time millisecondsToRun: [1 to: 1024*1024*64 do: [:ign| nil perform: #ifNotNilDo: with: nil]] 3639"
	"Time millisecondsToRun: [1 to: 1024*1024*64 do: [:ign| nil perform: #ifNotNilDo:ifNil: with: nil with: nil]] 12401"! !

!BochsIA32AlienTests methodsFor: 'accessing' stamp: 'eem 3/18/2014 10:44'!
integerRegisterGetters
	^#(eax ecx edx ebx esp ebp esi edi eip)! !

!BochsIA32AlienTests methodsFor: 'accessing' stamp: 'eem 3/18/2014 10:45'!
integerRegisterSetters
	^#(eax: ecx: edx: ebx: esp: ebp: esi: edi: eip:)! !

!BochsIA32AlienTests methodsFor: 'accessing' stamp: 'eem 12/12/2008 16:23'!
nfib
	"long fib(long n) { return n <= 1 ? 1 : fib(n-1) + fib(n-2) + 1; }
	 as compiled by Microsoft Visual C++ V6 (12.00.8804) cl /O2 /Fc"
	"| bat nfib ip |
	bat := BochsIA32AlienTests new.
	nfib := bat nfib asByteArray.
	ip := 0.
	20 timesRepeat:
		[bat processor disassembleInstructionAt: ip In: nfib into:
			[:da :len|
			Transcript nextPutAll: da; cr; flush.
			ip := ip + len]]"
	^#("00000" 16r56							"push    esi"
		"00001" 16r8B 16r74 16r24 16r08		"mov     esi, DWORD PTR _n$[esp]"
		"00005" 16r83 16rFE 16r01				"cmp     esi, 1"
		"00008" 16r7F 16r07						"jg      SHORT $L528"
		"0000a" 16rB8 16r01 16r00 16r00 16r00	"mov     eax, 1"
		"0000f" 16r5E							"pop     esi"
		"00010" 16rC3							"ret     0"
"
$L528:"
		"00011" 16r8D 16r46 16rFE				"lea     eax, DWORD PTR [esi-2]"
		"00014" 16r57							"push    edi"
		"00015" 16r50							"push    eax"
		"00016" 16rE8 16rE5 16rFF 16rFF 16rFF   "call    _fib"
		"0001b" 16r4E							"dec     esi"
		"0001c" 16r8B 16rF8						"mov     edi, eax"
		"0001e" 16r56							"push    esi"
		"0001f" 16rE8 16rDC 16rFF 16rFF 16rFF   "call    _fib"
		"00024" 16r83 16rC4 16r08				"add     esp, 8"
		"00027" 16r8D 16r44 16r07 16r01		"lea     eax, DWORD PTR [edi+eax+1]"
		"0002b" 16r5F							"pop     edi"
		"0002c" 16r5E							"pop     esi"
		"0002d" 16rC3							"ret     0")! !

!BochsIA32AlienTests methodsFor: 'accessing' stamp: 'eem 12/11/2008 13:53'!
processor
	processor ifNil:
		[processor := BochsIA32Alien new].
	^processor! !

!BochsIA32AlienTests methodsFor: 'execution' stamp: 'eem 10/21/2010 11:02'!
runNFib: n disassemble: disassemble printRegisters: printRegisters
	"Run nfib wth the argument. Answer the result."
	"self new runNFib: 5 disassemble: true printRegisters: true"
	| memory |
	memory := ByteArray new: 4096 * 2 withAll: self processor nopOpcode.
	memory
		replaceFrom: 1 to: self nfib size with: self nfib asByteArray startingAt: 1;
		longAt: memory size - 3 put: n bigEndian: false; "argument n"
		longAt: memory size - 7 put: self nfib size bigEndian: false.  "return address"
	self processor
		eip: 0;
		esp: (memory size - 8). "Room for return address and argument n"
	printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	"run until something goes wrong."
	self processor runInMemory: memory readExecuteOnlyBelow: memory size / 2.
	printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	^self processor eax! !

!BochsIA32AlienTests methodsFor: 'execution' stamp: 'eem 10/21/2010 11:06'!
singleStepNFib: n disassemble: disassemble printRegisters: printRegisters
	"Run nfib wth the argument. Answer the result."
	"self new runNFib: 5 disassemble: true printRegisters: true"
	| memory finalSP |
	memory := ByteArray new: 4096 * 2 withAll: self processor nopOpcode.
	finalSP := memory size - 4. "Stop when we return to the nop following nfib"
	memory
		replaceFrom: 1 to: self nfib size with: self nfib asByteArray startingAt: 1;
		longAt: memory size - 3 put: n bigEndian: false; "argument n"
		longAt: memory size - 7 put: self nfib size bigEndian: false.  "return address"
	self processor
			eip: 0;
			esp: (memory size - 8). "Room for return address and argument n"
	printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	[disassemble ifTrue:
		[Transcript nextPutAll: (self processor disassembleNextInstructionIn: memory); cr; flush].
	 self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	 printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	 self processor esp ~= finalSP] whileTrue.
	^self processor eax! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 4/15/2009 17:13'!
testCPUHasSSE2
	"Use the CPUID instruction to check if SSE2 is supported.  Cog
	 uses SSE2 instructions for machine-code floating-point primitives."
	self processor eax: 0. "get vendor identfication string"
	self processor eip: 0; singleStepIn: (ByteArray with: 16r0F with: 16rA2 with: 16r90) "cpuid;nop".
	self assert: self processor eip = 2.
	self assert: self processor eax >= 1.
	self processor eax: 1.
	self processor eip: 0; singleStepIn: (ByteArray with: 16r0F with: 16rA2 with: 16r90) "cpuid;nop".
	self assert: self processor eip = 2.
	self assert: (self processor edx bitAnd: 1 << 26) ~= 0

	"self new testCPUHasSSE2"! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 12/11/2008 18:09'!
testCPUID
	| vendorString |
	self processor
			eip: 0;
			eax: 0. "get vendor identfication string"
	self processor singleStepIn: (ByteArray with: 16r0F with: 16rA2 with: 16r90) "cpuid;nop".
	self assert: self processor eip = 2.
	self assert: self processor eax ~= 0.
	vendorString := (ByteArray new: 12)
						longAt: 1 put: self processor ebx bigEndian: false;
						longAt: 5 put: self processor edx bigEndian: false;
						longAt: 9 put: self processor ecx bigEndian: false;
						asString.
	self assert: (vendorString = 'GenuineIntel'
				or: [vendorString = 'AuthenticAMD'])! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 5/7/2010 11:05'!
testCallTrap
	"Call a function that is out-of-range.  Ensure the call is trapped."
	"self new testCallTrap"
	| memory |
	 "The address is out of range of memory every which way (whether relative or absolute and whether big-endian or little."
	memory := ByteArray new: 1024.
	memory replaceFrom: 1 to: 5 with: { self processor callOpcode. 0. 16r80. 16r80. 0. } asByteArray.
	self processor
			eip: 0;
			esp: (memory size - 4). "Room for return address"
	self should: [self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: pst address = ((memory longAt: 2 bigEndian: false) + 5 "length of call instr").
			self assert: pst pc = 0.
			self assert: pst type = #call].

	"| memory |
	memory := ByteArray new: 1024.
	memory replaceFrom: 1 to: 5 with: { BochsIA32Alien new callOpcode. 0. 16r80. 16r80. 0. } asByteArray.
	BochsIA32AlienTests new processor
		eip: 0;
		esp: (memory size - 4);
		singleStepIn: memory;
		printRegistersOn: Transcript.
	Transcript flush"! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 10/20/2010 15:58'!
testExecutionTrap
	"Execute a run of nops.  test executing beyond the executable limit is trapped."
	"self new testExecutionTrap"
	| memory |
	 "The address is out of range of memory every which way (whether relative or absolute and whether big-endian or little."
	memory := ByteArray new: 4096 * 2 withAll: self processor nopOpcode.
	self processor
			eip: 0;
			esp: (memory size - 4). "Room for return address"
	self should: [self processor runInMemory: memory minimumAddress: 0 readOnlyBelow: memory size / 2]
		raise: Error
		withExceptionDo:
			[:err|
			self assert: self processor pc = (memory size / 2).
			self assert: ('*EIP*> CS.limit*' match: err messageText)].
	self processor eip: 0.
	self should: [[self processor singleStepIn: memory minimumAddress: 0 readOnlyBelow: memory size / 2] repeat]
		raise: Error
		withExceptionDo:
			[:err|
			self assert: self processor pc = (memory size / 2).
			self assert: ('*EIP*> CS.limit*' match: err messageText)]! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 4/16/2009 17:57'!
testMOVSD
	"Test MOVSD indirecting through edx."
	"self new testMOVSD"
	self processor
		edx: 0;
		eip: 0;
		singleStepIn: {16rF2. 16r0F. 16r10. 16r42. 16r04. 16r90. 16r01. 16r02. 16r03. 16r04. 16r05. 16r06} asByteArray "movsd %ds:0x4(%edx), %xmm0;nop;garbage".
	self assert: self processor eip = 5.
	self assert: self processor xmm0low = 16r0605040302019004! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 1/14/2009 15:50'!
testNfib1
	"self new testNfib1"
	self should: [self runNFib: 1 disassemble: false printRegisters: false]
		raise: Error.
	self deny: (self processor eip between: 1 and: self nfib size).
	self assert: self processor eax = 1 benchFib! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 1/14/2009 15:51'!
testNfib16
	"self new testNfib16"
	self should: [self runNFib: 16 disassemble: false printRegisters: false]
		raise: Error.
	self deny: (self processor eip between: 1 and: self nfib size).
	self assert: self processor eax = 16 benchFib! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 1/14/2009 15:50'!
testNfib2
	"self new testNfib2"
	self should: [self runNFib: 2 disassemble: false printRegisters: false]
		raise: Error.
	self deny: (self processor eip between: 1 and: self nfib size).
	self assert: self processor eax = 2 benchFib! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 1/14/2009 15:49'!
testNfib4
	"self new testNfib4"
	self should: [self runNFib: 4 disassemble: false printRegisters: false]
		raise: Error.
	self deny: (self processor eip between: 1 and: self nfib size).
	self assert: self processor eax = 4 benchFib! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 3/18/2014 10:44'!
testResetCPU
	"self new testResetCPU"
	self integerRegisterSetters do:
		[:setter|
		self processor perform: setter with: 16r55555555].
	self integerRegisterGetters do:
		[:getter|
		self assert: 16r55555555 = (self processor perform: getter)].
	self processor reset.
	self integerRegisterGetters do:
		[:getter|
		self assert: 0 = (self processor perform: getter)]! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 1/14/2009 15:10'!
testStepNfib1
	"self new testNfib1"
	self singleStepNFib: 1 disassemble: false printRegisters: false.
	self assert: self processor eip = self nfib size.
	self assert: self processor eax = 1 benchFib! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 1/14/2009 15:10'!
testStepNfib2
	"self new testNfib2"
	self singleStepNFib: 2 disassemble: false printRegisters: false.
	self assert: self processor eip = self nfib size.
	self assert: self processor eax = 2 benchFib! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 1/14/2009 15:11'!
testStepNfib4
	"self new testNfib4"
	self singleStepNFib: 4 disassemble: false printRegisters: false.
	self assert: self processor eip = self nfib size.
	self assert: self processor eax = 4 benchFib! !

TestCase subclass: #CogVMTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Tests'!

!CogVMTests methodsFor: 'support' stamp: 'eem 6/17/2009 23:18'!
recurse
	self recurse! !

!CogVMTests methodsFor: 'support' stamp: 'eem 6/17/2009 08:45'!
runningOnCogit
	"CogVMTests new runningOnCogit"
	^(1 to: 3) anySatisfy: [:each| thisContext xrayIsExecutingMachineCode]! !

!CogVMTests methodsFor: 'tests' stamp: 'eem 9/14/2009 06:18'!
testMultiplicativeOperators
	"CogVMTests new setUp testMultiplicativeOperators"
	self runningOnCogit ifTrue:
		[thisContext xrayIsExecutingMachineCode ifFalse:
			[^self testMultiplicativeOperators]].
	1 to: 3 do: "Running 3 times should ensure all operators are compiled to machine code"
		[:ignored| | values |
		self assert: (1 / 2 literalEqual: (Fraction numerator: 1 denominator: 2)).
		self assert: 1 // 2 == 0.
		self assert: (1 quo: 2) == 0.
		self assert: 3 * 4 == 12.

		self assert: 65536 / 2 == 32768.
		self assert: 65536 // 2 == 32768.
		self assert: (65536 quo: 2) == 32768.
		self assert: 65536 * 2 == 131072.
		#(1 2 4 8 16 32 64 128 256 512 1024 2048 4096 8192 16384 32768 65536
		   131072 262144 524288 1048576 2097152 4194304 8388608 16777216 33554432
		   67108864 134217728 268435456 536870912 1073741824 2147483648 4294967296) withIndexDo:
			[:value :index| | power | "test that integer overflow is detected in multiplication"
			power := index - 1.
			self assert: value * value = (2 raisedTo: power + power)].

		self assert: SmallInteger minVal / -1 = (SmallInteger maxVal + 1).
		self assert: SmallInteger minVal // -1 = (SmallInteger maxVal + 1).
		self assert: (SmallInteger minVal quo: -1) = (SmallInteger maxVal + 1).
		self assert: (SmallInteger minVal \\ -1) = 0.

		values := Integer primesUpTo: 1000.
		values := (values reverse collect: [:ea| ea negated]), values.
		values do:
			[:dividend|
			values do:
				[:divisor|
				self assert: (dividend quo: divisor) * divisor + (dividend rem: divisor) = dividend.
				self assert: (dividend // divisor) * divisor + (dividend \\ divisor) = dividend]]]! !

!CogVMTests methodsFor: 'tests' stamp: 'eem 6/17/2009 23:18'!
testPCAccessForActivation
	"self new testPCAccessForActivation"
	| runningOnCogit theProcess block run pc executingMachineCode scanner blockCount |
	runningOnCogit := self runningOnCogit.
	run := true.
	theProcess := Processor activeProcess.
	"Fork a process that will sample the pc of the following recursive block."
	[(Delay forMilliseconds: 1) wait.
	 pc := theProcess suspendedContext pc.
	 executingMachineCode := theProcess suspendedContext xrayIsExecutingMachineCode.
	 run := false] forkAt: Processor userInterruptPriority.
	"The only suspension point in this block is on activation (assuming
	 ifTrue: is inlined) so its pc must be the first bytecode in the block."
	block := [run ifTrue: [block value]].
	block value.
	"Find the first bytecode of the second block in this method."
	blockCount := 0.
	(scanner := InstructionStream on: thisContext method)
		scanFor:
			[:b| blockCount = 2 or: [b == 143 and: [blockCount := blockCount + 1. false]]].
	self assert: pc = scanner pc.
	self assert: executingMachineCode = runningOnCogit.
	"Fork a process that will use recurse: to infinitely recurse.
	 The only suspension point in this call is on activation (assuming
	 ifTrue: is inlined) so its pc must be the first bytecode in the method."
	theProcess := [self recurse] forkAt: Processor activePriority - 1.
	(Delay forMilliseconds: 1) wait.
	pc := theProcess suspendedContext pc.
	executingMachineCode := theProcess suspendedContext xrayIsExecutingMachineCode.
	theProcess terminate.
	self assert: pc = (self class compiledMethodAt: #recurse) initialPC.
	self assert: executingMachineCode = runningOnCogit! !

!CogVMTests methodsFor: 'tests' stamp: 'eem 6/17/2009 22:31'!
testPCAccessForSends
	"self new testPCAccessForSends"
	| runningOnCogit |
	runningOnCogit := self runningOnCogit.
	#("Method-level pc maping"
		( '{ thisContext pc.
			thisContext xrayIsExecutingMachineCode.
			thisContext method }'
			pc)
		( '{ thisContext perform: #perform:withArguments: with: #pc with: Array new.
			thisContext xrayIsExecutingMachineCode.
			thisContext method }'
			perform:with:with: )
		( '{ [:ctxt :msg :ign1| ctxt perform: msg] value: thisContext value: #pc value: nil.
			thisContext xrayIsExecutingMachineCode.
			thisContext method }'
			value:value:value: )
	   "Block-level pc maping"
		( '[:method|
			{ thisContext pc.
			  thisContext xrayIsExecutingMachineCode.
			  method } ] value: thisContext method'
			pc)
		( '[:method|
			{ (thisContext perform: #perform:withArguments: with: #pc with: Array new).
			  thisContext xrayIsExecutingMachineCode.
			  method } ] value: thisContext method'
			perform:with:with:)
		( '[:method|
			{ [:ctxt :msg :ign1| ctxt perform: msg] value: thisContext value: #pc value: nil.
			  thisContext xrayIsExecutingMachineCode.
			  method } ] value: thisContext method'
			value:value:value: ) ) do:
		[:case|
		 [:actualPc :executingMachineCode :method| | flag scanner expectedPc |
		  flag := false.
		  (scanner := InstructionStream on: method)
			scanFor:
				[:b| flag or: [flag := scanner selectorToSendOrSelf == case second. false]].
		  expectedPc := scanner pc.
		  self assert: actualPc = expectedPc.
		  self assert: executingMachineCode = runningOnCogit]
			valueWithArguments: (Compiler evaluate: case first logged: false)]! !

TestCase subclass: #GdbARMAlienTests
	instanceVariableNames: 'processor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Processors-Tests'!

!GdbARMAlienTests methodsFor: 'accessing' stamp: 'tpr 3/20/2015 13:07'!
integerRegisterGetters
	^#(r0 r1 r2 r3 r4 r5 r6 r7 r8 r9 sl fp r12 lr sp pc)! !

!GdbARMAlienTests methodsFor: 'accessing' stamp: 'tpr 5/31/2014 12:07'!
integerRegisterSetters
	^#(r0: r1: r2: r3: r4: r5: r6: r7: r8: r9: r10: fp: r12: lr: sp: pc:)! !

!GdbARMAlienTests methodsFor: 'accessing' stamp: 'tpr 3/24/2015 13:29'!
memory 
"build a memory for this test; a ByteArray of 1024 bytes, filled with NOPs"
	| mem nop|
	nop := CogARMCompiler new mov: 0  rn: 0.
	mem := ByteArray new: 1024.
	1 to: 1024  by: 4do:[:i|
		mem unsignedLongAt: i put: nop bigEndian: false].
	^mem! !

!GdbARMAlienTests methodsFor: 'accessing' stamp: 'lw 7/11/2012 14:16'!
nfib
	"long fib(long n) { return n <= 1 ? 1 : fib(n-1) + fib(n-2) + 1; }
	 as compiled by arm-elf-gnuabi-gcc fib.c -c -marm
	also, the jumps are changed by hand."
	"| bat nfib ip |
	bat := GdbARMAlienTests new.
	nfib := bat nfib asWordArray.
	ip := 0.
	23 timesRepeat:
		[bat processor disassembleInstructionAt: ip In: nfib into:
			[:da :len|
			Transcript nextPutAll: da; cr; flush.
			ip := ip + len]]"
	^#("00000000 <fib>:
	   0:"		16re92d4810 		"push	{r4, fp, lr}	fp = r11, sp is changed in this command
	   4:"		16re28db008 		"add	fp, sp, #8	now, the frame pointer is changed
	   8:"		16re24dd00c 		"sub	sp, sp, #12
	   c:"		16re50b0010 		"str	r0, [fp, #-16]
	  10:"		16re51b3010 		"ldr	r3, [fp, #-16]	r3 <- [fp-16] <- r0
	  14:"		16re3530001 		"cmp	r3, #1
	  18:"		16rda00000c 		"ble	50 <fib+0x50>
	  1c:"		16re51b3010 		"ldr	r3, [fp, #-16]
	  20:"		16re2433001 		"sub	r3, r3, #1
	  24:"		16re1a00003 		"mov	r0, r3
	  28:"		16rebfffff4 		"bl	0 <fib>
	  2c:"		16re1a04000 		"mov	r4, r0
	  30:"		16re51b3010 		"ldr	r3, [fp, #-16]
	  34:"		16re2433002	 	"sub	r3, r3, #2
	  38:"		16re1a00003 		"mov	r0, r3
	  3c:"		16rebffffef 		"bl	0 <fib>
	  40:"		16re1a03000 		"mov	r3, r0
	  44:"		16re0843003 		"add	r3, r4, r3
	  48:"		16re2833001 		"add	r3, r3, #1
	  4c:"		16rea000000 		"b	54 <fib+0x54>
	  50:"		16re3a03001 		"mov	r3, #1
	  54:"		16re1a00003 		"mov	r0, r3
	  58:"		16re24bd008 		"sub	sp, fp, #8
	  5c:"		16re8bd8810 		"pop	{r4, fp, pc}")! !

!GdbARMAlienTests methodsFor: 'accessing' stamp: 'eem 12/11/2008 13:53'!
processor
	processor ifNil:
		[processor := GdbARMAlien new].
	^processor! !

!GdbARMAlienTests methodsFor: 'execution' stamp: 'lw 8/9/2012 20:57'!
runNFib: n disassemble: disassemble printRegisters: printRegisters
	"Run nfib wth the argument. Answer the result."
	"self new runNFib: 5 disassemble: true printRegisters: true"
	| memory |
	memory := Bitmap new: 1024 * 2 withAll: self processor nopOpcode.
	memory replaceFrom: 1 to: self nfib size with: self nfib asWordArray startingAt: 1.
	self processor
		r0: n;"argument n"
		lr: memory size * 2; "return address"
		pc: 0;
		sp: (memory size * 4) - 16.
	printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	"run until something goes wrong."
	self processor runInMemory: memory readExecuteOnlyBelow: memory size / 2.
	printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	^self processor r0! !

!GdbARMAlienTests methodsFor: 'execution' stamp: 'lw 7/11/2012 13:45'!
singleStepNFib: n disassemble: disassemble printRegisters: printRegisters
	"Run nfib wth the argument. Answer the result."
	"self new runNFib: 5 disassemble: true printRegisters: true"
	| memory |
	memory := WordArray new: 1024 * 2 withAll: self processor nopOpcode.
	memory replaceFrom: 1 to: self nfib size with: self nfib asWordArray startingAt: 1.
	self processor
		r0: n; "argument n"
		lr: self nfib size * 4;  "return address"
		pc: 0;
		sp: (memory size * 4 - 12). "Room for return address, frame pointer and r4"
	printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	[disassemble ifTrue:
		[Transcript nextPutAll: (self processor disassembleNextInstructionIn: memory); cr; flush].
	 self processor singleStepIn: memory readExecuteOnlyBelow: memory size * 4 / 2.
	 printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	"stop, once we leave the nfib code and step through the nops after that."
	 self processor pc < (self nfib size * 4)] whileTrue.
	^self processor r0! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/8/2014 08:38'!
testCall
	"Call a function that is in-range."
	
	"self new testCall"
	| memory |
	memory := self memory.
	self processor reset.

	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 40 ror: 0) bigEndian: false. 

	memory unsignedLongAt: 21 put: (CogARMCompiler new bl: 12) bigEndian: false.

	memory unsignedLongAt: 25 put: (CogARMCompiler new mov:5imm: 99 ror:0 ) bigEndian: false.
	memory unsignedLongAt: 41 put: (CogARMCompiler new mov: 4 imm: 42 ror: 0) bigEndian: false.
	memory unsignedLongAt: 45 put: (CogARMCompiler new bx: 14) bigEndian: false.
	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r14.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r28 "check the call".
	self processor singleStepIn: memory.
	self assert: processor r4 = 42.
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.

	self assert: self processor pc = 16r1C.
	self assert: self processor lr = 16r18.
	self assert: self processor r5 = 99
! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 17:25'!
testCallTrap
	"Call a function that is out-of-range.  Ensure the call is trapped."
	"self new testCallTrap"
	| memory |
	memory := self memory.
	memory unsignedLongAt: 5 put: (CogARMCompiler new bl: 1020) bigEndian: false.
	"Can't do this diassemble until after the #asByteArray - "
	"processor disassembleFrom: 0 to:16 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step twice, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 4.
			self assert: self processor lr = 8.
			self assert: pst pc = 4.
			self assert: pst nextpc = 8.
			self assert: pst address = 1032.
			self assert: pst type = #call].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 17:26'!
testCallTrap2
	"Call a function that is out-of-range.  Ensure the call is trapped
	This version calls well outside the memory array."
	"self new testCallTrap2"
	| memory |
	memory := self memory.
	memory unsignedLongAt: 5 put: (CogARMCompiler new bl: 16rFF00) bigEndian: false.
	"Can't do this diassemble until after the #asByteArray - "
	"processor disassembleFrom: 0 to:16 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step twice, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r4.
			self assert: self processor lr = 8.
			self assert: pst pc = 4.
			self assert: pst nextpc = 8.
			self assert: pst address  = 16rFF0C.
			self assert: pst type = #call].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 17:26'!
testCallTrap3
	"Call a function that is out-of-range.  Ensure the call is trapped
	This version calls well outside the memory array negatively"
	"self new testCallTrap3"
	| memory |
	memory := self memory.
	memory unsignedLongAt: 5 put: (CogARMCompiler new bl: -16rFF00) bigEndian: false.
	"Can't do this diassemble until after the #asByteArray - "
	"processor disassembleFrom: 0 to:16 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step twice, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r4.
			self assert: self processor lr = 8.
			self assert: pst pc = 4.
			self assert: pst nextpc = 8.
			self assert: pst address  = 16rFFFF010C.
			self assert: pst type = #call].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 3/26/2015 15:30'!
testDisassembling
	"self new testDisassembling"

	| memory result |
	memory := WordArray new: 2.
	memory at: 1 put:  (CogARMCompiler new add: 15 rn: 10 imm: 100 ror:0).
	result := self processor
		disassembleInstructionAt: 0 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str = '00000000: add	pc, sl, #100	; 0x64'].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 17:20'!
testExecutionTrap
	"Execute a run of nops.  test executing beyond the executable limit is trapped."
	"self new testExecutionTrap"
	| memory |
	 "Run through NOPs until we hit the limit set by readOnlyBelow: "
	memory := (Bitmap new: 1024 * 2 withAll: self processor nopOpcode) asByteArray.
	self processor
			pc: 0;
			sp: (memory size - 4). "Room for return address"
	self should: [self processor runInMemory: memory minimumAddress: 0 readOnlyBelow: memory size / 2]
		raise: Error
		withExceptionDo:
			[:err|
			self assert: self processor pc = (memory size / 2-4).
			self assert: ('Error 0: Illegal Instruction fetch address (0x1000).' match: err messageText)].
	self processor reset;  pc: 0.
	self should: [[self processor singleStepIn: memory minimumAddress: 0 readOnlyBelow: memory size / 2] repeat]
		raise: Error
		withExceptionDo:
			[:err|
			self assert: self processor pc = (memory size / 2- 4).
			self assert: ('Error 0: Illegal Instruction fetch address (0x1000).' match: err messageText)]! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/6/2014 15:31'!
testFlags
"test the processor flag state reading and setting"
	"self new testFlags"
	| memory |
	memory := Bitmap new: 5.
	self processor reset.
	memory longAt: 1 put: 16rE3A03001 bigEndian: false. "MOV r3, #1"
	memory longAt: 5 put: 16rE3530001 bigEndian: false. "CMP r3, #1"
	memory longAt: 9 put: 16r13A00003 bigEndian: false. "MOVNE r0, #3"
	memory longAt: 13 put: 16r03A00005 bigEndian: false. "MOVEQ r0, #5"
	memory := memory asByteArray.
	self processor
		disassembleInstructionAt: 0 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '00000000: mov	r3, #1'].
	self processor
		disassembleInstructionAt: 4 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '00000004: cmp	r3, #1'].
	self processor
		disassembleInstructionAt: 8 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '00000008: movne	r0, #3'].
	self processor
		disassembleInstructionAt: 12 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '0000000c: moveq	r0, #5'].
	self processor
		pc: 0;
		singleStepIn: memory;
		singleStepIn: memory;
		singleStepIn: memory;
		assert: self processor r0 = 0;
		singleStepIn: memory.
	self 
		assert: self processor pc = 16;
		assert: self processor r3 = 1;
		assert: self processor r0 = 5;
		assert: self processor zflag = 1;
		assert: self processor cflag = 1;
		assert: self processor vflag = 0;
		assert: self processor nflag = 0.
	self processor reset.
	self assert: self processor eflags = 3. "IFFlags are both set."! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/8/2014 08:42'!
testJump
	"Jump in-range."
	
	"self new testJump"
	| memory |
	memory := self memory.
	self processor reset.

	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 40 ror: 0) bigEndian: false. 

	memory unsignedLongAt: 21 put: (CogARMCompiler new b: 12) bigEndian: false.

	memory unsignedLongAt: 25 put: (CogARMCompiler new mov:5imm: 99 ror:0 ) bigEndian: false.
	memory unsignedLongAt: 41 put: (CogARMCompiler new mov: 4 imm: 42 ror: 0) bigEndian: false.
	memory unsignedLongAt: 45 put: (CogARMCompiler new bx: 14) bigEndian: false.
	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r14.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r28 "check the call".
	self processor singleStepIn: memory.
	self assert: processor r4= 42.
! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/11/2014 03:19'!
testJumpTrap
	"Jump a function that is out-of-range.  Ensure the call is trapped."
	"self new testJumpTrap"
	| memory |
	memory := self memory.
	memory unsignedLongAt: 5 put: (CogARMCompiler new b: 1020) bigEndian: false.
	"Can't do this diassemble until after the #asByteArray - "
	"processor disassembleFrom: 0 to:16 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step twice, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 4.
			self assert: self processor lr = 0.
			self assert: pst pc = 4.
			self assert: pst nextpc = 8.
			self assert: pst address = 1032.
			self assert: pst type = #jump].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/7/2014 18:44'!
testLongCall
	"Long-Call a function that is in-range."
	
	"self new testLongCall"
	| memory |
	memory := self memory.
	self processor reset.

	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 40 ror: 0) bigEndian: false. 

	memory unsignedLongAt: 21 put: (CogARMCompiler new blx: 10) bigEndian: false.

	memory unsignedLongAt: 25 put: (CogARMCompiler new mov:5imm: 99 ror:0 ) bigEndian: false.
	memory unsignedLongAt: 41 put: (CogARMCompiler new mov: 4 imm: 42 ror: 0) bigEndian: false.
	memory unsignedLongAt: 45 put: (CogARMCompiler new bx: 14) bigEndian: false.
	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r14.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r28 "check the call".
	self processor singleStepIn: memory.
	self assert: processor r4 = 42.
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.

	self assert: self processor pc = 16r1C.
	self assert: self processor lr = 16r18.
	self assert: self processor r5 = 99
! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 17:28'!
testLongCallTrap
	"Long-Call a function that is above-range."
	
	"self new testLongCallTrap"
	| memory |
	memory := self memory.
	self processor reset.

	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 4 ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 

	memory unsignedLongAt: 21 put: (CogARMCompiler new blx: 10) bigEndian: false.

	memory unsignedLongAt: 25 put: (CogARMCompiler new mov:5imm: 99 ror:0 ) bigEndian: false.
	memory unsignedLongAt: 41 put: (CogARMCompiler new mov: 4 imm: 42 ror: 0) bigEndian: false.
	memory unsignedLongAt: 45 put: (CogARMCompiler new bx: 14) bigEndian: false.
	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r14.
			self assert: self processor lr = 16r18.
			self assert: pst pc = 16r14.
			self assert: pst nextpc = 16r18.
			self assert: pst address = 1024.
			self assert: pst type = #call].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 17:28'!
testLongCallTrap2
	"Long-Call a function that is way outside range."
	
	"self new testLongCallTrap2"
	| memory |
	memory := self memory.
	self processor reset.

	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 16rFF ror: 8)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 4 ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 

	memory unsignedLongAt: 21 put: (CogARMCompiler new blx: 10) bigEndian: false.

	memory unsignedLongAt: 25 put: (CogARMCompiler new mov:5imm: 99 ror:0 ) bigEndian: false.
	memory unsignedLongAt: 41 put: (CogARMCompiler new mov: 4 imm: 42 ror: 0) bigEndian: false.
	memory unsignedLongAt: 45 put: (CogARMCompiler new bx: 14) bigEndian: false.
	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r14.
			self assert: self processor lr = 16r18.
			self assert: pst pc = 16r14.
			self assert: pst nextpc = 16r18.
			self assert: pst address = 16rFF000400.
			self assert: pst type = #call].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/8/2014 08:47'!
testLongJump
	"Jump in-range."
	
	"self new testLongJump"
	| memory |
	memory := self memory.
	self processor reset.

	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 40 ror: 0) bigEndian: false. 

	memory unsignedLongAt: 21 put: (CogARMCompiler new bx: 10) bigEndian: false.

	memory unsignedLongAt: 25 put: (CogARMCompiler new mov:5imm: 99 ror:0 ) bigEndian: false.
	memory unsignedLongAt: 41 put: (CogARMCompiler new mov: 4 imm: 42 ror: 0) bigEndian: false.
	memory unsignedLongAt: 45 put: (CogARMCompiler new bx: 14) bigEndian: false.
	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r14.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r28 "check the call".
	self processor singleStepIn: memory.
	self assert: processor r4= 42.
! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 3/20/2015 13:07'!
testLongJumpAddressForming
	"self new testLongJumpAddressForming"
	"test of the somewhat loopy code used in CogARMCompiler>concretizeConditionalJumpLong: to generate the oading of a long address for jumps"
	| memory |
	memory := self memory.
	self processor reset.
	memory unsignedLongAt: 1 put: (CogARMCompiler new mov: 10 imm: 16r7F ror: 8)  bigEndian: false. 
	memory unsignedLongAt: 5 put: (CogARMCompiler new orr: 10 imm: 16rFF ror: 16) bigEndian: false.
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 16rFE ror: 24) bigEndian: false. 
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 16r68 ror: 0) bigEndian: false. 

	self processor
		disassembleInstructionAt: 0 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '00000000: mov	sl, #2130706432	; 0x7f000000'].
	self processor
		disassembleInstructionAt: 4 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '00000004: orr	sl, sl, #16711680	; 0xff0000'].
	self processor
		disassembleInstructionAt: 8 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '00000008: orr	sl, sl, #65024	; 0xfe00'].
	self processor
		disassembleInstructionAt: 12 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '0000000c: orr	sl, sl, #104	; 0x68'].
	self processor
		pc: 0;
		singleStepIn: memory;
		singleStepIn: memory;
		singleStepIn: memory;
		singleStepIn: memory.
	self 
		assert: self processor pc = 16;
		assert: self processor sl = 16r7FFFFE68;
		assert: self processor zflag = 0;
		assert: self processor cflag = 0;
		assert: self processor vflag = 0;
		assert: self processor nflag = 0.
! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 17:29'!
testLongJumpTrap
	"Long-Jump a function that is above-range."
	
	"self new testLongJumpTrap"
	| memory |
	memory := self memory.
	self processor reset.

	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 4 ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 

	memory unsignedLongAt: 21 put: (CogARMCompiler new bx: 10) bigEndian: false.

	memory unsignedLongAt: 25 put: (CogARMCompiler new mov:5imm: 99 ror:0 ) bigEndian: false.
	memory unsignedLongAt: 41 put: (CogARMCompiler new mov: 4 imm: 42 ror: 0) bigEndian: false.
	memory unsignedLongAt: 45 put: (CogARMCompiler new bx: 14) bigEndian: false.
	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r14.
			self assert: pst pc = 16r14.
			self assert: pst nextpc = 16r18.
			self assert: pst address = 1024.
			self assert: pst type =  #jump].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 15:54'!
testMoveAwR
	"Read a register from a constant address that is in-range."
	
	"self new testMoveAwR"
	| memory |
	memory := self memory.
	self processor reset.

	"LEA sl, #16r228"
	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 2 ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 40 ror: 0) bigEndian: false. 
	"LDR R5, [sl]"
	memory unsignedLongAt: 21 put: (CogARMCompiler new ldr: 5 rn: 10 plusImm: 0) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	memory unsignedLongAt: 16r228 + 1 put: 99.
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self assert:[processor r5 = 99]
! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 16:12'!
testMoveAwRTrap1
	"Read from a register at a constant address that is out-of--range."
	
	"self new testMoveAwRTrap1"
	| memory |
	memory := self memory.
	self processor reset.

	"LEA sl, #16rFF00001FC"
	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 16rFF ror: 8)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 1 ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 16rFC ror: 0) bigEndian: false. 
	"STR R5, [sl]"
	memory unsignedLongAt: 21 put: (CogARMCompiler new ldr: 5 rn: 10 plusImm: 0) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	
	self should: [self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r14.
			self assert: pst pc = 16r14.
			self assert: pst nextpc = 16r18.
			self assert: pst address = 16rFF0001FC.
			self assert: pst type = #read]! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 3/20/2015 13:07'!
testMoveRAw
	"Write a register to a constant address that is in-range."
	
	"self new testMoveRAw"
	| memory |
	memory := self memory.
	self processor reset.

	"LEA sl, #16r3FC"
	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 2 ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 40 ror: 0) bigEndian: false. 
	"STR R5, [sl]"
	memory unsignedLongAt: 21 put: (CogARMCompiler new str: 5 rn: 10 plusImm: 0) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			r5: 99;
			singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self assert:[(memory unsignedLongAt: (processor sl) + 1) = processor r5]
! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 15:36'!
testMoveRAwTrap1
	"Write a register to a constant address that is below-range."
	
	"self new testMoveRAwTrap1"
	| memory |
	memory := self memory.
	self processor reset.

	"LEA sl, #16r1FC"
	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 1 ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 16rFC ror: 0) bigEndian: false. 
	"STR R5, [sl]"
	memory unsignedLongAt: 21 put: (CogARMCompiler new str: 5 rn: 10 plusImm: 0) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			r5: 99;
			singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	
	self should: [self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r14.
			self assert: pst pc = 16r14.
			self assert: pst nextpc = 16r18.
			self assert: pst address = 16r1FC.
			self assert: pst type = #write]! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 15:46'!
testMoveRAwTrap2
	"Write a register to a constant address that is below-range."
	
	"self new testMoveRAwTrap2"
	| memory |
	memory := self memory.
	self processor reset.

	"LEA sl, #16r1FC"
	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 16rFF ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 16rFC ror: 0) bigEndian: false. 
	"STR R5, [sl]"
	memory unsignedLongAt: 21 put: (CogARMCompiler new str: 5 rn: 10 plusImm: 0) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			r5: 99;
			singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	
	self should: [self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r14.
			self assert: pst pc = 16r14.
			self assert: pst nextpc = 16r18.
			self assert: pst address = 16rFFFC.
			self assert: pst type = #write]! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'lw 8/18/2012 14:24'!
testNfib1
	"self new testNfib1"
	self should: [self runNFib: 1 disassemble: false printRegisters: false]
		raise: Error
		withExceptionDo: 
			[:err| self assert: err messageText = 'Error 0: Illegal Instruction fetch address (0x1000).'].
	self deny: (self processor pc between: 0 and: self nfib size).
	self assert: self processor r0 = 1 benchFib! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'lw 7/11/2012 14:21'!
testNfib16
	"self new testNfib16"
	self should: [self runNFib: 16 disassemble: false printRegisters: false]
		raise: Error.
	self deny: (self processor pc between: 0 and: self nfib size).
	self assert: self processor r0 = 16 benchFib! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'lw 7/10/2012 14:29'!
testNfib2
	"self new testNfib2"
	self should: [self runNFib: 2 disassemble: false printRegisters: false]
		raise: Error.
	self deny: (self processor pc between: 0 and: self nfib size).
	self assert: self processor r0 = 2 benchFib! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'lw 7/11/2012 14:20'!
testNfib4
	"self new testNfib4"
	self should: [self runNFib: 4 disassemble: false printRegisters: false]
		raise: Error.
	self deny: (self processor pc between: 0 and: self nfib size).
	self assert: self processor r0 = 4 benchFib! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 3/24/2015 13:09'!
testQuickDisassemby
	"self new testQuickDisassemby"

	| memory result |
	memory := WordArray new: 2.
	memory at: 1 put: (CogARMCompiler new orr: 6  imm: 16r3F ror: 16).
	result := self processor
		disassembleInstructionAt: 0 
		In: memory 
		into: [:str :len | 
			^str =  '00000000: orr	r6, r6, #4128768	; 0x3f0000'].! !

!GdbARMAlienTests methodsFor: 'execution' stamp: 'tpr 4/30/2014 11:43'!
testQuickDisassembyOf: word
	"self new testQuickDisassembyOf: 3858758348"

	| memory result |
	memory := WordArray new: 2.
	memory at: 1 put: word.
	result := self processor
		disassembleInstructionAt: 0 
		In: memory 
		into: [:str :len | 
			^str].! !

!GdbARMAlienTests methodsFor: 'execution' stamp: 'eem 3/18/2014 10:44'!
testResetCPU
	"self new testResetCPU"
	self integerRegisterSetters do:
		[:setter|
		self processor perform: setter with: 16r55555555].
	self integerRegisterGetters do:
		[:getter|
		self assert: 16r55555555 = (self processor perform: getter)].
	self processor reset.
	self integerRegisterGetters do:
		[:getter|
		self assert: 0 = (self processor perform: getter)]! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/28/2014 21:56'!
testReturnTrap
	"return above-range with a bad address"
	
	"self new testReturnTrap"
	| memory badAddress|
	badAddress := 16r1E000000. 
	memory := self memory.
	self processor reset.

	"pop the stack into pc to emulate a return via stack as generated in  various trampoline code"	
	memory unsignedLongAt: 1 put: (CogARMCompiler new mov: 15 rn: 14) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 0;
			sp: (memory size - 4); "Room for return address"
			lr: badAddress;
			singleStepIn: memory readExecuteOnlyBelow: memory size /2 .
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 0.
			self assert: pst pc = 0.
			self assert: pst nextpc = 4.
			self assert: pst address = badAddress.
			self assert: pst type = #return].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/28/2014 21:51'!
testReturnTrapWithThumbBug
	"return above-range with a bad address that ends in 1 - which triggers an ARM sim bug"
	
	"self new testReturnTrapWithThumbBug"
	| memory badAddress|
	badAddress := 16r1E000001. "this will try to set thumb mode"
	memory := self memory.
	self processor reset.

	"pop the stack into pc to emulate a return via stack as generated in  various trampoline code"	
	memory unsignedLongAt: 1 put: (CogARMCompiler new mov: 15 rn: 14) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 0;
			sp: (memory size - 4); "Room for return address"
			lr: badAddress;
			singleStepIn: memory readExecuteOnlyBelow: memory size /2 .
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 0.
			self assert: pst pc = 0.
			self assert: pst nextpc = 4.
			self assert: pst address = badAddress.
			self assert: pst type = #return].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'lw 7/11/2012 13:27'!
testStepNfib1
	"self new testStepNfib1"
	self singleStepNFib: 1 disassemble: false printRegisters: false.
	self assert: self processor pc = (self nfib asWordArray size * 4).
	self assert: self processor r0 = 1 benchFib! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'lw 7/11/2012 14:19'!
testStepNfib2
	"self new testStepNfib2"
	self singleStepNFib: 2 disassemble: false printRegisters: false.
	self assert: self processor pc = (self nfib size * 4).
	self assert: self processor r0 = 2 benchFib! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'lw 7/11/2012 14:20'!
testStepNfib4
	"self new testStepNfib4"
	self singleStepNFib: 4 disassemble: false printRegisters: false.
	self assert: self processor pc = (self nfib size * 4).
	self assert: self processor r0 = 4 benchFib! !

Object subclass: #BytecodeEncoderPutschEditor
	instanceVariableNames: 'xlator xlation kwdxlation ranges index output codeIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Morphing Bytecode Set'!

!BytecodeEncoderPutschEditor commentStamp: '<historical>' prior: 0!
I am a MethodNode that uses the size and emit methods that use the BytecodeEncoder hierarchy's bytecode generation facilities.  This means my nodes no longer need encode specifics about the bytecode set.

To compile edited versions of the size* and emit* methods use
	BytecodeEncoderPutschEditor new edit

In 3.8:
To get the source of the new version of MethodNode>>generate: for BytecodeAgnosticMethodNode use
BytecodeEncoderPutschEditor new
	editCode: (MethodNode sourceCodeAt: #generate:) asString
	inClass: BytecodeAgnosticMethodNode
	withSelector: #generate:

In 3.9:
To get the source of the new version of MethodNode>>generateWith:using: for BytecodeAgnosticMethodNode use
BytecodeEncoderPutschEditor new
	editCode: (BytecodeAgnosticMethodNode sourceCodeAt: #generateWith:using:) asString
	inClass: BytecodeAgnosticMethodNode
	withSelector: #generateWith:using:!

!BytecodeEncoderPutschEditor methodsFor: 'code editing' stamp: 'eem 5/5/2008 19:24'!
edit
	| sn |
	sn := SystemNavigation default.
	xlation keysAndValuesDo:
		[:s :t|
		(sn allImplementorsOf: s localTo: ParseNode) do:
			[:md|
			md actualClass
				compile: (self editCode: md sourceString inClass: md actualClass withSelector: md methodSymbol)
				classified: 'code generation (new scheme)']]! !

!BytecodeEncoderPutschEditor methodsFor: 'code editing' stamp: 'eem 5/6/2008 10:55'!
editCode: code inClass: class withSelector: selector
	| codeString |
	ranges := SHParserST80 new rangesIn: code classOrMetaClass: class workspace: nil  environment: nil.
	index := 1.
	codeIndex := 1.
	output := String new writeStream.
	codeString := code asString.
	self process: codeString while: [:ign| true].
	"(StringHolder new textContents:
		(TextDiffBuilder buildDisplayPatchFrom: code to: output contents))
			openLabel: class name , '>>', selector."
	^output contents! !

!BytecodeEncoderPutschEditor methodsFor: 'initialize-release' stamp: 'eem 5/6/2008 10:53'!
initialize
	xlator := [:s|
			((((s allButFirst: 4) beginsWith: 'For') or: [((s allButFirst: 4) beginsWith: 'Except') or: [s fifth = $:]])
				ifTrue: [(s first: 4), 'Code', (s allButFirst: 4)]
				ifFalse: [(s first: 4), 'CodeFor', (s allButFirst: 4)]) copyReplaceAll: ':on:' with: ':encoder:'].
	xlation := Dictionary new.
	(((ParseNode withAllSubclasses removeAll: Encoder withAllSubclasses; yourself)
		inject: Set new
		into: [:s :c| s addAll: c selectors. s])
			select:
				[:s| ((s beginsWith: 'emit') or: [s beginsWith: 'size'])
					and: [(s includesSubstring: 'Code' caseSensitive: true) not]]) do:
					[:s|xlation at: s put: (xlator value: s) asSymbol].
	kwdxlation := Dictionary new.
	xlation keysAndValuesDo: [:k :v| kwdxlation at: k keywords first put: v keywords first]! !

!BytecodeEncoderPutschEditor methodsFor: 'code editing' stamp: 'eem 5/6/2008 11:25'!
process: code while: aBlock
	| range mapOnToEncoder kwd |
	mapOnToEncoder := false.
	[index <= ranges size] whileTrue:
		[range := ranges at: index.
		  (aBlock value: range) ifFalse:
			[^self].
		 index := index + 1.
		 [codeIndex < range start] whileTrue:
			[output nextPut: (code at: codeIndex).
			 codeIndex := codeIndex + 1].
		range type == #assignment
			ifTrue: [output nextPutAll: ':='.
					codeIndex := range end + 1]
			ifFalse:
				[(#(keyword patternKeyword) includes: range type) ifTrue:
					[kwd := code copyFrom: range start to: range end.
					(mapOnToEncoder and: [kwd = 'on:'])
						ifTrue:
							[output nextPutAll: 'encoder: encoder'.
							 mapOnToEncoder := false.
							 codeIndex := (ranges at: index) end + 1.
							 index := index + 1]
						ifFalse:
							[(kwdxlation includesKey: kwd) ifTrue:
								[(kwd beginsWith: 'emit') ifTrue:
									[mapOnToEncoder := true].
								 output nextPutAll: (kwdxlation at: kwd).
								 codeIndex := range end + 1]]]
					ifFalse:
						[[codeIndex <= range end] whileTrue:
							[output nextPut: (code at: codeIndex).
							 codeIndex := codeIndex + 1].
						"kill whitespace after up-arrow in ^ expr"
						(range type == #return and: [index <= ranges size]) ifTrue:
							[codeIndex := (ranges at: index) start]]]]! !

Object subclass: #ClassHierarchyDuplicator
	instanceVariableNames: 'xlator classes prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Morphing Bytecode Set'!

!ClassHierarchyDuplicator methodsFor: 'code editing' stamp: 'eem 5/16/2008 15:50'!
edit
	(ChangeSet superclassOrder: classes asArray) do:
		[:class| | newClass |
		newClass := class subclassDefinerClass evaluate: (self editClassDefinitionOf: class).
		{ class. class class }
			with: { newClass. newClass class }
			do: [:b :nb|
				b selectors do:
					[:s|
					nb
						compile: (self editCode: (b sourceCodeAt: s) inClass: b withSelector: s)
						classified: (class organization categoryOfElement: s)]]]

	"self new edit"! !

!ClassHierarchyDuplicator methodsFor: 'code editing' stamp: 'eem 5/16/2008 15:43'!
editClassDefinitionOf: aClass
	| classDef categoryString |
	categoryString := 'category: '''.
	classDef := self editCode: aClass definition inClass: nil withSelector: nil.
	classDef := classDef
					copyReplaceAll: categoryString
					with: categoryString, prefix.
	^classDef
		copyReplaceAll: aClass classVariablesString
		with: (String streamContents: [:s| aClass classVariablesString subStrings do: [:ea| s nextPutAll: prefix; nextPutAll: ea; space]])

	"self new editClassDefinitionOf: MessageNode"! !

!ClassHierarchyDuplicator methodsFor: 'code editing' stamp: 'eem 5/16/2008 15:59'!
editCode: sourceText inClass: class withSelector: selector
	| ranges index codeIndex output codeString range |
	ranges := SHParserST80 new
				rangesIn: (codeString := sourceText asString)
				classOrMetaClass: class
				workspace: nil
				environment: nil.
	index := codeIndex := 1.
	output := (String new: codeString size) writeStream.
	[index <= ranges size] whileTrue:
		[range := ranges at: index.
		 index := index + 1.
		 [codeIndex < range start] whileTrue:
			[output nextPut: (codeString at: codeIndex).
			 codeIndex := codeIndex + 1].
		range type == #assignment
			ifTrue: [output nextPutAll: ':='.
					codeIndex := range end + 1]
			ifFalse:
				[(#(globalVar classVar) includes: range type)
					ifTrue:
						[output nextPutAll: (xlator value: (codeString copyFrom: range start to: range end)).
						 codeIndex := range end + 1]
					ifFalse:
						[#symbol == range type
							ifTrue:
								[output
									nextPut: (codeString at: range start); "#"
									nextPutAll: (xlator value: (codeString copyFrom: range start + 1 to: range end)).
								 codeIndex := range end + 1]
							ifFalse:
								[[codeIndex <= range end] whileTrue:
									[output nextPut: (codeString at: codeIndex).
									 codeIndex := codeIndex + 1].
								"kill whitespace after up-arrow in ^ expr"
								(range type == #return and: [index <= ranges size]) ifTrue:
									[codeIndex := (ranges at: index) start]]]]].
	^output contents

	"SHParserST80 new
		rangesIn: (ClassHierarchyDuplicator sourceCodeAt: #editCode:inClass:withSelector:) asString
		classOrMetaClass: ClassHierarchyDuplicator
		workspace: nil
		environment: nil"

	"SHParserST80 new
		rangesIn: ClassHierarchyDuplicator definition asString
		classOrMetaClass: nil
		workspace: nil
		environment: nil"

	"ClassHierarchyDuplicator new editCode: LeafNode definition inClass: nil withSelector: nil"
	"ClassHierarchyDuplicator new editCode: (MessageNode sourceCodeAt: #emitToDo:on:value:) inClass: MethodNode withSelector: #emitToDo:on:value:"
	"ClassHierarchyDuplicator new editCode: (MessageNode class sourceCodeAt: #initialize) inClass: MessageNode class withSelector: #initialize"! !

!ClassHierarchyDuplicator methodsFor: 'initialize-release' stamp: 'eem 5/16/2008 15:53'!
initialize
	| globalNames |
	prefix := 'XXX'.
	classes := Set new.
	((SystemOrganization categories reject: [:c| c beginsWith: prefix]) select:
		[:c| ('*Compiler*' match: c) and: [#'Compiler-Morphing Bytecode Set' ~= c]]) do:
			[:cat|
			(SystemOrganization listAtCategoryNamed: cat) do:
				[:cn|
				classes add: (Smalltalk at: cn)]].
	globalNames := classes collect: [:ea| ea name asString].
	classes do: [:c| c classPool keys do: [:sym| globalNames add: sym asString]].
	xlator := [:s| (globalNames includes: s) ifTrue: [prefix, s] ifFalse: [s]]

	"self new edit"! !

Object subclass: #ClosureLabelsPrintEditor
	instanceVariableNames: 'xlator xlation kwdxlation ranges index output codeIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Morphing Bytecode Set'!

!ClosureLabelsPrintEditor methodsFor: 'code editing' stamp: 'eem 6/2/2008 11:47'!
edit: generateViewBar
	"self new edit: true"
	| sn |
	sn := SystemNavigation default.
	xlation keysAndValuesDo:
		[:s :t|
		(sn allImplementorsOf: s localTo: ParseNode) do:
			[:md| | newCode |
			newCode := self editCode: md sourceString inClass: md actualClass withSelector: md methodSymbol.
			generateViewBar
				ifTrue: [md actualClass compile: newCode classified: 'printing']
				ifFalse:
					[(StringHolder new textContents:
						(CodeDiffBuilder buildDisplayPatchFrom: md sourceString to: newCode))
							openLabel: md printString]]]! !

!ClosureLabelsPrintEditor methodsFor: 'code editing' stamp: 'eem 6/2/2008 11:39'!
editCode: code inClass: class withSelector: selector
	| codeString |
	ranges := SHParserST80 new rangesIn: code classOrMetaClass: class workspace: nil  environment: nil.
	index := 1.
	codeIndex := 1.
	output := String new writeStream.
	codeString := code asString.
	self process: codeString.
	^output contents! !

!ClosureLabelsPrintEditor methodsFor: 'initialize-release' stamp: 'eem 6/2/2008 11:38'!
initialize
	xlator := [:s| s copyReplaceAll: 'print' with: 'printWithClosureAnalysis'].
	xlation := Dictionary new.
	(((ParseNode withAllSubclasses removeAll: Encoder withAllSubclasses; yourself)
		inject: Set new
		into: [:s :c| s addAll: c selectors. s]) select:
			[:s| s beginsWith: 'print']) do:
				[:s|xlation at: s put: (xlator value: s) asSymbol].
	kwdxlation := Dictionary new.
	xlation keysAndValuesDo: [:k :v| kwdxlation at: k keywords first put: v keywords first]! !

!ClosureLabelsPrintEditor methodsFor: 'code editing' stamp: 'eem 6/2/2008 11:43'!
process: code
	| range kwd |
	[index <= ranges size] whileTrue:
		[range := ranges at: index.
		 index := index + 1.
		 [codeIndex < range start] whileTrue:
			[output nextPut: (code at: codeIndex).
			 codeIndex := codeIndex + 1].
		range type == #assignment
			ifTrue: [output nextPutAll: ':='.
					codeIndex := range end + 1]
			ifFalse:
				[(#(keyword patternKeyword) includes: range type) ifTrue:
					[kwd := code copyFrom: range start to: range end.
					(kwdxlation includesKey: kwd) ifTrue:
						[output nextPutAll: (kwdxlation at: kwd).
						 codeIndex := range end + 1]]
					ifFalse:
						[[codeIndex <= range end] whileTrue:
							[output nextPut: (code at: codeIndex).
							 codeIndex := codeIndex + 1].
						"kill whitespace after up-arrow in ^ expr"
						(range type == #return and: [index <= ranges size]) ifTrue:
							[codeIndex := (ranges at: index) start]]]]! !

Object subclass: #CogScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Scripts'!

!CogScripts class methodsFor: 'closure scripts' stamp: 'eem 7/17/2008 18:56'!
bootstrapClosures
	"CogScripts bootstrapClosures"
	| rep |
	Transcript clear.
	rep := false
			ifTrue: [MCCacheRepository default]
			ifFalse:
				[MCHttpRepository
					location: 'http://dev.qwaq.com/ss/Oinq'
					user: 'qwaq'
					password: ''].
	"This changes load order in Monticello such that additions come in before modifications."
	(rep loadVersionFromFileNamed: 'Monticello-eem.302.mcz') load.
	"This adds some prereqs the compiler uses that are loaded in later packages:
	 Fix the ClassBuilder so redefining CompiledMethod can add and remove class variables.
	 Add Object/Array>>isArray.
	 Add new interface for accessing inst vars & fields on initializing the compiler (Encoder)."
	self bootstrapClosuresCompilerPreloadCode readStream fileIn.
	"This temporarily stops Monticello from unloading code on load and warning about overwriting changes.
	 Since changes span multiple packages need all additions in before any deletions occur.
	 Can't warn about anything until the new debugger api is installed."
	ChangeSet
		newChangesFromStream: self bootstrapClosuresNeuterMonticelloCode readStream
		named: 'neuterMonticello'.
	Smalltalk at: #DoNotUnload put: true.
	1 to: 2 do:
		 [:i|
		  #(	'Compiler-eem.30.mcz'
			'Files-eem.21.mcz'
			'Exceptions-eem.14.mcz'
			'Collections-eem.55.mcz'
			'Tools-eem.45.mcz'
			'Kernel-eem.82.mcz'
			'System-eem.53.mcz'
			'Brad-eem.51.mcz'
			'Morphic-eem.38.mcz'
			'Tweak-Compiler-eem.36.mcz'
			'Tweak-Hacks-eem.30.mcz'
			'Tweak-Basic-eem.151.mcz'
			'Tweak-Core-Proto-eem.56.mcz') do:
				[:pn|
				Transcript clear; nextPutAll: pn; space; nextPut: $(; print: i; nextPut: $); endEntry.
				(rep loadVersionFromFileNamed: pn) load].
		 Smalltalk at: #DoNotUnload put: false].
	"Now remove the temporary hacks to Monticello"
	(ChangeSet named: 'neuterMonticello') changedMessageList do:
		[:mr| | changeRecords |
		changeRecords := mr actualClass changeRecordsAt: mr methodSymbol.
		changeRecords second fileIn].
	"Install BlockClosure in the specialObjectsArray"
	Smalltalk recreateSpecialObjectsArray.
	"Throw the switch to compile to closures"
	self bootstrapClosuresClosureCompilerSwitchCode readStream fileIn.
	"Recompile the system except the one method we can't yet deal with in GeniePlugin (1 too many literals)"
	(Smalltalk forgetDoIts allClasses reject: [:c| c name == #GeniePlugin]) do:
		[:c|
		{ c. c class } do:
			[:b|
			Transcript cr; print: b; endEntry.
			b selectors asSortedCollection do:
				[:s|
				b recompile: s from: b]]].
	UsefulScripts postRecompileCleanup.
	self inform: 'Save and quit and then run UsefulScripts postRecompileCleanup.\Rinse and repeat' withCRs! !

!CogScripts class methodsFor: 'closure scripts' stamp: 'eem 6/16/2008 17:29'!
bootstrapClosuresClosureCompilerSwitchCode
	^'
!!Parser methodsFor: ''public access'' stamp: ''eem 5/15/2008 15:44''!!
encoder
	encoder isNil ifTrue:
		[encoder := EncoderForV3PlusClosures new].
	^encoder!! !!'! !

!CogScripts class methodsFor: 'closure scripts' stamp: 'eem 6/13/2008 14:52'!
bootstrapClosuresCompilerPreloadCode
	^'
!!ClassBuilder methodsFor: ''class format'' stamp: ''eem 6/13/2008 10:03''!!
computeFormat: type instSize: newInstSize forSuper: newSuper ccIndex: ccIndex
	"Compute the new format for making oldClass a subclass of newSuper.
	Return the format or nil if there is any problem."
	| instSize isVar isWords isPointers isWeak |
	type == #compiledMethod
		ifTrue:[^CompiledMethod format].
	instSize := newInstSize + (newSuper ifNil:[0] ifNotNil:[newSuper instSize]).
	instSize > 254 ifTrue:[
		self error: ''Class has too many instance variables ('', instSize printString,'')''.
		^nil].
	type == #normal ifTrue:[isVar := isWeak := false. isWords := isPointers := true].
	type == #bytes ifTrue:[isVar := true. isWords := isPointers := isWeak := false].
	type == #words ifTrue:[isVar := isWords := true. isPointers := isWeak := false].
	type == #variable ifTrue:[isVar := isPointers := isWords := true. isWeak := false].
	type == #weak ifTrue:[isVar := isWeak := isWords := isPointers := true].
	(isPointers not and:[instSize > 0]) ifTrue:[
		self error:''A non-pointer class cannot have instance variables''.
		^nil].
	^(self format: instSize 
		variable: isVar 
		words: isWords 
		pointers: isPointers 
		weak: isWeak) + (ccIndex bitShift: 11).!! !!

!!ClassBuilder methodsFor: ''public'' stamp: ''eem 6/13/2008 10:00''!!
superclass: aClass
	variableByteSubclass: t instanceVariableNames: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class in which the subclass is to 
	have indexable byte-sized nonpointer variables."
	| oldClassOrNil actualType |
	(aClass instSize > 0)
		ifTrue: [^self error: ''cannot make a byte subclass of a class with named fields''].
	(aClass isVariable and: [aClass isWords])
		ifTrue: [^self error: ''cannot make a byte subclass of a class with word fields''].
	(aClass isVariable and: [aClass isPointers])
		ifTrue: [^self error: ''cannot make a byte subclass of a class with pointer fields''].
	oldClassOrNil := aClass environment at: t ifAbsent:[nil].
	actualType := (oldClassOrNil notNil
				   and: [oldClassOrNil typeOfClass == #compiledMethod])
					ifTrue: [#compiledMethod]
					ifFalse: [#bytes].
	^self 
		name: t
		inEnvironment: aClass environment
		subclassOf: aClass
		type: actualType
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat!! !!

!!Array methodsFor: ''testing'' stamp: ''eem 5/8/2008 11:13''!!
isArray
	^true!! !!

!!Object methodsFor: ''testing'' stamp: ''eem 5/8/2008 11:13''!!
isArray
	^false!! !!

!!Behavior methodsFor: ''compiling'' stamp: ''eem 5/13/2008 09:50''!!
instVarNamesAndOffsetsDo: aBinaryBlock
	"This is part of the interface between the compiler and a class''s instance or field names.
	 The class should enumerate aBinaryBlock with the instance variable name strings and
	 their integer offsets.  The order is important. Names evaluated later will override the
	 same names occurring earlier."

	"Nothing to do here; ClassDescription introduces named instance variables"
	^self!! !!

!!ClassDescription methodsFor: ''compiling'' stamp: ''eem 5/13/2008 09:48''!!
instVarNamesAndOffsetsDo: aBinaryBlock
	"This is part of the interface between the compiler and a class''s instance or field names.
	 The class should enumerate aBinaryBlock with the instance variable name strings and
	 their integer offsets.  The order is important. Names evaluated later will override the
	 same names occurring earlier."

	| superInstSize |
	(superInstSize := superclass notNil ifTrue: [superclass instSize] ifFalse: [0]) > 0 ifTrue:
		[superclass instVarNamesAndOffsetsDo: aBinaryBlock].
	1 to: self instSize - superInstSize do:
		[:i| aBinaryBlock value: (instanceVariables at: i) value: i + superInstSize]!! !!


!!Behavior methodsFor: ''compiling'' stamp: ''eem 5/13/2008 09:50''!!
variablesAndOffsetsDo: aBinaryBlock
	"This is the interface between the compiler and a class''s instance or field names.  The
	 class should enumerate aBinaryBlock with the field definitions (with nil offsets) followed
	 by the instance variable name strings and their integer offsets.  The order is important.
	 Names evaluated later will override the same names occurring earlier."

	"Only need to do instance variables here.  CProtoObject introduces field definitions."
	self instVarNamesAndOffsetsDo: aBinaryBlock!! !!

!!CProtoObject class methodsFor: ''compiling'' stamp: ''eem 5/13/2008 09:53''!!
variablesAndOffsetsDo: aBinaryBlock
	"This is the interface between the compiler and a class''s instance or field names.  The
	 class should enumerate aBinaryBlock with the field definitions (with nil offsets) followed
	 by the instance variable name strings and their integer offsets.  The order is important.
	 Names evaluated later will override the same names occurring earlier."

	self allFieldsReverseDo: [:field| aBinaryBlock value: field value: nil].
	self instVarNamesAndOffsetsDo: aBinaryBlock!! !!'! !

!CogScripts class methodsFor: 'closure scripts' stamp: 'eem 6/13/2008 14:56'!
bootstrapClosuresNeuterMonticelloCode
	^'
!!MCVersionLoader methodsFor: ''checking'' stamp: ''eem 6/12/2008 17:30''!!
checkForModifications
	| modifications |
	modifications := versions select: [:ea | ea package workingCopy modified].
	true ifTrue: [^true].
	modifications isEmpty ifFalse: [self warnAboutLosingChangesTo: modifications].!! !!

!!MCClassDefinition methodsFor: ''installing'' stamp: ''eem 6/12/2008 17:53''!!
unload
	(Smalltalk at: #DoNotUnload ifAbsent: [false]) ifTrue: [^self].
	Smalltalk removeClassNamed: name!! !!

!!MCMethodDefinition methodsFor: ''installing'' stamp: ''eem 6/12/2008 17:53''!!
unload
	| previousVersion |
	(Smalltalk at: #DoNotUnload ifAbsent: [false]) ifTrue: [^self].
	self isOverrideMethod ifTrue: [previousVersion := self scanForPreviousVersion].
	previousVersion
		ifNil: [self actualClass ifNotNilDo: [:class | class removeSelector: selector]]
		ifNotNil: [previousVersion fileIn] !! !!

!!MCOrganizationDefinition methodsFor: ''as yet unclassified'' stamp: ''eem 6/12/2008 18:06''!!
postloadOver: oldDefinition
	[SystemOrganization categories:
		(self
			reorderCategories: SystemOrganization categories
			original: (oldDefinition ifNil: [#()] ifNotNil: [oldDefinition categories]))]
		on: Error
		do: [:ex| Transcript cr; print: ex messageText; endEntry]!! !!

!!MCPackageLoader methodsFor: ''private'' stamp: ''eem 6/12/2008 21:32''!!
tryToLoad: aDefinition
	[aDefinition loadOver: (self obsoletionFor: aDefinition)]
		on: Error
		do: [:ex| self halt. errorDefinitions add: aDefinition]!! !!'! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 6/11/2010 13:21'!
browseExclusiveMethodImportsForPrimitiveClass: primClass
	"Browse methods used by the class holding VM primitives and unused elsewhere."
	"self browseExclusiveMethodImportsForPrimitiveClass: StackInterpreterSPrimitives"
	Cursor execute showWhile:
		["The algorithm computes a fixed point of the methods used
		   by the parcel which are unused outside it.  The algorithm is
				compute messages sent within parcel
				repeat until at a fixed point:
					compute intersection of this with methods implemented outside parcel
					compute messages sent outside parcel not within the intersection
					remove these from intersection"

		| parcelMessages "<IdentitySet of: Symbol>
								messages sent within this parcel"
		  externalMethods "<Set of: MethodDescription>
								methods implemented outside this parcel"
		  danglingMethods "<Set of: MethodDescription>
								methods importeded only by this parcel"
		  previousDangling "<Set of: MethodDescription>
								intermediate value of danglingMethods (for determining if fixed point is reached)"
		  danglingMessages "<Set of: Symbol> selectors of methods in danglingMethods"
		  noLongerDangling "<Set of: Symbol> selectors to be moved from dangling" |

		parcelMessages := IdentitySet new.
		primClass methodsDo:
			[:meth| parcelMessages addAll: meth messages].
		"compute starting points for danglingMethods and externalMethods"
		danglingMethods := Set new: 50.
		externalMethods := Set new: 20000.
		(PackageInfo named: 'VMMaker') classes do:
			[:aBehavior| | extends |
			(aBehavior = primClass or: [aBehavior inheritsFrom: primClass]) ifFalse:
				[aBehavior selectorsAndMethodsDo:
					[:sel :meth|
					(primClass includesSelector: sel) ifFalse:
						[((parcelMessages includes: sel)
							ifTrue: [danglingMethods]
							ifFalse: [externalMethods])
								add: (MethodReference class: aBehavior selector: sel)]]]].
		["Now iterate to the fixed-point.  Any method in dangling with a selector sent
		  in external must be moved into external until dangling reaches its fixed point."
		previousDangling := danglingMethods copy.
		danglingMessages := danglingMethods collect: [:md| md selector].
		noLongerDangling := Set new: danglingMethods size.
		externalMethods do:
			[:md|
			md compiledMethod messages do:
				[:l|
				(danglingMessages includes: l) ifTrue:
					[noLongerDangling add: l]]].
		externalMethods := danglingMethods select: [:md| noLongerDangling includes: md selector].
		danglingMethods removeAll: externalMethods.
		danglingMethods size ~= previousDangling size] whileTrue.
		SystemNavigation default
			browseMessageList: danglingMethods asSortedCollection
			name: 'Methods Used Only by ', primClass name, ' but not in ', primClass name]! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 11/13/2014 13:57'!
changeMethodsForBasicConstantSendsIn: aClass
	"CogScripts changedMethodsForBasicConstantSendsIn: StackInterpreter"
	| receiver rules model env |
	rules := RBParseTreeRewriter new.
	receiver := ((aClass includesBehavior: ObjectMemory)
				 or: [aClass includesBehavior: SpurMemoryManager])
					ifTrue: ['self']
					ifFalse:
						[#('objectMemory' 'manager' 'interpreterProxy') detect: [:ivn| (aClass instVarIndexFor: ivn ifAbsent: nil) notNil]].
	rules
		replace: 'BaseHeaderSize' with: receiver, ' baseHeaderSize';
		replace: 'BytesPerOop' with: receiver, ' bytesPerOop';
		replace: 'BytesPerWord' with: receiver, ' wordSize';
		replace: 'ShiftForWord' with: receiver, ' shiftForWord'.
	model := RBNamespace new.
	env := RBBrowserEnvironment new forClasses: { aClass }.
	env classesAndSelectorsDo:
		[ :class :selector | | tree |
		tree := class parseTreeFor: selector.
		(rules executeTree: tree) ifTrue:
			[model compile: rules tree newSource in: class classified: (class whichCategoryIncludesSelector: selector)]].

	model changes changes do:
		[:mr|
		aClass
			compile: mr source
			classified: (aClass whichCategoryIncludesSelector: mr selector)
			withStamp: (Utilities changeStamp copyReplaceAll: Utilities authorInitials with: Utilities authorInitials, ' (const to msg rewrite)')
			notifying: nil]! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 2/5/2014 10:31'!
changedMethodsForObjectMemorySends
	"Answer the methods in StackInterpreter and subclasses that change if sends to self for methods implemented
	 in ObjectMemory, NewObjectMemory (& NewObjectMemorySE ?) become sends to objectMemory."
	"CogScripts changedMethodsForObjectMemorySends"
	| selectors rules model environment sortedChanges |
	selectors := { ObjectMemory. NewObjectMemory. "NewObjectMemorySE" }
					inject: Set new
					into: [:sels :class| sels addAll: class selectors; yourself].
	rules := RBParseTreeRewriter new.
	rules
		replace: 'self `@method: ``@args'
		with: 'objectMemory `@method: ``@args'
		when: [:node| selectors includes: node selector].
	#(	'nilObj' 'trueObj' 'falseObj')
		do: [:instVar|
			rules
				replace: instVar, ' := ``@args' with: 'objectMemory ', instVar, 'ect: ``@args';
				replace: instVar with: 'objectMemory ', instVar, 'ect'].
	self readWriteVars do: [:instVar|
			rules
				replace: instVar, ' := ``@args' with: 'objectMemory ', instVar, ': ``@args';
				replace: instVar with: 'objectMemory ', instVar].
	self readOnlyVars do: [:instVar|
			rules replace: instVar with: 'objectMemory ', instVar].
	model := RBNamespace new.
	environment := RBBrowserEnvironment new forClasses:
						{ StackInterpreter. CoInterpreter. CoInterpreterMT.
						   StackInterpreterSimulator. CogVMSimulator }.
	environment classesAndSelectorsDo:
		[ :class :selector | | tree |
		"(class == StackInterpreter and: [selector == #isContextHeader:]) ifTrue: [self halt]."
		"(class == StackInterpreter and: [selector == #isIndexable:]) ifTrue: [self halt]."
		"(class == StackInterpreter and: [selector == #printContextCallStackOf:]) ifTrue: [self halt]."
		tree := class parseTreeFor: selector.
		(rules executeTree: tree) ifTrue:
			[model compile: rules tree newSource in: class classified: (class whichCategoryIncludesSelector: selector)]].
	false ifTrue: [model changes inspect].
	false ifTrue: "shortest change:"
		[(model changes changes inject: model changes changes first into: [:c1 :c2| c1 printString size < c2 printString size ifTrue: [c1] ifFalse: [c2]]) inspect].

	sortedChanges := model changes changes asSortedCollection:
						[:c1 :c2|
						c1 changeClass == c2 changeClass
							ifTrue: [c1 selector <= c2 selector]
							ifFalse: [c2 changeClass inheritsFrom: c1 changeClass]].
	true ifTrue:
		[MessageSetTextDifferencer
			openMessageList: (sortedChanges collect: [:mr| { MethodReference class: mr changeClass selector: mr selector. TextReference new text: mr source class: mr class selector: mr selector }])
			name: 'self foo <-> objectMemory foo et al' 
			autoSelect: nil].

	^sortedChanges! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 12/16/2016 16:39'!
changedSpurCompactorMethods
	"Answer the methods in SpurPigCompactor and subclasses that change if sends to self for methods implemented
	 in SpurMemoryManager become sends to manager."
	"CogScripts changedSpurCompactorMethods"
	| selectors compactorVars spurMemoryManagerSelectors rules model environment sortedChanges |
	selectors := (self systemNavigation allAccessesTo: 'firstFreeChunk' from: SpurMemoryManager) asSet,
				 (self systemNavigation allAccessesTo: 'lastFreeChunk' from: SpurMemoryManager)
					collect: [:mr| mr selector].
	selectors addAll: (SpurMemoryManager selectors select: [:s| ('*pigcompact*' match: s) or: [s endsWith: 'Pig']]).
	compactorVars := #('numCompactionPasses' 'firstFreeChunk' 'lastFreeChunk' 'scavenger' 'coInterpreter').
	spurMemoryManagerSelectors := SpurMemoryManager selectors.
	rules := RBParseTreeRewriter new.
	rules
		replace: 'self `@method: ``@args'
		with: 'manager `@method: ``@args'
		when: [:node| (spurMemoryManagerSelectors includes: node selector) and: [(selectors includes: node selector) not]].
	(SpurMemoryManager instVarNames reject: [:iv| compactorVars includes: iv]) do:
		[:instVar|
		 rules
			replace: instVar, ' := ``@args' with: 'manager ', instVar, ': ``@args';
			replace: instVar with: 'manager ', instVar].
	#(	'nilObj' 'trueObj' 'falseObj')
		do: [:instVar|
			rules
				replace: instVar, ' := ``@args' with: 'manager ', instVar, 'ect: ``@args';
				replace: instVar with: 'manager ', instVar, 'ect'].
	model := RBNamespace new.
	environment := RBBrowserEnvironment new forClasses: { SpurMemoryManager }.
	environment classesAndSelectorsDo:
		[ :class :selector | | tree |
		((selectors includes: selector)
		 and: [rules executeTree: (tree := class parseTreeFor: selector)]) ifTrue:
			[model compile: rules tree newSource in: class classified: (class whichCategoryIncludesSelector: selector)]].
	false ifTrue: [model changes inspect].
	false ifTrue: "shortest change:"
		[(model changes changes inject: model changes changes first into: [:c1 :c2| c1 printString size < c2 printString size ifTrue: [c1] ifFalse: [c2]]) inspect].

	sortedChanges := model changes changes asSortedCollection:
						[:c1 :c2|
						c1 changeClass == c2 changeClass
							ifTrue: [c1 selector <= c2 selector]
							ifFalse: [c2 changeClass inheritsFrom: c1 changeClass]].
	true ifTrue:
		[MessageSetTextDifferencer
			openMessageList: (sortedChanges collect: [:mr| { MethodReference class: mr changeClass selector: mr selector. TextReference new text: mr source class: mr changeClass selector: mr selector }])
			name: 'self foo <-> manager foo et al' 
			autoSelect: nil].

	^sortedChanges! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 9/30/2010 13:20'!
createObjMemSims
	"self createObjMemSims"
	{ NewObjectMemory. NewCoObjectMemory } do:
		[:c| | sc oc nc |
		sc := Compiler evaluate: ((Class templateForSubclassOf: c category: c category, 'Simulation') copyReplaceAll: 'NameOfSubclass' with: c name, 'Simulator').
		false ifTrue:
			[oc := NewObjectMemorySimulator.
			oc selectors do:
				[:s| [sc compile: (oc sourceCodeAt: s) asString
						classified: (oc whichCategoryIncludesSelector: s)
						withStamp: (oc >> s) timeStamp
						notifying: nil] on: Error do: [:ex|]]].
		nc := Compiler evaluate: ((Class templateForSubclassOf: sc category: sc category) copyReplaceAll: 'NameOfSubclass' with: sc name, 'LSB').
		oc := nc selectors size > 0 ifTrue: [nc] ifFalse: [NewObjectMemorySimulatorLSB].
		oc selectors do:
			[:s| | aoc |
			aoc := (CogVMSimulatorLSB includesSelector: s) ifTrue: [CogVMSimulatorLSB] ifFalse: [NewObjectMemorySimulatorLSB].
			nc compile: (aoc sourceCodeAt: s) asString
					classified: (aoc whichCategoryIncludesSelector: s)
					withStamp: (aoc >> s) timeStamp
					notifying: nil].
		nc := Compiler evaluate: ((Class templateForSubclassOf: sc category: sc category) copyReplaceAll: 'NameOfSubclass' with: sc name, 'MSB').
		oc := NewObjectMemorySimulatorMSB.
		oc selectors do:
			[:s| nc compile: (oc sourceCodeAt: s) asString
					classified: (oc whichCategoryIncludesSelector: s)
					withStamp: (oc >> s) timeStamp
					notifying: nil]]! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 6/8/2010 16:54'!
createSVMTree
	"Create the parallel StackInterpreterS, CoInterpreterS tree in which
	 objectMemory is an inst var rather than ObjectMemory et al being a superclass"
	"CogScripts createSVMTree"

	| changes map |
	changes := Cursor execute showWhile: [self changedMethodsForObjectMemorySends].

	map := Cursor execute showWhile: [self createStackInterpreterSHierarchy].

	(ChangeSet superclassOrder: (StackInterpreter withAllSubclasses select: [:c| map includesKey: c]) asArray) do:
		[:sourceClass|
		sourceClass selectors do:
			[:sel| | destClass source stamp |
			destClass := map
							at: (((sel beginsWith: 'primitive')
								and: [sel last ~~ $:
								and: [sel ~~ #primitiveFail]])
									ifTrue: [{sourceClass. #primitives}]
									ifFalse: [sourceClass])
							ifAbsent: [map at: sourceClass].
			(changes detect: [:c| c changeClass == sourceClass and: [c selector = sel]] ifNone: [])
				ifNotNil:
					[:change|
					source := change source.
					stamp := Utilities changeStamp copyReplaceAll: Utilities authorInitials with: Utilities authorInitials, ' (objmem refactor)']
				ifNil:
					[source := sourceClass sourceCodeAt: sel.
					stamp := (sourceClass >> sel) timeStamp].
			[destClass
					compile: source
					classified: (sourceClass whichCategoryIncludesSelector: sel)
					withStamp: stamp
					notifying: nil]
				on: SyntaxErrorNotification
				do: [:ex| | newBrowser |
					newBrowser := Browser new setClass: destClass selector: nil.
					newBrowser selectMessageCategoryNamed: (sourceClass whichCategoryIncludesSelector: sel).
					Browser
						openBrowserView: (newBrowser openMessageCatEditString: source)
						label: 'category "', (sourceClass whichCategoryIncludesSelector: sel), '" in ', destClass name]]].

	self readWriteVars, self readOnlyVars do:
		[:sym|
		(NewObjectMemory whichClassIncludesSelector: sym) ifNil:
			[(NewObjectMemory whichClassDefinesInstVar: sym asString)
				compile: sym, (String with: Character cr with: Character tab with: $^), sym
				classified: #accessing]].
	self readWriteVars do:
		[:sym| | setter | setter := (sym, ':') asSymbol.
		(NewObjectMemory whichClassIncludesSelector: setter) ifNil:
			[(NewObjectMemory whichClassDefinesInstVar: sym asString)
				compile: setter, ' aValue', (String with: Character cr with: Character tab with: $^), sym, ' := aValue'
				classified: #accessing]].! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 6/2/2010 18:15'!
createStackInterpreterSHierarchy
	"Create the parallel StackInterpreterS, CoInterpreterS tree (without methods).
	 Answer a Dictionary maping source class to dest class with {source. #primitives} -> dest
	 for the added primitives classes."

	| map |
	(Smalltalk classNamed: #StackInterpreterS) ifNotNil:
		[:sis|
		(Object confirm: 'StackInterpreterS exists, nuke?') ifTrue:
			[(ChangeSet superclassOrder: sis withAllSubclasses asArray) reverseDo:
				[:sissc| sissc removeFromSystemUnlogged]]].

	map := Dictionary new.
	(ChangeSet superclassOrder: (StackInterpreter withAllSubclasses
									remove: SchizophrenicClosureFormatStackInterpreter;
									yourself) asArray) do:
		[:sisc| | def |
		def := sisc definition.
		def := sisc == StackInterpreter
				ifTrue: [((def copyReplaceAll: sisc superclass name, ' ' with: ObjectMemory superclass name, ' ')
							copyReplaceAll: 'instanceVariableNames: ''' with: 'instanceVariableNames: ''objectMemory ')
							copyReplaceAll: 'poolDictionaries: ''' with: 'poolDictionaries: ''', (ObjectMemory poolDictionaryNames fold: [:a :b| a, ' ', b]), ' ']
				ifFalse: [def copyReplaceAll: sisc superclass name, ' ' with: sisc superclass name, 'S '].
		def := def copyReplaceAll: sisc name printString with: sisc name printString, 'S'.
		map at: sisc put: (Compiler evaluate: def)].

	map at: {StackInterpreter. #primitives}
		put: (Compiler
				evaluate: 'StackInterpreterS subclass: #StackInterpreterSPrimitives
							instanceVariableNames: ''''
							classVariableNames: ''''
							poolDictionaries: ''''
							category: ''VMMaker-Interpreter''');
		at: {CoInterpreter. #primitives}
		put: (Compiler
				evaluate: 'CoInterpreterS subclass: #CoInterpreterSPrimitives
						instanceVariableNames: ''''
						classVariableNames: ''''
						poolDictionaries: ''''
						category: ''VMMaker-Interpreter''');
		at: {StackInterpreter. #objmem}
		put: (Compiler
				evaluate: 'NewObjectMemory subclass: #NewObjectMemoryS
						instanceVariableNames: ''coInterpreter''
							classVariableNames: ''''
							poolDictionaries: ''''
							category: ''VMMaker-Interpreter''');
		at: {CoInterpreter. #objmem}
		put: (Compiler
				evaluate: 'NewObjectMemoryS subclass: #NewCoObjectMemoryS
						instanceVariableNames: ''''
						classVariableNames: ''''
						poolDictionaries: ''''
						category: ''VMMaker-Interpreter''').

	"reparent subclasses underneath StackInterpreterSPrimitives & CoInterpreterSPrimitives"
	#(StackInterpreterS CoInterpreterS) do:
		[:cn|
		((Smalltalk classNamed: cn) subclasses reject: [:c| c name endsWith: 'Primitives']) do:
			[:sisc| | def |
			def := sisc definition.
			def := def copyReplaceAll: cn, ' ' with: cn, 'Primitives '.
			Compiler evaluate: def]].
	^map! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 12/16/2016 16:02'!
defineSpurPigCompactor
	"Define SpurPigCompactor"
	"self defineSpurPigCompactor"
	| changes pigCompactor |
	pigCompactor := SpurMemoryManager superclass
						subclass: #SpurPigCompactor
						instanceVariableNames: 'manager scavenger coInterpreter firstFreeChunk lastFreeChunk numCompactionPasses'
						classVariableNames: 'CompactionPassesForGC CompactionPassesForSnapshot'
						poolDictionaries: 'SpurMemoryManagementConstants VMBasicConstants VMSpurObjectRepresentationConstants'
						category: SpurMemoryManager category.
	changes := CogScripts changedSpurCompactorMethods.
	changes do:
		[:mr|
		pigCompactor compile: mr source classified: (SpurMemoryManager whichCategoryIncludesSelector: mr selector)].
	changes do:
		[:mr|
		SpurMemoryManager removeSelector: mr selector].
	SpurMemoryManager organization removeEmptyCategories! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 2/5/2014 10:32'!
doClassSide
	"self doClassSide"
	| classes rules model env sortedChanges |
	classes := (PackageInfo named: 'VMMaker') classes.
	classes := classes select: [:c| classes anySatisfy: [:d| d name last = $S and: [d name allButLast = c name]]].

	rules := RBParseTreeRewriter new.
	model := RBNamespace new.
	env := RBBrowserEnvironment new forClasses: classes.
	classes do: [:c| rules replace: c name with: c name, 'S'].
	env classesAndSelectorsDo:
		[:class :selector| | tree |
		class isMeta ifTrue:
			[tree := class parseTreeFor: selector.
			rules executeTree: tree.
			model compile: rules tree newSource in: class classified: (class whichCategoryIncludesSelector: selector)]].
	false ifTrue: [model changes inspect].
	false ifTrue: "shortest change:"
		[(model changes changes inject: model changes changes first into: [:c1 :c2| c1 printString size < c2 printString size ifTrue: [c1] ifFalse: [c2]]) inspect].

	sortedChanges := model changes changes asSortedCollection:
						[:c1 :c2|
						c1 changeClass == c2 changeClass
							ifTrue: [c1 selector <= c2 selector]
							ifFalse: [c2 changeClass inheritsFrom: c1 changeClass]].
	true ifTrue:
		[MessageSetTextDifferencer
			openMessageList: (sortedChanges collect: [:mr| { MethodReference class: mr changeClass selector: mr selector. TextReference new text: mr source class: mr class selector: mr selector }])
			name: 'class side' 
			autoSelect: nil].

	sortedChanges do:
		[:mr|
		(Smalltalk classNamed: (mr changeClass theNonMetaClass name, 'S') asSymbol) class
			compile: mr source
			classified: (mr changeClass whichCategoryIncludesSelector: mr selector)
			withStamp: (mr source asString = (mr changeClass sourceCodeAt: mr selector) asString
							ifTrue: [(mr changeClass >> mr selector) timeStamp]
							ifFalse: [Utilities changeStamp copyReplaceAll: Utilities authorInitials with: Utilities authorInitials, ' (objmem refactor)'])
			notifying: nil]! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 6/8/2010 17:01'!
readOnlyVars
	^#(#checkForLeaks #fullGCLock #gcStartUsecs #memoryLimit #scavengeThreshold #youngStart
		#statCompMoveCount #statFullGCUsecs #statFullGCs #statGCEndUsecs #statGrowMemory #statIGCDeltaUsecs
		#statIncrGCUsecs #statIncrGCs #statMarkCount #statMkFwdCount #statRootTableCount #statRootTableOverflows
		#statShrinkMemory #statSpecialMarkCount #statSurvivorCount #statSweepCount #statTenures)! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 6/8/2010 17:06'!
readWriteVars
	^#(#specialObjectsOop
		#edenBytes #endOfMemory #forceTenureFlag #freeStart #needGCFlag
		#gcBiasToGrow #gcBiasToGrowGCLimit #gcBiasToGrowThreshold
		#growHeadroom #lastHash #lowSpaceThreshold #memory
		#remapBuffer #remapBufferCount #rootTable #rootTableCount
		#signalLowSpace #shrinkThreshold tenuringThreshold)! !

!CogScripts class methodsFor: 'documentation' stamp: 'eem 2/5/2014 10:17'!
refactoringPackages
	"to use the source editing facilities in the refactoring browser that this class uses load
		AST-Core
		AST-Semantic
		Refactoring-Core
		Refactoring-Environment
		Refactoring-Changes
	in that order from http://www.squeaksource.com/rb.  Relevant tests are
		AST-Tests-Core
		AST-Tests-Semantic
		Refactoring-Tests-Core
		Refactoring-Tests-Environment
		Refactoring-Tests-Changes"! !

!CogScripts methodsFor: 'look on class side' stamp: 'eem 6/13/2008 14:32'!
seeClassSide
	"All the code is on the class side"! !

Object subclass: #MultiProcessor
	instanceVariableNames: 'mutex processor guardedProcessorProtocol unguardedProcessorProtocol owner registerState coInterpreter threadIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Processors'!

!MultiProcessor class methodsFor: 'instance creation' stamp: 'eem 10/19/2010 14:52'!
for: aProcessorAlien coInterpreter: coInterpreter
	^self new
		processor: aProcessorAlien;
		coInterpreter: coInterpreter;
		yourself! !

!MultiProcessor methodsFor: 'initialize-release' stamp: 'eem 10/19/2010 14:32'!
coInterpreter: aCoInterpreter
	coInterpreter := aCoInterpreter! !

!MultiProcessor methodsFor: 'message forwarding' stamp: 'eem 10/20/2010 17:28'!
doesNotUnderstand: aMessage
	"Forward a message to the actual processor, managing a thread-switch if necessary.
	 Catch ProcessorSimulationTraps and raise them outside of the critical section to
	 avoid deadlock when reentering the VM from a trap and switching threads in the run-time."
	| selector result trap |
	selector := aMessage selector.
	(guardedProcessorProtocol includes: selector) ifFalse:
		[^(unguardedProcessorProtocol includes: selector)
			ifTrue: [processor perform: selector withArguments: aMessage arguments]
			ifFalse: [super doesNotUnderstand: aMessage]].
	result := [mutex critical:
				[owner ~~ mutex owningProcess ifTrue:
					[owner ifNotNil:
						[registerState at: owner put: processor registerState].
					 (registerState at: (owner := mutex owningProcess) ifAbsent: nil)
						ifNil: [coInterpreter initializeProcessorForThreadIndex: (threadIndex := threadIndex + 1)]
						ifNotNil: [:newState| processor setRegisterState: newState]].
				 processor perform: selector withArguments: aMessage arguments]]
					on: ProcessorSimulationTrap, Error
					do: [:ex| trap := ex].
	^trap ifNil: [result] ifNotNil: [trap signal]! !

!MultiProcessor methodsFor: 'initialize-release' stamp: 'eem 10/20/2010 12:42'!
initialize
	registerState := WeakIdentityKeyDictionary new.
	mutex := Mutex new.
	threadIndex := 0.
	guardedProcessorProtocol := unguardedProcessorProtocol := Set new! !

!MultiProcessor methodsFor: 'initialize-release' stamp: 'eem 9/3/2013 11:33'!
processor: aProcessor
	processor := aProcessor.
	guardedProcessorProtocol := aProcessor class selectors asSet
									addAll: aProcessor class superclass selectors;
									yourself.
	unguardedProcessorProtocol := #(#'Cog API' #opcodes #disassembly #printing)
										inject: Set new
										into: [ :protocol :category|
											protocol
												addAll: (aProcessor class organization listAtCategoryNamed: category);
												addAll: (aProcessor class superclass organization listAtCategoryNamed: category);
												yourself].
	guardedProcessorProtocol removeAll: unguardedProcessorProtocol! !

Object subclass: #SpurBootstrapMonticelloPackagePatcher
	instanceVariableNames: 'sourceDir destDir packagesAndPatches imageTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Bootstrapping'!

!SpurBootstrapMonticelloPackagePatcher commentStamp: 'eem 1/15/2014 17:59' prior: 0!
A SpurBootstrapMonticelloPackagePatcher is used to construct a new set of patched Monticello packages for Spur.  The use case is some bootstrap process loads a set of Monticello packages.  To repeat the bootstrap with a Spur image the bootstrap must use suitably patched Monticello packages containing the new method versions on the class side of SpurBootstrap.

Instance Variables
	destDir:			<FileDirectory>
	sourceDir:		<FileDirectory>

destDir
	- directory to which patched packages are to be written

sourceDir
	- directory from which packages to be patched are to be read!

!SpurBootstrapMonticelloPackagePatcher class methodsFor: 'baselines' stamp: 'eem 5/10/2014 11:36'!
squeak45baseline
	"The base Squeak-4.5-13680 package set."
	^#(	name 'base-Squeak45-eem'
		repository ('http://source.squeak.org/squeak45')
		dependency ('Squeak-Version' 'Squeak-Version-ar.4662' '6bfece28-65a4-b147-9462-417b2e86acd0')
		dependency ('311Deprecated' '311Deprecated-nice.2' '6df45c33-740a-fc4f-b3d0-45412ad7d284')
		dependency ('39Deprecated' '39Deprecated-ar.19' '8da20c38-7d28-3241-9f29-da261d6f9bfe')
		dependency ('45Deprecated' '45Deprecated-fbs.24' '4033c169-94c6-7741-9aee-5a7570a7ec7a')
		dependency ('Balloon' 'Balloon-nice.24' '97e2ed51-707d-4da1-ab4f-35add3deee5e')
		dependency ('Network' 'Network-nice.150' 'c844e5ea-c919-44fc-905e-69487b035947')
		dependency ('Compression' 'Compression-fbs.40' '82b0d6e4-0239-1241-968c-461a785fb6a7')
		dependency ('Graphics' 'Graphics-nice.289' 'e809bcbf-53e1-420b-846a-9e86e0dd1f06')
		dependency ('Multilingual' 'Multilingual-fbs.194' '07f4a7b5-7169-3345-85fc-5a8ba04e5323')
		dependency ('CollectionsTests' 'CollectionsTests-dtl.214' 'cf157d3a-2d71-46f3-86ce-450ee24e8d27')
		dependency ('PackageInfo-Base' 'PackageInfo-Base-nice.68' 'b6669527-9a35-4783-a64f-8f2af97e330b')
		dependency ('Compiler' 'Compiler-nice.279' '94b1b5f8-f71b-4425-b035-461d3dc94e3f')
		dependency ('Environments' 'Environments-ul.46' 'cfd9e7f7-6a4b-400e-b9c7-9c6239da4752')
		dependency ('Kernel' 'Kernel-dtl.836' '410e695f-7f23-43e4-9dc2-d292b9954f0d')
		dependency ('MonticelloConfigurations' 'MonticelloConfigurations-fbs.123' 'b9735d10-7cf4-a746-8a64-b50fa9cf273f')
		dependency ('Tools' 'Tools-cmm.519' 'dae6bdb9-8b54-491a-a2a4-0b114f02e10d')
		dependency ('MorphicExtras' 'MorphicExtras-tpr.147' 'e76a71a5-6be9-4420-b71a-2c92d900c476')
		dependency ('Files' 'Files-dtl.130' '8ee82071-69f7-446d-8ed7-77eafc838f03')
		dependency ('System' 'System-dtl.666' '098b856a-ecc5-498a-bceb-ef3457d3511e')
		dependency ('Collections' 'Collections-ul.564' '4b9a37ef-df86-40a0-a0dd-8e8b2c04d4ed')
		dependency ('Monticello' 'Monticello-cmm.586' 'a4dbd656-e50a-47ba-8661-44f8c87bb3e0')
		dependency ('EToys' 'EToys-cmm.117' 'c3e71dbe-17af-4b71-ad9c-c0bb2a2bc193')
		dependency ('Exceptions' 'Exceptions-cmm.49' '6cede9fe-b13d-481a-b8de-bb004ece1145')
		dependency ('FlexibleVocabularies' 'FlexibleVocabularies-bf.13' '55c72a72-619e-4a81-831f-303600bbd792')
		dependency ('GraphicsTests' 'GraphicsTests-fbs.38' '081189cc-a44f-fa4e-965e-25438280ea93')
		dependency ('Installer-Core' 'Installer-Core-cmm.392' '7cb5c040-6f68-479d-bc9e-0b264b172443')
		dependency ('KernelTests' 'KernelTests-nice.259' '0f7301b0-612c-49d8-936f-775995b35e0f')
		dependency ('GetText' 'GetText-nice.34' '4d432f8e-55be-428a-9138-63dd1738035e')
		dependency ('Sound' 'Sound-nice.38' 'b626daf0-be23-4fb8-b2d5-04b9cd370539')
		dependency ('ToolBuilder-Tests' 'ToolBuilder-Tests-cmm.1' 'e77685b9-ca09-40c0-b84e-6caee75f4075')
		dependency ('Morphic' 'Morphic-cmm.720' 'e5e81c18-990b-4e35-b325-adb032b8418d')
		dependency ('MorphicTests' 'MorphicTests-nice.24' 'e33a9ad3-2f39-4c19-a3a7-dc87f18177fc')
		dependency ('MorphicExtrasTests' 'MorphicExtrasTests-fbs.3' '1c039763-bc92-834c-943e-d96d8820cbd7')
		dependency ('MultilingualTests' 'MultilingualTests-fbs.18' '07e26018-8455-3349-9b44-9ecb4aaeefb2')
		dependency ('Nebraska' 'Nebraska-nice.36' 'cc80dca4-ed72-4c39-952c-3b37886100de')
		dependency ('NetworkTests' 'NetworkTests-fbs.37' '97699685-5826-fe47-af98-356971abf2fb')
		dependency ('PreferenceBrowser' 'PreferenceBrowser-fbs.49' '72d30dfa-0ff5-4347-9823-eb77ae236f8f')
		dependency ('Protocols' 'Protocols-nice.46' '15b63671-d541-4c1d-9ff5-72da4fc5bfe9')
		dependency ('SMBase' 'SMBase-nice.132' 'a70c8bd2-3eee-4e21-b9c6-113f6b194527')
		dependency ('SMLoader' 'SMLoader-fbs.79' '9f7d983e-d958-4115-94aa-21302f89ad8b')
		dependency ('ST80' 'ST80-cmm.172' '47b2f84a-6951-480b-88f2-b2726dba08bd')
		dependency ('ST80Tests' 'ST80Tests-nice.2' '7ee5426b-73f1-48ac-8ec4-3943dc452cb6')
		dependency ('ST80Tools' 'ST80Tools-fbs.1' '108ec7bc-d1f5-dd4b-9511-e7a653a71e9f')
		dependency ('SUnit' 'SUnit-fbs.99' 'a5be81dd-6e9f-8d41-a091-3c6c27a28abe')
		dependency ('SUnitGUI' 'SUnitGUI-fbs.59' '0bfcf308-0d02-a749-9930-6229492cca48')
		dependency ('ScriptLoader' 'ScriptLoader-cmm.338' 'adb79117-0915-40a5-a5ee-c766e4b50d42')
		dependency ('Services-Base' 'Services-Base-topa.51' '94328e86-1643-4090-8f18-bc4467119161')
		dependency ('SmallLand-ColorTheme' 'SmallLand-ColorTheme-fbs.6' 'a78b81e3-3b11-c24e-9c84-3bb5319e0858')
		dependency ('SystemChangeNotification-Tests' 'SystemChangeNotification-Tests-nice.23' '3eed6d26-4aef-4095-a604-d9f914240281')
		dependency ('Tests' 'Tests-cmm.290' 'f3fccfae-6baf-4093-ba62-e15ef110a687')
		dependency ('ToolBuilder-Kernel' 'ToolBuilder-Kernel-nice.60' '86949a07-725b-4a27-a7cd-a827c74f48be')
		dependency ('ToolBuilder-MVC' 'ToolBuilder-MVC-fbs.34' 'aded987d-5cd5-6f41-9635-1d38da947ddf')
		dependency ('ToolBuilder-Morphic' 'ToolBuilder-Morphic-fbs.91' 'abaa076b-af43-af42-8c98-7a71482c6a30')
		dependency ('ToolBuilder-SUnit' 'ToolBuilder-SUnit-fbs.19' '3e30756c-2af8-0741-836f-0d42a9d5af32')
		dependency ('ToolsTests' 'ToolsTests-cmm.68' '98c1608a-6cb3-4a03-a28a-dd101e6c876b')
		dependency ('MonticelloForTraits' 'MonticelloForTraits-fbs.1' '160be615-5ab7-4148-a7cb-60dd629ab085')
		dependency ('Traits' 'Traits-topa.302' '58712f55-3f3f-467e-ac0e-e118c9737c53')
		dependency ('TraitsTests' 'TraitsTests-fbs.13' '0429146f-6767-4a4f-8fce-37571625920a')
		dependency ('TrueType' 'TrueType-nice.28' '42a74f04-e193-455b-a2c1-14ec51724234')
		dependency ('Universes' 'Universes-nice.46' '805eb73f-391b-4e3f-aef9-64add79e4e8c')
		dependency ('VersionNumber' 'VersionNumber-cmm.4' '68fb1f05-d3e2-4c9b-9234-20a9bed166dc')
		dependency ('XML-Parser' 'XML-Parser-fbs.36' 'a2d9791a-c341-564b-9b57-a0fe9f42b66f')
		dependency ('ReleaseBuilder' 'ReleaseBuilder-cmm.114' 'ea773780-69e1-48dd-a16c-e167acb9de04')
		dependency ('ShoutCore' 'ShoutCore-cwp.40' '81b3e230-2e8a-42c5-9521-e54338fadb6f')
		dependency ('VersionNumberTests' 'VersionNumberTests-fbs.4' '953a944c-9648-dd4b-898e-9e10e0507b91')
		dependency ('HelpSystem-Core' 'HelpSystem-Core-ul.56' '6d8a0d54-5f60-da45-8c3c-d42ea8abd999')
		dependency ('HelpSystem-Tests' 'HelpSystem-Tests-fbs.15' '8927a848-29a0-f54c-8c79-efb8070c4702')
		dependency ('Help-Squeak-Project' 'Help-Squeak-Project-kfr.10' 'b86eb622-cc53-634d-aa65-aed2c86263f9')
		dependency ('Help-Squeak-TerseGuide' 'Help-Squeak-TerseGuide-dtl.2' '8b18cab9-7183-4c5e-8cac-f79c4400da43')
		dependency ('SystemReporter' 'SystemReporter-ul.21' '34c5c48c-e7cc-4dfe-8133-6dec3bc63ff7')
		dependency ('BalloonTests' 'BalloonTests-egp.2' 'a8206c39-12ee-4222-a29a-caa537e037c4')
		dependency ('CommandLine' 'CommandLine-fbs.2' '414e59b8-4f4a-814d-9dac-b7b9886e92a0')
		dependency ('UpdateStream' 'UpdateStream-nice.4' '5fcdedce-88aa-469a-bf8b-32820f051c4f')
		)! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 10/8/2014 17:56'!
cachedNonDiffyVersionNamed: versionName from: repo
	"Make sure that the cache contains a non-diffy version of versionName and  answer it."
	| cacheRepo nonDiffyVersion |
	self assert: (versionName endsWith: '.mcz').
	cacheRepo := MCCacheRepository default.
	"Make sure that at least the diffy (.mcd) version is present"
	(cacheRepo directory includesKey: versionName) ifFalse:
		[cacheRepo storeVersion: (repo versionNamed: versionName)].
	"if after storeVersion there's still no .mcz we need to create one; sigh..."
	(cacheRepo directory includesKey: versionName) ifFalse:
		[| baseName diffyVersionName diffyVersion file delete |
		 baseName := versionName allButLast: 4. "strip .mcz"
		 diffyVersionName := cacheRepo directory fileNames detect: [:fn| (fn endsWith: '.mcd') and: [(fn copyUpTo: $() = baseName]].
		 diffyVersion := cacheRepo versionNamed: diffyVersionName.
		 file := cacheRepo directory newFileNamed: versionName.
		 delete := false.
		 [file binary.
		  [MCMczWriter fileOut: diffyVersion on: file]
			on: Error
			do: [:ex|
				delete := true. "don't leave half-formed .mcz files around to screw things up later on..."
				ex pass]]
			ensure:
				[file close.
				 delete ifTrue:
					[cacheRepo directory deleteFileNamed: versionName]].
		 "now delete the damn diffy version that caused all the pain in the first place"
		 delete ifFalse:
			[cacheRepo directory deleteFileNamed: diffyVersionName].
		 cacheRepo flushCache; cacheAllFilenames].
	nonDiffyVersion := cacheRepo versionNamed: versionName.
	self assert: (nonDiffyVersion fileName endsWith: '.mcz').
	^nonDiffyVersion! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'private-accessing' stamp: 'eem 5/7/2015 10:01'!
classDefinitionFor: className type: typeSymbol from: definitions comment: commentString stamp: stampString
	| classDef |
	classDef := definitions
					detect: [:d| d isClassDefinition and: [d className = className]]
					ifNone:
						[self assert: (#(BoxedFloat64 SmallFloat64) includes: className).
						 MCClassDefinition new
							initializeWithName: className
							superclassName: #Float
							traitComposition: '{}'
							classTraitComposition: '{}'
							category: 'Kernel-Numbers'
							instVarNames: #()
							classVarNames: #()
							poolDictionaryNames: #()
							classInstVarNames: #()
							type: typeSymbol
							comment: commentString asString
							commentStamp: stampString].
	className == #Character ifTrue:
		[classDef variables removeAllSuchThat:
			[:varDef|
			 varDef isInstanceVariable and: [varDef name = 'value']]].
	classDef instVarNamed: 'type' put: typeSymbol.
	commentString ifNotNil:
		[classDef
			instVarNamed: 'comment' put: commentString;
			instVarNamed: 'commentStamp' put: stampString].
	^MCAddition of: classDef! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'private-accessing' stamp: 'eem 5/7/2015 10:01'!
compiledMethodClassDefinition
	^MCAddition of: 
		(MCClassDefinition new
			initializeWithName: #CompiledMethod
			superclassName: #ByteArray
			category: #'Kernel-Methods'
			instVarNames: #()
			classVarNames: #(LargeFrame PrimaryBytecodeSetEncoderClass SecondaryBytecodeSetEncoderClass SmallFrame)
			poolDictionaryNames: #()
			classInstVarNames: #()
			type: #compiledMethod
			comment:
'CompiledMethod instances are methods suitable for interpretation by the virtual machine.  Instances of CompiledMethod and its subclasses are the only objects in the system that have both indexable pointer fields and indexable 8-bit integer fields.  The first part of a CompiledMethod is pointers, the second part is bytes.  CompiledMethod inherits from ByteArray to avoid duplicating some of ByteArray''s methods, not because a CompiledMethod is-a ByteArray.

Class variables:
SmallFrame								- the number of stack slots in a small frame Context
LargeFrame							- the number of stack slots in a large frame Context
PrimaryBytecodeSetEncoderClass		- the encoder class that defines the primary instruction set
SecondaryBytecodeSetEncoderClass	- the encoder class that defines the secondary instruction set

The current format of a CompiledMethod is as follows:

	header (4 or 8 bytes, SmallInteger)
	literals (4 or 8 bytes each, Object, see "The last literal..." below)
	bytecodes  (variable, bytes)
	trailer (variable, bytes)

The header is a SmallInteger (which in the 32-bit system has 31 bits, and in the 64-bit system, 61 bits) in the following format:

	(index 0)		15 bits:	number of literals (#numLiterals)
	(index 15)		  1 bit:	is optimized - reserved for methods that have been optimized by Sista
	(index 16)		  1 bit:	has primitive
	(index 17)		  1 bit:	whether a large frame size is needed (#frameSize => either SmallFrame or LargeFrame)
	(index 18)		  6 bits:	number of temporary variables (#numTemps)
	(index 24)		  4 bits:	number of arguments to the method (#numArgs)
	(index 28)		  2 bits:	reserved for an access modifier (00-unused, 01-private, 10-protected, 11-public), although accessors for bit 29 exist (see #flag).
	sign bit:			  1 bit: selects the instruction set, >= 0 Primary, < 0 Secondary (#signFlag)

If the method has a primitive then the first bytecode of the method must be a callPrimitive: bytecode that encodes the primitive index.

The trailer is an encoding of an instance of CompiledMethodTrailer.  It is typically used to encode the index into the source files array of the method''s source, but may be used to encode other values, e.g. tempNames, source as a string, etc.  See the class CompiledMethodTrailer.

The last literal in a CompiledMethod must be its methodClassAssociation, a binding whose value is the class the method is installed in.  The methodClassAssociation is used to implement super sends.  If a method contains no super send then its methodClassAssociation may be nil (as would be the case for example of methods providing a pool of inst var accessors).  By convention the penultimate literal of a method is either its selector or an instance of AdditionalMethodState.  AdditionalMethodState holds any pragmas and properties of a method, but may also be used to add instance variables to a method, albeit ones held in the method''s AdditionalMethodState.  Subclasses of CompiledMethod that want to add state should subclass AdditionalMethodState to add the state they want, and implement methodPropertiesClass on the class side of the CompiledMethod subclass to answer the specialized subclass of AdditionalMethodState.'
			commentStamp: 'eem 1/22/2015 15:47')! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'initialization' stamp: 'eem 5/10/2014 13:46'!
directoryFrom: dirName
	^FileDirectory on: (dirName first = $/
							ifTrue: [dirName]
							ifFalse: [(FileDirectory default directoryNamed: dirName) fullName])! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'repository population' stamp: 'eem 5/11/2014 10:57'!
download: baseConfigurationOrArray "<MCConfiguration|Array>" from: repo
	| base |
	base := baseConfigurationOrArray isArray
				ifTrue: [MCConfiguration fromArray: baseConfigurationOrArray]
				ifFalse: [baseConfigurationOrArray].
	self packagesAndPatches keysAndValuesDo:
		[:package :patches| | dependency |
		dependency := base dependencies detect: [:dep| dep package name = package name].
		self downloadToSourceDirAllPackageVersionsStartingWith: dependency versionInfo
			from: repo].! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'repository population' stamp: 'eem 5/10/2014 14:33'!
downloadToSourceDirAllPackageVersionsStartingWith: aMCVersionInfo from: repo 
	| localRepo priorName |
	priorName := MCVersionName on: (aMCVersionInfo versionName
											copyReplaceAll: aMCVersionInfo versionNumber asString
											with: (aMCVersionInfo versionNumber - 1) asString).
	localRepo := MCDirectoryRepository directory: sourceDir.
	(repo possiblyNewerVersionsOfAnyOf: {priorName asMCVersionName}) do:
		[:newerVersion | 
		(localRepo includesVersionNamed: newerVersion) ifFalse:
			[localRepo storeVersion: (repo versionNamed: newerVersion)]]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'private-accessing' stamp: 'eem 5/7/2015 15:53'!
filesForPackage: package in: aDirectory
	"Names sorted from lowest version to highest"
	^((aDirectory fileNames
			select:
				[:fileName|
				(fileName beginsWith: package name)
				 and: [(fileName at: package name size + 1) isLetter not
				 and: [(fileName copyFrom: package name size + 2 to: package name size + 5) ~= 'spur']]]
			thenCollect: [:fn| {fn asMCVersionName versionNumber. fn}])
		sort: [:tuple :tupolev|
			tuple first < tupolev first
			or: [tuple first = tupolev first
				and: [tuple last < tupolev last]]])
		collect: [:tuple| tuple last]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'private-accessing' stamp: 'eem 11/26/2014 14:06'!
filteredDefinitionsAsPatches: modifiedDefinitions patches: existingPatches
	^modifiedDefinitions
		select:
			[:def|
			 existingPatches noneSatisfy:
				[:addition|
				def isMethodDefinition
				and: [addition definition isMethodDefinition
				and: [addition definition selector = def selector
				and: [addition definition className = def className
				and: [addition definition classIsMeta = def classIsMeta]]]]]]
		thenCollect:
			[:def|
			 ((def source includesSubString: 'DELETEME')
				ifTrue: [MCRemoval]
				ifFalse: [MCAddition]) of: def]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'configurations' stamp: 'eem 10/15/2014 18:43'!
findOldestConfigurationFor: packageVersions inVersionNames: configurationVersionNames repository: repo
	| oldest |
	oldest := configurationVersionNames first.
	configurationVersionNames do:
		[:cfgver| | config |
		config := repo versionNamed: cfgver.
		(packageVersions noneSatisfy:
			[:pkgver| | configVersion |
			configVersion := config dependencies detect:
								[:dep|
								 pkgver packageName = dep package name].
			configVersion versionInfo versionNumber >= pkgver versionNumber]) ifTrue:
				[^oldest].
		oldest := cfgver].
	self error: 'couldn''t find configuration newer than supplied versions'! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'initialization' stamp: 'eem 5/10/2014 13:45'!
from: sourceDirName to: destDirName
	sourceDir := self directoryFrom: sourceDirName.
	destDir := self directoryFrom: destDirName! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'initialization' stamp: 'eem 8/10/2014 16:27'!
imageTypes: typeArray
	imageTypes := typeArray! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'private-accessing' stamp: 'eem 3/3/2014 18:50'!
modifiedCharacterDefinitionsIn: definitions
	| rewriter |
	rewriter := RBParseTreeRewriter new.
	rewriter
		replace: 'value' with: 'self asInteger';
		replace: 'value := ``@args' with: 'DELETEME'.
	^(((definitions select: [:d| d isMethodDefinition and: [d fullClassName = #Character]])
		collect: [:d| { d. self patchDefinition: d withRewriter: rewriter} ]
		thenSelect: [:pair| pair first source ~= pair second source])
			collect: [:pair| pair second])! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'private-accessing' stamp: 'eem 5/7/2015 10:02'!
modifiedFloatDefinitionsIn: definitions
	"Delete the non-accessing primitives in Float (prims 41 through 59),
	 and copy them to BoxedFloat64,
	 and create corresponding ones in SmallFloat64 with primtiive numbers + 500."
	| floatPrims |
	floatPrims := definitions select:
					[:d| | index |
					d isMethodDefinition
					and: [d fullClassName = #Float
					and: [(index := d source indexOfSubCollection: '<primitive: ') > 0
					and: [(Integer readFrom: (ReadStream on: d source from: index + '<primitive: ' size to: index + '<primitive: ' size + 4))
							between: 41
							and: 59]]]].
	^(floatPrims collect:
		[:d|
		 MCMethodDefinition new
			initializeWithClassName: d className
			classIsMeta: false
			selector: d selector
			category: d category
			timeStamp: d timeStamp
			source: d source, 'DELETEME']),
	 (floatPrims collect:
		[:d|
		 MCMethodDefinition new
			initializeWithClassName: #BoxedFloat64
			classIsMeta: false
			selector: d selector
			category: d category
			timeStamp: d timeStamp
			source: d source]),
	 (floatPrims collect:
		[:d|
		 MCMethodDefinition new
			initializeWithClassName: #SmallFloat64
			classIsMeta: false
			selector: d selector
			category: d category
			timeStamp: 'eem 11/25/2014 07:54'
			source: (d source copyReplaceAll: '<primitive: ' with: '<primitive: 5')])! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'accessing' stamp: 'eem 11/27/2014 11:35'!
packageForMissingClassNamed: className
	(className = #BoxedFloat64
	 or: [className = #SmallFloat64]) ifTrue:
		[^PackageInfo named: 'Kernel'].
	self error: 'unknown missing class'! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'private-accessing' stamp: 'eem 10/16/2014 04:37'!
packages
	"Answer the packages Spur modifies."
	^self packagesAndPatches keys! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'private-accessing' stamp: 'eem 5/29/2015 16:47'!
packagesAndPatches
	"SpurBootstrapMonticelloPackagePatcher new packagesAndPatches"
	| spurBootstrap |
	packagesAndPatches ifNotNil:
		[^packagesAndPatches].
	packagesAndPatches := Dictionary new.
	spurBootstrap := SpurBootstrap new.
	imageTypes ifNotNil:
		[spurBootstrap imageTypes: imageTypes].
	spurBootstrap prototypeClassNameMetaSelectorMethodDo:
		[:className :isMeta :selector :method| | package category source definition |
		 (Smalltalk classNamed: className)
			ifNil: [package := self packageForMissingClassNamed: className]
			ifNotNil:
				[:behavior| | class methodReference |
				 class := isMeta ifTrue: [behavior class] ifFalse: [behavior].
				 (class includesSelector: selector) ifTrue:
					[methodReference := (class >> selector) methodReference.
					 category := methodReference category.
					 category first = $* ifTrue:
						[category := nil]].
				 package := (methodReference isNil
							  or: [methodReference category = Categorizer default
							  or: [methodReference category first = $*]]) "This for Scorch's override of InstructionClient>>classPrimitive:"
								ifTrue: [PackageOrganizer default packageOfClass: class]
								ifFalse: [PackageOrganizer default packageOfMethod: methodReference]].
		 source := method getSourceFromFile asString allButFirst: method selector size - selector size.
		 source first ~= selector first ifTrue:
			[source replaceFrom: 1 to: selector size with: selector startingAt: 1].
		 definition := MCAddition of: (MCMethodDefinition new
										initializeWithClassName: className
										classIsMeta: isMeta
										selector: selector
										category: (category ifNil: [SpurBootstrap
																	categoryForClass: className
																	meta: isMeta
																	selector: selector])
										timeStamp: method timeStamp
										source: source).
		 (method pragmaAt: #remove) ifNotNil:
			[definition := definition inverse].
		 (packagesAndPatches at: package ifAbsentPut: [OrderedCollection new])
			add: definition].
	^packagesAndPatches! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 11/27/2014 10:55'!
patch
	"(SpurBootstrapMonticelloPackagePatcher new
			from: 'trunkpackages'
			to: 'spurpackages')
		patch"
	"(SpurBootstrapMonticelloPackagePatcher new
			from: '/Users/eliot/Squeak/Squeak4.5-spur/squeakv3-package-cache'
			to: '/Users/eliot/Squeak/Squeak4.5-spur/package-cache')
		patch"
	"(SpurBootstrapMonticelloPackagePatcher new
			from: '/Users/eliot/Glue/repositories/nsboot/Squeak4.3/squeak-package-cache'
			to: '/Users/eliot/Glue/repositories/nsboot/Squeak4.3/package-cache')
		patch"
	
	sourceDir exists ifFalse:
		[self error: 'source directory doest not exist'].
	destDir assureExistence.
	self packagesAndPatches keysAndValuesDo:
		[:package :patches|
		 (self filesForPackage: package in: sourceDir) do:
			[:packageFile|
			 self patchPackage: packageFile with: patches for: package]]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 5/7/2015 16:29'!
patchAndUploadAllInTrunk
	"Look for all versions in the default repository that have patched versions there-in.
	 Download and patch them and upload the patched versions (overwriting the older ones)."
	"(SpurBootstrapMonticelloPackagePatcher new
		from: 'trunkpackages'
		to: 'spurpackages')
			patchAndUploadAllInTrunk"
	| seed trunk sourceRepo cacheRepo |
	seed := 'Are you really sure you want to do this?\It should happen only once!!' withCRs.
	3 timesRepeat:
		[(UIManager confirm: seed) ifFalse: [^self].
		 seed := seed copyReplaceAll: 'really ' with: 'really, really '].
	sourceDir assureExistence; deleteLocalFiles.
	destDir assureExistence; deleteLocalFiles.
	sourceRepo := MCDirectoryRepository directory: sourceDir.
	cacheRepo := MCCacheRepository default.
	(trunk := self trunk) cacheAllFileNamesDuring:
		[| latestBranches latestUnbranched |
		latestBranches := self packages collect:
							[:package|
							(trunk versionNamesForPackageNamed: package name, '.spur') detectMin: [:vn | vn asMCVersionName versionNumber]].
		latestUnbranched := latestBranches collect:
								[:verName|
								(trunk versionNamed: (verName copyReplaceAll: '.spur' with: '') asMCVersionName) info ancestors first versionName].
		((trunk possiblyNewerVersionsOfAnyOf: latestUnbranched)
			reject: [:unpatched| unpatched includesSubString: '.spur'])
			do: [:unpatched|
				"it is claimed that whether a repository contains a .mcz or a .mcd is irrelevant.  At least for the cache repository that's not true."
				sourceRepo storeVersion: (self cachedNonDiffyVersionNamed: unpatched from: trunk)].
		 self patchAsNeeded.
		 self uploadFrom: (MCDirectoryRepository directory: destDir) to: trunk]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 5/12/2015 14:58'!
patchAndUploadNewer
	"Look for unbranched versions on the default repository that are newer than the
	 image''s versions. Download and patch them and upload the patched versions."
	"(SpurBootstrapMonticelloPackagePatcher new
		from: 'trunkpackages'
		to: 'spurpackages')
			patchAndUploadNewer"
	| repo sourceRepo |
	sourceDir deleteLocalFiles.
	destDir deleteLocalFiles.
	repo := self repositoryForUrl: MCMcmUpdater defaultUpdateURL.
	sourceRepo := MCDirectoryRepository directory: sourceDir.
	repo cacheAllFileNamesDuring:
		[self packages do:
			[:package| | workingCopy |
			workingCopy := MCWorkingCopy allManagers detect: [:pkg| pkg packageName = package packageName].
			(workingCopy possiblyNewerVersionsIn: repo) do:
				[:newerVersion|
				 newerVersion packageAndBranchName = package packageName ifTrue: "Don't patch already patched packages!!!!"
					[(sourceRepo includesVersionNamed: newerVersion) ifFalse:
						[sourceRepo storeVersion: (repo versionNamed: newerVersion)]]]].
		 self patchAsNeeded.
		 self uploadFrom: (MCDirectoryRepository directory: destDir) to: repo]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 5/12/2015 14:58'!
patchAndUploadUnpatchedInTrunk
	"Look for unbranched versions in the default repository that are newer than the
	 latest patched versions there-in. Download and patch them and upload the patched
	 versions."
	"(SpurBootstrapMonticelloPackagePatcher new
		from: 'trunkpackages'
		to: 'spurpackages')
			patchAndUploadUnpatchedInTrunk"
	| trunk sourceRepo cacheRepo |
	sourceDir assureExistence; deleteLocalFiles.
	destDir assureExistence; deleteLocalFiles.
	sourceRepo := MCDirectoryRepository directory: sourceDir.
	cacheRepo := MCCacheRepository default.
	(trunk := self trunk) cacheAllFileNamesDuring:
		[| latestBranches latestUnbranched |
		latestBranches := self packages collect:
							[:package|
							(trunk versionNamesForPackageNamed: package name, '.spur') detectMax: [:vn | vn asMCVersionName versionNumber]]
							thenSelect: [:branch| branch notNil].
		latestUnbranched := latestBranches collect: [:verName| (verName copyReplaceAll: '.spur' with: '') asMCVersionName].
		((trunk possiblyNewerVersionsOfAnyOf: latestUnbranched)
			reject: [:unpatched| unpatched includesSubString: '.spur'])
			do: [:unpatched|
				"it is claimed that whether a repository contains a .mcz or a .mcd is irrelevant.  At least for the cache repositoriy that's not true."
				sourceRepo storeVersion: (self cachedNonDiffyVersionNamed: unpatched from: trunk)].
		 self patchAsNeeded.
		 self uploadFrom: (MCDirectoryRepository directory: destDir) to: trunk]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 5/12/2015 14:56'!
patchAsNeeded
	(sourceDir exists and: [destDir exists]) ifFalse:
		[self error: 'one or both of the directories don''t exist'].
	self packagesAndPatches keysAndValuesDo:
		[:package :patches|
		 (self filesForPackage: package in: sourceDir) do:
			[:packageFile| | spurPackageFile |
			 spurPackageFile := self spurBranchNameForInfo: packageFile package: package.
			 ((destDir includesKey: packageFile) or: [destDir includesKey: spurPackageFile])
				ifTrue:
					[Transcript
						cr; nextPutAll: destDir fullName; nextPutAll: ' contains either ';
						nextPutAll: packageFile; nextPutAll: ' or '; nextPutAll: spurPackageFile;
						nextPutAll: '; not saving'; flush]
				ifFalse:
					[self patchPackage: packageFile with: patches for: package]]]

	"| patcher |
	 patcher := SpurBootstrapMonticelloPackagePatcher new
					from: 'trunkpackages'
					to: 'spurpackages'.
	patcher trunk cacheAllFileNamesDuring:
		[patcher patchAsNeeded]"! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 5/7/2015 09:58'!
patchDefinition: aMCMethodDefinition withRewriter: aRBParseTreeRewriter 
	| parseTree |
	parseTree := RBParser
					parseMethod: aMCMethodDefinition source
					onError: [:str :pos | self halt].
	aRBParseTreeRewriter executeTree: parseTree.
	^MCMethodDefinition new
		initializeWithClassName: aMCMethodDefinition className
		classIsMeta:aMCMethodDefinition classIsMeta
		selector: aMCMethodDefinition selector
		category: aMCMethodDefinition category
		timeStamp: aMCMethodDefinition timeStamp
		source: aRBParseTreeRewriter tree newSource! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 7/17/2014 12:44'!
patchFile: packageFile
	"(SpurBootstrapMonticelloPackagePatcher new
			from: '/Users/eliot/oscogvm/image/package-cache'
			to: '/Users/eliot/oscogvm/image/spurpackages')
		patchFile: 'Collections-ul.573(nice.572).mcd'"
	
	sourceDir exists ifFalse:
		[self error: 'source directory doest not exist'].
	destDir assureExistence.
	self packagesAndPatches keysAndValuesDo:
		[:package :patches|
		 ((packageFile beginsWith: package name)
		  and: [(packageFile at: package name size + 1) isLetter not]) ifTrue:
			[self patchPackage: packageFile with: patches for: package]]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 10/9/2014 10:06'!
patchPackage: packageFileName with: patches for: package
	| version newVersion |
	version := self versionFor: packageFileName in: sourceDir.
	newVersion := self version: version withPatches: patches for: package.
	self storeVersion: newVersion! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 5/12/2015 14:37'!
patches: basePatches forSnapshot: snapshot
	"Add modified class defs for Character, SmallInteger, Float, BoxedFloat64, SmallFloat64 and COmpiledMethod.
	 Remove ObjectHistory and ObjectHistoryMark (which Spur does not support)."
	| patches defs |
	patches  := basePatches copy.
	defs := snapshot definitions.
	(defs anySatisfy: [:d| d isClassDefinition and: [d className == #Character]]) ifTrue:
		[patches
			addAll: (self filteredDefinitionsAsPatches: (self modifiedCharacterDefinitionsIn: snapshot definitions)
						patches: patches);
			add: (self
					classDefinitionFor: #Character
					type: #immediate
					from: snapshot definitions
					comment: 'I represent a character by storing its associated Unicode as an unsigned 30-bit value.  Characters are created uniquely, so that all instances of a particular Unicode are identical.  My instances are encoded in tagged pointers in the VM, so called immediates, and therefore are pure immutable values.

	The code point is based on Unicode.  Since Unicode is 21-bit wide character set, we have several bits available for other information.  As the Unicode Standard  states, a Unicode code point doesn''t carry the language information.  This is going to be a problem with the languages so called CJK (Chinese, Japanese, Korean.  Or often CJKV including Vietnamese).  Since the characters of those languages are unified and given the same code point, it is impossible to display a bare Unicode code point in an inspector or such tools.  To utilize the extra available bits, we use them for identifying the languages.  Since the old implementation uses the bits to identify the character encoding, the bits are sometimes called "encoding tag" or neutrally "leading char", but the bits rigidly denotes the concept of languages.

	The other languages can have the language tag if you like.  This will help to break the large default font (font set) into separately loadable chunk of fonts.  However, it is open to the each native speakers and writers to decide how to define the character equality, since the same Unicode code point may have different language tag thus simple #= comparison may return false.'
					stamp: 'eem 8/12/2014 14:53')].
	(defs anySatisfy: [:def| def isClassDefinition and: [def className == #SmallInteger]]) ifTrue:
		[patches
			add: (self
					classDefinitionFor: #SmallInteger
					type: #immediate
					from: snapshot definitions
					comment: 'My instances are at least 31-bit numbers, stored in twos complement form. The allowable range in 32-bits is approximately +- 10^9 (+- 1billion).  In 64-bits my instances are 61-bit numbers, stored in twos complement form. The allowable range is approximately +- 10^18 (+- 1 quintillion).   The actual values are computed at start-up.  See SmallInteger class startUp:, minVal, maxVal.'
					stamp: 'eem 11/20/2014 08:41')].
	(defs anySatisfy: [:def| def isClassDefinition and: [def className == #Float]]) ifTrue:
		[patches
			add: (self
					classDefinitionFor: #Float
					type: #normal
					from: snapshot definitions
					comment: nil
					stamp: nil);
			add: (self
					classDefinitionFor: #BoxedFloat64
					type: #words
					from: snapshot definitions
					comment: 'My instances hold 64-bit Floats in heap objects.  This is the only representation on 32-bit systems.  But on 64-bit systems SmallFloat64 holds a subset of the full 64-bit double-precision range in immediate objects.'
					stamp: 'eem 11/25/2014 07:54');
			add: (self
					classDefinitionFor: #SmallFloat64
					type: #immediate
					from: snapshot definitions
					comment: 'My instances represent 64-bit Floats whose exponent fits in 8 bits as immediate objects.  This representation is only available on 64-bit systems, not 32-bit systems.'
					stamp: 'eem 11/25/2014 07:54');
			addAll: (self filteredDefinitionsAsPatches: (self modifiedFloatDefinitionsIn: snapshot definitions)
						patches: patches)].
	(defs anySatisfy: [:def| def isClassDefinition and: [def className == #CompiledMethod]]) ifTrue:
		[patches
			add: self compiledMethodClassDefinition].
	(defs anySatisfy: [:def| def isClassDefinition and: [def className == #ObjectHistory]]) ifTrue:
		[patches addAll:
			(defs
				select: [:def| #(ObjectHistory ObjectHistoryMark) includes: def className]
				thenCollect: [:def| MCRemoval of: def])].
	^MCPatch operations: patches! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'repository population' stamp: 'eem 7/20/2014 07:57'!
repositoryForUrl: url
	^MCRepositoryGroup default repositories 
		detect: [:r| r description = url]
		ifNone: [MCHttpRepository
					location: url
					user: 'squeak'
					password: 'squeak']! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 5/12/2015 14:55'!
spurBranchNameForInfo: versionInfoOrString package: package
	^(versionInfoOrString isString
		ifTrue: [versionInfoOrString]
		ifFalse: [versionInfoOrString name]) copyReplaceAll: package name with: package name, '.spur'! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'configurations' stamp: 'eem 2/3/2015 12:59'!
spurConfigurationOf: anMCConfiguration forRepository: repo
	"Answer a copy of anMCConfiguration containing the matching Spur dependencies.
	 If no replacements could be made (because no Spur versions exist) then answer nil."
	| found clone |
	found := false.
	clone := Array streamContents:
				[:s|
				s nextPut: #name; nextPut: (anMCConfiguration name copyReplaceAll: 'update-' with: 'update.spur-');
				 "no location accessor!!!!"
				  nextPut: #repository; nextPut: {anMCConfiguration repositories first locationWithTrailingSlash allButLast}.
				 anMCConfiguration dependencies do:
					[:dep| | info pkg ver spurVersionName |
					 info := dep versionInfo.
					 ((pkg := self packages
								detect: [:package| package name = dep package name]
								ifNone: []) notNil
					  and: [spurVersionName := (info name
													copyReplaceAll: pkg name
													with: pkg name, '.spur'), '.mcz'.
						 (ver := MCCacheRepository default versionNamed: spurVersionName asMCVersionName) ifNil:
							[ver := repo versionNamed: spurVersionName asMCVersionName].
						 ver notNil])
						ifTrue: [found := true. info := ver info].
					(ver isNil and: [spurVersionName notNil]) ifTrue:
						[Transcript nextPutAll: 'failed to get ', spurVersionName, ' in ', anMCConfiguration name; cr; flush.
						 self error: 'failed to get ', spurVersionName, ' in ', anMCConfiguration name].
					s nextPut: #dependency; nextPut: (MCConfiguration dependencyToArray: (MCVersionDependency package: dep package info: info))]].
	^found ifTrue:
		[MCConfiguration fromArray: clone]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 1/15/2014 17:51'!
storeVersion: newVersion
	[(MCDirectoryRepository new directory: destDir) storeVersion: newVersion]
		on: FileExistsException
		do: [:ex| ex resume: (ex fileClass forceNewFileNamed: ex fileName)]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'repository population' stamp: 'eem 7/20/2014 07:57'!
trunk
	^self repositoryForUrl: 'http://source.squeak.org/trunk'! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'repository population' stamp: 'eem 5/11/2014 10:54'!
uploadFrom: localRepo to: uploadRepository
	localRepo allVersionsDo:
		[:version|
		(uploadRepository includesVersionNamed: version info name) ifFalse:
			[uploadRepository storeVersion: version]]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'configurations' stamp: 'eem 10/16/2014 13:21'!
uploadNewerSpurConfigurationsInTrunk
	"Make sure that update.spur configurations exist for all relevant update.* configurations."
	"SpurBootstrapMonticelloPackagePatcher new uploadNewerSpurConfigurationsInTrunk"
	| trunk |
	trunk := self trunk.
	trunk cacheAllFileNamesDuring:
		[| configurations spurConfigurations oldestUpdate |
		 spurConfigurations := (trunk versionNamesForPackageNamed: 'update.spur') sort: [:a :b| a versionNumber > b versionNumber].
		 configurations := ((trunk versionNamesForPackageNamed: 'update') select: [:n| n beginsWith: 'update-']) sort: [:a :b| a versionNumber > b versionNumber].
		 oldestUpdate := spurConfigurations isEmpty
							ifTrue:
								[| earliestBranches earliestUnbranched  |
								 earliestBranches := self packages collect:
														[:package|
														(trunk versionNamesForPackageNamed: package name, '.spur') detectMin:
															[:vn | vn asMCVersionName versionNumber]].
								 earliestUnbranched := earliestBranches collect:
															[:verName| (verName copyReplaceAll: '.spur' with: '') asMCVersionName].
								 self
									findOldestConfigurationFor: earliestUnbranched
									inVersionNames: configurations
									repository: trunk]
							ifFalse:
								[spurConfigurations first copyReplaceAll: '.spur' with: ''].
		 Transcript nextPutAll: 'Oldest: ', oldestUpdate; cr; flush.
		 (configurations copyFrom: 1 to: (configurations indexOf: oldestUpdate) - 1) reverseDo:
			[:configName|
			 "((configName beginsWith: 'update-eem.29') and: ['34' includes: (configName at: 14)]) ifTrue:
				[self halt]."
			 (self spurConfigurationOf: (trunk versionNamed: configName) forRepository: trunk) ifNotNil:
				[:edition| trunk storeVersion: edition]]]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 1/29/2015 11:20'!
version: version withPatches: patches for: package
	| snapshot ancestry possibleSpurAncestor actualAncestor |
	snapshot := MCPatcher
					apply: (self patches: patches forSnapshot: version snapshot)
					to: version snapshot.
	ancestry := MCWorkingAncestry new addAncestor: version info.
	"this is a hack; we may not be patching w.r.t. a directory or trunk"
	possibleSpurAncestor := (self spurBranchNameForInfo: version info ancestors first package: package) , '.mcz'.
	(destDir includesKey: possibleSpurAncestor)
		ifTrue:
			[actualAncestor := self versionFor: possibleSpurAncestor in: destDir]
		ifFalse:
			[((self trunk versionNamesForPackageNamed: package name) includes: possibleSpurAncestor) ifTrue:
				[actualAncestor := self trunk versionNamed: possibleSpurAncestor]].
	actualAncestor ifNotNil:
		[ancestry addAncestor: actualAncestor info].
	^MCVersion
		package: version package
		info: (ancestry
				infoWithName: (self spurBranchNameForInfo: version info package: package)
				message:	version info name,
							' patched for Spur by ',
							(CCodeGenerator shortMonticelloDescriptionForClass: self class),
							'\\' withCRs,
							version info message)
		snapshot: snapshot
		dependencies: {} "punt on computing dependencies; there are't any so far"! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 10/9/2014 09:36'!
versionFor: packageFileName in: directory
	^directory
		readOnlyFileNamed: packageFileName
		do: [:fs|
			((MCVersionReader readerClassForFileNamed: fs fullName)
				on: fs fileName: fs fullName)
					version]! !

Object subclass: #SpurBootstrapNewspeakFilePatcher
	instanceVariableNames: 'source substitutions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Bootstrapping'!

!SpurBootstrapNewspeakFilePatcher methodsFor: 'patching' stamp: 'eem 2/26/2014 07:24'!
editTo: dest "<FileStream>"
	source reopen.
	[substitutions do:
		[:tuple|
		 [:start :end :substitution|
		  [source position + 1 < start] whileTrue:
			[dest nextPut: source next].
		   dest nextPutAll: (substitution
							copyReplaceAll: (String with: Character cr)
							with: (String with: Character lf)).
		   source skip: end - start + 1] valueWithArguments: tuple].
	 dest nextPutAll: source upToEnd]
		ensure: [source close]! !

!SpurBootstrapNewspeakFilePatcher methodsFor: 'parsing' stamp: 'eem 2/25/2014 10:27'!
findClassDeclarationFor: className in: ast "<ClassDeclarationAST>" "^(ClassDeclarationAST|nil)"
	^ast instanceSide nestedClasses
		detect: [:classDecl| classDecl name = className]
		ifNone: []! !

!SpurBootstrapNewspeakFilePatcher methodsFor: 'parsing' stamp: 'eem 2/25/2014 16:35'!
findMethodDeclarationFor: selector "<Symbol>" in: ast "<ClassDeclarationAST>" "^(MethodAST|nil)"
	ast instanceSide categories do:
		[:categoryAST|
		 categoryAST methods do:
			[:methodAST|
			methodAST pattern selector = selector ifTrue:
				[^methodAST]]].
	^nil! !

!SpurBootstrapNewspeakFilePatcher methodsFor: 'initialize-release' stamp: 'eem 2/25/2014 16:48'!
initialize
	substitutions := SortedCollection sortBlock: [:tupleA :tupleB | tupleA first <= tupleB first]! !

!SpurBootstrapNewspeakFilePatcher methodsFor: 'patching' stamp: 'eem 2/28/2014 14:19'!
newspeakSourceFor: method "<CompiledMethod>" selector: selector "<Symbol>"
	| source startIndex nextIndex |
	source := method getSourceFromFile asString allButFirst: method selector size - selector size.
	source first ~= selector first ifTrue:
		[source replaceFrom: 1 to: selector size with: selector startingAt: 1].

	"map comments to Newspeak format..."
	startIndex := 1.
	[(startIndex := source indexOf: $" startingAt: startIndex) > 0] whileTrue:
		[nextIndex := source indexOf: $" startingAt: startIndex + 1.
		 nextIndex < startIndex ifTrue:
			[self error: 'matching close comment not found'].
		 source := source copyReplaceFrom: nextIndex to: nextIndex with: ' *)'.
		 source := source copyReplaceFrom: startIndex to: startIndex with: '(* '.
		 startIndex := nextIndex + 5].

	"map assignments to Newspeak format"
	startIndex := 1.
	[(startIndex := source indexOfSubCollection: ':=' startingAt: startIndex) > 0] whileTrue:
		[nextIndex := startIndex.
		 [(source at: nextIndex - 1) isSeparator] whileTrue:
			[nextIndex := nextIndex - 1].
		 source := source copyReplaceFrom: nextIndex to: startIndex + 1 with: '::'.
		 startIndex := nextIndex + 1].

	"add the horror-show parentheses"
	startIndex := source indexOf: Character cr.
	source := source copyReplaceFrom: startIndex to: startIndex - 1 with: ' = ('.
	source := source, (String with: Character cr with: $) ).
	^source! !

!SpurBootstrapNewspeakFilePatcher methodsFor: 'parsing' stamp: 'eem 2/26/2014 07:23'!
parse
	| platform |
	platform := BlackMarket platform.
	^[(NewspeakParsing
			usingPlatform: platform
			grammar: (NewspeakGrammar parserLib: (CombinatorialParsing usingPlatform: platform))
			asts: (NewspeakASTs usingLib: platform)) Parser new compilationUnit parse: source]
		ensure: [source close]! !

!SpurBootstrapNewspeakFilePatcher methodsFor: 'patching' stamp: 'eem 2/25/2014 16:56'!
patch: className inDirectory: dir
	"SpurBootstrapNewspeakFilePatcher new
		patch: 'KernelForSqueak'
		inDirectory: '../newspeak'"
	| directory |
	directory := FileDirectory default directoryNamed: dir.
	source := directory oldFileNamed: className, '.ns3'.
	self substitute: self parse.
	self editTo: (directory forceNewFileNamed: className, '.ns3.patched')! !

!SpurBootstrapNewspeakFilePatcher methodsFor: 'patching' stamp: 'eem 2/25/2014 16:56'!
substitute: ast "<ClassDeclarationAST>"
															
	SpurBootstrap new prototypeClassNameMetaSelectorMethodDo:
		[:className :isMeta :selector :method| | source |
		 method primitive = 0 ifTrue: "all primitives are in the VMMirror package"
		 	[(self findClassDeclarationFor: className in: ast) ifNotNil:
				[:classDecl|
				 (self findMethodDeclarationFor: selector in: classDecl) ifNotNil:
					[:methodDecl|
					 source := self newspeakSourceFor: method selector: selector.
					 substitutions add: {methodDecl start. methodDecl end. source}]]]]! !

Object subclass: #SpurBootstrapPrototypes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Bootstrapping'!

SpurBootstrapPrototypes subclass: #SpurBootstrapPharoPrototypes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Bootstrapping'!

!SpurBootstrapPharoPrototypes class methodsFor: 'accessing' stamp: 'EstebanLorenzano 8/27/2014 15:13'!
imageType
	^ 'pharo'! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'eem 7/8/2014 16:47'!
BehaviorPROTOTYPEbasicIdentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	 Behavior implements identityHash to allow the VM to use an object representation which
	 does not include a direct reference to an object's class in an object.  If the VM is using
	 this implementation then classes are held in a class table and instances contain the index
	 of their class in the table.  A class's class table index is its identityHash so that an instance
	 can be created without searching the table for a class's index.  The VM uses this primitive
	 to enter the class into the class table, assigning its identityHash with an as yet unused
	 class table index. If this primitive fails it means that the class table is full.  In Spur as of
	 2014 there are 22 bits of classTable index and 22 bits of identityHash per object.

	 Primitive. Essential. Do not override. See Object documentation whatIsAPrimitive."

	<primitive: 175>
	self primitiveFailed! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'eem 7/8/2014 12:24'!
BehaviorPROTOTYPElargeIdentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	 Behavior implements identityHash to allow the VM to use an object representation which
	 does not include a direct reference to an object's class in an object.  If the VM is using
	 this implementation then classes are held in a class table and instances contain the index
	 of their class in the table.  A class's class table index is its identityHash so that an instance
	 can be created without searching the table for a class's index.  The VM uses this primitive
	 to enter the class into the class table, assigning its identityHash with an as yet unused
	 class table index. If this primitive fails it means that the class table is full.  In Spur as of
	 2014 there are 22 bits of classTable index and 22 bits of identityHash per object."

	<primitive: 175>
	self primitiveFailed! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/7/2014 14:11'!
BlockClosurePHAROPROTOTYPEsimulateValueWithArguments: anArray caller: aContext
	<indirect>! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 10/31/2014 16:21'!
CharacterPROTOTYPEcodePoint
	"Just for ANSI Compliance"	
	^self asciiValue! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 6/16/2014 18:24'!
CharacterPROTOTYPEsetValue: newValue
	self error: 'Characters are immutable'! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 8/27/2014 14:38'!
CharacterPROTOTYPEshallowCopy
	"Answer the receiver, because Characters are unique."
	^self! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 8/27/2014 16:41'!
ContextPROTOTYPEdoPrimitive: primitiveIndex method: meth receiver: aReceiver args: arguments 
	<indirect>! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 8/27/2014 16:42'!
ContextPROTOTYPEfailPrimitiveWith: maybePrimFailToken
	<indirect>! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 8/27/2014 16:43'!
ContextPROTOTYPEisPrimFailToken: anObject
	<indirect>
! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 10/31/2014 14:05'!
ContextPROTOTYPEobjectClass: aReceiver 
	<indirect>! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/7/2014 14:19'!
ContextPROTOTYPEsend: selector to: rcvr with: arguments lookupIn: lookupClass
	"Simulate the action of sending a message with selector and arguments
	 to rcvr. The argument, lookupClass, is the class in which to lookup the
	 message.  This is the receiver's class for normal messages, but for super
	 messages it will be some specific class related to the source method."

	| meth primIndex val ctxt |
	(meth := lookupClass lookupSelector: selector) ifNil:
		[^self send: #doesNotUnderstand:
				to: rcvr
				with: {Message selector: selector arguments: arguments}
				lookupIn: lookupClass].
	(primIndex := meth primitive) > 0 ifTrue:
		[val := self doPrimitive: primIndex method: meth receiver: rcvr args: arguments.
		 (self isPrimFailToken: val) ifFalse:
			[^val]].
	(selector == #doesNotUnderstand: and: [lookupClass == ProtoObject]) ifTrue:
		[^self error: 'Simulated message ', arguments first selector, ' not understood'].
	ctxt := Context sender: self receiver: rcvr method: meth arguments: arguments.
	primIndex > 0 ifTrue:
		[ctxt failPrimitiveWith: val].
	^ctxt! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'eem 7/24/2014 10:39'!
ContextclassPROTOTYPEallInstances
	"Answer all instances of the receiver."
	<primitive: 177>
	"The primitive can fail because memory is low.  If so, fall back on the old
	 enumeration code, which gives the system a chance to GC and/or grow.
	 Because aBlock might change the class of inst (for example, using become:),
	 it is essential to compute next before aBlock value: inst.
	 Only count until thisContext since this context has been created only to
	 compute the existing instances."
	| inst insts next |
	insts := WriteStream on: (Array new: 64).
	inst := self someInstance.
	[inst == thisContext or: [inst == nil]] whileFalse:
		[next := inst nextInstance.
		 insts nextPut: inst.
		 inst := next].
	^insts contents! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'eem 7/24/2014 10:39'!
ContextclassPROTOTYPEallInstancesDo: aBlock
	"Evaluate aBlock with each of the current instances of the receiver."
	| instances inst next |
	instances := self allInstancesOrNil.
	instances ifNotNil:
		[instances do: aBlock.
		 ^self].
	"allInstancesOrNil can fail because memory is low.  If so, fall back on the old
	 enumeration code.  Because aBlock might change the class of inst (for example,
	 using become:), it is essential to compute next before aBlock value: inst.
	 Only count until thisContext since evaluation of aBlock will create new contexts."
	inst := self someInstance.
	[inst == thisContext or: [inst == nil]] whileFalse:
		[next := inst nextInstance.
		 aBlock value: inst.
		 inst := next]! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'eem 7/8/2014 16:55'!
ProtoObjectPROTOTYPEidentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	 This method must not be overridden, except by SmallInteger.  As of
	 2014, the 32-bit Spur VM has 22 bits of hash and 31-bit SmallIntegers
	 (30 bits + 1 sign bit).  Shifting by 8 will not create large integers.
	
	 Do not override."

	^self basicIdentityHash bitShift: 8! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 6/16/2014 14:18'!
SlotClassBuilderPROTOTYPEcomputeFormat: type instSize: newInstSize forSuper: newSuper ccIndex: ccIndex
	"Compute the new format for making oldClass a subclass of newSuper.
	 Answer the format or nil if there is any problem."
	| instSize isVar isWords isPointers isWeak |
	type == #compiledMethod ifTrue:
		[newInstSize > 0 ifTrue:
			[self error: 'A compiled method class cannot have named instance variables'.
			^nil].
		^CompiledMethod format].
	instSize := newInstSize + (newSuper ifNil:[0] ifNotNil:[newSuper instSize]).
	instSize > 65535 ifTrue:
		[self error: 'Class has too many instance variables (', instSize printString,')'.
		^nil].
	type == #normal ifTrue:[isVar := isWeak := false. isWords := isPointers := true].
	type == #bytes ifTrue:[isVar := true. isWords := isPointers := isWeak := false].
	type == #words ifTrue:[isVar := isWords := true. isPointers := isWeak := false].
	type == #variable ifTrue:[isVar := isPointers := isWords := true. isWeak := false].
	type == #weak ifTrue:[isVar := isWeak := isWords := isPointers := true].
	type == #ephemeron ifTrue:[isVar := false. isWeak := isWords := isPointers := true].
	type == #immediate ifTrue:[isVar := isWeak := isPointers := false. isWords := true].
	(isPointers not and: [instSize > 0]) ifTrue:
		[self error: 'A non-pointer class cannot have named instance variables'.
		^nil].
	^self format: instSize variable: isVar words: isWords pointers: isPointers weak: isWeak! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 6/16/2014 14:18'!
SlotClassBuilderPROTOTYPEformat: nInstVars variable: isVar words: isWords pointers: isPointers weak: isWeak
	"Compute the format for the given instance specfication.
	 Above Cog Spur the class format is
		<5 bits inst spec><16 bits inst size>
	 where the 5-bit inst spec is
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= reserved for 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	| instSpec |
	instSpec := isWeak
					ifTrue:
						[isVar
							ifTrue: [4]
							ifFalse: [5]]
					ifFalse:
						[isPointers
							ifTrue:
								[isVar
									ifTrue: [nInstVars > 0 ifTrue: [3] ifFalse: [2]]
									ifFalse: [nInstVars > 0 ifTrue: [1] ifFalse: [0]]]
							ifFalse:
								[isVar
									ifTrue: [isWords ifTrue: [12] ifFalse: [16]]
									ifFalse: [7]]].
	^(instSpec bitShift: 16) + nInstVars! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 6/16/2014 14:18'!
SlotClassBuilderPROTOTYPEsuperclass: aClass
	immediateSubclass: t instanceVariableNames: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a
	 new immediate class as a subclass of an existing class."
	| env |
	aClass instSize > 0
		ifTrue: [^self error: 'cannot make an immediate subclass of a class with named fields'].
	aClass isVariable
		ifTrue: [^self error: 'cannot make an immediate subclass of a class with indexed instance variables'].
	aClass isPointers
		ifFalse: [^self error: 'cannot make an immediate subclass of a class without pointer fields'].
	"Cope with pre-environment and environment versions. Simplify asap."
	env := (Smalltalk classNamed: #EnvironmentRequest)
				ifNil: [aClass environment]
				ifNotNil: [:erc| erc signal ifNil: [aClass environment]].
	^self 
		name: t
		inEnvironment: env
		subclassOf: aClass
		type: #immediate
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 6/16/2014 14:18'!
SlotClassBuilderPROTOTYPEupdate: oldClass to: newClass
	"Convert oldClass, all its instances and possibly its meta class into newClass,
	 instances of newClass and possibly its meta class. The process is surprisingly
	 simple in its implementation and surprisingly complex in its nuances and potentially
	 bad side effects.
	 We can rely on two assumptions (which are critical):
		#1: The method #updateInstancesFrom: will not create any lasting pointers to
			 'old' instances ('old' is quote on quote since #updateInstancesFrom: will do
			 a become of the old vs. the new instances and therefore it will not create
			 pointers to *new* instances before the #become: which are *old* afterwards)
		#2: The non-preemptive execution of the critical piece of code guarantees that
			 nobody can get a hold by 'other means' (such as process interruption and
			 reflection) on the old instances.
	 Given the above two, we know that after #updateInstancesFrom: there are no pointers
	 to any old instances. After the forwarding become there will be no pointers to the old
	 class or meta class either.
	 Andreas Raab, 2/27/2003 23:42"
	| meta |
	meta := oldClass isMeta.
	"Note: Everything from here on will run without the ability to get interrupted
	to prevent any other process to create new instances of the old class."
	["Note: The following removal may look somewhat obscure and needs an explanation.
	  When we mutate the class hierarchy we create new classes for any existing subclass.
	  So it may look as if we don't have to remove the old class from its superclass. However,
	  at the top of the hierarchy (the first class we reshape) that superclass itself is not newly
	  created so therefore it will hold both the oldClass and newClass in its (obsolete or not)
	  subclasses. Since the #become: below will transparently replace the pointers to oldClass
	  with newClass the superclass would have newClass in its subclasses TWICE. With rather
	  unclear effects if we consider that we may convert the meta-class hierarchy itself (which
	  is derived from the non-meta class hierarchy).
	  Due to this problem ALL classes are removed from their superclass just prior to converting
	  them. Here, breaking the superclass/subclass invariant really doesn't matter since we will
	  effectively remove the oldClass (becomeForward:) just a few lines below."

		oldClass superclass removeSubclass: oldClass.
		oldClass superclass removeObsoleteSubclass: oldClass.

		"make sure that the VM cache is clean"
		oldClass methodDict do: [:cm | cm flushCache].
		
		"Convert the instances of oldClass into instances of newClass"
		newClass updateInstancesFrom: oldClass.

		meta
			ifTrue:
				[oldClass becomeForward: newClass.
				 oldClass updateMethodBindingsTo: oldClass binding]
			ifFalse:
				[{oldClass. oldClass class} elementsForwardIdentityTo: {newClass. newClass class}.
				 oldClass updateMethodBindingsTo: oldClass binding.
				 oldClass class updateMethodBindingsTo: oldClass class binding].

		"eem 5/31/2014 07:22 At this point there used to be a garbage collect whose purpose was
		 to ensure no old instances existed after the becomeForward:.  Without the GC it was possible
		 to resurrect old instances using e.g. allInstancesDo:.  This was because the becomeForward:
		 updated references from the old objects to new objects but didn't destroy the old objects.
		 But as of late 2013/early 2014 becomeForward: has been modified to free all the old objects."]
			valueUnpreemptively! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/11/2014 09:21'!
SmalltalkImagePROTOTYPEnewSpecialObjectsArray
	"Smalltalk recreateSpecialObjectsArray"
	
	"To external package developers:
	**** DO NOT OVERRIDE THIS METHOD.  *****
	If you are writing a plugin and need additional special object(s) for your own use, 
	use addGCRoot() function and use own, separate special objects registry "
	
	"The Special Objects Array is an array of objects used by the Squeak virtual machine.
	 Its contents are critical and accesses to it by the VM are unchecked, so don't even
	 think of playing here unless you know what you are doing."
	| newArray |
	newArray := Array new: 60.
	"Nil false and true get used throughout the interpreter"
	newArray at: 1 put: nil.
	newArray at: 2 put: false.
	newArray at: 3 put: true.
	"This association holds the active process (a ProcessScheduler)"
	newArray at: 4 put: (self globals associationAt: #Processor).
	"Numerous classes below used for type checking and instantiation"
	newArray at: 5 put: Bitmap.
	newArray at: 6 put: SmallInteger.
	newArray at: 7 put: ByteString.
	newArray at: 8 put: Array.
	newArray at: 9 put: Smalltalk.
	newArray at: 10 put: Float.
	newArray at: 11 put: (self globals at: #MethodContext ifAbsent: [self globals at: #Context]).
	newArray at: 12 put: nil. "was BlockContext."
	newArray at: 13 put: Point.
	newArray at: 14 put: LargePositiveInteger.
	newArray at: 15 put: Display.
	newArray at: 16 put: Message.
	newArray at: 17 put: CompiledMethod.
	newArray at: 18 put: ((self primitiveGetSpecialObjectsArray at: 18) ifNil: [Semaphore new]). "low space Semaphore"
	newArray at: 19 put: Semaphore.
	newArray at: 20 put: Character.
	newArray at: 21 put: #doesNotUnderstand:.
	newArray at: 22 put: #cannotReturn:.
	newArray at: 23 put: nil. "This is the process signalling low space."
	"An array of the 32 selectors that are compiled as special bytecodes,
	 paired alternately with the number of arguments each takes."
	newArray at: 24 put: #(	#+ 1 #- 1 #< 1 #> 1 #<= 1 #>= 1 #= 1 #~= 1
							#* 1 #/ 1 #\\ 1 #@ 1 #bitShift: 1 #// 1 #bitAnd: 1 #bitOr: 1
							#at: 1 #at:put: 2 #size 0 #next 0 #nextPut: 1 #atEnd 0 #== 1 #class 0
							#blockCopy: 1 #value 0 #value: 1 #do: 1 #new 0 #new: 1 #x 0 #y 0 ).
	"An array of the 255 Characters in ascii order.
	 Cog inlines table into machine code at: prim so do not regenerate it.
	 This is nil in Spur, which has immediate Characters."
	newArray at: 25 put: (self primitiveGetSpecialObjectsArray at: 25).
	newArray at: 26 put: #mustBeBoolean.
	newArray at: 27 put: ByteArray.
	newArray at: 28 put: Process.
	"An array of up to 31 classes whose instances will have compact headers; an empty array in Spur"
	newArray at: 29 put: self compactClassesArray.
	newArray at: 30 put: ((self primitiveGetSpecialObjectsArray at: 30) ifNil: [Semaphore new]). "delay Semaphore"
	newArray at: 31 put: ((self primitiveGetSpecialObjectsArray at: 31) ifNil: [Semaphore new]). "user interrupt Semaphore"
	"Entries 32 - 34 unreferenced. Previously these contained prototype instances to be copied for fast initialization"
	newArray at: 32 put: nil. "was the prototype Float"
	newArray at: 33 put: nil. "was the prototype 4-byte LargePositiveInteger"
	newArray at: 34 put: nil. "was the prototype Point"
	newArray at: 35 put: #cannotInterpret:.
	newArray at: 36 put: nil. "was the prototype MethodContext"
	newArray at: 37 put: BlockClosure.
	newArray at: 38 put: nil. "was the prototype BlockContext"
	"array of objects referred to by external code"
	newArray at: 39 put: (self primitiveGetSpecialObjectsArray at: 39).	"external semaphores"
	newArray at: 40 put: nil. "Reserved for Mutex in Cog VMs"
	newArray at: 41 put: ((self primitiveGetSpecialObjectsArray at: 41) ifNil: [LinkedList new]). "Reserved for a LinkedList instance for overlapped calls in CogMT"
	newArray at: 42 put: ((self primitiveGetSpecialObjectsArray at: 42) ifNil: [Semaphore new]). "finalization Semaphore"
	newArray at: 43 put: LargeNegativeInteger.
	"External objects for callout.
	 Note: Written so that one can actually completely remove the FFI."
	newArray at: 44 put: (self at: #ExternalAddress ifAbsent: []).
	newArray at: 45 put: (self at: #ExternalStructure ifAbsent: []).
	newArray at: 46 put: (self at: #ExternalData ifAbsent: []).
	newArray at: 47 put: (self at: #ExternalFunction ifAbsent: []).
	newArray at: 48 put: (self at: #ExternalLibrary ifAbsent: []).
	newArray at: 49 put: #aboutToReturn:through:.
	newArray at: 50 put: #run:with:in:.
	"51 reserved for immutability message"
	newArray at: 51 put: #attemptToAssign:withIndex:.
	newArray at: 52 put: #(nil "nil => generic error" #'bad receiver'
							#'bad argument' #'bad index'
							#'bad number of arguments'
							#'inappropriate operation'  #'unsupported operation'
							#'no modification' #'insufficient object memory'
							#'insufficient C memory' #'not found' #'bad method'
							#'internal error in named primitive machinery'
							#'object may move' #'resource limit exceeded'
							#'object is pinned' #'primitive write beyond end of object').
	"53 to 55 are for Alien"
	newArray at: 53 put: (self at: #Alien ifAbsent: []).
	newArray at: 54 put: #invokeCallbackContext:. "use invokeCallback:stack:registers:jmpbuf: for old Alien callbacks."
	newArray at: 55 put: (self at: #UnsafeAlien ifAbsent: []).

	"Used to be WeakFinalizationList for WeakFinalizationList hasNewFinalization, obsoleted by ephemeron support."
	newArray at: 56 put: nil.

	"reserved for foreign callback process"
	newArray at: 57 put: (self primitiveGetSpecialObjectsArray at: 57 ifAbsent: []).

	newArray at: 58 put: #unusedBytecode.
	"59 reserved for Sista counter tripped message"
	newArray at: 59 put: #conditionalBranchCounterTrippedOn:.
	"60 reserved for Sista class trap message"
	newArray at: 60 put: #classTrapFor:.

	^newArray! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 7/3/2014 15:06'!
TraitBehaviorPROTOTYPEallInstances
	"Answer all instances of the receiver."
	self error: 'Traits does not have instances.'! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 7/3/2014 15:06'!
TraitBehaviorPROTOTYPEallInstancesDo: aBlock
	"Evaluate aBlock with each of the current instances of the receiver."
	self error: 'Traits does not have instances.'! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 8/27/2014 16:47'!
TraitBehaviorPROTOTYPEinstSpec
	"Answer the instance specification part of the format that defines what kind of object
	 an instance of the receiver is.  The formats are
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	^(self format bitShift: -16) bitAnd: 16r1F! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 7/2/2014 18:12'!
TraitBehaviorPROTOTYPEisBits
	"Answer whether the receiver contains just bits (not pointers).
	 Above Cog Spur the class format is
		<5 bits inst spec><16 bits inst size>
	 where the 5-bit inst spec is
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	^self instSpec >= 7! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 7/2/2014 18:13'!
TraitBehaviorPROTOTYPEisBytes
	"Answer whether the receiver has 8-bit instance variables.
	 Above Cog Spur the class format is
		<5 bits inst spec><16 bits inst size>
	 where the 5-bit inst spec is
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	^self instSpec >= 16! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 7/2/2014 18:15'!
TraitBehaviorPROTOTYPEisEphemeronClass
	"Answer whether the receiver has ephemeral instance variables.  The garbage collector will
	 fire (queue for finalization) any ephemeron whose first instance variable is not referenced
	 other than from the transitive closure of references from ephemerons. Hence referring to
	 an object from the first inst var of an ephemeron will cause the ephemeron to fire when
	 the rest of the system does not refer to the object and that object is ready to be collected.
	 Since references from the remaining inst vars of an ephemeron will not prevent the ephemeron
	 from firing, ephemerons may act as the associations in weak dictionaries such that the value
	 (e.g. properties attached to the key) will not prevent firing when the key is no longer referenced
	 other than from ephemerons.  Ephemerons can therefore be used to implement instance-based
	 pre-mortem finalization."
	^self instSpec = 5! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 7/2/2014 18:15'!
TraitBehaviorPROTOTYPEisImmediateClass
	"Answer whether the receiver has immediate instances.  Immediate instances
	 store their value in their object pointer, not in an object body.  Hence immediates
	 take no space and are immutable.  The immediates are distinguished by tag bits
	 in the pointer. They include SmallIntegers and Characters.  Hence in the 32-bit
	 system SmallIntegers are 31-bit signed integers and Characters are 30-bit
	 unsigned character codes."
	^self instSpec = 7! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 7/2/2014 18:15'!
TraitBehaviorPROTOTYPEisVariable
	"Answer whether the receiver has indexable variables.
	 Above Cog Spur the class format is
		<5 bits inst spec><16 bits inst size>
	 where the 5-bit inst spec is
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	| instSpec |
	instSpec := self instSpec.
	^instSpec >= 2 and: [instSpec <= 4 or: [instSpec >= 9]]! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 7/2/2014 18:16'!
TraitBehaviorPROTOTYPEkindOfSubclass
	"Answer a String that is the keyword that describes the receiver's kind of subclass,
	 either a regular subclass, a variableSubclass, a variableByteSubclass,
	 a variableWordSubclass, a weakSubclass, an ephemeronSubclass or an immediateSubclass.
	 c.f. typeOfClass"
	^self isVariable
		ifTrue:
			[self isBits
				ifTrue:
					[self isBytes
						ifTrue: [' variableByteSubclass: ']
						ifFalse: [' variableWordSubclass: ']]
				ifFalse:
					[self isWeak
						ifTrue: [' weakSubclass: ']
						ifFalse: [' variableSubclass: ']]]
		ifFalse:
			[self isImmediateClass
				ifTrue: [' immediateSubclass: ']
				ifFalse:
					[self isEphemeronClass
						ifTrue: [' ephemeronSubclass: ']
						ifFalse: [' subclass: ']]]! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 11/14/2014 15:54'!
VirtualMachinePROTOTYPEisSpur 
	"this value is always true but is here for backward compatibility (non Spur images should return false)"
	^ true! !

!SpurBootstrapPharoPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 7/2/2014 15:07'!
VirtualMachinePROTOTYPEsetGCParameters
	"Adjust the VM's default GC parameters to avoid too much tenuring.
	 Maybe this should be left to the VM?"

	| proportion edenSize survivorSize averageObjectSize numObjects |
	proportion := 0.9. "tenure when 90% of pastSpace is full"
	edenSize := self parameterAt: 44.
	survivorSize := edenSize / 5.0. "David's paper uses 140Kb eden + 2 x 28kb survivor spaces; Spur uses the same ratios :-)"
	averageObjectSize := 8 * self wordSize. "a good approximation"
	numObjects := (proportion * survivorSize / averageObjectSize) rounded.
	self tenuringThreshold: numObjects  "tenure when more than this many objects survive the GC"! !

!SpurBootstrapPrototypes class methodsFor: 'accessing method dictionary' stamp: 'eem 11/26/2014 11:25'!
allMethodPrototypes
	^(self canUnderstand: #allMethods)
		ifTrue: "Pharo"
			[self allMethods select:
				[:each| each category = 'method prototypes']]
		ifFalse: "Squeak" "%$#@*!! collect: on IdentitySet answers a *Set*, not an IdentitySet %$#@*!!"
			[(self allSelectors collect: [:s| self lookupSelector: s] as: IdentitySet)
				select: [:m| m protocol = 'method prototypes']]! !

!SpurBootstrapPrototypes class methodsFor: 'accessing' stamp: 'EstebanLorenzano 8/27/2014 15:11'!
imageType 
	^ self subclassResponsibility! !

!SpurBootstrapPrototypes class methodsFor: 'instance creation' stamp: 'eem 11/26/2014 09:09'!
prototypeClassFor: type 
	| deepest |
	deepest := nil.
	self allSubclassesDo:
		[:aClass | aClass imageType = type ifTrue: [deepest := aClass]].
	^deepest! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 12/25/2014 17:51'!
ArrayPROTOTYPEelementsExchangeIdentityWith: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of the
	 receiver to be replaced by pointers to the corresponding elements of otherArray.
	 At the same time, all pointers to the elements of otherArray are replaced by
	 pointers to the corresponding elements of this array.  The identityHashes remain
	 with the pointers rather than with the objects so that objects in hashed structures
	 should still be properly indexed after the mutation."

	<primitive: 128 error: ec>
	ec == #'bad receiver' ifTrue:
		[^self error: 'receiver must be of class Array'].
	ec == #'bad argument' ifTrue:
		[^self error: (otherArray class == Array
						ifTrue: ['arg must be of class Array']
						ifFalse: ['receiver and argument must have the same size'])].
	ec == #'inappropriate operation' ifTrue:
		[^self error: 'can''t become immediates such as SmallIntegers or Characters'].
	ec == #'no modification' ifTrue:
		[^self error: 'can''t become immutable objects'].
	ec == #'object is pinned' ifTrue:
		[^self error: 'can''t become pinned objects'].
	ec == #'insufficient object memory' ifTrue:
		[Smalltalk garbageCollect < 1048576 ifTrue:
			[Smalltalk growMemoryByAtLeast: 1048576].
		 ^self elementsExchangeIdentityWith: otherArray].
	self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/21/2016 11:28'!
ArrayPROTOTYPEelementsForwardIdentityTo: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of the
	 receiver to be replaced by pointers to the corresponding elements of otherArray.
	 The identityHashes remain with the pointers rather than with the objects so that
	 the objects in this array should still be properly indexed in any existing hashed
	 structures after the mutation."
	<primitive: 72 error: ec>
	ec == #'bad receiver' ifTrue:
		[^self error: 'receiver must be of class Array'].
	ec == #'bad argument' ifTrue:
		[^self error: (otherArray class == Array
						ifTrue: ['arg must be of class Array']
						ifFalse: ['receiver and argument must have the same size'])].
	ec == #'inappropriate operation' ifTrue:
		[^self error: 'can''t become immediates such as SmallIntegers or Characters'].
	ec == #'no modification' ifTrue:
		[^self error: 'can''t become immutable objects'].
	ec == #'object is pinned' ifTrue:
		[^self error: 'can''t become pinned objects'].
	ec == #'insufficient object memory' ifTrue:
		[Smalltalk garbageCollect < 1048576 ifTrue:
			[Smalltalk growMemoryByAtLeast: 1048576].
		 ^self elementsForwardIdentityTo: otherArray].
	self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/21/2016 11:30'!
ArrayPROTOTYPEelementsForwardIdentityTo: otherArray copyHash: copyHash
	"This primitive performs a bulk mutation, causing all pointers to the elements of the
	 receiver to be replaced by pointers to the corresponding elements of otherArray.
	 If copyHash is true, the identityHashes remain with the pointers rather than with the
	 objects so that the objects in the receiver should still be properly indexed in any
	 existing hashed structures after the mutation.  If copyHash is false, then the hashes
	 of the objects in otherArray remain unchanged.  If you know what you're doing this
	 may indeed be what you want."
	<primitive: 249 error: ec>
	ec == #'bad receiver' ifTrue:
		[^self error: 'receiver must be of class Array'].
	ec == #'bad argument' ifTrue:
		[^self error: (otherArray class == Array
						ifTrue: ['arg must be of class Array']
						ifFalse: ['receiver and argument must have the same size'])].
	ec == #'inappropriate operation' ifTrue:
		[^self error: 'can''t become immediates such as SmallIntegers or Characters'].
	ec == #'no modification' ifTrue:
		[^self error: 'can''t become immutable objects'].
	ec == #'object is pinned' ifTrue:
		[^self error: 'can''t become pinned objects'].
	ec == #'insufficient object memory' ifTrue:
		[Smalltalk garbageCollect < 1048576 ifTrue:
			[Smalltalk growMemoryByAtLeast: 1048576].
		 ^self elementsForwardIdentityTo: otherArray copyHash: copyHash].
	self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/10/2014 19:04'!
BehaviorPROTOTYPEallInstances
	"Answer all instances of the receiver."
	<primitive: 177>
	"The primitive can fail because memory is low.  If so, fall back on the old
	 enumeration code, which gives the system a chance to GC and/or grow.
	 Because aBlock might change the class of inst (for example, using become:),
	 it is essential to compute next before aBlock value: inst."
	| inst insts next |
	insts := WriteStream on: (Array new: 64).
	inst := self someInstance.
	[inst == nil] whileFalse:
		[next := inst nextInstance.
		 (inst == insts or: [inst == insts originalContents]) ifFalse: [insts nextPut: inst].
		 inst := next].
	^insts contents! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/10/2014 18:42'!
BehaviorPROTOTYPEallInstancesDo: aBlock
	"Evaluate aBlock with each of the current instances of the receiver."
	| instances inst next |
	instances := self allInstancesOrNil.
	instances ifNotNil:
		[instances do: aBlock.
		 ^self].
	"allInstancesOrNil can fail because memory is low.  If so, fall back on the old
	 enumeration code.  Because aBlock might change the class of inst (for example,
	 using become:), it is essential to compute next before aBlock value: inst."
	inst := self someInstance.
	[inst == nil] whileFalse:
		[next := inst nextInstance.
		 aBlock value: inst.
		 inst := next]! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/10/2014 19:04'!
BehaviorPROTOTYPEallInstancesOrNil
	"Answer all instances of the receiver, or nil if the primitive
	 fails, which it may be due to being out of memory."
	<primitive: 177>
	^nil! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/13/2014 06:32'!
BehaviorPROTOTYPEbasicNew
	"Primitive. Answer an instance of the receiver (which is a class) with no 
	 indexable variables. Fail if the class is indexable. Essential. See Object 
	 documentation whatIsAPrimitive.
	
	 If the primitive fails because space is low then the scavenger will run
	 before the method is activated.  Check that space was low and retry
	 via handleFailingBasicNew if so."

	<primitive: 70 error: ec>
	ec == #'insufficient object memory' ifTrue:
		[^self handleFailingBasicNew].
	self isVariable ifTrue: [^self basicNew: 0].
	self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/13/2014 05:52'!
BehaviorPROTOTYPEbasicNew: sizeRequested
	"Primitive. Answer an instance of this class with the number of indexable
	 variables specified by the argument, sizeRequested.  Fail if this class is not
	 indexable or if the argument is not a positive Integer, or if there is not
	 enough memory available. Essential. See Object documentation whatIsAPrimitive.
	
	 If the primitive fails because space is low then the scavenger will run before the
	 method is activated.  Check args and retry via handleFailingBasicNew: if they're OK."

	<primitive: 71 error: ec>
	ec == #'insufficient object memory' ifTrue:
		[^self handleFailingBasicNew: sizeRequested].
	self isVariable ifFalse:
		[self error: self printString, ' cannot have variable sized instances'].
	self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 6/28/2014 17:14'!
BehaviorPROTOTYPEbyteSizeOfInstance
	"Answer the total memory size of an instance of the receiver."

	<primitive: 181 error: ec>
	self isVariable ifTrue:
		[^self byteSizeOfInstanceOfSize: 0].
	self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 6/28/2014 17:13'!
BehaviorPROTOTYPEbyteSizeOfInstanceOfSize: basicSize
	"Answer the total memory size of an instance of the receiver
	 with the given number of indexable instance variables."

	<primitive: 181 error: ec>
	self isVariable
		ifTrue: "If the primitive overflowed answer a close approximation"
			[(basicSize isInteger
			  and: [basicSize >= 16r1000000]) ifTrue:
				[^2 * (self byteSizeOfInstanceOfSize: basicSize + 1 // 2)
				   - (self byteSizeOfInstanceOfSize: 0)]]
		ifFalse:
			[basicSize = 0 ifTrue:
				[^self byteSizeOfInstance]].
	self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/25/2014 11:25'!
BehaviorPROTOTYPEelementSize
	"Answer the size in bytes of an element in the receiver.  The formats are
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	| instSpec |
	instSpec := self instSpec.
	instSpec < 9 ifTrue: [^Smalltalk wordSize].
	instSpec >= 16 ifTrue: [^1].
	instSpec >= 12 ifTrue: [^2].
	instSpec >= 10 ifTrue: [^4].
	^8! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/26/2014 07:56'!
BehaviorPROTOTYPEhandleFailingBasicNew
	"handleFailingBasicNew gets sent after basicNew has failed and allowed
	 a scavenging garbage collection to occur.  The scavenging collection
	 will have happened as the VM is activating the (failing) basicNew.  If
	 handleFailingBasicNew fails then the scavenge failed to reclaim sufficient
	 space and a global garbage collection is required.  Retry after garbage
	 collecting and growing memory if necessary.

	 Primitive. Answer an instance of this class with the number of indexable
	 variables specified by the argument, sizeRequested.  Fail if this class is not
	 indexable or if the argument is not a positive Integer, or if there is not
	 enough memory available. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 70>
	Smalltalk garbageCollect < 1048576 ifTrue:
		[Smalltalk growMemoryByAtLeast: 1048576].
	^self handleFailingFailingBasicNew "retry after global garbage collect"! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/12/2014 10:32'!
BehaviorPROTOTYPEhandleFailingBasicNew: sizeRequested
	"handleFailingBasicNew: gets sent after basicNew: has failed and allowed
	 a scavenging garbage collection to occur.  The scavenging collection
	 will have happened as the VM is activating the (failing) basicNew:.  If
	 handleFailingBasicNew: fails then the scavenge failed to reclaim sufficient
	 space and a global garbage collection is required.  Retry after garbage
	 collecting and growing memory if necessary.

	 Primitive. Answer an instance of this class with the number of indexable
	 variables specified by the argument, sizeRequested.  Fail if this class is not
	 indexable or if the argument is not a positive Integer, or if there is not
	 enough memory available. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 71>
	| bytesRequested |
	bytesRequested := self byteSizeOfInstanceOfSize: sizeRequested.
	Smalltalk garbageCollect < bytesRequested ifTrue:
		[Smalltalk growMemoryByAtLeast: bytesRequested].
	"retry after global garbage collect and possible grow"
	^self handleFailingFailingBasicNew: sizeRequested! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/26/2014 08:00'!
BehaviorPROTOTYPEhandleFailingFailingBasicNew
	"This basicNew gets sent after handleFailingBasicNew: has done a full
	 garbage collection and possibly grown memory.  If this basicNew fails
	 then the system really is low on space, so raise the OutOfMemory signal.

	 Primitive. Answer an instance of this class with the number of indexable
	 variables specified by the argument, sizeRequested.  Fail if this class is not
	 indexable or if the argument is not a positive Integer, or if there is not
	 enough memory available. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 70>
	"space must be low"
	OutOfMemory signal.
	^self basicNew  "retry if user proceeds"! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/26/2014 08:01'!
BehaviorPROTOTYPEhandleFailingFailingBasicNew: sizeRequested
	"This basicNew: gets sent after handleFailingBasicNew: has done a full
	 garbage collection and possibly grown memory.  If this basicNew: fails
	 then the system really is low on space, so raise the OutOfMemory signal.

	 Primitive. Answer an instance of this class with the number of indexable
	 variables specified by the argument, sizeRequested.  Fail if this class is not
	 indexable or if the argument is not a positive Integer, or if there is not
	 enough memory available. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 71>
	"space must be low."
	OutOfMemory signal.
	^self basicNew: sizeRequested  "retry if user proceeds"! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 7/31/2014 05:47'!
BehaviorPROTOTYPEindexIfCompact
	"Backward compatibility with the Squeak V3 object format.
	 Spur does not have a distinction between compact and non-compact classes."
	^0! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 8/27/2014 16:21'!
BehaviorPROTOTYPEinstSize
	<indirect>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'EstebanLorenzano 8/27/2014 16:22'!
BehaviorPROTOTYPEinstSpec
	<indirect>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/25/2014 11:24'!
BehaviorPROTOTYPEisBits
	"Answer whether the receiver contains just bits (not pointers).
	 Above Cog Spur the class format is
		<5 bits inst spec><16 bits inst size>
	 where the 5-bit inst spec is
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	^self instSpec >= 7! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/25/2014 11:24'!
BehaviorPROTOTYPEisBytes
	"Answer whether the receiver has 8-bit instance variables.
	 Above Cog Spur the class format is
		<5 bits inst spec><16 bits inst size>
	 where the 5-bit inst spec is
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	^self instSpec >= 16! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 12/1/2014 11:46'!
BehaviorPROTOTYPEisCompiledMethodClass
	"Answer whether the receiver has compiled method instances that mix pointers and bytes."
	^self instSpec >= 24! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 17:23'!
BehaviorPROTOTYPEisEphemeronClass
	"Answer whether the receiver has ephemeral instance variables.  The garbage collector will
	 fire (queue for finalization) any ephemeron whose first instance variable is not referenced
	 other than from the transitive closure of references from ephemerons. Hence referring to
	 an object from the first inst var of an ephemeron will cause the ephemeron to fire when
	 the rest of the system does not refer to the object and that object is ready to be collected.
	 Since references from the remaining inst vars of an ephemeron will not prevent the ephemeron
	 from firing, ephemerons may act as the associations in weak dictionaries such that the value
	 (e.g. properties attached to the key) will not prevent firing when the key is no longer referenced
	 other than from ephemerons.  Ephemerons can therefore be used to implement instance-based
	 pre-mortem finalization."
	^self instSpec = 5! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 17:23'!
BehaviorPROTOTYPEisImmediateClass
	"Answer whether the receiver has immediate instances.  Immediate instances
	 store their value in their object pointer, not in an object body.  Hence immediates
	 take no space and are immutable.  The immediates are distinguished by tag bits
	 in the pointer. They include SmallIntegers and Characters.  Hence in the 32-bit
	 system SmallIntegers are 31-bit signed integers and Characters are 30-bit
	 unsigned character codes."
	^self instSpec = 7! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/1/2014 10:19'!
BehaviorPROTOTYPEisVariable
	"Answer whether the receiver has indexable variables.
	 Above Cog Spur the class format is
		<5 bits inst spec><16 bits inst size>
	 where the 5-bit inst spec is
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	| instSpec |
	instSpec := self instSpec.
	^instSpec >= 2 and: [instSpec <= 4 or: [instSpec >= 9]]! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 17:23'!
BehaviorPROTOTYPEkindOfSubclass
	"Answer a String that is the keyword that describes the receiver's kind of subclass,
	 either a regular subclass, a variableSubclass, a variableByteSubclass,
	 a variableWordSubclass, a weakSubclass, an ephemeronSubclass or an immediateSubclass.
	 c.f. typeOfClass"
	^self isVariable
		ifTrue:
			[self isBits
				ifTrue:
					[self isBytes
						ifTrue: [' variableByteSubclass: ']
						ifFalse: [' variableWordSubclass: ']]
				ifFalse:
					[self isWeak
						ifTrue: [' weakSubclass: ']
						ifFalse: [' variableSubclass: ']]]
		ifFalse:
			[self isImmediateClass
				ifTrue: [' immediateSubclass: ']
				ifFalse:
					[self isEphemeronClass
						ifTrue: [' ephemeronSubclass: ']
						ifFalse: [' subclass: ']]]! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 1/29/2014 16:49'!
BehaviorPROTOTYPEshouldNotBeRedefined
	"Answer if the receiver should not be redefined.
	 The assumption is that classes in Smalltalk specialObjects and 
	 instance-specific Behaviors should not be redefined"

	^(Smalltalk specialObjectsArray
		identityIndexOf: self
		ifAbsent: [(self isKindOf: self) ifTrue: [1] ifFalse: [0]]) ~= 0! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 17:23'!
BehaviorPROTOTYPEtypeOfClass
	"Answer a symbol uniquely describing the type of the receiver. c.f. kindOfSubclass"
	self isBytes ifTrue:
		[^self instSpec = CompiledMethod instSpec
			ifTrue: [#compiledMethod] "Very special!!"
			ifFalse: [#bytes]].
	(self isWords and: [self isPointers not]) ifTrue:
		[^self instSpec = SmallInteger instSpec
			ifTrue: [#immediate] "Very special!!"
			ifFalse: [#words]].
	self isWeak ifTrue: [^#weak].
	self isVariable ifTrue: [^#variable].
	self isEphemeronClass ifTrue: [^#ephemeron].
	^#normal! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'nice 1/2/2013 07:54'!
BoxedFloat64classPROTOTYPEbasicNew
	^self basicNew: 2! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 11/25/2014 07:54'!
BoxedFloat64classPROTOTYPEbasicNew: sizeRequested 
	"Primitive. Answer an instance of this class with the number
	 of indexable variables specified by the argument, sizeRequested.
	 Fail if this class is not indexable or if the argument is not a
	 positive Integer, or if there is not enough memory available. 
	 Essential. See Object documentation whatIsAPrimitive."

	<primitive: 71>
	sizeRequested isInteger ifTrue:
		[^sizeRequested = 2
			ifTrue: "arg okay; space must be low."
				[OutOfMemory signal.
				 self basicNew: sizeRequested]  "retry if user proceeds"
			ifFalse:
				[self error: 'a Float shall always have two slots']].
	self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/10/2014 14:11'!
BytecodeEncoderPROTOTYPEcomputeMethodHeaderForNumArgs: numArgs numTemps: numTemps numLits: numLits primitive: primitiveIndex
	numArgs > 15 ifTrue:
		[^self error: 'Cannot compile -- too many arguments'].
	numTemps > 63 ifTrue:
		[^self error: 'Cannot compile -- too many temporary variables'].	
	numLits > 65535 ifTrue:
		[^self error: 'Cannot compile -- too many literals'].
	^(CompiledMethod headerFlagForEncoder: self)
	+ (numArgs bitShift: 24)
	+ (numTemps bitShift: 18)
	"+ (largeBit bitShift: 17)" "largeBit gets filled in later"
	+ (primitiveIndex > 0 ifTrue: [1 bitShift: 16] ifFalse: [0])
	+ numLits! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 10/23/2012 16:50'!
BytecodeEncoderPROTOTYPEsizeCallPrimitive: primitiveIndex
	^self sizeOpcodeSelector: #genCallPrimitive: withArguments: {primitiveIndex}! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 10/11/2013 12:55'!
CharacterPROTOTYPEDollarEquals: aCharacter 
	"Primitive. Answer if the receiver and the argument are the
	 same object (have the same object pointer). Optional. See
	 Object documentation whatIsAPrimitive."
	<primitive: 110>
	^self == aCharacter! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:57'!
CharacterPROTOTYPEasInteger
	"Answer the receiver's character code."
	<primitive: 171>
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:57'!
CharacterPROTOTYPEasciiValue
	"Answer the receiver's character code.
	 This will be ascii for characters with value <= 127,
	 and Unicode for those with higher values."
	<primitive: 171>
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/12/2015 15:15'!
CharacterPROTOTYPEcomeFullyUpOnReload: smartRefStream
	"Now Characters are immediates, this can be deleted."
	<remove>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:52'!
CharacterPROTOTYPEcopy
	"Answer the receiver, because Characters are unique."
	^self! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:52'!
CharacterPROTOTYPEdeepCopy
	"Answer the receiver, because Characters are unique."
	^self! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:55'!
CharacterPROTOTYPEhash
	"Hash is reimplemented because = is implemented.
	 Answer the receiver's character code."
	<primitive: 171>
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:56'!
CharacterPROTOTYPEidentityHash
	"Answer the receiver's character code."
	<primitive: 171>
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:53'!
CharacterPROTOTYPEshallowCopy
	"Answer the receiver, because Characters are unique."
	^self! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:53'!
CharacterPROTOTYPEveryDeepCopyWith: deepCopier
	"Answer the receiver, because Characters are unique."
	^self! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/24/2013 23:43'!
CharacterclassPROTOTYPEdigitValue: x 
	"Answer the Character whose digit value is x. For example,
	 answer $9 for x=9, $0 for x=0, $A for x=10, $Z for x=35."

	| n |
	n := x asInteger.
	^self value: (n < 10 ifTrue: [n + 48] ifFalse: [n + 55])! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 7/8/2014 11:24'!
CharacterclassPROTOTYPEinitialize
	"Create the DigitsValues table."
	"Character initialize"
	self initializeDigitValues! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:49'!
CharacterclassPROTOTYPEvalue: anInteger
	"Answer the Character whose value is anInteger."
	<primitive: 170>
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/2/2015 10:42'!
ClassDescriptionPROTOTYPEupdateInstances: oldInstances from: oldClass isMeta: isMeta
	"Recreate any existing instances of the argument, oldClass, as instances of the receiver,
	 which is a newly changed class. Permute variables as necessary, and forward old instances
	 to new instances.  Answer nil to defeat old clients that expect an array of old instances.
	 The old behaviour, which necessitated a global GC, exchanged identities and answered
	 the old instances.  But no clients used the result.  This way we avoid the unnecessary GC,"
	| map variable instSize newInstances |

	oldInstances isEmpty ifTrue:
		[^nil]. "no instances to convert"
	isMeta ifTrue:
		[(oldInstances size = 1
		  and: [self soleInstance class == self
				or: [self soleInstance class == oldClass]]) ifFalse:
			[^self error: 'Metaclasses can only have one instance']].
	map := self instVarMappingFrom: oldClass.
	variable := self isVariable.
	instSize := self instSize.
	newInstances := Array new: oldInstances size.
	1 to: oldInstances size do:
		[:i|
		newInstances
			at: i
			put: (self newInstanceFrom: (oldInstances at: i) variable: variable size: instSize map: map)].
	"Now perform a bulk mutation of old instances into new ones"
	oldInstances elementsForwardIdentityTo: newInstances.
	^nil! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 12/22/2014 13:42'!
ClassDescriptionPROTOTYPEupdateInstancesFrom: oldClass
	"Recreate any existing instances of the argument, oldClass, as instances of 
	 the receiver, which is a newly changed class. Permute variables as necessary,
	 and forward old instances to new instances.. Answer nil to defeat any clients
	 that expected the old behaviour of answering the array of old instances."
	"ar 7/15/1999: The updating below is possibly dangerous. If there are any
	contexts having an old instance as receiver it might crash the system if
	the new receiver in which the context is executed has a different layout.
	See bottom below for a simple example:"
	self updateInstances: oldClass allInstances asArray from: oldClass isMeta: self isMeta.
	"Now fix up instances in segments that are out on the disk."
	ImageSegment allSubInstancesDo:
		[:seg |
		seg segUpdateInstancesOf: oldClass toBe: self isMeta: self isMeta].
	^nil

"This attempts to crash the VM by stepping off the end of an instance.
 As the doctor says, do not do this."
"	| crashingBlock class |
	class := Object subclass: #CrashTestDummy
		instanceVariableNames: 'instVar'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Crash-Test'.
	class compile:'instVar: value instVar := value'.
	class compile:'crashingBlock ^[instVar]'.
	crashingBlock := (class new) instVar: 42; crashingBlock.
	Object subclass: #CrashTestDummy
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Crash-Test'.
	crashingBlock value"! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 1/22/2015 15:49'!
CompiledMethodPROTOTYPEnumLiterals
	"Answer the number of literals used by the receiver."
	^self header bitAnd: 16r7FFF! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/8/2014 15:32'!
CompiledMethodPROTOTYPEprimitive
	"Answer the primitive index associated with the receiver.
	 Zero indicates that this is not a primitive method."
	| initialPC |
	^(self header anyMask: 65536) "Is the hasPrimitive? flag set?"
		ifTrue: [(self at: (initialPC := self initialPC) + 1) + ((self at: initialPC + 2) bitShift: 8)]
		ifFalse: [0]! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/13/2014 05:52'!
CompiledMethodclassPROTOTYPEhandleFailingFailingNewMethod: numberOfBytes header: headerWord
	"This newMethod:header: gets sent after handleFailingBasicNew: has done a full
	 garbage collection and possibly grown memory.  If this basicNew: fails then the
	 system really is low on space, so raise the OutOfMemory signal.

	 Primitive. Answer an instance of this class with the number of indexable variables
	 specified by the argument, headerWord, and the number of bytecodes specified
	 by numberOfBytes.  Fail if this if the arguments are not Integers, or if numberOfBytes
	 is negative, or if the receiver is not a CompiledMethod class, or if there is not enough
	 memory available. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 79>
	"space must be low."
	OutOfMemory signal.
	"retry if user proceeds"
	^self newMethod: numberOfBytes header: headerWord! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/13/2014 05:51'!
CompiledMethodclassPROTOTYPEhandleFailingNewMethod: numberOfBytes header: headerWord
	"This newMethod:header: gets sent after newMethod:header: has failed
	 and allowed a scavenging garbage collection to occur.  The scavenging
	 collection will have happened as the VM is activating the (failing) basicNew:.
	 If handleFailingBasicNew: fails then the scavenge failed to reclaim sufficient
	 space and a global garbage collection is required.  Retry after garbage
	 collecting and growing memory if necessary.

	 Primitive. Answer an instance of this class with the number of indexable variables
	 specified by the argument, headerWord, and the number of bytecodes specified
	 by numberOfBytes.  Fail if this if the arguments are not Integers, or if numberOfBytes
	 is negative, or if the receiver is not a CompiledMethod class, or if there is not enough
	 memory available. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 79>
	| bytesRequested |
	bytesRequested := (headerWord bitAnd: 16rFFFF) + 1 * Smalltalk wordSize + numberOfBytes + 16.
	Smalltalk garbageCollect < bytesRequested ifTrue:
		[Smalltalk growMemoryByAtLeast: bytesRequested].
	"retry after global garbage collect and possible grow"
	^self handleFailingFailingNewMethod: numberOfBytes header: headerWord! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/12/2014 12:39'!
CompiledMethodclassPROTOTYPEheaderFlagForEncoder: anEncoder
	<indirect>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/12/2014 17:50'!
CompiledMethodclassPROTOTYPEinitialize    "CompiledMethod initialize"
	<indirect>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/13/2014 13:13'!
CompiledMethodclassPROTOTYPEinstallPrimaryBytecodeSet: aBytecodeEncoderSubclass
	<indirect>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/13/2014 13:13'!
CompiledMethodclassPROTOTYPEinstallSecondaryBytecodeSet: aBytecodeEncoderSubclass
	<indirect>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/8/2014 07:55'!
CompiledMethodclassPROTOTYPEnewBytes: numberOfBytes trailerBytes: trailer nArgs: nArgs nTemps: nTemps nStack: stackSize nLits: nLits primitive: primitiveIndex
	"Since this method refers to ClassVariables things are easier if it lives in the actual class."

	<indirect>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/8/2014 17:49'!
CompiledMethodclassPROTOTYPEnewBytes: numberOfBytes trailerBytes: trailer nArgs: nArgs nTemps: nTemps nStack: stackSize nLits: nLits primitive: primitiveIndex flag: flag
	"Since this method refers to ClassVariables things are easier if it lives in the actual class."

	<indirect>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/13/2014 05:55'!
CompiledMethodclassPROTOTYPEnewMethod: numberOfBytes header: headerWord
	"Primitive. Answer an instance of me. The number of literals (and other 
	 information) is specified by the headerWord (see my class comment).
	 The first argument specifies the number of fields for bytecodes in the
	 method. Fail if either argument is not a SmallInteger, or if numberOfBytes
	 is negative, or if memory is low. Once the header of a method is set by
	 this primitive, it cannot be changed to change the number of literals.
	 Essential. See Object documentation whatIsAPrimitive."

	<primitive: 79 error: ec>
	ec == #'insufficient object memory' ifTrue:
		[^self handleFailingNewMethod: numberOfBytes header: headerWord].
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/10/2014 12:41'!
CompiledMethodclassPROTOTYPEtoReturnConstant: index trailerBytes: trailer
	"Answer an instance of me that is a quick return of the constant
	indexed in (true false nil -1 0 1 2)."

	^self newBytes: 3 trailerBytes: trailer nArgs: 0 nTemps: 0 nStack: 0 nLits: 2 primitive: 256 + index! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/10/2014 12:41'!
CompiledMethodclassPROTOTYPEtoReturnField: field trailerBytes: trailer
	"Answer an instance of me that is a quick return of the instance variable 
	indexed by the argument, field."

	^self newBytes: 3 trailerBytes: trailer nArgs: 0 nTemps: 0 nStack: 0 nLits: 2 primitive: 264 + field! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/10/2014 12:41'!
CompiledMethodclassPROTOTYPEtoReturnSelfTrailerBytes: trailer
	"Answer an instance of me that is a quick return of the instance (^self)."

	^self newBytes: 3 trailerBytes: trailer nArgs: 0 nTemps: 0 nStack: 0 nLits: 2 primitive: 256! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/22/2014 11:47'!
EncoderForV3PROTOTYPEcomputeMethodHeaderForNumArgs: numArgs numTemps: numTemps numLits: numLits primitive: primitiveIndex
	<remove>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/8/2014 08:06'!
EncoderForV3PlusClosuresPROTOTYPEgenCallPrimitive: primitiveIndex
	"Since this method has inst var refs the prototype must live in the actual class."

	<indirect>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/8/2014 08:05'!
EncoderForV3PlusClosuresclassPROTOTYPEbytecodeSize: bytecode
	"Answer the number of bytes in the bytecode."
	bytecode <= 125 ifTrue:
		[^1].
	bytecode >= 176 ifTrue:
		[^1].
	bytecode >= 160 ifTrue: "long jumps"
		[^2].
	bytecode >= 144 ifTrue: "short jumps"
		[^1].
	"extensions"
	bytecode >= 128 ifTrue:
		[^#(2 2 2 2 3 2 2 1 1 1 2 3 3 3 3 4) at: bytecode - 127].
	^nil! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/8/2014 09:14'!
EncoderForV3PlusClosuresclassPROTOTYPEcallPrimitiveCode
	"139	11101111	iiiiiiii jjjjjjjj	Call Primitive #iiiiiiii + (jjjjjjjj * 256)"
	^139! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 11/25/2014 07:54'!
FloatclassPROTOTYPEbasicNew
	^BoxedFloat64 basicNew: 2! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 11/25/2014 07:54'!
FloatclassPROTOTYPEbasicNew: anInteger
	^BoxedFloat64 basicNew: 2! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 1/14/2015 17:25'!
FloatclassPROTOTYPEfromIEEE32Bit: word
	"Convert the given 32 bit word (which is supposed to be a positive 32-bit value) from
	 a 32 bit IEEE floating point representation into an actual Squeak float object (being
	 64 bits wide). Should only be used for conversion in FloatArrays or likewise objects."
	
	| sign mantissa exponent delta |
	word <= 0 ifTrue:
		[^word negative
			ifTrue: [self error: 'Cannot deal with negative numbers']
			ifFalse: [self zero]].
	sign := word bitAnd: 16r80000000.
	word = sign ifTrue:
		[^self negativeZero].
	
	exponent := ((word bitShift: -23) bitAnd: 16rFF) - 127.
	mantissa := word bitAnd:  16r7FFFFF.

	exponent = 128 ifTrue: "Either NAN or INF"
		[^mantissa = 0
			ifTrue:
				[sign = 0 
					ifTrue: [self infinity]
					ifFalse: [self negativeInfinity]]
			ifFalse: [self nan]].

	exponent = -127 ifTrue:
		"gradual underflow (denormalized number)
		 Remove first bit of mantissa and adjust exponent"
		[delta := mantissa highBit.
		 mantissa := (mantissa bitAnd: (1 bitShift: delta - 1) - 1) bitShift: 24 - delta.
		 exponent := exponent + delta - 23].
	
	"Create new float"
	^(self basicNew: 2)
		basicAt: 1 put: ((sign bitOr: (1023 + exponent bitShift: 20)) bitOr: (mantissa bitShift: -3));
		basicAt: 2 put: ((mantissa bitAnd: 7) bitShift: 29);
		* 1.0 "reduce to SmallFloat64 if possible"! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/8/2014 07:50'!
InstructionClientPROTOTYPEcallPrimitive: pimIndex
	"V3PlusClosures:	139 10001011	iiiiiiii   jjjjjjjj  Call Primitive #iiiiiiii + (jjjjjjjj * 256)
	 NewsqueakV4:		249 11111001	iiiiiiii   jjjjjjjj  Call Primitive #iiiiiiii + (jjjjjjjj * 256)
	 SistaV1:			248 11111000 iiiiiiii mjjjjjjj  Call Primitive #iiiiiiii + ( jjjjjjj * 256)
							m=1 means inlined primitive, no hard return after execution."! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/4/2014 15:24'!
InstructionStreamPROTOTYPEinterpretV3ClosuresExtension: offset in: method for: client
	"Since this method has inst var refs the prototype must live in the actual class."

	<indirect>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 1/26/2015 16:06'!
LargeNegativeIntegerPROTOTYPEnormalize
	"Check for leading zeroes and return shortened copy if so"
	| sLen val len oldLen minVal |
	<primitive: 'primNormalizeNegative' module: 'LargeIntegers'>
	"First establish len = significant length"
	len := oldLen := self digitLength.
	[len = 0 ifTrue: [^0].
	(self digitAt: len) = 0]
		whileTrue: [len := len - 1].

	"Now check if in SmallInteger range.
	 Fast compute SmallInteger minVal digitLength"
	sLen := SmallInteger minVal < -16r40000000
				ifTrue: [8]
				ifFalse: [4].
	len <= sLen ifTrue:
		[minVal := SmallInteger minVal.
		(len < sLen
		 or: [(self digitAt: sLen) < minVal lastDigit])
			ifTrue: ["If high digit less, then can be small"
					val := 0.
					len to: 1 by: -1 do:
						[:i | val := (val *256) - (self digitAt: i)].
					^ val].
		1 to: sLen do:  "If all digits same, then = minVal"
			[:i | (self digitAt: i) = (minVal digitAt: i)
					ifFalse: ["Not so; return self shortened"
							len < oldLen
								ifTrue: [^ self growto: len]
								ifFalse: [^ self]]].
		^ minVal].

	"Return self, or a shortened copy"
	len < oldLen
		ifTrue: [^ self growto: len]
		ifFalse: [^ self]! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 1/26/2015 16:06'!
LargePositiveIntegerPROTOTYPEnormalize
	"Check for leading zeroes and return shortened copy if so"
	| sLen val len oldLen |
	<primitive: 'primNormalizePositive' module:'LargeIntegers'>
	"First establish len = significant length"
	len := oldLen := self digitLength.
	[len = 0 ifTrue: [^0].
	(self digitAt: len) = 0]
		whileTrue: [len := len - 1].

	"Now check if in SmallInteger range.  Fast compute SmallInteger maxVal digitLength"
	sLen := SmallInteger maxVal > 16r3FFFFFFF
				ifTrue: [8]
				ifFalse: [4].
	(len <= sLen
	 and: [(self digitAt: sLen) <= (SmallInteger maxVal digitAt: sLen)])
		ifTrue: ["If so, return its SmallInt value"
				val := 0.
				len to: 1 by: -1 do:
					[:i | val := (val *256) + (self digitAt: i)].
				^ val].

	"Return self, or a shortened copy"
	len < oldLen
		ifTrue: [^ self growto: len]
		ifFalse: [^ self]! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/13/2011 15:00'!
MethodNodeOLDSQUEAKPROTOTYPEgenerate: trailer 
	"The receiver is the root of a parse tree. Answer a CompiledMethod.
	 The argument, trailer, is arbitrary but is typically either the reference
	 to the source code that is stored with every CompiledMethod, or an
	 encoding of the method's temporary names."

	^self generate: trailer using: CompiledMethod! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/8/2014 07:26'!
MethodNodePROTOTYPEgenerate: trailer using: aCompiledMethodClass
	"Since this method has inst var refs the prototype must live in the actual class."

	<indirect>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 12/1/2014 12:03'!
ObjectPROTOTYPEclone
	"Answer a shallow copy of the receiver."
	<primitive: 148 error: ec>
	| class newObject |
	ec == #'insufficient object memory' ifFalse:
		[^self primitiveFailed].
	"If the primitive fails due to insufficient memory, instantiate via basicNew: to invoke
	 the garbage collector before retrying, and use copyFrom: to copy state."
	newObject := (class := self class) isVariable
					ifTrue: 
						[class isCompiledMethodClass
							ifTrue:
								[class newMethod: self basicSize - self initialPC + 1 header: self header]
							ifFalse:
								[class basicNew: self basicSize]]
					ifFalse:
						[class basicNew].
	^newObject copyFrom: self! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 12/25/2014 18:01'!
ObjectPROTOTYPEinstVarAt: index
	"Primitive. Answer a fixed variable in an object. The numbering of the variables
	 corresponds to the named instance variables, followed by the indexed instance
	 variables. Fail if the index is not an Integer or is not the index of a fixed variable.
	 Essential. See Object documentation whatIsAPrimitive."

	<primitive: 173 error: ec>
	self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 12/25/2014 18:01'!
ObjectPROTOTYPEinstVarAt: index put: anObject
	"Primitive. Store a value into a fixed variable in an object. The numbering of the
	 variables corresponds to the named instance variables, followed by the indexed
	 instance variables. Fail if the index is not an Integer or is not the index of a fixed
	 variable. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 174 error: ec>
	self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 12/25/2014 15:04'!
ObjectPROTOTYPEisPinned
	"Answer if the receiver is pinned.  The VM's garbage collector routinely moves
	 objects as it reclaims and compacts memory.  But it can also pin an object so
	 that it will not be moved, which can make it easier to pass objects out through
	 the FFI."
	<primitive: 183 error: ec>
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 1/28/2015 16:07'!
ObjectPROTOTYPEoopAge
	<remove>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 1/28/2015 16:07'!
ObjectPROTOTYPEoopTimestamp
	<remove>! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 12/25/2014 15:13'!
ObjectPROTOTYPEpin
	"The VM's garbage collector routinely moves objects as it reclaims and compacts
	 memory. But it can also pin an object so that it will not be moved, which can make
	 it easier to pass objects out through the FFI.  Objects are unpinnned when created.
	 This method ensures an object is pinned, and answers whether it was already pinned."
	^self setPinned: true! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 12/25/2014 15:13'!
ObjectPROTOTYPEsetPinned: aBoolean
	"The VM's garbage collector routinely moves objects as it reclaims and compacts
	 memory. But it can also pin an object so that it will not be moved, which can make
	 it easier to pass objects out through the FFI.  Objects are unpinnned when created.
	 This primitive either pins or unpins an object, and answers if it was already pinned."
	<primitive: 184 error: ec>
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 12/25/2014 15:12'!
ObjectPROTOTYPEunpin
	"The VM's garbage collector routinely moves objects as it reclaims and compacts
	 memory. But it can also pin an object so that it will not be moved, which can make
	 it easier to pass objects out through the FFI.  Objects are unpinnned when created.
	 This method ensures an object is unpinned, and answers whether it was pinned."
	^self setPinned: false! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 12/1/2014 11:49'!
SmallFloat64PROTOTYPEclone
	"Answer the receiver, because SmallFloat64s are unique."
	^self! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 11/25/2014 07:54'!
SmallFloat64PROTOTYPEcopy
	"Answer the receiver, because SmallFloat64s are unique."
	^self! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 11/25/2014 07:54'!
SmallFloat64PROTOTYPEdeepCopy
	"Answer the receiver, because SmallFloat64s are unique."
	^self! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 12/22/2014 12:36'!
SmallFloat64PROTOTYPEidentityHash
	"Answer an integer unique to the receiver."
	<primitive: 171>
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 11/25/2014 07:54'!
SmallFloat64PROTOTYPEshallowCopy
	"Answer the receiver, because SmallFloat64s are unique."
	^self! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 11/25/2014 07:54'!
SmallFloat64PROTOTYPEveryDeepCopyWith: deepCopier
	"Answer the receiver, because SmallFloat64s are unique."
	^self! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 11/25/2014 07:54'!
SmallFloat64classPROTOTYPEbasicNew
	self error: 'SmallFloat64s can only be created by performing arithmetic'! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 11/25/2014 07:54'!
SmallFloat64classPROTOTYPEbasicNew: anInteger
	^self basicNew! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/5/2013 16:49'!
SmallIntegerPROTOTYPEasCharacter
	<primitive: 170>
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 12/15/2014 20:32'!
SmallIntegerPROTOTYPEdecimalDigitLength
	"Answer the number of digits printed out in base 10.
	 Note that this only works for positive SmallIntegers up to 64-bits."
	
	^self < 10000
		ifTrue:
			[self < 100
				ifTrue:
					[self < 10 ifTrue: [1] ifFalse: [2]]
				ifFalse:
					[self < 1000 ifTrue: [3] ifFalse: [4]]]
		ifFalse:
			[self < 100000000
				ifTrue:
					[self < 1000000
						ifTrue: [self < 100000 ifTrue: [5] ifFalse: [6]]
						ifFalse: [self < 10000000 ifTrue: [7] ifFalse: [8]]]
				ifFalse:
					[self < 1000000000000
						ifTrue:
							[self < 10000000000
								ifTrue: [self < 1000000000 ifTrue: [9] ifFalse: [10]]
								ifFalse: [self < 100000000000 ifTrue: [11] ifFalse: [12]]]
						ifFalse:
							[self < 10000000000000000
								ifTrue:
									[self < 100000000000000
										ifTrue: [self < 10000000000000 ifTrue: [13] ifFalse: [14]]
										ifFalse: [self < 1000000000000000 ifTrue: [15] ifFalse: [16]]]
								ifFalse:
									[self < 1000000000000000000
										ifTrue: [self < 100000000000000000 ifTrue: [17] ifFalse: [18]]
										ifFalse: [self < 10000000000000000000 ifTrue: [19] ifFalse: [20]]]]]]! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 1/26/2015 14:50'!
SmallIntegerPROTOTYPEdigitLength
	"Answer the number of indexable fields in the receiver. This value is the 
	 same as the largest legal subscript. Included so that a SmallInteger can 
	 behave like a LargePositiveInteger or LargeNegativeInteger."

	| value length |
	length := 1.
	value := self.
	value >= 0
		ifTrue:
			[[value > 255] whileTrue:
				[value := value bitShift: -8.
				 length := length + 1]]
		ifFalse:
			[[value < -255] whileTrue:
				[value := value bitShift: -8.
				 length := length + 1]].
	^length! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/5/2014 14:53'!
SmalltalkImagePROTOTYPEcompactClassesArray
	"Smalltalk compactClassesArray"
	"Backward-compatibility support.  Spur does not have compact classes."
	^{}! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/19/2014 13:51'!
SmalltalkImagePROTOTYPEgrowMemoryByAtLeast: numBytes
	"Grow memory by at least the requested number of bytes.
	 Primitive.  Essential. Fail if no memory is available."
	<primitive: 180>
	(numBytes isInteger and: [numBytes > 0]) ifTrue:
		[OutOfMemory signal].
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/5/2013 17:10'!
SmalltalkImagePROTOTYPEmaxIdentityHash
	"Answer the maximum identityHash value supported by the VM."
	<primitive: 176>
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/23/2015 10:00'!
SmalltalkImagePROTOTYPEprimBytesLeft
	"Primitive. Answer the number of free bytes available in old space.
	 Not accurate unless preceded by
		Smalltalk garbageCollectMost (for reasonable accuracy), or
		Smalltalk garbageCollect (for real accuracy).
	 See Object documentation whatIsAPrimitive."

	<primitive: 112>
	^0! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/23/2015 10:00'!
SmalltalkImagePROTOTYPEprimitiveGarbageCollect
	"Primitive. Reclaims all garbage and answers the size of the largest free chunk in old space.."

	<primitive: 130>
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/12/2014 10:31'!
SpaceTallyPROTOTYPEspaceForInstancesOf: aClass
	"Answer a pair of the number of bytes consumed by all instances of the
	 given class, including their object headers, and the number of instances."

	| instances total |
	instances := aClass allInstances.
	instances isEmpty ifTrue: [^#(0 0)].
	total := 0.
	aClass isVariable
		ifTrue:
			[instances do:
				[:i| total := total + (aClass byteSizeOfInstanceOfSize: i basicSize)]]
		ifFalse:
			[total := instances size * aClass byteSizeOfInstance].
	^{ total. instances size }! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/19/2014 14:08'!
SystemDictionaryPROTOTYPEgrowMemoryByAtLeast: numBytes
	"Grow memory by at least the requested number of bytes.
	 Primitive.  Fail if no memory is available.  Essential."
	<primitive: 180>
	^(numBytes isInteger and: [numBytes > 0])
		ifTrue: [OutOfMemory signal]
		ifFalse: [self primitiveFailed]! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/5/2013 17:10'!
SystemDictionaryPROTOTYPEmaxIdentityHash
	"Answer the maximum identityHash value supported by the VM."
	<primitive: 176>
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/10/2014 19:05'!
SystemNavigationPROTOTYPEallObjects
	"Answer an Array of all objects in the system.  Fail if
	 there isn't enough memory to instantiate the result."
	<primitive: 178>
	^self primitiveFailed! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/11/2014 13:59'!
SystemNavigationPROTOTYPEallObjectsDo: aBlock 
	"Evaluate the argument, aBlock, for each object in the system, excluding immediates
	 such as SmallInteger and Character."
	self allObjectsOrNil
		ifNotNil: [:allObjects| allObjects do: aBlock]
		ifNil:
			["Fall back on the old single object primitive code.  With closures, this needs
			  to use an end marker (lastObject) since activation of the block will create
			  new contexts and cause an infinite loop.  The lastObject must be created
			  before calling someObject, so that the VM can settle the enumeration (e.g.
			  by flushing new space) as a side effect of  someObject"
			| object lastObject |
			lastObject := Object new.
			object := self someObject.
			[lastObject == object or: [0 == object]] whileFalse:
				[aBlock value: object.
				 object := object nextObject]]! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/11/2014 13:56'!
SystemNavigationPROTOTYPEallObjectsOrNil
	"Answer an Array of all objects in the system.  Fail if there isn't
	 enough memory to instantiate the result and answer nil."
	<primitive: 178>
	^nil! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/6/2014 14:38'!
WideStringPROTOTYPEat: index
	"Answer the Character stored in the field of the receiver indexed by the
	 argument.  Primitive.  Fail if the index argument is not an Integer or is out
	 of bounds.  Essential.  See Object documentation whatIsAPrimitive."

	<primitive: 63>
	^index isInteger
		ifTrue:
			[self errorSubscriptBounds: index]
		ifFalse:
			[index isNumber
				ifTrue: [self at: index asInteger]
				ifFalse: [self errorNonIntegerIndex]]! !

!SpurBootstrapPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/6/2014 14:40'!
WideStringPROTOTYPEat: index put: aCharacter
	"Store the Character into the field of the receiver indicated by the index.
	 Primitive.  Fail if the index is not an Integer or is out of bounds, or if the
	 argument is not a Character.  Essential.  See Object documentation whatIsAPrimitive."

	<primitive: 64>
	^aCharacter isCharacter
		ifTrue:
			[index isInteger
				ifTrue: [self errorSubscriptBounds: index]
				ifFalse: [self errorNonIntegerIndex]]
		ifFalse:
			[self errorImproperStore]! !

SpurBootstrapPrototypes subclass: #SpurBootstrapSqueakFamilyPrototypes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Bootstrapping'!

SpurBootstrapSqueakFamilyPrototypes subclass: #SpurBootstrapCuisPrototypes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Bootstrapping'!

!SpurBootstrapCuisPrototypes class methodsFor: 'accessing' stamp: 'eem 5/18/2016 09:28'!
imageType
	^ 'cuis'! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/21/2016 10:34'!
ArrayPROTOTYPEcreateMethod: numberOfBytesForAllButTrailer class: aCompiledMethodClass header: headerWord 
	| meth delta |
	meth := aCompiledMethodClass newMethod: numberOfBytesForAllButTrailer + self size header: headerWord.
	"copy the trailer data"
	delta := meth size - self size.
	1 to: self size do:
		[:i | meth at: delta + i put: (self at: i)].
	^meth! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
BehaviorPROTOTYPEidentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	 Behavior implements identityHash to allow the VM to use an object representation which
	 does not include a direct reference to an object's class in an object.  If the VM is using
	 this implementation then classes are held in a class table and instances contain the index
	 of their class in the table.  A class's class table index is its identityHash so that an instance
	 can be created without searching the table for a class's index.  The VM uses this primitive
	 to enter the class into the class table, assigning its identityHash with an as yet unused
	 class table index. If this primitive fails it means that the class table is full.  In Spur as of
	 2014 there are 22 bits of classTable index and 22 bits of identityHash per object.

	 Primitive. Essential. Do not override. See Object documentation whatIsAPrimitive."

	<primitive: 175>
	self primitiveFailed! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
BlockClosurePROTOTYPEsimulateValueWithArguments: anArray caller: aContext
	<indirect>! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
CharacterPROTOTYPEclone
	"Answer the receiver, because Characters are unique."
	^self! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
CharacterPROTOTYPEsetValue: v
	<remove>! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 16:06'!
CharacterPROTOTYPEvalue
	"Answer the value of the receiver that represents its ISO 8859-15 (Latin-9) encoding."
	<primitive: 171>
	^self primitiveFailed! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/23/2016 15:30'!
CharacterclassPROTOTYPEinitialize
	<ignore>! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:36'!
ClassDescriptionPROTOTYPEupdateInstancesFrom: oldClass
	"Recreate any existing instances of the argument, oldClass, as instances of 
	 the receiver, which is a newly changed class. Permute variables as necessary,
	 and forward old instances to new instances.. Answer nil to defeat any clients
	 that expected the old behaviour of answering the array of old instances."
	"ar 7/15/1999: The updating below is possibly dangerous. If there are any
	contexts having an old instance as receiver it might crash the system if
	the new receiver in which the context is executed has a different layout.
	See bottom below for a simple example:"
	self updateInstances: oldClass allInstances asArray from: oldClass isMeta: self isMeta.
	^nil

"This attempts to crash the VM by stepping off the end of an instance.
 As the doctor says, do not do this."
"	| crashingBlock class |
	class := Object subclass: #CrashTestDummy
		instanceVariableNames: 'instVar'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Crash-Test'.
	class compile:'instVar: value instVar := value'.
	class compile:'crashingBlock ^[instVar]'.
	crashingBlock := (class new) instVar: 42; crashingBlock.
	Object subclass: #CrashTestDummy
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Crash-Test'.
	crashingBlock value"! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
ClassDescriptionPROTOTYPEupdateMethodBindingsTo: aBinding
	<indirect>! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
ClassPROTOTYPEimmediateSubclass: t instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat 
	"This is the standard initialization message for creating a new
	 immediate class as a subclass of an existing class (the receiver)."
	^ClassBuilder new
		superclass: self
		immediateSubclass: t
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
CompiledMethodPROTOTYPEbytecodeSetName
	^self encoderClass name copyReplaceAll: 'EncoderFor' with: ''! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:37'!
CompiledMethodPROTOTYPEheaderDescription
	"Answer a description containing the information about the form of the
	 receiver and the form of the context needed to run the receiver."

	^(String new: 128) writeStream
		print: self header; cr;
		nextPutAll: '"primitive: '; print: self primitive; cr;
		nextPutAll: ' numArgs: '; print: self numArgs; cr;
		nextPutAll: ' numTemps: '; print: self numTemps; cr;
		nextPutAll: ' numLiterals: '; print: self numLiterals; cr;
		nextPutAll: ' frameSize: '; print: self frameSize; cr;
		nextPutAll: ' bytecodeSet: '; nextPutAll: self bytecodeSetName;
		nextPut: $"; cr;
		contents! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
ContextPartPROTOTYPEactivateReturn: aContext value: value
	"Activate 'aContext return: value' in place of self, so execution will return to aContext's sender"

	^MethodContext 
		sender: self
		receiver: aContext
		method: MethodContext theReturnMethod
		arguments: {value}! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:55'!
ContextPartPROTOTYPEdoPrimitive: primitiveIndex method: meth receiver: receiver args: arguments
	"Simulate a primitive method whose index is primitiveIndex.  The simulated receiver and
	 arguments are given as arguments to this message. If successful, push result and return
	 resuming context, else ^ {errCode, PrimitiveFailToken}. Any primitive which provokes
	 execution needs to be intercepted and simulated to avoid execution running away."

	| value |
	"Judicious use of primitive 19 (a null primitive that doesn't do anything) prevents
	 the debugger from entering various run-away activities such as spawning a new
	 process, etc.  Injudicious use results in the debugger not being able to debug
	 interesting code, such as the debugger itself.  hence use primitive 19 with care :-)"
	"SystemNavigation new browseAllSelect: [:m| m primitive = 19]"
	primitiveIndex = 19 ifTrue:
		[Debugger 
			openContext: self
			label:'Code simulation error'
			contents: nil].

	((primitiveIndex between: 201 and: 222)
	 and: [(self objectClass: receiver) includesBehavior: BlockClosure]) ifTrue:
		[((primitiveIndex between: 201 and: 205)			 "BlockClosure>>value[:value:...]"
		  or: [primitiveIndex between: 221 and: 222]) ifTrue: "BlockClosure>>valueNoContextSwitch[:]"
			[^receiver simulateValueWithArguments: arguments caller: self].
		 primitiveIndex = 206 ifTrue:						"BlockClosure>>valueWithArguments:"
			[^receiver simulateValueWithArguments: arguments first caller: self]].

	primitiveIndex = 83 ifTrue: "afr 9/11/1998 19:50" "Object>>perform:[with:...]"
		[^self send: arguments first to: receiver with: arguments allButFirst super: false].
	primitiveIndex = 84 ifTrue: "afr 9/11/1998 19:50 & eem 8/18/2009 17:04" "Object>>perform:withArguments:"
		[^self send: arguments first to: receiver with: (arguments at: 2) lookupIn: (self objectClass: receiver)].
	primitiveIndex = 100 ifTrue: "eem 8/18/2009 16:57" "Object>>perform:withArguments:inSuperclass:"
		[^self send: arguments first to: receiver with: (arguments at: 2) lookupIn: (arguments at: 3)].

	"Mutex>>primitiveEnterCriticalSection
	 Mutex>>primitiveTestAndSetOwnershipOfCriticalSection"
	(primitiveIndex = 186 or: [primitiveIndex = 187]) ifTrue:
		[| active effective |
		 active := Processor activeProcess.
		 effective := active effectiveProcess.
		 "active == effective"
		 value := primitiveIndex = 186
					ifTrue: [receiver primitiveEnterCriticalSectionOnBehalfOf: effective]
					ifFalse: [receiver primitiveTestAndSetOwnershipOfCriticalSectionOnBehalfOf: effective].
		 ^(self isPrimFailToken: value)
			ifTrue: [value]
			ifFalse: [self push: value]].

	primitiveIndex = 188 ifTrue: "eem 5/27/2008 11:10 Object>>withArgs:executeMethod:"
		[^MethodContext
			sender: self
			receiver: receiver
			method: (arguments at: 2)
			arguments: (arguments at: 1)].

	"Closure primitives"
	(primitiveIndex = 200 and: [self == receiver]) ifTrue:
		"ContextPart>>closureCopy:copiedValues:; simulated to get startpc right"
		[^self push: (BlockClosure
						outerContext: receiver
						startpc: self pc + 2
						numArgs: arguments first
						copiedValues: arguments last)].

	primitiveIndex = 118 ifTrue: "tryPrimitive:withArgs:; avoid recursing in the VM"
		[(arguments size = 2
		 and: [arguments first isInteger
		 and: [(self objectClass: arguments last) == Array]]) ifFalse:
			[^ContextPart primitiveFailTokenFor: nil].
		 ^self doPrimitive: arguments first method: meth receiver: receiver args: arguments last].

	value := primitiveIndex = 120 "FFI method"
				ifTrue: [(meth literalAt: 1) tryInvokeWithArguments: arguments]
				ifFalse:
					[primitiveIndex = 117 "named primitives"
						ifTrue: [self tryNamedPrimitiveIn: meth for: receiver withArgs: arguments]
						ifFalse: [receiver tryPrimitive: primitiveIndex withArgs: arguments]].

	^(self isPrimFailToken: value)
		ifTrue: [value]
		ifFalse: [self push: value]! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
ContextPartPROTOTYPEisPrimFailToken: anObject
	<indirect>! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
ContextPartPROTOTYPEsend: selector to: rcvr with: arguments lookupIn: lookupClass
	"Simulate the action of sending a message with selector and arguments
	 to rcvr. The argument, lookupClass, is the class in which to lookup the
	 message.  This is the receiver's class for normal messages, but for super
	 messages it will be some specific class related to the source method."

	| meth primIndex val ctxt |
	(meth := lookupClass lookupSelector: selector) ifNil:
		[^self send: #doesNotUnderstand:
				to: rcvr
				with: {Message selector: selector arguments: arguments}
				lookupIn: lookupClass].
	(primIndex := meth primitive) > 0 ifTrue:
		[val := self doPrimitive: primIndex method: meth receiver: rcvr args: arguments.
		 (self isPrimFailToken: val) ifFalse:
			[^val]].
	(selector == #doesNotUnderstand: and: [lookupClass == ProtoObject]) ifTrue:
		[^self error: 'Simulated message ', arguments first selector, ' not understood'].
	ctxt := MethodContext sender: self receiver: rcvr method: meth arguments: arguments.
	primIndex > 0 ifTrue:
		[ctxt failPrimitiveWith: val].
	^ctxt! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
ContextPartPROTOTYPEsend: selector to: rcvr with: arguments super: superFlag 
	"Simulate the action of sending a message with selector arguments
	 to rcvr. The argument, superFlag, tells whether the receiver of the
	 message was specified with 'super' in the source method."

	^self send: selector
		to: rcvr
		with: arguments
		lookupIn: (superFlag
					ifTrue: [self method methodClassAssociation value superclass]
					ifFalse: [self objectClass: rcvr])! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
ContextPartPROTOTYPEtryNamedPrimitiveIn: aCompiledMethod for: aReceiver withArgs: arguments
	"Invoke the named primitive for aCompiledMethod, answering its result, or,
	 if the primiitve fails, answering the error code."
	<primitive: 218 error: ec>
	ec ifNotNil:
		["If ec is an integer other than -1 there was a problem with primitive 218,
		  not with the external primitive itself.  -1 indicates a generic failure (where
		  ec should be nil) but ec = nil means primitive 218 is not implemented.  So
		  interpret -1 to mean the external primitive failed with a nil error code."
		 ec isInteger ifTrue:
			[ec = -1
				ifTrue: [ec := nil]
				ifFalse: [self primitiveFailed]]].
	^self class primitiveFailTokenFor: ec! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
IntegerclassPROTOTYPEinitialize
	"Integer initialize"	
	self initializeLowBitPerByteTable! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
MethodContextPROTOTYPEfailPrimitiveWith: maybePrimFailToken
	<indirect>! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
MethodContextclassPROTOTYPEallInstances
	"Answer all instances of the receiver."
	<primitive: 177>
	"The primitive can fail because memory is low.  If so, fall back on the old
	 enumeration code, which gives the system a chance to GC and/or grow.
	 Because aBlock might change the class of inst (for example, using become:),
	 it is essential to compute next before aBlock value: inst.
	 Only count until thisContext since this context has been created only to
	 compute the existing instances."
	| inst insts next |
	insts := WriteStream on: (Array new: 64).
	inst := self someInstance.
	[inst == thisContext or: [inst == nil]] whileFalse:
		[next := inst nextInstance.
		 insts nextPut: inst.
		 inst := next].
	^insts contents! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
MethodContextclassPROTOTYPEallInstancesDo: aBlock
	"Evaluate aBlock with each of the current instances of the receiver."
	| instances inst next |
	instances := self allInstancesOrNil.
	instances ifNotNil:
		[instances do: aBlock.
		 ^self].
	"allInstancesOrNil can fail because memory is low.  If so, fall back on the old
	 enumeration code.  Because aBlock might change the class of inst (for example,
	 using become:), it is essential to compute next before aBlock value: inst.
	 Only count until thisContext since evaluation of aBlock will create new contexts."
	inst := self someInstance.
	[inst == thisContext or: [inst == nil]] whileFalse:
		[next := inst nextInstance.
		 aBlock value: inst.
		 inst := next]! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/19/2016 17:30'!
MethodNodePROTOTYPEgenerate: trailer using: aCompiledMethodClass ifQuick: methodBlock
	<indirect>! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
ProtoObjectPROTOTYPEscaledIdentityHash
	"For identityHash values returned by primitive 75, answer
	 such values times 2^8.  Otherwise, match the existing
	 identityHash implementation"

	^self identityHash * 256 "bitShift: 8"! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:22'!
SmallIntegerPROTOTYPEclone
	"Answer the receiver, because SmallIntegers are unique."
	^self! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:39'!
SmalltalkImagePROTOTYPErecreateSpecialObjectsArray
	<remove>! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:23'!
SmalltalkImagePROTOTYPEsetGCParameters
	"Adjust the VM's default GC parameters to avoid too much tenuring.
	 Maybe this should be left to the VM?"
	<remove>! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 16:31'!
SystemDictionaryPROTOTYPErecreateSpecialObjectsArray
	"Smalltalk recreateSpecialObjectsArray"
	
	"To external package developers:
	**** DO NOT OVERRIDE THIS METHOD.  *****
	If you are writing a plugin and need additional special object(s) for your own use, 
	use addGCRoot() function and use own, separate special objects registry "
	
	"The Special Objects Array is an array of objects used by the Squeak virtual machine.
	 Its contents are critical and accesses to it by the VM are unchecked, so don't even
	 think of playing here unless you know what you are doing."
	| newArray |
	newArray := Array new: 60.
	"Nil false and true get used throughout the interpreter"
	newArray at: 1 put: nil.
	newArray at: 2 put: false.
	newArray at: 3 put: true.
	"This association holds the active process (a ProcessScheduler)"
	newArray at: 4 put: (self associationAt: #Processor).
	"Numerous classes below used for type checking and instantiation"
	newArray at: 5 put: Bitmap.
	newArray at: 6 put: SmallInteger.
	newArray at: 7 put: String.
	newArray at: 8 put: Array.
	newArray at: 9 put: Smalltalk.
	newArray at: 10 put: BoxedFloat64.
	newArray at: 11 put: MethodContext.
	newArray at: 12 put: nil. "was BlockContext."
	newArray at: 13 put: Point.
	newArray at: 14 put: LargePositiveInteger.
	newArray at: 15 put: Display.
	newArray at: 16 put: Message.
	newArray at: 17 put: CompiledMethod.
	newArray at: 18 put: ((self specialObjectsArray at: 18) ifNil: [Semaphore new]). "low space Semaphore"
	newArray at: 19 put: Semaphore.
	newArray at: 20 put: Character.
	newArray at: 21 put: #doesNotUnderstand:.
	newArray at: 22 put: #cannotReturn:.
	newArray at: 23 put: nil. "This is the process signalling low space."
	"An array of the 32 selectors that are compiled as special bytecodes,
	 paired alternately with the number of arguments each takes."
	newArray at: 24 put: #(	#+ 1 #- 1 #< 1 #> 1 #<= 1 #>= 1 #= 1 #~= 1
							#* 1 #/ 1 #\\ 1 #@ 1 #bitShift: 1 #// 1 #bitAnd: 1 #bitOr: 1
							#at: 1 #at:put: 2 #size 0 #next 0 #nextPut: 1 #atEnd 0 #== 1 #class 0
							#blockCopy: 1 #value 0 #value: 1 #do: 1 #new 0 #new: 1 #x 0 #y 0 ).
	"An array of the 255 Characters in ascii order.
	 Cog inlines table into machine code at: prim so do not regenerate it.
	 This is nil in Spur, which has immediate Characters."
	newArray at: 25 put: (self specialObjectsArray at: 25).
	newArray at: 26 put: #mustBeBoolean.
	newArray at: 27 put: ByteArray.
	newArray at: 28 put: Process.
	"An array of up to 31 classes whose instances will have compact headers; an empty array in Spur"
	newArray at: 29 put: self compactClassesArray.
	newArray at: 30 put: ((self specialObjectsArray at: 30) ifNil: [Semaphore new]). "delay Semaphore"
	newArray at: 31 put: ((self specialObjectsArray at: 31) ifNil: [Semaphore new]). "user interrupt Semaphore"
	"Entries 32 - 34 unreferenced. Previously these contained prototype instances to be copied for fast initialization"
	newArray at: 32 put: nil. "was the prototype Float"
	newArray at: 33 put: nil. "was the prototype 4-byte LargePositiveInteger"
	newArray at: 34 put: nil. "was the prototype Point"
	newArray at: 35 put: #cannotInterpret:.
	newArray at: 36 put: nil. "was the prototype MethodContext"
	newArray at: 37 put: BlockClosure.
	newArray at: 38 put: nil. "was the prototype BlockContext"
	"array of objects referred to by external code"
	newArray at: 39 put: (self specialObjectsArray at: 39).	"external semaphores"
	newArray at: 40 put: nil. "Reserved for Mutex in Cog VMs"
	newArray at: 41 put: ((self specialObjectsArray at: 41) ifNil: [LinkedList new]). "Reserved for a LinkedList instance for overlapped calls in CogMT"
	newArray at: 42 put: ((self specialObjectsArray at: 42) ifNil: [Semaphore new]). "finalization Semaphore"
	newArray at: 43 put: LargeNegativeInteger.
	"External objects for callout.
	 Note: Written so that one can actually completely remove the FFI."
	newArray at: 44 put: (self at: #ExternalAddress ifAbsent: []).
	newArray at: 45 put: (self at: #ExternalStructure ifAbsent: []).
	newArray at: 46 put: (self at: #ExternalData ifAbsent: []).
	newArray at: 47 put: (self at: #ExternalFunction ifAbsent: []).
	newArray at: 48 put: (self at: #ExternalLibrary ifAbsent: []).
	newArray at: 49 put: #aboutToReturn:through:.
	newArray at: 50 put: #run:with:in:.
	"51 reserved for immutability message"
	newArray at: 51 put: #attemptToAssign:withIndex:.
	newArray at: 52 put: #(nil "nil => generic error" #'bad receiver'
							#'bad argument' #'bad index'
							#'bad number of arguments'
							#'inappropriate operation'  #'unsupported operation'
							#'no modification' #'insufficient object memory'
							#'insufficient C memory' #'not found' #'bad method'
							#'internal error in named primitive machinery'
							#'object may move' #'resource limit exceeded'
							#'object is pinned' #'primitive write beyond end of object').
	"53 to 55 are for Alien"
	newArray at: 53 put: (self at: #Alien ifAbsent: []).
	newArray at: 54 put: #invokeCallbackContext:. "use invokeCallback:stack:registers:jmpbuf: for old Alien callbacks."
	newArray at: 55 put: (self at: #UnsafeAlien ifAbsent: []).

	"Used to be WeakFinalizationList for WeakFinalizationList hasNewFinalization, obsoleted by ephemeron support."
	newArray at: 56 put: nil.

	"reserved for foreign callback process"
	newArray at: 57 put: (self specialObjectsArray at: 57 ifAbsent: []).

	newArray at: 58 put: #unusedBytecode.
	"59 reserved for Sista counter tripped message"
	newArray at: 59 put: #conditionalBranchCounterTrippedOn:.
	"60 reserved for Sista class trap message"
	newArray at: 60 put: #classTrapFor:.

	"Now replace the interpreter's reference in one atomic operation"
	self specialObjectsArray becomeForward: newArray! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/18/2016 09:24'!
SystemDictionaryPROTOTYPEsetGCParameters
	"Adjust the VM's default GC parameters to avoid too much tenuring.
	 Maybe this should be left to the VM?"

	| proportion edenSize survivorSize averageObjectSize numObjects |
	proportion := 0.9. "tenure when 90% of pastSpace is full"
	edenSize := Smalltalk vmParameterAt: 44.
	survivorSize := edenSize / 5.0. "David's paper uses 140Kb eden + 2 x 28kb survivor spaces; Spur uses the same ratios :-)"
	averageObjectSize := 8 * self wordSize. "a good approximation"
	numObjects := (proportion * survivorSize / averageObjectSize) rounded.
	Smalltalk vmParameterAt: 6 put: numObjects  "tenure when more than this many objects survive the GC"! !

!SpurBootstrapCuisPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/19/2016 12:50'!
SystemDictionaryPROTOTYPEwordSize
	"Answer the size in bytes of an object pointer or word in the object memory.
	 The value does not change for a given image, but may be modified by a SystemTracer
	 when converting the image to another format."

	"Smalltalk wordSize"

	^self vmParameterAt: 40! !

SpurBootstrapSqueakFamilyPrototypes subclass: #SpurBootstrapSqueak43Prototypes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Bootstrapping'!

!SpurBootstrapSqueak43Prototypes class methodsFor: 'accessing' stamp: 'EstebanLorenzano 8/27/2014 15:13'!
imageType
	^ 'squeak 4.3'! !

!SpurBootstrapSqueak43Prototypes methodsFor: 'method prototypes' stamp: 'eem 9/7/2014 14:11'!
BlockClosurePROTOTYPEsimulateValueWithArguments: anArray caller: aContext
	<indirect>! !

!SpurBootstrapSqueak43Prototypes methodsFor: 'method prototypes' stamp: 'nice 7/14/2011 22:21'!
CharacterPROTOTYPEshouldBePrintedAsLiteral

	^(self asInteger between: 33 and: 255) and: [self asInteger ~= 127]! !

!SpurBootstrapSqueak43Prototypes methodsFor: 'method prototypes' stamp: 'eem 8/12/2014 09:32'!
CompiledMethodPROTOTYPEencoderClass
	<indirect>! !

!SpurBootstrapSqueak43Prototypes methodsFor: 'method prototypes' stamp: 'eem 9/4/2014 15:16'!
DecompilerPROTOTYPEdecompile: aSelector in: aClass method: aMethod using: aConstructor
	<indirect>! !

!SpurBootstrapSqueak43Prototypes methodsFor: 'method prototypes' stamp: 'eem 8/11/2014 20:30'!
InstructionStreamPROTOTYPEinterpretExtension: offset in: method for: client
	^self interpretV3ClosuresExtension: offset in: method for: client! !

!SpurBootstrapSqueak43Prototypes methodsFor: 'method prototypes' stamp: 'eem 9/9/2014 17:19'!
InstructionStreamPROTOTYPEnextPc: currentByte
	<indirect>! !

!SpurBootstrapSqueak43Prototypes methodsFor: 'method prototypes' stamp: 'eem 9/9/2014 17:20'!
InstructionStreamPROTOTYPEskipCallPrimitive
	<indirect>! !

!SpurBootstrapSqueak43Prototypes methodsFor: 'method prototypes' stamp: 'eem 9/4/2014 15:20'!
MCClassDefinitionPROTOTYPEkindOfSubclass
	<indirect>! !

!SpurBootstrapSqueak43Prototypes methodsFor: 'method prototypes' stamp: 'eem 9/4/2014 15:18'!
MCMethodDefinitionPROTOTYPEinitializeWithClassName: classString
classIsMeta: metaBoolean
selector: selectorString
category: catString
timeStamp: timeString
source: sourceString
	<indirect>! !

!SpurBootstrapSqueak43Prototypes methodsFor: 'method prototypes' stamp: 'eem 9/9/2014 21:42'!
MethodNodePROTOTYPEprintPropertiesOn: aStream
	<indirect>! !

!SpurBootstrapSqueakFamilyPrototypes class methodsFor: 'accessing' stamp: 'eem 11/25/2014 15:10'!
imageType
	^'squeak'! !

!SpurBootstrapSqueakFamilyPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 18:17'!
ClassBuilderPROTOTYPEcomputeFormat: type instSize: newInstSize forSuper: newSuper ccIndex: ccIndex
	"Compute the new format for making oldClass a subclass of newSuper.
	 Answer the format or nil if there is any problem."
	| instSize isVar isWords isPointers isWeak |
	type == #compiledMethod ifTrue:
		[newInstSize > 0 ifTrue:
			[self error: 'A compiled method class cannot have named instance variables'.
			^nil].
		^CompiledMethod format].
	instSize := newInstSize + (newSuper ifNil:[0] ifNotNil:[newSuper instSize]).
	instSize > 65535 ifTrue:
		[self error: 'Class has too many instance variables (', instSize printString,')'.
		^nil].
	type == #normal ifTrue:[isVar := isWeak := false. isWords := isPointers := true].
	type == #bytes ifTrue:[isVar := true. isWords := isPointers := isWeak := false].
	type == #words ifTrue:[isVar := isWords := true. isPointers := isWeak := false].
	type == #variable ifTrue:[isVar := isPointers := isWords := true. isWeak := false].
	type == #weak ifTrue:[isVar := isWeak := isWords := isPointers := true].
	type == #ephemeron ifTrue:[isVar := false. isWeak := isWords := isPointers := true].
	type == #immediate ifTrue:[isVar := isWeak := isPointers := false. isWords := true].
	(isPointers not and: [instSize > 0]) ifTrue:
		[self error: 'A non-pointer class cannot have named instance variables'.
		^nil].
	^self format: instSize variable: isVar words: isWords pointers: isPointers weak: isWeak! !

!SpurBootstrapSqueakFamilyPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/28/2014 15:07'!
ClassBuilderPROTOTYPEformat: nInstVars variable: isVar words: is32BitWords pointers: isPointers weak: isWeak
	"Compute the format for the given instance specfication.
	 Above Cog Spur the class format is
		<5 bits inst spec><16 bits inst size>
	 where the 5-bit inst spec is
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= reserved for 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	| instSpec |
	instSpec := isWeak
					ifTrue:
						[isVar
							ifTrue: [4]
							ifFalse: [5]]
					ifFalse:
						[isPointers
							ifTrue:
								[isVar
									ifTrue: [nInstVars > 0 ifTrue: [3] ifFalse: [2]]
									ifFalse: [nInstVars > 0 ifTrue: [1] ifFalse: [0]]]
							ifFalse:
								[isVar
									ifTrue: [is32BitWords ifTrue: [10] ifFalse: [16]]
									ifFalse: [7]]].
	^(instSpec bitShift: 16) + nInstVars! !

!SpurBootstrapSqueakFamilyPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 17:09'!
ClassBuilderPROTOTYPEsuperclass: aClass
	immediateSubclass: t instanceVariableNames: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a
	 new immediate class as a subclass of an existing class."
	| env |
	aClass instSize > 0
		ifTrue: [^self error: 'cannot make an immediate subclass of a class with named fields'].
	aClass isVariable
		ifTrue: [^self error: 'cannot make an immediate subclass of a class with indexed instance variables'].
	aClass isPointers
		ifFalse: [^self error: 'cannot make an immediate subclass of a class without pointer fields'].
	"Cope with pre-environment and environment versions. Simplify asap."
	env := (Smalltalk classNamed: #EnvironmentRequest)
				ifNil: [aClass environment]
				ifNotNil: [:erc| erc signal ifNil: [aClass environment]].
	^self 
		name: t
		inEnvironment: env
		subclassOf: aClass
		type: #immediate
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!SpurBootstrapSqueakFamilyPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/31/2014 07:32'!
ClassBuilderPROTOTYPEupdate: oldClass to: newClass
	"Convert oldClass, all its instances and possibly its meta class into newClass,
	 instances of newClass and possibly its meta class. The process is surprisingly
	 simple in its implementation and surprisingly complex in its nuances and potentially
	 bad side effects.
	 We can rely on two assumptions (which are critical):
		#1: The method #updateInstancesFrom: will not create any lasting pointers to
			 'old' instances ('old' is quote on quote since #updateInstancesFrom: will do
			 a become of the old vs. the new instances and therefore it will not create
			 pointers to *new* instances before the #become: which are *old* afterwards)
		#2: The non-preemptive execution of the critical piece of code guarantees that
			 nobody can get a hold by 'other means' (such as process interruption and
			 reflection) on the old instances.
	 Given the above two, we know that after #updateInstancesFrom: there are no pointers
	 to any old instances. After the forwarding become there will be no pointers to the old
	 class or meta class either.
	 Andreas Raab, 2/27/2003 23:42"
	| meta |
	meta := oldClass isMeta.
	"Note: Everything from here on will run without the ability to get interrupted
	to prevent any other process to create new instances of the old class."
	["Note: The following removal may look somewhat obscure and needs an explanation.
	  When we mutate the class hierarchy we create new classes for any existing subclass.
	  So it may look as if we don't have to remove the old class from its superclass. However,
	  at the top of the hierarchy (the first class we reshape) that superclass itself is not newly
	  created so therefore it will hold both the oldClass and newClass in its (obsolete or not)
	  subclasses. Since the #become: below will transparently replace the pointers to oldClass
	  with newClass the superclass would have newClass in its subclasses TWICE. With rather
	  unclear effects if we consider that we may convert the meta-class hierarchy itself (which
	  is derived from the non-meta class hierarchy).
	  Due to this problem ALL classes are removed from their superclass just prior to converting
	  them. Here, breaking the superclass/subclass invariant really doesn't matter since we will
	  effectively remove the oldClass (becomeForward:) just a few lines below."

		oldClass superclass removeSubclass: oldClass.
		oldClass superclass removeObsoleteSubclass: oldClass.

		"make sure that the VM cache is clean"
		oldClass methodDict do: [:cm | cm flushCache].
		
		"Convert the instances of oldClass into instances of newClass"
		newClass updateInstancesFrom: oldClass.

		meta
			ifTrue:
				[oldClass becomeForward: newClass.
				 oldClass updateMethodBindingsTo: oldClass binding]
			ifFalse:
				[{oldClass. oldClass class} elementsForwardIdentityTo: {newClass. newClass class}.
				 oldClass updateMethodBindingsTo: oldClass binding.
				 oldClass class updateMethodBindingsTo: oldClass class binding].

		"eem 5/31/2014 07:22 At this point there used to be a garbage collect whose purpose was
		 to ensure no old instances existed after the becomeForward:.  Without the GC it was possible
		 to resurrect old instances using e.g. allInstancesDo:.  This was because the becomeForward:
		 updated references from the old objects to new objects but didn't destroy the old objects.
		 But as of late 2013/early 2014 becomeForward: has been modified to free all the old objects."]
			valueUnpreemptively! !

!SpurBootstrapSqueakFamilyPrototypes methodsFor: 'method prototypes' stamp: 'eem 5/21/2016 11:38'!
InstructionPrinterPROTOTYPEcallPrimitive: index
	"Print the callPrimitive bytecode."

	self print: 'callPrimitive: ' , index printString! !

SpurBootstrapSqueakFamilyPrototypes subclass: #SpurBootstrapSqueakPrototypes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Bootstrapping'!

!SpurBootstrapSqueakPrototypes class methodsFor: 'accessing' stamp: 'EstebanLorenzano 8/27/2014 15:13'!
imageType
	^ 'squeak'! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/25/2014 11:32'!
BehaviorPROTOTYPEidentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	 Behavior implements identityHash to allow the VM to use an object representation which
	 does not include a direct reference to an object's class in an object.  If the VM is using
	 this implementation then classes are held in a class table and instances contain the index
	 of their class in the table.  A class's class table index is its identityHash so that an instance
	 can be created without searching the table for a class's index.  The VM uses this primitive
	 to enter the class into the class table, assigning its identityHash with an as yet unused
	 class table index. If this primitive fails it means that the class table is full.  In Spur as of
	 2014 there are 22 bits of classTable index and 22 bits of identityHash per object.

	 Primitive. Essential. Do not override. See Object documentation whatIsAPrimitive."

	<primitive: 175>
	self primitiveFailed! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/7/2014 14:11'!
BlockClosurePROTOTYPEsimulateValueWithArguments: anArray caller: aContext
	<indirect>! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:52'!
CharacterPROTOTYPEclone
	"Answer the receiver, because Characters are unique."
	^self! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/9/2014 21:18'!
CharacterPROTOTYPEsetValue: v
	<remove>! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/7/2014 13:35'!
ClassDescriptionPROTOTYPEupdateMethodBindingsTo: aBinding
	<indirect>! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 13:37'!
ClassPROTOTYPEimmediateSubclass: t instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat 
	"This is the standard initialization message for creating a new
	 immediate class as a subclass of an existing class (the receiver)."
	^ClassBuilder new
		superclass: self
		immediateSubclass: t
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/11/2014 12:04'!
CompiledMethodPROTOTYPEbytecodeSetName
	^self encoderClass name copyReplaceAll: 'EncoderFor' with: ''! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/11/2014 12:12'!
CompiledMethodPROTOTYPEheaderDescription
	"Answer a description containing the information about the form of the
	 receiver and the form of the context needed to run the receiver."

	^(ByteString new: 128) writeStream
		print: self header; cr;
		nextPutAll: '"primitive: '; print: self primitive; cr;
		nextPutAll: ' numArgs: '; print: self numArgs; cr;
		nextPutAll: ' numTemps: '; print: self numTemps; cr;
		nextPutAll: ' numLiterals: '; print: self numLiterals; cr;
		nextPutAll: ' frameSize: '; print: self frameSize; cr;
		nextPutAll: ' bytecodeSet: '; nextPutAll: self bytecodeSetName;
		nextPut: $"; cr;
		contents! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/11/2014 12:28'!
ContextPartPROTOTYPEactivateReturn: aContext value: value
	"Activate 'aContext return: value' in place of self, so execution will return to aContext's sender"

	^MethodContext 
		sender: self
		receiver: aContext
		method: MethodContext theReturnMethod
		arguments: {value}! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/4/2014 15:17'!
ContextPartPROTOTYPEdoPrimitive: primitiveIndex method: meth receiver: receiver args: arguments 
	<indirect>! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/11/2014 12:57'!
ContextPartPROTOTYPEisPrimFailToken: anObject
	<indirect>! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/11/2014 13:43'!
ContextPartPROTOTYPEsend: selector to: rcvr with: arguments lookupIn: lookupClass
	"Simulate the action of sending a message with selector and arguments
	 to rcvr. The argument, lookupClass, is the class in which to lookup the
	 message.  This is the receiver's class for normal messages, but for super
	 messages it will be some specific class related to the source method."

	| meth primIndex val ctxt |
	(meth := lookupClass lookupSelector: selector) ifNil:
		[^self send: #doesNotUnderstand:
				to: rcvr
				with: {Message selector: selector arguments: arguments}
				lookupIn: lookupClass].
	(primIndex := meth primitive) > 0 ifTrue:
		[val := self doPrimitive: primIndex method: meth receiver: rcvr args: arguments.
		 (self isPrimFailToken: val) ifFalse:
			[^val]].
	(selector == #doesNotUnderstand: and: [lookupClass == ProtoObject]) ifTrue:
		[^self error: 'Simulated message ', arguments first selector, ' not understood'].
	ctxt := MethodContext sender: self receiver: rcvr method: meth arguments: arguments.
	primIndex > 0 ifTrue:
		[ctxt failPrimitiveWith: val].
	^ctxt! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/11/2014 13:44'!
ContextPartPROTOTYPEsend: selector to: rcvr with: arguments super: superFlag 
	"Simulate the action of sending a message with selector arguments
	 to rcvr. The argument, superFlag, tells whether the receiver of the
	 message was specified with 'super' in the source method."

	^self send: selector
		to: rcvr
		with: arguments
		lookupIn: (superFlag
					ifTrue: [self method methodClassAssociation value superclass]
					ifFalse: [self objectClass: rcvr])! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 8/11/2014 13:05'!
ContextPartPROTOTYPEtryNamedPrimitiveIn: aCompiledMethod for: aReceiver withArgs: arguments
	"Invoke the named primitive for aCompiledMethod, answering its result, or,
	 if the primiitve fails, answering the error code."
	<primitive: 218 error: ec>
	ec ifNotNil:
		["If ec is an integer other than -1 there was a problem with primitive 218,
		  not with the external primitive itself.  -1 indicates a generic failure (where
		  ec should be nil) but ec = nil means primitive 218 is not implemented.  So
		  interpret -1 to mean the external primitive failed with a nil error code."
		 ec isInteger ifTrue:
			[ec = -1
				ifTrue: [ec := nil]
				ifFalse: [self primitiveFailed]]].
	^self class primitiveFailTokenFor: ec! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 7/16/2014 15:27'!
IntegerclassPROTOTYPEinitialize
	"Integer initialize"	
	self initializeLowBitPerByteTable! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/4/2014 15:18'!
MethodContextPROTOTYPEfailPrimitiveWith: maybePrimFailToken
	<indirect>! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 7/24/2014 10:39'!
MethodContextclassPROTOTYPEallInstances
	"Answer all instances of the receiver."
	<primitive: 177>
	"The primitive can fail because memory is low.  If so, fall back on the old
	 enumeration code, which gives the system a chance to GC and/or grow.
	 Because aBlock might change the class of inst (for example, using become:),
	 it is essential to compute next before aBlock value: inst.
	 Only count until thisContext since this context has been created only to
	 compute the existing instances."
	| inst insts next |
	insts := WriteStream on: (Array new: 64).
	inst := self someInstance.
	[inst == thisContext or: [inst == nil]] whileFalse:
		[next := inst nextInstance.
		 insts nextPut: inst.
		 inst := next].
	^insts contents! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 7/24/2014 10:39'!
MethodContextclassPROTOTYPEallInstancesDo: aBlock
	"Evaluate aBlock with each of the current instances of the receiver."
	| instances inst next |
	instances := self allInstancesOrNil.
	instances ifNotNil:
		[instances do: aBlock.
		 ^self].
	"allInstancesOrNil can fail because memory is low.  If so, fall back on the old
	 enumeration code.  Because aBlock might change the class of inst (for example,
	 using become:), it is essential to compute next before aBlock value: inst.
	 Only count until thisContext since evaluation of aBlock will create new contexts."
	inst := self someInstance.
	[inst == thisContext or: [inst == nil]] whileFalse:
		[next := inst nextInstance.
		 aBlock value: inst.
		 inst := next]! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/6/2013 14:31'!
ProtoObjectPROTOTYPEscaledIdentityHash
	"For identityHash values returned by primitive 75, answer
	 such values times 2^8.  Otherwise, match the existing
	 identityHash implementation"

	^self identityHash * 256 "bitShift: 8"! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 12/1/2014 13:10'!
SmallIntegerPROTOTYPEclone
	"Answer the receiver, because SmallIntegers are unique."
	^self! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 11/25/2014 16:41'!
SmalltalkImagePROTOTYPErecreateSpecialObjectsArray
	"Smalltalk recreateSpecialObjectsArray"
	
	"To external package developers:
	**** DO NOT OVERRIDE THIS METHOD.  *****
	If you are writing a plugin and need additional special object(s) for your own use, 
	use addGCRoot() function and use own, separate special objects registry "
	
	"The Special Objects Array is an array of objects used by the Squeak virtual machine.
	 Its contents are critical and accesses to it by the VM are unchecked, so don't even
	 think of playing here unless you know what you are doing."
	| newArray |
	newArray := Array new: 60.
	"Nil false and true get used throughout the interpreter"
	newArray at: 1 put: nil.
	newArray at: 2 put: false.
	newArray at: 3 put: true.
	"This association holds the active process (a ProcessScheduler)"
	newArray at: 4 put: (self specialObjectsArray at: 4) "(self bindingOf: #Processor) but it answers an Alias".
	"Numerous classes below used for type checking and instantiation"
	newArray at: 5 put: Bitmap.
	newArray at: 6 put: SmallInteger.
	newArray at: 7 put: ByteString.
	newArray at: 8 put: Array.
	newArray at: 9 put: Smalltalk.
	newArray at: 10 put: BoxedFloat64.
	newArray at: 11 put: (self globals at: #MethodContext ifAbsent: [self globals at: #Context]).
	newArray at: 12 put: nil. "was BlockContext."
	newArray at: 13 put: Point.
	newArray at: 14 put: LargePositiveInteger.
	newArray at: 15 put: Display.
	newArray at: 16 put: Message.
	newArray at: 17 put: CompiledMethod.
	newArray at: 18 put: ((self specialObjectsArray at: 18) ifNil: [Semaphore new]). "low space Semaphore"
	newArray at: 19 put: Semaphore.
	newArray at: 20 put: Character.
	newArray at: 21 put: #doesNotUnderstand:.
	newArray at: 22 put: #cannotReturn:.
	newArray at: 23 put: nil. "This is the process signalling low space."
	"An array of the 32 selectors that are compiled as special bytecodes,
	 paired alternately with the number of arguments each takes."
	newArray at: 24 put: #(	#+ 1 #- 1 #< 1 #> 1 #<= 1 #>= 1 #= 1 #~= 1
							#* 1 #/ 1 #\\ 1 #@ 1 #bitShift: 1 #// 1 #bitAnd: 1 #bitOr: 1
							#at: 1 #at:put: 2 #size 0 #next 0 #nextPut: 1 #atEnd 0 #== 1 #class 0
							#blockCopy: 1 #value 0 #value: 1 #do: 1 #new 0 #new: 1 #x 0 #y 0 ).
	"An array of the 255 Characters in ascii order.
	 Cog inlines table into machine code at: prim so do not regenerate it.
	 This is nil in Spur, which has immediate Characters."
	newArray at: 25 put: (self specialObjectsArray at: 25).
	newArray at: 26 put: #mustBeBoolean.
	newArray at: 27 put: ByteArray.
	newArray at: 28 put: Process.
	"An array of up to 31 classes whose instances will have compact headers; an empty array in Spur"
	newArray at: 29 put: self compactClassesArray.
	newArray at: 30 put: ((self specialObjectsArray at: 30) ifNil: [Semaphore new]). "delay Semaphore"
	newArray at: 31 put: ((self specialObjectsArray at: 31) ifNil: [Semaphore new]). "user interrupt Semaphore"
	"Entries 32 - 34 unreferenced. Previously these contained prototype instances to be copied for fast initialization"
	newArray at: 32 put: nil. "was the prototype Float"
	newArray at: 33 put: nil. "was the prototype 4-byte LargePositiveInteger"
	newArray at: 34 put: nil. "was the prototype Point"
	newArray at: 35 put: #cannotInterpret:.
	newArray at: 36 put: nil. "was the prototype MethodContext"
	newArray at: 37 put: BlockClosure.
	newArray at: 38 put: nil. "was the prototype BlockContext"
	"array of objects referred to by external code"
	newArray at: 39 put: (self specialObjectsArray at: 39).	"external semaphores"
	newArray at: 40 put: nil. "Reserved for Mutex in Cog VMs"
	newArray at: 41 put: ((self specialObjectsArray at: 41) ifNil: [LinkedList new]). "Reserved for a LinkedList instance for overlapped calls in CogMT"
	newArray at: 42 put: ((self specialObjectsArray at: 42) ifNil: [Semaphore new]). "finalization Semaphore"
	newArray at: 43 put: LargeNegativeInteger.
	"External objects for callout.
	 Note: Written so that one can actually completely remove the FFI."
	newArray at: 44 put: (self at: #ExternalAddress ifAbsent: []).
	newArray at: 45 put: (self at: #ExternalStructure ifAbsent: []).
	newArray at: 46 put: (self at: #ExternalData ifAbsent: []).
	newArray at: 47 put: (self at: #ExternalFunction ifAbsent: []).
	newArray at: 48 put: (self at: #ExternalLibrary ifAbsent: []).
	newArray at: 49 put: #aboutToReturn:through:.
	newArray at: 50 put: #run:with:in:.
	"51 reserved for immutability message"
	newArray at: 51 put: #attemptToAssign:withIndex:.
	newArray at: 52 put: #(nil "nil => generic error" #'bad receiver'
							#'bad argument' #'bad index'
							#'bad number of arguments'
							#'inappropriate operation'  #'unsupported operation'
							#'no modification' #'insufficient object memory'
							#'insufficient C memory' #'not found' #'bad method'
							#'internal error in named primitive machinery'
							#'object may move' #'resource limit exceeded'
							#'object is pinned' #'primitive write beyond end of object').
	"53 to 55 are for Alien"
	newArray at: 53 put: (self at: #Alien ifAbsent: []).
	newArray at: 54 put: #invokeCallbackContext:. "use invokeCallback:stack:registers:jmpbuf: for old Alien callbacks."
	newArray at: 55 put: (self at: #UnsafeAlien ifAbsent: []).

	"Used to be WeakFinalizationList for WeakFinalizationList hasNewFinalization, obsoleted by ephemeron support."
	newArray at: 56 put: nil.

	"reserved for foreign callback process"
	newArray at: 57 put: (self specialObjectsArray at: 57 ifAbsent: []).

	newArray at: 58 put: #unusedBytecode.
	"59 reserved for Sista counter tripped message"
	newArray at: 59 put: #conditionalBranchCounterTrippedOn:.
	"60 reserved for Sista class trap message"
	newArray at: 60 put: #classTrapFor:.

	"Now replace the interpreter's reference in one atomic operation"
	self specialObjectsArray becomeForward: newArray! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/21/2013 07:39'!
SmalltalkImagePROTOTYPEsetGCParameters
	"Adjust the VM's default GC parameters to avoid too much tenuring.
	 Maybe this should be left to the VM?"

	| proportion edenSize survivorSize averageObjectSize numObjects |
	proportion := 0.9. "tenure when 90% of pastSpace is full"
	edenSize := SmalltalkImage current vmParameterAt: 44.
	survivorSize := edenSize / 5.0. "David's paper uses 140Kb eden + 2 x 28kb survivor spaces; Spur uses the same ratios :-)"
	averageObjectSize := 8 * self wordSize. "a good approximation"
	numObjects := (proportion * survivorSize / averageObjectSize) rounded.
	SmalltalkImage current vmParameterAt: 6 put: numObjects  "tenure when more than this many objects survive the GC"! !

!SpurBootstrapSqueakPrototypes methodsFor: 'method prototypes' stamp: 'eem 9/21/2013 07:39'!
SystemDictionaryPROTOTYPEsetGCParameters
	"Adjust the VM's default GC parameters to avoid too much tenuring.
	 Maybe this should be left to the VM?"

	| proportion edenSize survivorSize averageObjectSize numObjects |
	proportion := 0.9. "tenure when 90% of pastSpace is full"
	edenSize := SmalltalkImage current vmParameterAt: 44.
	survivorSize := edenSize / 5.0. "David's paper uses 140Kb eden + 2 x 28kb survivor spaces; Spur uses the same ratios :-)"
	averageObjectSize := 8 * self wordSize. "a good approximation"
	numObjects := (proportion * survivorSize / averageObjectSize) rounded.
	SmalltalkImage current vmParameterAt: 6 put: numObjects  "tenure when more than this many objects survive the GC"! !

!CompiledMethod class methodsFor: '*Cog-method prototypes' stamp: 'eem 8/12/2014 12:39'!
CompiledMethodclassPROTOTYPEheaderFlagForEncoder: anEncoder
	anEncoder class == PrimaryBytecodeSetEncoderClass ifTrue:
		[^0].
	anEncoder class == SecondaryBytecodeSetEncoderClass ifTrue:
		[^SmallInteger minVal].
	self error: 'The encoder is not one of the two installed bytecode sets'! !

!CompiledMethod class methodsFor: '*Cog-method prototypes' stamp: 'eem 5/12/2014 17:50'!
CompiledMethodclassPROTOTYPEinitialize    "CompiledMethod initialize"
	"Initialize class variables specifying the size of the temporary frame
	needed to run instances of me."

	SmallFrame := 16.	"Context range for temps+stack"
	LargeFrame := 56.
	PrimaryBytecodeSetEncoderClass ifNil:
		[PrimaryBytecodeSetEncoderClass := EncoderForV3PlusClosures].
	SecondaryBytecodeSetEncoderClass ifNil:
		[SecondaryBytecodeSetEncoderClass := EncoderForV3PlusClosures]! !

!CompiledMethod class methodsFor: '*Cog-method prototypes' stamp: 'eem 8/13/2014 13:29'!
CompiledMethodclassPROTOTYPEinstallPrimaryBytecodeSet: aBytecodeEncoderSubclass
	PrimaryBytecodeSetEncoderClass == aBytecodeEncoderSubclass ifTrue:
		[^self].
	(aBytecodeEncoderSubclass inheritsFrom: BytecodeEncoder) ifFalse:
		[self error: 'A bytecode set encoder is expected to be a subclass of BytecodeEncoder'].
	(self allSubInstances
			detect: [:m| m header >= 0 and: [m encoderClass ~~ aBytecodeEncoderSubclass]]
			ifNone: []) ifNotNil:
		[Warning signal: 'There are existing CompiledMethods with a different encoderClass.'].
	PrimaryBytecodeSetEncoderClass := aBytecodeEncoderSubclass! !

!CompiledMethod class methodsFor: '*Cog-method prototypes' stamp: 'eem 8/13/2014 13:29'!
CompiledMethodclassPROTOTYPEinstallSecondaryBytecodeSet: aBytecodeEncoderSubclass
	PrimaryBytecodeSetEncoderClass == aBytecodeEncoderSubclass ifTrue:
		[^self].
	(aBytecodeEncoderSubclass inheritsFrom: BytecodeEncoder) ifFalse:
		[self error: 'A bytecode set encoder is expected to be a subclass of BytecodeEncoder'].
	(self allSubInstances
			detect: [:m| m header < 0 and: [m encoderClass ~~ aBytecodeEncoderSubclass]]
			ifNone: []) ifNotNil:
		[Warning signal: 'There are existing CompiledMethods with a different encoderClass.'].
	SecondaryBytecodeSetEncoderClass := aBytecodeEncoderSubclass! !

!CompiledMethod class methodsFor: '*Cog-method prototypes' stamp: 'eem 5/21/2016 11:37'!
CompiledMethodclassPROTOTYPEnewBytes: numberOfBytes trailerBytes: trailer nArgs: nArgs nTemps: nTemps nStack: stackSize nLits: nLits primitive: primitiveIndex
	"Answer an instance of me. The header is specified by the message 
	 arguments. The remaining parts are not as yet determined."
	| method pc |
	nArgs > 15 ifTrue:
		[^self error: 'Cannot compile -- too many arguments'].
	nTemps > 63 ifTrue:
		[^self error: 'Cannot compile -- too many temporary variables'].	
	nLits > 32768 ifTrue:
		[^self error: 'Cannot compile -- too many literals'].

	method := trailer
				createMethod: numberOfBytes
				class: self
				header:    (nArgs bitShift: 24)
						+ (nTemps bitShift: 18)
						+ ((nTemps + stackSize) > SmallFrame ifTrue: [1 bitShift: 17] ifFalse: [0])
						+ nLits
						+ (primitiveIndex > 0 ifTrue: [1 bitShift: 16] ifFalse: [0]).
	primitiveIndex > 0 ifTrue:
		[pc := method initialPC.
		 method
			at: pc + 0 put: method encoderClass callPrimitiveCode;
			at: pc + 1 put: (primitiveIndex bitAnd: 16rFF);
			at: pc + 2 put: (primitiveIndex bitShift: -8)].
	^method! !

!CompiledMethod class methodsFor: '*Cog-method prototypes' stamp: 'eem 5/21/2016 11:37'!
CompiledMethodclassPROTOTYPEnewBytes: numberOfBytes trailerBytes: trailer nArgs: nArgs nTemps: nTemps nStack: stackSize nLits: nLits primitive: primitiveIndex flag: flag
	"Answer an instance of me. The header is specified by the message 
	 arguments. The remaining parts are not as yet determined."
	| method pc |
	nArgs > 15 ifTrue:
		[^self error: 'Cannot compile -- too many arguments'].
	nTemps > 63 ifTrue:
		[^self error: 'Cannot compile -- too many temporary variables'].	
	nLits > 32768 ifTrue:
		[^self error: 'Cannot compile -- too many literals'].

	method := trailer
				createMethod: numberOfBytes
				class: self
				header:    (nArgs bitShift: 24)
						+ (nTemps bitShift: 18)
						+ ((nTemps + stackSize) > SmallFrame ifTrue: [1 bitShift: 17] ifFalse: [0])
						+ nLits
						+ (primitiveIndex > 0 ifTrue: [1 bitShift: 16] ifFalse: [0])
						+ (flag ifTrue: [1 bitShift: 29] ifFalse: [0]).
	primitiveIndex > 0 ifTrue:
		[pc := method initialPC.
		 method
			at: pc + 0 put: method encoderClass callPrimitiveCode;
			at: pc + 1 put: (primitiveIndex bitAnd: 16rFF);
			at: pc + 2 put: (primitiveIndex bitShift: -8)].
	^method! !

!CompiledMethod methodsFor: '*Cog-method prototypes' stamp: 'eem 8/5/2014 20:52'!
CompiledMethodPROTOTYPEencoderClass
	"Answer the encoder class that encoded the bytecodes in this method.
	 The sign flag bit is used by the VM to select a bytecode set.  This formulation
	 may seem odd but this has to be fast, so no property probe unless needed."

	^self header >= 0
		ifTrue: 
			[PrimaryBytecodeSetEncoderClass]
		ifFalse:
			[PrimaryBytecodeSetEncoderClass == SecondaryBytecodeSetEncoderClass
				ifTrue: "Support for testing prior to installing another set"
					[(self propertyValueAt: #encoderClass) ifNil: [SecondaryBytecodeSetEncoderClass]]
				ifFalse:
					[SecondaryBytecodeSetEncoderClass]]! !

!InstructionStream methodsFor: '*Cog-method prototypes' stamp: 'eem 8/8/2014 07:43'!
InstructionStreamPROTOTYPEinterpretV3ClosuresExtension: offset in: method for: client
	| type offset2 byte2 byte3 byte4 |
	offset <= 6 ifTrue: 
		["Extended op codes 128-134"
		byte2 := method at: pc. pc := pc + 1.
		offset <= 2 ifTrue:
			["128-130:  extended pushes and pops"
			type := byte2 // 64.
			offset2 := byte2 \\ 64.
			offset = 0 ifTrue: 
				[type = 0 ifTrue: [^client pushReceiverVariable: offset2].
				type = 1 ifTrue: [^client pushTemporaryVariable: offset2].
				type = 2  ifTrue: [^client pushConstant: (method literalAt: offset2 + 1)].
				type = 3 ifTrue: [^client pushLiteralVariable: (method literalAt: offset2 + 1)]].
			offset = 1 ifTrue: 
				[type = 0 ifTrue: [^client storeIntoReceiverVariable: offset2].
				type = 1 ifTrue: [^client storeIntoTemporaryVariable: offset2].
				type = 2 ifTrue: [self error: 'illegalStore'].
				type = 3 ifTrue: [^client storeIntoLiteralVariable: (method literalAt: offset2 + 1)]].
			offset = 2 ifTrue: 
				[type = 0 ifTrue: [^client popIntoReceiverVariable: offset2].
				type = 1 ifTrue: [^client popIntoTemporaryVariable: offset2].
				type = 2 ifTrue: [self error: 'illegalStore'].
				type = 3  ifTrue: [^client popIntoLiteralVariable: (method literalAt: offset2 + 1)]]].
		"131-134: extended sends"
		offset = 3 ifTrue:  "Single extended send"
			[^client send: (method literalAt: byte2 \\ 32 + 1)
					super: false numArgs: byte2 // 32].
		offset = 4 ifTrue:    "Double extended do-anything"
			[byte3 := method at: pc. pc := pc + 1.
			type := byte2 // 32.
			type = 0 ifTrue: [^client send: (method literalAt: byte3 + 1)
									super: false numArgs: byte2 \\ 32].
			type = 1 ifTrue: [^client send: (method literalAt: byte3 + 1)
									super: true numArgs: byte2 \\ 32].
			type = 2 ifTrue: [^client pushReceiverVariable: byte3].
			type = 3 ifTrue: [^client pushConstant: (method literalAt: byte3 + 1)].
			type = 4 ifTrue: [^client pushLiteralVariable: (method literalAt: byte3 + 1)].
			type = 5 ifTrue: [^client storeIntoReceiverVariable: byte3].
			type = 6 ifTrue: [^client popIntoReceiverVariable: byte3].
			type = 7 ifTrue: [^client storeIntoLiteralVariable: (method literalAt: byte3 + 1)]].
		offset = 5 ifTrue:  "Single extended send to super"
			[^client send: (method literalAt: byte2 \\ 32 + 1)
					super: true
					numArgs: byte2 // 32].
		offset = 6 ifTrue:   "Second extended send"
			[^client send: (method literalAt: byte2 \\ 64 + 1)
					super: false
					numArgs: byte2 // 64]].
	offset = 7 ifTrue: [^client doPop].
	offset = 8 ifTrue: [^client doDup].
	offset = 9 ifTrue: [^client pushActiveContext].
	byte2 := method at: pc. pc := pc + 1.
	offset = 10 ifTrue:
		[^byte2 < 128
			ifTrue: [client pushNewArrayOfSize: byte2]
			ifFalse: [client pushConsArrayWithElements: byte2 - 128]].
	byte3 := method at: pc.  pc := pc + 1.
	offset = 11 ifTrue: [^client callPrimitive: byte2 + (byte3 bitShift: 8)].
	offset = 12 ifTrue: [^client pushRemoteTemp: byte2 inVectorAt: byte3].
	offset = 13 ifTrue: [^client storeIntoRemoteTemp: byte2 inVectorAt: byte3].
	offset = 14 ifTrue: [^client popIntoRemoteTemp: byte2 inVectorAt: byte3].
	"offset = 15"
	byte4 := method at: pc.  pc := pc + 1.
	^client
		pushClosureCopyNumCopiedValues: (byte2 bitShift: -4)
		numArgs: (byte2 bitAnd: 16rF)
		blockSize: (byte3 * 256) + byte4! !

!InstructionStream methodsFor: '*Cog-method prototypes' stamp: 'eem 5/17/2014 17:21'!
InstructionStreamPROTOTYPEnextPc: currentByte
	"Answer the pc of the next bytecode following the current one, given the current bytecode.."

	^pc + (self method encoderClass bytecodeSize: currentByte)! !

!InstructionStream methodsFor: '*Cog-method prototypes' stamp: 'eem 11/27/2014 12:17'!
InstructionStreamPROTOTYPEskipCallPrimitive
	"If the receiver's method starts with a callPrimitive: bytecode, skip it."
	| method encoderClass callPrimitiveCode |
	method := self method.
	encoderClass := method encoderClass.
	callPrimitiveCode := encoderClass callPrimitiveCode.
	(method byteAt: pc) = callPrimitiveCode ifTrue:
		[pc := pc + (encoderClass bytecodeSize: callPrimitiveCode)]! !

Object subclass: #SimulatorHarness
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'VMObjectIndices'
	category: 'Cog-Bootstrapping'!

!SimulatorHarness methodsFor: 'testing' stamp: 'eem 11/17/2014 19:39'!
deny: aBooleanOrBlock
	aBooleanOrBlock value ifTrue: [AssertionFailure signal: 'Assertion failed']! !

!SimulatorHarness methodsFor: 'bootstrap methods' stamp: 'eem 9/5/2014 11:44'!
interpreter: sim object: receiver perform: selector withArguments: arguments
	"Interpret an expression in oldHeap using oldInterpreter.
	 Answer the result."
	| fp savedpc savedsp savedStackPages result startByteCount |
	self assert: ({receiver. selector}, arguments allSatisfy:
					[:oop| oop isInteger and: [sim objectMemory addressCouldBeOop: oop]]).
	savedpc := sim localIP.
	savedsp := sim localSP.
	savedStackPages := Set with: sim stackPage.
	sim internalPush: receiver.
	arguments do: [:arg| sim internalPush: arg].
	sim
		argumentCount: arguments size;
		messageSelector: selector.
	fp := sim localFP.
	startByteCount := sim byteCount.
	"sim byteCount = 66849 ifTrue: [self halt]."
	sim normalSend.
	sim incrementByteCount. "otherwise, send is not counted"
	["sim printFrame: sim localFP WithSP: sim localSP"
	 "sim setBreakSelector: #elementsForwardIdentityTo:"
	 "sim byteCount = 66849 ifTrue: [self halt]."
	 "(sim byteCount > 7508930 and: [sim localFP = -16r27894]) ifTrue:
		[self halt]."
	 fp = sim localFP] whileFalse:
		[sim singleStep.
		 (savedStackPages includes: sim stackPage) ifFalse: "If the stack gets deep something has probably gone wrong..."
			[savedStackPages size > 20 ifTrue: [self halt].
			 savedStackPages add: sim stackPage]].
	result := sim internalPopStack.
	self assert: savedsp = sim localSP.
	self assert: sim localIP - 1 = savedpc.
	sim localIP: savedpc.
	^result! !

!SimulatorHarness methodsFor: 'bootstrap methods' stamp: 'eem 10/15/2014 11:40'!
withExecutableInterpreter: sim do: aBlock
	"With the oldInterpreter ready to execute code, evaluate aBlock,
	 then return the interpreter (and the heap) to the ``just snapshotted'' state."
	| savedpc savedfp initialContext finalContext |
	sim
		initStackPages;
		loadInitialContext;
		internalizeIPandSP.
	savedpc := sim localIP.
	savedfp := sim localFP.
	"sim printHeadFrame."
	aBlock value.
	"sim printHeadFrame."
	sim
		internalPush: sim localIP;
		externalizeIPandSP.
	"now undo the execution state"
	self assert: sim localFP = savedfp.
	initialContext := sim frameContext: savedfp.
	finalContext := sim voidVMStateForSnapshotFlushingExternalPrimitivesIf: false.
	self assert: initialContext = finalContext.
	self assert: sim localIP = savedpc.
	sim objectMemory
		storePointer: SuspendedContextIndex
		ofObject: sim activeProcess
		withValue: finalContext! !

SimulatorHarness subclass: #Spur32BitPreen
	instanceVariableNames: 'oldHeap newHeap map reverseMap oldInterpreter newInterpreter imageHeaderFlags savedWindowSize'
	classVariableNames: ''
	poolDictionaries: 'VMObjectIndices'
	category: 'Cog-Bootstrapping'!

!Spur32BitPreen commentStamp: 'eem 8/15/2016 19:49' prior: 0!
A Spur32BitPreen is a simple image rewriter for 32-bit Spru images that eliminates free space and hence shrinks the preened image.  Use via
	Spur32BitPreen new preenImage: 'spur'
which will produce spur-preen.image and spur-preen.changes from spur.image and spur.changes.

Instance Variables
	imageHeaderFlags:		<Integer>
	map:					<Dictionary>
	newHeap:				<Spur32BitMMLESimulator>
	newInterpreter:			<StackInterpreterSimulatorLSB>
	oldHeap:				<Spur32BitMMLESimulator>
	oldInterpreter:			<StackInterpreterSimulatorLSB>
	reverseMap:			<Dictionary>
	savedWindowSize:		<Integer>

imageHeaderFlags
	- flags word in image header

map
	- map from oops in old image to oops in new image

newHeap
	- the preened heap

newInterpreter
	- the interpreter wrapping the preened heap

oldHeap
	- the heap to be preened

oldInterpreter
	- the interpreter wrapping the heap to be preened

reverseMap
	- map from oops in new image to oops in old image

savedWindowSize
	- screen size word in mage header
!

!Spur32BitPreen methodsFor: 'bootstrap image' stamp: 'eem 8/15/2016 17:15'!
clone: oldObj
	| newObj hash |
	newObj := newHeap
				allocateSlots: (oldHeap numSlotsOf: oldObj)
				format: (oldHeap formatOf: oldObj)
				classIndex: (oldHeap classIndexOf: oldObj).
	(hash := oldHeap rawHashBitsOf: oldObj) ~= 0 ifTrue:
		[newHeap setHashBitsOf: newObj to: hash].
	(oldHeap isImmutable: oldObj) ifTrue:
		[newHeap setIsImmutableOf: newObj to: true].
	(oldHeap isPinned: oldObj) ifTrue:
		[newHeap setIsPinnedOf: newObj to: true].
	self deny: (oldHeap isRemembered: oldObj).
	self deny: (oldHeap isMarked: oldObj).
	self deny: (oldHeap isGrey: oldObj).
	reverseMap at: newObj put: oldObj.
	^map at: oldObj put: newObj! !

!Spur32BitPreen methodsFor: 'bootstrap image' stamp: 'eem 8/15/2016 17:22'!
cloneFreeLists: oldObj
	| newObj |
	newObj := newHeap
				allocateSlots: newHeap numFreeLists
				format: newHeap wordIndexableFormat
				classIndex: newHeap wordSizeClassIndexPun.
	reverseMap at: newObj put: oldObj.
	^map at: oldObj put: newObj! !

!Spur32BitPreen methodsFor: 'bootstrap image' stamp: 'eem 12/16/2014 11:34'!
cloneObjects
	"Clone all normal objects.  Of hidden objects only clone the freeLists object and
	 the classTableRoot and class table pages. In particular, dont clone objStacks.
	 The refs to the objStacks are nilled out in fillInHeap."
	| i freeListsObject |
	i := 0.
	freeListsObject := oldHeap freeListsObject.
	oldHeap allOldSpaceObjectsDo:
		[:obj32|
		(i := i + 1) >= 100000 ifTrue:
			[Transcript nextPut: $:; flush. i := 0].
		 obj32 = freeListsObject
			ifTrue:
				[self cloneFreeLists: obj32]
			ifFalse:
				[(self shouldClone: obj32) ifTrue:
					[self clone: obj32]]]! !

!Spur32BitPreen methodsFor: 'bootstrap image' stamp: 'eem 11/17/2014 19:22'!
fillInBitsObject: obj64 from: obj32
	0 to: (oldHeap numBytesOf: obj32) - 1 do:
		[:i|
		newHeap
			storeByte: i
			ofObject: obj64
			withValue: (oldHeap fetchByte: i ofObject: obj32)]! !

!Spur32BitPreen methodsFor: 'bootstrap image' stamp: 'eem 8/15/2016 19:21'!
fillInClassTable
	self fillInPointerObject: (map at: oldHeap classTableRootObj) from: oldHeap classTableRootObj! !

!Spur32BitPreen methodsFor: 'bootstrap image' stamp: 'eem 8/15/2016 15:45'!
fillInCompiledMethod: newObj from: oldObj
	"oldInterpreter printOop: oldObj"
	"newInterpreter printOop: newObj"
	0 to: (oldHeap numPointerSlotsOf: oldObj) - 1 do:
		[:i| | oldOop newOop |
		 oldOop := oldHeap fetchPointer: i ofObject: oldObj.
		 newOop := self map32BitOop: oldOop.
		 newHeap
			storePointerUnchecked: i
			ofObject: newObj
			withValue: newOop].
	(oldInterpreter startPCOfMethod: oldObj)
		to: (oldHeap numBytesOf: oldObj) - 1
		do: [:j|
			newHeap
				storeByte: j 
				ofObject: newObj
				withValue: (oldHeap fetchByte: j ofObject: oldObj)]! !

!Spur32BitPreen methodsFor: 'bootstrap image' stamp: 'eem 11/19/2014 12:50'!
fillInHeap
	| heapEnd freeListsObj |
	heapEnd := newHeap freeStart.
	newHeap
		nilObject: (map at: oldHeap nilObject);
		falseObject: (map at: oldHeap falseObject);
		trueObject: (map at: oldHeap trueObject);
		specialObjectsOop: (map at: oldHeap specialObjectsOop);
		lastHash: oldHeap lastHash;
		setHiddenRootsObj: (map at: oldHeap classTableRootObj).
	newHeap segmentManager
		initSegmentForInImageCompilationFrom: newHeap nilObject
		to: heapEnd + newHeap bridgeSize.
	freeListsObj := newHeap objectAfter: newHeap trueObject.
	"Nil-out the free lists."
	newHeap
		fillObj: freeListsObj numSlots: (newHeap numSlotsOf: freeListsObj) with: 0;
		initializeFreeSpacePostLoad: freeListsObj;
		initializePostBootstrap;
		setEndOfMemory: (newHeap segmentManager bridgeAt: 0) + newHeap baseHeaderSize! !

!Spur32BitPreen methodsFor: 'bootstrap image' stamp: 'eem 8/15/2016 19:36'!
fillInObjects
	"interpreter32 printOop: oldObj"
	| i |
	{oldHeap markStack. oldHeap weaklingStack. oldHeap mournQueue} do:
		[:obj|
		obj ~= oldHeap nilObject ifTrue:
			[map at: obj put: (map at: oldHeap nilObject)]].
	i := 0.
	oldHeap allObjectsDo:
		[:oldObj|
		(i := i + 1) >= 10000 ifTrue:
			[Transcript nextPut: $.; flush. i := 0].
		(map at: oldObj ifAbsent: nil)
			ifNotNil:
				[:newObj| | format |
				(newHeap numSlotsOf: newObj) > 0 ifTrue: "filter-out filtered objStack pages"
					[format := oldHeap formatOf: oldObj.
					 (newHeap isPointersFormat: format)
						ifTrue:
							[self fillInPointerObject: newObj from: oldObj]
						ifFalse:
							[(newHeap isCompiledMethodFormat: format)
								ifTrue: [self fillInCompiledMethod: newObj from: oldObj]
								ifFalse: [self fillInBitsObject: newObj from: oldObj]]]]
			ifNil: [self assert: (self isUnmappedObject: oldObj)]]! !

!Spur32BitPreen methodsFor: 'bootstrap image' stamp: 'eem 8/15/2016 16:12'!
fillInPointerObject: newObj from: oldObj 
	0 to: (oldHeap numSlotsOf: oldObj) - 1 do:
		[:i|
		 newHeap
			storePointerUnchecked: i
			ofObject: newObj
			withValue: (self map32BitOop: (oldHeap fetchPointer: i ofObject: oldObj))]! !

!Spur32BitPreen methodsFor: 'bootstrap image' stamp: 'eem 11/17/2014 20:15'!
incrementPCField: fieldIndex ofObject: obj64 for: method32
	| value nLits |
	value := newHeap fetchPointer: fieldIndex ofObject: obj64.
	(newHeap isIntegerObject: value)
		ifTrue:
			[nLits := oldHeap literalCountOf: method32.
			 newHeap
				storePointerUnchecked: fieldIndex
				ofObject: obj64
				withValue: (newHeap integerObjectOf: nLits + LiteralStart * 4 + (newHeap integerValueOf: value))]
		ifFalse:
			[self assert: (reverseMap at: value) = oldHeap nilObject]! !

!Spur32BitPreen methodsFor: 'initialize-release' stamp: 'eem 8/15/2016 15:49'!
initMaps
	map := Dictionary new: oldHeap memory size // 32.
	reverseMap := Dictionary new: oldHeap memory size // 32! !

!Spur32BitPreen methodsFor: 'bootstrap image' stamp: 'eem 8/15/2016 16:13'!
isUnmappedObject: obj32
	"Answer if obj32 is an object that is not cloned by the bootstrap."
	^obj32 = oldHeap freeListsObject
	  or: [(oldHeap isValidObjStackPage: obj32)]! !

!Spur32BitPreen methodsFor: 'bootstrap image' stamp: 'eem 8/15/2016 15:40'!
map32BitOop: obj32
	"oldInterpreter printOop: obj32"
	^map
		at: obj32
		ifAbsent:
			[(oldHeap isImmediateCharacter: obj32)
				ifTrue: [newHeap characterObjectOf: (oldHeap characterValueOf: obj32)]
				ifFalse: [newHeap integerObjectOf: (oldHeap integerValueOf: obj32)]]! !

!Spur32BitPreen methodsFor: 'public access' stamp: 'eem 8/15/2016 15:56'!
on: imageName
	(oldInterpreter := StackInterpreterSimulator newWithOptions: #(ObjectMemory Spur32BitMemoryManager))
		openOn: imageName extraMemory: 0.
	oldHeap := oldInterpreter objectMemory.
	imageHeaderFlags := oldInterpreter getImageHeaderFlags.
	savedWindowSize := oldInterpreter savedWindowSize.
	newInterpreter := StackInterpreterSimulator newWithOptions: #(ObjectMemory Spur32BitMemoryManager).
	newHeap := newInterpreter objectMemory.
	newHeap
		allocateMemoryOfSize: oldHeap oldSpaceSize
		newSpaceSize: 8 * 1024 * 1024
		stackSize: 16 * 1024
		codeSize: 0.
	newHeap bootstrapping: true.
	self initMaps! !

!Spur32BitPreen methodsFor: 'public access' stamp: 'eem 8/15/2016 19:01'!
preenImage
	self cloneObjects.
	self fillInObjects.
	self fillInClassTable.
	self fillInHeap.
	self reportSizes! !

!Spur32BitPreen methodsFor: 'public access' stamp: 'eem 8/15/2016 15:56'!
preenImage: imageName
	(Smalltalk classNamed: #FileReference) ifNotNil:
		[^self preenImageUsingFileReference: imageName].
	(Smalltalk classNamed: #FileDirectory) ifNotNil:
		[^self preenImageUsingFileDirectory: imageName].
	self error: 'at a loss as to what file system support to use'! !

!Spur32BitPreen methodsFor: 'public access' stamp: 'eem 8/15/2016 15:56'!
preenImageUsingFileDirectory: imageName
	| dirName baseName dir |
	dirName := FileDirectory dirPathFor: imageName.
	baseName := (imageName endsWith: '.image')
					ifTrue: [FileDirectory baseNameFor: imageName]
					ifFalse: [FileDirectory localNameFor: imageName].
	dir := dirName isEmpty ifTrue: [FileDirectory default] ifFalse: [FileDirectory default on: dirName].
	self on: (dir fullNameFor: baseName, '.image').
	[self preenImage]
		on: Halt
		do: [:ex|
			"suppress halts from the usual suspects (development time halts)"
			(#(fullGC compactImage) includes: ex signalerContext sender selector)
				ifTrue: [ex resume]
				ifFalse: [ex pass]].
	self writeSnapshot: (dir fullNameFor: baseName, '-preen.image')
		headerFlags: imageHeaderFlags
		screenSize: savedWindowSize.
	dir deleteFileNamed: baseName, '-preen.changes';
		copyFileNamed: baseName, '.changes' toFileNamed: baseName, '-preen.changes'! !

!Spur32BitPreen methodsFor: 'bootstrap image' stamp: 'eem 8/15/2016 19:40'!
reportSizes
	| change oldHeapSize newHeapSize |
	oldHeapSize := oldHeap oldSpaceSize.
	newHeapSize := newHeap oldSpaceSize.
	change := newHeapSize - oldHeapSize / oldHeapSize.
	Transcript
		nextPutAll: 'done.'; cr;
		nextPutAll: 'old heap size: '; nextPutAll: oldHeapSize asStringWithCommas; tab;
		nextPutAll: 'initial new heap size: '; nextPutAll: newHeapSize asStringWithCommas; cr;
		nextPutAll: 'change: '; print: change * 100.0 maxDecimalPlaces: 2; nextPut: $%; cr;
		flush.
	newHeapSize := newHeap endOfMemory
					- newHeap scavenger eden limit
					- newHeap totalFreeListBytes.
	change := newHeapSize - oldHeapSize / oldHeapSize.
	Transcript
		nextPutAll: 'final new heap size: '; nextPutAll: newHeapSize asStringWithCommas; tab;
		nextPutAll: 'change: '; print: change * 100.0 maxDecimalPlaces: 2; nextPut: $%; cr;
		flush! !

!Spur32BitPreen methodsFor: 'bootstrap image' stamp: 'eem 8/15/2016 15:41'!
shouldClone: obj32
	^(oldHeap isValidObjStackPage: obj32) not! !

!Spur32BitPreen methodsFor: 'snapshot' stamp: 'eem 8/15/2016 15:43'!
writeSnapshot: imageFileName headerFlags: headerFlags screenSize: screenSizeInteger
	newHeap
		checkFreeSpace;
		runLeakCheckerForFullGC.
	newInterpreter
		setImageHeaderFlagsFrom: headerFlags;
		setDisplayForm: nil;
		setSavedWindowSize: savedWindowSize;
		imageName: imageFileName;
		writeImageFileIO.
	Transcript cr; show: 'Done!!'! !

SimulatorHarness subclass: #SpurBootstrap
	instanceVariableNames: 'oldHeap newHeap oldHeapSize newHeapSize oldHeapNumObjs newHeapNumObjs map reverseMap classToIndex oldInterpreter lastClassTablePage literalMap methodClasses installedPrototypes installedMethodOops classMetaclass imageTypes classMethodContextIndex classBlockClosureIndex toBeInitialized'
	classVariableNames: 'ImageHeaderFlags ImageName ImageScreenSize TransformedImage'
	poolDictionaries: 'VMObjectIndices'
	category: 'Cog-Bootstrapping'!

!SpurBootstrap commentStamp: 'eem 9/11/2013 05:45' prior: 0!
SpurBootstrap bootstraps an image in SpurMemoryManager format from a Squeak V3 + closures format.

e.g.
	(SpurBootstrap32 new on: '/Users/eliot/Cog/startreader.image')
		transform;
		launch

Bootstrap issues:
- should it implement a deterministic Symbol identityHash? This means set a Symbol's identityHash at instance creation time
  based on its string hash so that e.g. MethodDIctionary instances have a deterministic order and don't need to be rehashed on load.
- should it collapse ContextPart and MethodContext down onto Context (and perhaps eliminate BlockContext)?

Instance Variables
	classToIndex:			<Dictionary>
	lastClassTablePage:	<Integer>
	map:					<Dictionary>
	methodClasses:		<Set>
	newHeap:				<SpurMemoryManager>
	oldHeap:				<NewObjectMemory>
	oldInterpreter:			<StackInterpreterSimulator>
	reverseMap:			<Dictionary>
	symbolMap:				<Dictionary>

classToIndex
	- oldClass to new classIndex map

lastClassTablePage
	- oop in newHeap of last classTable page.  U<sed in validation to filter-out class table.

methodClasses
	- cache of methodClassAssociations for classes in which modified methods are installed

map
	- oldObject to newObject map

newHeap
	- the output, bootstrapped image

oldHeap
	- the input, image

oldInterpreter
	- the interpreter associated with oldHeap, needed for a hack to grab WeakArray

reverseMap
	- newObject to oldObject map

symbolMap
	- symbol toi symbol oop in oldHeap, used to map prototype methdos to methods in oldHeap!

!SpurBootstrap class methodsFor: 'utilities' stamp: 'eem 5/18/2016 09:45'!
bootstrapCuisImage: imageFileBaseName
	self bootstrapImage: imageFileBaseName type: #('squeak' 'cuis')! !

!SpurBootstrap class methodsFor: 'utilities' stamp: 'eem 7/31/2014 13:12'!
bootstrapImage: imageFileNameOrBaseName type: typeName
	"SpurBootstrap bootstrapImage: '/Users/eliot/Squeak/Squeak4.5/Squeak4.5-13680'"
	| imageFileBaseName imageFormat |
	imageFileBaseName := (imageFileNameOrBaseName endsWith: '.image')
								ifTrue: [imageFileNameOrBaseName allButLast: 6]
								ifFalse: [imageFileNameOrBaseName].
	imageFormat := ImageFormat fromFile: imageFileBaseName, '.image'.
	imageFormat requiresClosureSupport ifFalse:
		[self error: 'Can''t bootstrap this image since Spur assumes closure support.'].
	imageFormat requiresSpurSupport ifTrue:
		[self error: 'This image is already in Spur format.'].
	imageFormat is32Bit ifTrue:
		[^SpurBootstrap32 new bootstrapImage: imageFileBaseName type: typeName].
	self error: '64-bit support and 64-bit generation as-yet-unimplemented'! !

!SpurBootstrap class methodsFor: 'utilities' stamp: 'eem 8/8/2014 17:24'!
bootstrapOldSqueakImage: imageFileBaseName
	"Try asnd bootstrap a pre-CompiledMethodTrailer Squeak image."
	self bootstrapImage: imageFileBaseName type: #('squeak' 'old squeak')! !

!SpurBootstrap class methodsFor: 'utilities' stamp: 'EstebanLorenzano 10/14/2014 15:08'!
bootstrapPharoImage: imageFileBaseName
	| oldCompilerClass oldBytecodeBackend |
	
	oldCompilerClass := SmalltalkImage compilerClass.
	oldBytecodeBackend := CompilationContext bytecodeBackend. 
	[ 
		SmalltalkImage compilerClass: Compiler. 
		CompilationContext bytecodeBackend: IRSpurSqueakV3PlusClosuresBytecodeGenerator.
		self bootstrapImage: imageFileBaseName type: 'pharo' ]
	ensure: [ 
		SmalltalkImage compilerClass: oldCompilerClass.
		CompilationContext bytecodeBackend: oldBytecodeBackend ]! !

!SpurBootstrap class methodsFor: 'utilities' stamp: 'EstebanLorenzano 7/2/2014 17:26'!
bootstrapSqueakImage: imageFileBaseName
	self bootstrapImage: imageFileBaseName type: 'squeak'! !

!SpurBootstrap class methodsFor: 'method prototype categorization' stamp: 'eem 5/29/2015 16:44'!
categoryForClass: className meta: isMeta selector: selector 
	^(isMeta
			ifTrue: [{ className. #class. selector }]
			ifFalse: [{ className. selector }])
		caseOf: {
			[#(Behavior allInstancesOrNil)]					-> [#enumerating].
			[#(Behavior byteSizeOfInstance)]				-> [#'accessing instances and variables'].
			[#(Behavior byteSizeOfInstanceOfSize:)]		-> [#'accessing instances and variables'].
			[#(Behavior elementSize)]						-> [#'accessing instances and variables'].
			[#(Behavior handleFailingBasicNew)]			-> [#private].
			[#(Behavior handleFailingBasicNew:)]			-> [#private].
			[#(Behavior handleFailingFailingBasicNew)]		-> [#private].
			[#(Behavior handleFailingFailingBasicNew:)]		-> [#private].
			[#(Behavior identityHash)]						-> [#comparing].
			[#(Behavior isCompiledMethodClass)]			-> [#testing].
			[#(Behavior isEphemeronClass)]				-> [#testing].
			[#(Behavior isImmediateClass)]					-> [#testing].
			[#(BoxedFloat64 class basicNew)]				-> [#'instance creation'].
			[#(BoxedFloat64 class basicNew:)]				-> [#'instance creation'].
			[#(Character identityHash)]						-> [#comparing].
			[#(Character setValue:)]						-> [#accessing].
			[#(Class immediateSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:)]
															-> [#'subclass creation'].
			[#(ClassBuilder superclass:immediateSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:)]
															-> [#public].
			[#(CompiledMethod bytecodeSetName)]		-> [#accessing].
			[#(CompiledMethod class handleFailingFailingNewMethod:header:)]
															-> [#private].
			[#(CompiledMethod class handleFailingNewMethod:header:)]
															-> [#private].
			[#(CompiledMethod class headerFlagForEncoder:)]
															-> [#'method encoding'].
			[#(CompiledMethod class installPrimaryBytecodeSet:)]
															-> [#'class initialization'].
			[#(CompiledMethod class installSecondaryBytecodeSet:)]
															-> [#'class initialization'].
			[#(Context class allInstances)]					-> [#enumerating].
			[#(Context class allInstancesDo:)]				-> [#enumerating].
			[#(Context failPrimitiveWith:)]					-> [#'system simulation'].
			[#(Context isPrimFailToken:)]					-> [#private].
			[#(Context send:to:with:lookupIn:)]				-> [#controlling].
			[#(ContextPart isPrimFailToken:)]				-> [#private].
			[#(ContextPart send:to:with:lookupIn:)]			-> [#controlling].
			[#(EncoderForV3 computeMethodHeaderForNumArgs:numTemps:numLits:primitive:)]
															-> [#'method encoding'].
			[#(EncoderForV3PlusClosures genCallPrimitive:)]
															-> [#'bytecode generation'].
			[#(EncoderForV3PlusClosures class callPrimitiveCode)]
															-> [#'bytecode decoding'].
			[#(InstructionClient callPrimitive:)]				-> [#'instruction decoding'].
			[#(MethodContext failPrimitiveWith:)]			-> [#'system simulation'].
			[#(MethodContext class allInstances)]			-> [#enumerating].
			[#(MethodContext class allInstancesDo:)]		-> [#enumerating].
			[#(Object isPinned)]							-> [#'system primitives'].
			[#(Object pin)]									-> [#'system primitives'].
			[#(Object setPinned:)]							-> [#'system primitives'].
			[#(Object unpin)]								-> [#'system primitives'].
			[#(SmallFloat64 class basicNew)]				-> [#'instance creation'].
			[#(SmallFloat64 class basicNew:)]				-> [#'instance creation'].
			[#(SmallFloat64 clone)]							-> [#copying].
			[#(SmallFloat64 copy)]							-> [#copying].
			[#(SmallFloat64 deepCopy)]					-> [#copying].
			[#(SmallFloat64 identityHash)]					-> [#comparing].
			[#(SmallFloat64 shallowCopy)]					-> [#copying].
			[#(SmallFloat64 veryDeepCopyWith:)]			-> [#copying].
			[#(SmallInteger asCharacter)]					-> [#converting].
			[#(SmalltalkImage growMemoryByAtLeast:)]	-> [#'memory space'].
			[#(SmalltalkImage maxIdentityHash)]			-> [#'system attributes'].
			[#(SystemDictionary growMemoryByAtLeast:)]	-> [#'memory space'].
			[#(SystemDictionary maxIdentityHash)]			-> [#'system attributes'].
			[#(SystemDictionary setGCParameters)]		-> [#'snapshot and quit'].
			[#(SystemNavigation allObjects)]				-> [#query].
			[#(SystemNavigation allObjectsOrNil)]			-> [#query].
			 }
		otherwise:
			[Transcript nextPutAll: className.
			 isMeta ifTrue: [Transcript nextPutAll: ' class'].
			 Transcript nextPutAll: '>>'; store: selector; nextPutAll: ' is unclassified'; cr; flush.
			 ^Categorizer default]! !

!SpurBootstrap class methodsFor: 'debugger' stamp: 'eem 7/31/2014 13:47'!
defaultIntegerBaseInDebugger
	^16! !

!SpurBootstrap class methodsFor: 'utilities' stamp: 'eem 9/7/2014 14:35'!
isolatedPrototypes
	"SpurBootstrap isolatedPrototypes"
	| prototypes |
	prototypes := (self systemNavigation allMethodsSelect:
						[:m| m selector includesSubString: 'PROTOTYPE'])
							collect: [:mr| mr compiledMethod].
	^prototypes select:
		[:m|
		(m methodClass includesBehavior: SpurBootstrapPrototypes)
			ifTrue:
				[(m pragmaAt: #indirect) notNil
				  and: [prototypes noneSatisfy:
						[:p|
						p selector == m selector
						and: [p methodClass ~~ m methodClass]]]]
			ifFalse:
				[prototypes noneSatisfy:
					[:p|
					p selector == m selector
					and: [(p methodClass includesBehavior: SpurBootstrapPrototypes)
					and: [(p pragmaAt: #indirect) notNil]]]]]! !

!SpurBootstrap class methodsFor: 'tests' stamp: 'eem 3/3/2014 18:39'!
testComputeFormat
	"self testComputeFormat"
	#(	(normal 0)
		(bytes 16)
		(words 12)
		(variable 2)
		(weak 4)
		(ephemeron 5)
		(immediate 7)
		(compiledMethod 24)) do:
		[:tuple|
		 [:type :instSpec| | fmt |
		   fmt := [self ClassBuilderPROTOTYPEcomputeFormat: type instSize: 0 forSuper: Object ccIndex: 0]
					on: MessageNotUnderstood
					do: [:ex|
						ex message selector ~~ #format:variable:words:pointers:weak: ifTrue:
							[ex pass].
						self perform: #ClassBuilderPROTOTYPEformat:variable:words:pointers:weak:
							withArguments: ex message arguments].
		   self assert: (fmt >> 16 = instSpec
						or: [type = #compiledMethod and: [fmt = CompiledMethod format]]).
		 ] valueWithArguments: tuple]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'EstebanLorenzano 8/26/2014 13:40'!
addMissingClassVars: classVars
	"Add any missing class vars given classVars, a Dictionary from nonMetaClass to binding.
	 Initialize any classes that get inst vars added."
	| addClassVarNameSym bindingOfSym |
	classVars isEmpty ifTrue:
		[^self].
	addClassVarNameSym := self findSymbol: #addClassVarName:.
	addClassVarNameSym ifNil: 
		[addClassVarNameSym := self findSymbol: #addClassVarNamed:].
	bindingOfSym := self findSymbol: #bindingOf:.
	classVars keysAndValuesDo:
		[:binding :class| 
		Transcript cr;  nextPutAll: 'ADDING CLASS VAR '; store: binding key; nextPutAll: ' TO '; print: class; flush.
		self interpreter: oldInterpreter
			object: (self oldClassOopFor: class)
			perform: addClassVarNameSym
			withArguments: {oldHeap stringForCString: binding key}.
		literalMap
			at: binding
			put: (self interpreter: oldInterpreter
					object: (self oldClassOopFor: class)
					perform: bindingOfSym
					withArguments: {self findSymbol: binding key})].
	toBeInitialized := classVars asSet! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 8/23/2014 16:39'!
addNewMethods
	"Get the simulator to add any and all missing methods immediately."
	| cmaiaSym basSym |
	cmaiaSym := self findSymbol: #compiledMethodAt:ifAbsent:.
	basSym := self findSymbol: #basicAddSelector:withMethod:.
	basSym ifNil:
		[basSym := self findSymbol: #addSelectorSilently:withMethod:].
	self allPrototypeClassNamesDo:
		[:sym :symIsMeta|
		(self findClassNamed: (literalMap at: sym))
			ifNil: [Transcript
					cr;
					nextPutAll: 'not installing any methods for ';
					nextPutAll: sym;
					nextPutAll: '; class not found in image';
					flush.]
			ifNotNil:
				[:theClass| | class |
				class := symIsMeta ifTrue: [oldHeap fetchClassOfNonImm: theClass] ifFalse: [theClass].
				self prototypeClassNameMetaSelectorMethodDo:
					[:className :isMeta :selector :method| | methodOrNil |
					(className = sym
					 and: [symIsMeta = isMeta
					 and: [(method pragmaAt: #remove) isNil]]) ifTrue:
						["probe method dictionary of the class for each method, installing a dummy if not found."
						 "Transcript cr; nextPutAll: 'checking for '; nextPutAll: selector; flush."
						 methodOrNil := self interpreter: oldInterpreter
											object: class
											perform: cmaiaSym
											withArguments: {literalMap at: selector. oldHeap nilObject}.
						 methodOrNil = oldHeap nilObject
							ifTrue: "no method.  install the real thing now"
								[Transcript
									cr;
									nextPutAll: 'installing ';
									nextPutAll: className;
									nextPutAll: (isMeta ifTrue: [' class>>'] ifFalse: ['>>']);
									store: selector;
									flush.
								 self interpreter: oldInterpreter
									object: class
									perform: basSym
									withArguments: { literalMap at: selector.
													   self installableMethodFor: method
														selector: selector
														className: className
														isMeta: isMeta}.
								installedPrototypes add: method selector]
							ifFalse: "existing method; collect the methodClassAssociation; its needed later"
								[methodClasses add: (oldInterpreter methodClassAssociationOf: methodOrNil)]]]]]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 12/14/2015 15:19'!
allInstancesOf: classOop
	| instances |
	instances := OrderedCollection new.
	oldHeap allObjectsDo:
		[:o|
		((oldHeap isPointersNonImm: o)
		 and: [(oldHeap fetchClassOf: o) = classOop]) ifTrue:
			[instances addLast: o]].
	^instances! !

!SpurBootstrap methodsFor: 'method prototypes' stamp: 'eem 5/23/2016 15:29'!
allMethodPrototypes
	"Answer all prototype selectors, including those marked <remove>"
	^(imageTypes 
		inject: (IdentitySet withAll: SpurBootstrapPrototypes allMethodPrototypes)
		into: [:allPrototypes :type | | prototypes |
			prototypes := (SpurBootstrapPrototypes prototypeClassFor: type) allMethodPrototypes.
			allPrototypes
				removeAllSuchThat: [:existing| prototypes anySatisfy: [:new| existing selector == new selector]];
				addAll: (prototypes reject: [:prototype| (prototype pragmaAt: #ignore) notNil]);
				yourself])
		asArray sort: [:ma :mb| ma selector <= mb selector]! !

!SpurBootstrap methodsFor: 'method prototypes' stamp: 'eem 9/6/2013 21:32'!
allPrototypeClassNamesDo: aBlock
	"self basicNew allPrototypeClassNames"
	| pairs |
	pairs := Set new.
	self prototypeClassNameMetaSelectorMethodDo:
		[:className :isMeta :selector :method |
		pairs add: {className. isMeta}].
	pairs do: [:pair| aBlock value: pair first value: pair last]! !

!SpurBootstrap methodsFor: 'method prototypes' stamp: 'eem 8/12/2014 13:03'!
allPrototypeMethodSymbols
	"self basicNew allPrototypeMethodSymbols"
	| symbols |
	self assert: SpurBootstrap isolatedPrototypes isEmpty.
	symbols := Set new.
	self prototypeClassNameMetaSelectorMethodDo:
		[:className :isMeta :selector :method | | adder |
		symbols
			add: className;
			add: selector.	
		adder := [:lit|
				   (lit isSymbol and: [lit ~~ method selector]) ifTrue: [symbols add: lit].
				   lit isArray ifTrue: [lit do: adder]].
		method literals do: adder].
	^symbols! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 10/14/2014 08:29'!
allocateClassTable
	"Allocate the root of the classTable plus enough pages to accomodate all classes in
	 the classToIndex map.  Don't fill in the entries yet; the classes have yet to be cloned."
	| tableRoot page maxSize numPages |
	tableRoot := newHeap
					allocateSlots: newHeap classTableRootSlots + newHeap hiddenRootSlots
					format: newHeap arrayFormat
					classIndex: newHeap arrayClassIndexPun.
	self assert: (newHeap numSlotsOf: tableRoot) = (newHeap classTableRootSlots + newHeap hiddenRootSlots).
	self assert: (newHeap formatOf: tableRoot) = newHeap arrayFormat.
	self assert: (newHeap classIndexOf: tableRoot) = newHeap arrayClassIndexPun.
	newHeap nilFieldsOf: tableRoot.
	"first page is strong"
	page := newHeap
					allocateSlots: newHeap classTablePageSize
					format: newHeap arrayFormat
					classIndex: newHeap arrayClassIndexPun.
	self assert: (newHeap numSlotsOf: page) = newHeap classTablePageSize.
	self assert: (newHeap formatOf: tableRoot) = newHeap arrayFormat.
	self assert: (newHeap classIndexOf: tableRoot) = newHeap arrayClassIndexPun.
	self assert: (newHeap objectAfter: tableRoot limit: newHeap freeStart) = page.
	lastClassTablePage := page.
	newHeap nilFieldsOf: page.
	newHeap storePointer: 0 ofObject: tableRoot withValue: page.
	newHeap setHiddenRootsObj: tableRoot.
	maxSize := classToIndex inject: 0 into: [:a :b| a max: b].
	numPages := (maxSize + newHeap classTableMinorIndexMask / newHeap classTablePageSize) truncated.
	2 to: numPages do:
		[:i|
		page := newHeap
					allocateSlots: newHeap classTablePageSize
					format: newHeap arrayFormat
					classIndex: newHeap arrayClassIndexPun.
		self assert: (newHeap numSlotsOf: page) = newHeap classTablePageSize.
		self assert: (newHeap formatOf: page) = newHeap arrayFormat.
		self assert: (newHeap classIndexOf: page) = newHeap arrayClassIndexPun.
		newHeap fillObj: page numSlots: newHeap classTablePageSize with: newHeap nilObject.
		newHeap storePointer: i - 1 ofObject: tableRoot withValue: page.
		self assert: (newHeap objectAfter: (newHeap fetchPointer: i - 2 ofObject: tableRoot)  limit: newHeap freeStart) = page.
		lastClassTablePage := page].
	"and once again to recompute numClassTablePages post building the class table."
	newHeap instVarNamed: 'numClassTablePages' put: nil.
	newHeap setHiddenRootsObj: tableRoot! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 5/18/2016 16:34'!
allocateFreeLists
	"Allocate the freeLists array."
	| freeListsOop |
	freeListsOop := newHeap
						allocateSlots: newHeap numFreeLists
						format: newHeap wordIndexableFormat
						classIndex: newHeap wordSizeClassIndexPun.
	self assert: (newHeap objectAfter: newHeap trueObject) = freeListsOop.
	0 to: newHeap numFreeLists - 1 do:
		[:i|
		newHeap
			storePointerUnchecked: i
			ofObject: freeListsOop
			withValue: 0]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/20/2014 03:09'!
bootstrapImage
	oldHeap fullGC.
	self measureOldHeapPostGC.
	self initMaps.
	Transcript cr; nextPutAll: 'transforming image...'; flush.
	self cloneNilTrueAndFalse.
	self allocateFreeLists.
	self buildClassMap.
	self allocateClassTable.
	self cloneObjects.
	self fillInObjects.
	self fillInClassTable.
	newHeapSize := newHeap freeStart.
	newHeap initializePostBootstrap.
	self measureNewHeapPostInitPostBootstrap! !

!SpurBootstrap methodsFor: 'public access' stamp: 'eem 7/8/2014 12:33'!
bootstrapImage: imageName
	(Smalltalk classNamed: #FileReference) ifNotNil:
		[^self bootstrapImageUsingFileReference: imageName].
	(Smalltalk classNamed: #FileDirectory) ifNotNil:
		[^self bootstrapImageUsingFileDirectory: imageName].
	self error: 'at a loss as to what file system support to use'! !

!SpurBootstrap methodsFor: 'public access' stamp: 'eem 5/18/2016 09:28'!
bootstrapImage: imageName type: typeNameOrArrayOfTypeNames
	"type can be:
		- 'squeak'
		- {'old squeak' 'squeak' }
		- { 'cuis' 'squeak' }
		- 'pharo'
		- it might be 'newspeak', if needed (but is not implemented)"
	imageTypes := typeNameOrArrayOfTypeNames isArray
						ifTrue: [typeNameOrArrayOfTypeNames]
						ifFalse: [{typeNameOrArrayOfTypeNames}].
	self bootstrapImage: imageName
	! !

!SpurBootstrap methodsFor: 'public access' stamp: 'eem 10/16/2014 15:31'!
bootstrapImageUsingFileDirectory: imageName
	| dirName baseName dir |
	dirName := FileDirectory dirPathFor: imageName.
	baseName := (imageName endsWith: '.image')
					ifTrue: [FileDirectory baseNameFor: imageName]
					ifFalse: [FileDirectory localNameFor: imageName].
	dir := dirName isEmpty ifTrue: [FileDirectory default] ifFalse: [FileDirectory default on: dirName].
	self on: (dir fullNameFor: baseName, '.image').
	[self transform]
		on: Halt
		do: [:ex|
			"suppress halts from the usual suspects (development time halts)"
			(#(fullGC compactImage) includes: ex signalerContext sender selector)
				ifTrue: [ex resume]
				ifFalse: [ex pass]].
	self writeSnapshot: (dir fullNameFor: baseName, '-spur.image')
		ofTransformedImage: newHeap
		headerFlags: oldInterpreter getImageHeaderFlags
		screenSize: oldInterpreter savedWindowSize.
	dir deleteFileNamed: baseName, '-spur.changes';
		copyFileNamed: baseName, '.changes' toFileNamed: baseName, '-spur.changes'! !

!SpurBootstrap methodsFor: 'public access' stamp: 'eem 7/8/2014 12:32'!
bootstrapImageUsingFileReference: imageName
	| dirName baseName dir |
	dirName := imageName asFileReference parent fullName.
	baseName := (imageName endsWith: '.image')
		ifTrue: [ imageName asFileReference base ]
		ifFalse: [ (imageName, '.image') asFileReference base ].
	dir := dirName asFileReference.
	self on: (dir / (baseName, '.image')) fullName.
	[self transform]
		on: Halt
		do: [:ex|
			"suppress halts from the usual suspects (development time halts)"
			(#(fullGC compactImage) includes: ex signalerContext sender selector)
				ifTrue: [ex resume]
				ifFalse: [ex pass]].
	self writeSnapshot: (dir / (baseName, '-spur.image')) fullName
		ofTransformedImage: newHeap
		headerFlags: oldInterpreter getImageHeaderFlags
		screenSize: oldInterpreter savedWindowSize.
	(dir / (baseName, '.changes')) copyTo: (dir / (baseName, '-spur.changes'))! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/5/2013 12:53'!
buildClassMap
	"enumerate all objects asking isBehavior:?  (class == Metaclass or class class == Metaclass) doesn't work for Newspeak"
	"Build a map from all classes in oldHeap to a class index.
	 ONLY DEALS WITH CLASSES THAT HAVE INSTANCES!!!! (can walk superclass chain?  Can walk subclasses set? Can ask class == Metaclass or class class == Metaclass class?)"
	| classes classTableIndex |
	self defineKnownClassIndices.
	classes := classToIndex keys asSet.
	classTableIndex := classToIndex inject: 0 into: [:a :b| a max: b].
	oldHeap allObjectsDo:
		[:oldObj| | oldClass |
		 oldClass := oldHeap fetchClassOfNonImm: oldObj.
		 self assert: (oldHeap isPointersNonImm: oldClass).
		 (classes includes: oldClass) ifFalse:
			[classes add: oldClass.
			 classToIndex at: oldClass put: (classTableIndex := classTableIndex + 1)]]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/5/2014 11:40'!
checkReshapeOf: ourMethodClasses
	"Check the shape of all our method classes match the shape of those in the image to be bootstrapped.
	 Use the simulator to redefine any that need it.  Does /not/ reshape metaclasses; these we assume are ok."
	| toReshape |
	toReshape := Set new.
	ourMethodClasses do:
		[:mc|
		(literalMap at: mc binding ifAbsent: []) ifNotNil:
			[:binding|
			(mc ~~ Character "Character will reshape anyway"
			 and: [mc instSize ~= (oldHeap instanceSizeOf: (oldHeap fetchPointer: ValueIndex ofObject: binding))]) ifTrue:
				[toReshape add: mc]]].
	toReshape isEmpty ifTrue:
		[^self].
	self interpreter: oldInterpreter
			object: (self oldClassOopFor: ClassBuilder)
			perform: (self findSymbol: #beSilent:)
			withArguments: {oldHeap trueObject}.
	"Assume only one class in any subtree needs reshaping.  Fast and loose but gets us there for now."
	toReshape copy do:
		[:class|
		toReshape removeAll: (toReshape select: [:ea| ea inheritsFrom: class])].
	toReshape do:
		[:class|
		Transcript cr;  nextPutAll: 'RESHAPING '; print: class; flush.
		self interpreter: oldInterpreter
			object: (self oldClassOopFor: Compiler)
			perform: (self findSymbol: #evaluate:)
			withArguments: {oldHeap stringForCString: class definition}]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/21/2014 08:06'!
classMetaclass
	^classMetaclass ifNil:
		[classMetaclass := oldHeap fetchClassOfNonImm: (oldHeap fetchClassOfNonImm: oldHeap classArray)]! !

!SpurBootstrap methodsFor: 'method prototypes' stamp: 'eem 8/8/2014 15:55'!
classNameForPrototypeMethod: protoMethod
	| protoSelector |
	protoSelector := protoMethod selector.
	#('OLDSQUEAKPROTOTYPE' 'SQUEAKPROTOTYPE' 'PHAROPROTOTYPE' 'PROTOTYPE') do:
		[:prototype| | index |
		(index := protoSelector indexOfSubCollection: prototype) ~= 0 ifTrue:
			[^(protoSelector first: index - 1) asSymbol]].
	self error: 'really??'! !

!SpurBootstrap methodsFor: 'class indices' stamp: 'eem 8/30/2013 14:45'!
classTableSize
	^newHeap classIndexMask + 1! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/10/2014 19:38'!
clone: oldObj classIndex: classIndex
	| newObj format numBytes |
	((format := oldHeap formatOf: oldObj) >= oldHeap firstLongFormat
	 and: [numBytes := oldHeap numBytesOf: oldObj.
		format >= oldHeap firstCompiledMethodFormat
		and: [(oldInterpreter primitiveIndexOf: oldObj) > 0]]) ifTrue:
			[numBytes := numBytes + 3].
	newObj := newHeap
				allocateSlots: (format >= oldHeap firstLongFormat
								ifTrue: [newHeap numSlotsForBytes: numBytes]
								ifFalse: [oldHeap numSlotsOf: oldObj])
				format: (self newFormatFor: oldObj numBytes: numBytes)
				classIndex: classIndex.
	reverseMap at: newObj put: oldObj.
	^map at: oldObj put: newObj! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 7/17/2014 13:44'!
cloneArrayLiteral: anArray
	"Currently serves only to clone the #(0 0) literal in SpaceTallyPROTOTYPEspaceForInstancesOf:"
	| array |
	array := oldHeap instantiateClass: (oldHeap splObj: ClassArray) indexableSize: anArray size.
	1 to: anArray size do:
		[:i| | lit |
		lit := anArray at: i.
		lit class caseOf: {
			[SmallInteger] -> [oldHeap
									storePointerUnchecked: i - 1
									ofObject: array
									withValue: (oldHeap integerObjectOf: lit)].
			[ByteSymbol] -> [oldHeap
									storePointer: i - 1
									ofObject: array
									withValue: (self findSymbol: lit)].
			[UndefinedObject] -> [oldHeap
									storePointerUnchecked: i - 1
									ofObject: array
									withValue: oldHeap nilObject] }].
	^array
! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 8/19/2014 14:34'!
cloneMethodProxy: proxy "<VMCompiledMethodProxy>"
	| bytes newMethod delta |
	bytes := proxy size - proxy initialPC + 1.
	delta := proxy primitive > 0
				ifTrue: [3]
				ifFalse: [0].
	newMethod := CompiledMethod
						newMethod: bytes + delta
						header: (self headerForOldMethodHeader: (oldHeap integerObjectOf: proxy header)).
	1 to: proxy numLiterals - 1 do:
		[:i| newMethod literalAt: i put: (proxy literalAt: i)].
	newMethod
		literalAt: proxy numLiterals
		put: (Smalltalk bindingOf: #Character).
	delta > 0 ifTrue:
		[newMethod
			at: newMethod initialPC + 0 put: 139;
			at: newMethod initialPC + 1 put: (proxy primitive bitAnd: 16rFF);
			at: newMethod initialPC + 2 put: (proxy primitive bitShift: -8)].
	proxy initialPC to: proxy size do:
		[:i| newMethod at: i + delta put: (proxy at: i)].
	^newMethod! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/4/2013 17:05'!
cloneNilTrueAndFalse
	{	oldHeap nilObject.
		oldHeap falseObject.
		oldHeap trueObject. }
		with: (self firstOrdinaryClassIndex to: self firstOrdinaryClassIndex + 2)
		do: [:obj :classIndex|
			classToIndex at: (oldHeap fetchClassOfNonImm: obj) put: classIndex.
			self clone: obj classIndex: classIndex].
	newHeap
		nilObject: (map at: oldHeap nilObject); "needed for nilling objects etc"
		falseObject: (map at: oldHeap falseObject);
		trueObject: (map at: oldHeap trueObject)! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 7/17/2014 10:50'!
cloneObjects
	| specialObjectsArray characterClass characterTable compactClasses oldObj oldClass |
	specialObjectsArray := oldHeap specialObjectsOop.
	characterClass := oldHeap classCharacter.
	characterTable := oldHeap characterTable.
	compactClasses := oldHeap splObj: CompactClasses.
	self clone: specialObjectsArray
		classIndex: (classToIndex at: (oldHeap fetchClassOfNonImm: specialObjectsArray)).
	oldObj := oldHeap objectAfter: oldHeap trueObject.
	[oldObj < oldHeap freeStart] whileTrue:
		[oldClass := oldHeap fetchClassOfNonImm: oldObj.
		 (oldObj ~= characterTable
		 and: [oldObj ~= specialObjectsArray
		 and: [oldObj ~= compactClasses
		 and: [oldClass ~= characterClass]]]) ifTrue:
			[self clone: oldObj classIndex: (classToIndex at: oldClass)].
		 oldObj := oldHeap objectAfter: oldObj].
	newHeap
		specialObjectsOop: (map at: oldHeap specialObjectsOop);
		lastHash: oldHeap lastHash! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 9/30/2013 16:14'!
coHeapFrom: aSpur32BitMMLESimulator
	| coHeap |
	coHeap := Spur32BitMMLECoSimulator new.
	aSpur32BitMMLESimulator class allInstVarNames do:
		[:ivn|
		coHeap instVarNamed: ivn put: (aSpur32BitMMLESimulator instVarNamed: ivn)].
	coHeap scavenger instVarNamed: 'manager' put: coHeap.
	^coHeap! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/20/2013 11:27'!
compactImage
	| firstFree lastUsed |
	newHeap allHeapEntitiesDo:
		[:o|
		(newHeap isFreeObject: o)
			ifTrue: [firstFree ifNil: [firstFree := o]]
			ifFalse: [lastUsed := o]].
	lastUsed < firstFree ifTrue: "nothing to do"
		[^self].
	self halt! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/10/2014 13:07'!
convertOldMethodHeader: methodHeader
	^((oldInterpreter argumentCountOfMethodHeader: methodHeader) << 24)
	 + ((oldInterpreter temporaryCountOfMethodHeader: methodHeader) << 18)
	 + ((oldInterpreter methodHeaderIndicatesLargeFrame: methodHeader) ifTrue: [1 << 17] ifFalse: [0])
	 + ((oldInterpreter methodHeaderHasPrimitive: methodHeader) ifTrue: [1 << 16] ifFalse: [0])
	 + (oldHeap literalCountOfMethodHeader: methodHeader)! !

!SpurBootstrap methodsFor: 'class indices' stamp: 'eem 8/9/2014 10:14'!
defineKnownClassIndices
	"The classTable is laid out
		- to make it easy to map immediates to classes; the tag pattern of an immediate is its class index.
		  hence there are two entries for SmallInteger
		- to assign small indices to well-known classes such as Array, Message et al
		- to leave plenty of room for new known classes; hence the first page contains only well-known classes
		- to enable overlaps and avoid conflicts with indices in the specialObjectsArray (?really? eem)
		- to provide a WeakArray pun for the pages of the table itself so that these do not show up as instances of WeakArray"
	| classMethodContext classBlockClosure classMessage "no api method for these" |
	classMessage := oldHeap splObj: (VMObjectIndices bindingOf: #ClassMessage) value.
	classMethodContext := oldHeap splObj: (VMObjectIndices bindingOf: #ClassMethodContext) value.
	classBlockClosure := oldHeap splObj: (VMObjectIndices bindingOf: #ClassBlockClosure) value.
	"c.f. SpurMemoryManager class>>intializeCompactClassIndices".
	classToIndex keysDo:
		[:oldClass|
		self assert: (oldInterpreter addressCouldBeClassObj: oldClass)].
	classToIndex
		at: oldHeap classSmallInteger put: 1; "N.B. must fill-in index 3 manually"
		at: oldHeap classCharacter put: 2;
		"at: oldHeap classSmallInteger put: 3" "N.B. must fill-in index 3 manually"
		"leave room for up to 15 tagged classes"
		"leave room for up to 16 puns"
		at: oldHeap classLargeNegativeInteger put: 32;
		at: oldHeap classLargePositiveInteger put: 33;
		at: oldHeap classFloat put: 34;

		at: "oldHeap" classMessage put: 35;
		at: "oldHeap" classMethodContext put: (classMethodContextIndex := 36);
		at: "oldHeap" classBlockClosure put: (classBlockClosureIndex := 37);

		at: oldHeap classSemaphore put: 48;
		"at: oldHeap classMutex put: 49; see below"

		at: oldHeap classByteArray put: 50;
		at: oldHeap classArray put: 51;
		at: oldHeap classString put: 52;
		at: oldHeap classBitmap put: 53;
		at: oldHeap classPoint put: 54.

	{{oldHeap classMutex. 49}.
	 {oldHeap classExternalAddress. 128}.
	 {oldHeap classExternalData. 129}.
	 {oldHeap classExternalFunction. 130}.
	 {oldHeap classExternalLibrary. 131}.
	 {oldHeap classExternalStructure. 132}.
	 {oldHeap classAlien. 133}.
	 {oldHeap classUnsafeAlien. 134}}
		do: [:pair|
			[:oop :index|
			oop ~= oldHeap nilObject ifTrue:
				[classToIndex at: oop put: index]] valueWithArguments: pair].

	classToIndex keysDo:
		[:oldClass|
		self assert: (oldInterpreter addressCouldBeClassObj: oldClass)]! !

!SpurBootstrap methodsFor: 'public access' stamp: 'eem 5/29/2015 16:46'!
fileOutPrototypesFor: imageTypeOrArrayOfTypes
	"SpurBootstrap new fileOutPrototypesFor: 'squeak'"
	| internalStream |
	imageTypes := imageTypeOrArrayOfTypes isString
						ifTrue: [{imageTypeOrArrayOfTypes}]
						ifFalse: [imageTypeOrArrayOfTypes asArray].
	internalStream := WriteStream on: (String new: 1000).
	internalStream header; timeStamp.
	self prototypeClassNameMetaSelectorMethodDo:
		[:className :isMeta :selector :method| | classNameString class category preamble source |
		class := Smalltalk classNamed: className.
		isMeta
			ifTrue: [class := class class. classNameString := className, ' class']
			ifFalse: [classNameString := className].
		(method pragmaAt: #remove)
			ifNil:
				[category := class ifNotNil: [class organization categoryOfElement: selector].
				 (category notNil and: [category first = $*]) ifTrue:
					[category := nil].
				 category ifNil:
					[category := self class categoryForClass: className meta: isMeta selector: selector].
				preamble := classNameString, ' methodsFor: ' , category asString printString, ' stamp: ''', method timeStamp, ''''.
				internalStream nextPut: $!!; nextChunkPut: preamble; cr.
				source := method getSourceFromFile asString.
				source := source copyFrom: (source indexOfSubCollection: 'PROTOTYPE') + 9 to: source size.
				(self selectorForPrototypeMethod: method) isBinary ifTrue:
					[source := (self selectorForPrototypeMethod: method), (source copyFrom: (source indexOf: Character space) to: source size)].
				internalStream nextChunkPut: source; space; nextPut: $!!; cr; cr]
			ifNotNil:
				[source := classNameString, ' removeSelector: ', selector storeString.
				 internalStream nextChunkPut: source; cr; cr]].
	internalStream trailer.

	FileStream
		writeSourceCodeFrom: internalStream
		baseName: ('SpurBootstrapPrototypes-', (imageTypes fold: [:a :b| a, '-', b]) replaceAll: Character space with: $_)
		isSt: true
		useHtml: false! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/18/2013 10:57'!
fillInClassTable
	| firstPage maxIndex |
	maxIndex := 0.
	classToIndex keysAndValuesDo:
		[:oldClass :index| | newClass page |
		maxIndex := maxIndex max: index.
		newClass := map at: oldClass.
		self assert: (newHeap isPointersNonImm: newClass).
		newHeap setHashBitsOf: newClass to: index.
		page := newHeap
					fetchPointer: index >> newHeap classTableMajorIndexShift
					ofObject: newHeap classTableRootObj.
		newHeap
			storePointer: (index bitAnd: newHeap classTableMinorIndexMask)
			ofObject: page
			withValue: newClass.
		self assert: (newHeap classAtIndex: index) = newClass].
	firstPage := newHeap
					fetchPointer: 0
					ofObject: newHeap classTableRootObj.
	newHeap
		storePointer: 1
			ofObject: firstPage
				withValue: (map at: oldHeap classSmallInteger);
		storePointer: 2
			ofObject: firstPage
				withValue: (map at: oldHeap classCharacter);
		storePointer: 3
			ofObject: firstPage
				withValue: (map at: oldHeap classSmallInteger);
		storePointer: newHeap arrayClassIndexPun
			ofObject: firstPage
				withValue: (map at: oldHeap classArray);
		storePointer: newHeap arrayClassIndexPun
			ofObject: firstPage
				withValue: (map at: oldHeap classArray).

	newHeap classTableIndex: maxIndex! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 3/6/2015 13:46'!
fillInCompiledMethod: newObj from: oldObj
	| firstByteIndex primIndex |
	self fillInPointerObject: newObj from: oldObj.
	"Now convert the CompiledMethod's format.  First write the header in the new format"
	newHeap
		storePointerUnchecked: 0
		ofObject: newObj
		withValue: (newHeap integerObjectOf: (self convertOldMethodHeader: (oldHeap fetchPointer: 0 ofObject: oldObj))).
	"Then if necessary prepend the callPrimitive: bytecode"
	(primIndex := oldInterpreter primitiveIndexOf: oldObj) > 0
		ifTrue:
			[firstByteIndex := oldHeap lastPointerOf: oldObj.
			 newHeap
				storeByte: firstByteIndex + 0 ofObject: newObj withValue: 139;
				storeByte: firstByteIndex + 1 ofObject: newObj withValue: (primIndex bitAnd: 255);
				storeByte: firstByteIndex + 2 ofObject: newObj withValue: (primIndex bitShift: -8).
			 firstByteIndex to: (oldHeap numBytesOfBytes: oldObj) - 1 do:
				[:i|
				newHeap storeByte: i + 3 ofObject: newObj withValue: (oldHeap fetchByte: i ofObject: oldObj)]]
		ifFalse:
			[(oldHeap lastPointerOf: oldObj) / oldHeap wordSize to: (oldHeap numSlotsOf: oldObj) - 1 do:
				[:i|
				newHeap storeLong32: i ofObject: newObj withValue: (oldHeap fetchLong32: i ofObject: oldObj)]]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/9/2014 10:16'!
fillInObjects
	oldHeap allObjectsDo:
		[:oldObj|
		(map at: oldObj ifAbsent: nil) ifNotNil:
			[:newObj| | format classIndex |
			format := newHeap formatOf: newObj.
			(newHeap isPointersFormat: format)
				ifTrue:
					[((newHeap isIndexableFormat: format)
						and: [(classIndex := newHeap classIndexOf: newObj) <= classBlockClosureIndex
						and: [classIndex >= classMethodContextIndex]])
						ifTrue: [self fillInPointerObjectWithPC: newObj from: oldObj]
						ifFalse: [self fillInPointerObject: newObj from: oldObj]]
				ifFalse:
					[(newHeap isCompiledMethodFormat: format)
						ifTrue: [self fillInCompiledMethod: newObj from: oldObj]
						ifFalse: [self fillInBitsObject: newObj from: oldObj]]]]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 2/10/2014 16:35'!
fillInPointerObject: newObj from: oldObj
	"Fill-in a newObj with appropriately mapped contents from oldObj.
	 Filter-out the character table and the compact classes array.
	 Map character objects to immediate characters."
	0 to: (oldHeap lastPointerOf: oldObj) / oldHeap wordSize - 1 do:
		[:i| | oldValue newValue |
		oldValue := oldHeap fetchPointer: i ofObject: oldObj.
		newValue := (oldHeap isIntegerObject: oldValue)
						ifTrue: [oldValue]
						ifFalse:
							[map at: oldValue ifAbsent:
								[(oldValue = oldHeap characterTable
								  or: [oldValue = (oldHeap splObj: CompactClasses)])
									ifTrue: [newHeap nilObject]
									ifFalse:
										[self assert: (oldHeap fetchClassOfNonImm: oldValue) = oldHeap classCharacter.
										 newHeap characterObjectOf:
											(oldHeap integerValueOf:
												(oldHeap fetchPointer: CharacterValueIndex ofObject: oldValue))]]].
		newHeap
			storePointerUnchecked: i
			ofObject: newObj
			withValue: newValue].
	(self isOldObjABehavior: oldObj) ifTrue:
		[self mapOldBehavior: oldObj toNewBehavior: newObj]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 11/25/2014 15:24'!
fillInPointerObjectWithPC: newObj from: oldObj
	"Fill-in a newObj with appropriately mapped contents from oldObj.
	 If the object has a pc and its method has a primitive, increment the
	 pc by the size of the callPrimitive: bytecode."
	| method |
	self fillInPointerObject: newObj from: oldObj.
	(newHeap classIndexOf: newObj) = classBlockClosureIndex ifTrue:
		[method := oldHeap
						fetchPointer: MethodIndex
						ofObject: (oldHeap
									fetchPointer: ClosureOuterContextIndex
									ofObject: oldObj).
		 (oldInterpreter primitiveIndexOf: method) > 0 ifTrue:
			[self incrementPCField: ClosureStartPCIndex ofObject: newObj by: 3]].
	(newHeap classIndexOf: newObj) = classMethodContextIndex ifTrue:
		[method := oldHeap
						fetchPointer: MethodIndex
						ofObject: oldObj.
		 (method ~= oldHeap nilObject
		  and: [(oldInterpreter primitiveIndexOf: method) > 0]) ifTrue:
			[self incrementPCField: InstructionPointerIndex ofObject: newObj by: 3]].! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/6/2013 21:18'!
findClassNamed: symbolOop 
	oldHeap allObjectsDo:
		[:o|
		((oldHeap isPointersNonImm: o)
		 and: [(oldInterpreter addressCouldBeClassObj: o)
		 and: [(oldHeap fetchPointer: oldInterpreter classNameIndex ofObject: o) = symbolOop]]) ifTrue:
			[^o]].
	^nil! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 11/21/2014 16:20'!
findLiteral: aLiteral inClass: classOop
	| bindingOrNil |
	aLiteral isString ifTrue:
		[^self stringFor: aLiteral].
	aLiteral isFloat ifTrue:
		[^oldHeap floatObjectOf: aLiteral].
	aLiteral isArray ifTrue:
		[^self cloneArrayLiteral: aLiteral].
	aLiteral isCharacter ifTrue:
		[^oldHeap characterObjectOf: aLiteral asciiValue].
	self assert: aLiteral isVariableBinding.
	bindingOrNil := self interpreter: oldInterpreter
						object: classOop
						perform: (self findSymbol: #bindingOf:)
						withArguments: {self findSymbol: aLiteral key}.
	bindingOrNil ~= oldHeap nilObject ifTrue:
		[^bindingOrNil].
	self error: 'couldn''t find literal ', aLiteral printString! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 11/26/2014 09:19'!
findRequiredGlobals
	"Look for the necessary gobal bindings in the prototype methods in the old image.
	 This has to be done early by sending bindingOf: to Smalltalk.  Collect the class
	 hierarchy of all prototypes that access inst vars (non-local prototypes) to check
	 their shapes.  Also find out Metaclass, needed for identifying classes."
	| globals ourMethodClasses classVars bindingOfSym |
	globals := Set new.
	ourMethodClasses := Set new.
	classVars := Dictionary new.
	self prototypeClassNameMetaSelectorMethodDo:
		[:c :m :s :method| | allNonMetaSupers |
		(Smalltalk classNamed: c) ifNotNil:
			[:nonMetaClass|
			allNonMetaSupers := nonMetaClass withAllSuperclasses.
			(method methodClass includesBehavior: SpurBootstrapPrototypes) ifFalse:
				[ourMethodClasses addAll: allNonMetaSupers.
				 globals addAll: (allNonMetaSupers collect: [:sc| sc binding])].
			method literals do:
				[:l|
				(l isVariableBinding
				 and: [l key isSymbol
				 and: [SpurBootstrapPrototypes withAllSubclasses noneSatisfy: [:sbpc| sbpc name == l key]]]) ifTrue:
					[((Smalltalk bindingOf: l key) == l
					  or: [(Undeclared bindingOf: l key) == l])
						ifTrue: [globals add: l]
						ifFalse:
							[self assert: (nonMetaClass bindingOf: l key) == l.
							classVars at: l put: nonMetaClass]]]]].
	globals add: Compiler binding. "For potential reshaping in checkReshapeOf:"
	bindingOfSym := self findSymbol: #bindingOf:.
	self withExecutableInterpreter: oldInterpreter
		do:	[| toBeAdded |
			globals do:
				[:global| | bindingOop |
				(self findSymbol: global key) ifNotNil:
					[:symbolOop|
					bindingOop := self interpreter: oldInterpreter
										object: (oldHeap splObj: 8) "Smalltalk"
										perform: bindingOfSym
										withArguments: {self findSymbol: global key}.
					bindingOop ~= oldHeap nilObject ifTrue:
						[literalMap at: global put: bindingOop]]].
			 toBeAdded := Dictionary new.
			 classVars keysAndValuesDo:
				[:var :class| | val |
				(self findSymbol: var key) "New class inst vars may not yet be interned."
					ifNil: [toBeAdded at: var put: class]
					ifNotNil:
						[:varName|
						val := self interpreter: oldInterpreter
									object: (self oldClassOopFor: class)
									perform: bindingOfSym
									withArguments: {varName}.
						val ~= oldHeap nilObject
							ifTrue: [literalMap at: var put: val]
							ifFalse: [toBeAdded at: var put: class]]].
			"May have to redefine to add missing inst vars and/or add any missing class vars."
			self checkReshapeOf: ourMethodClasses.
			self addMissingClassVars: toBeAdded]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 8/12/2014 11:41'!
findSymbol: aString
	"Find the Symbol equal to aString in oldHeap."
	| symbolClass |
	(literalMap at: aString ifAbsent: nil) ifNotNil:
		[:oop| ^oop].
	symbolClass := self symbolClass.
	oldHeap allObjectsDo:
		[:obj|
		(symbolClass = (oldHeap fetchClassOfNonImm: obj)
		 and: [(oldHeap numBytesOf: obj) = aString size
		 and: [aString = (oldHeap stringOf: obj)]]) ifTrue:
			[aString isSymbol ifTrue:
				[literalMap at: aString asSymbol put: obj].
			 ^obj]].
	Transcript cr; nextPutAll: 'Warning, could not find '; store: aString; flush.
	^nil! !

!SpurBootstrap methodsFor: 'class indices' stamp: 'eem 8/30/2013 15:18'!
firstOrdinaryClassIndex
	^newHeap classTablePageSize! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/18/2013 16:55'!
followForwardingPointers
	newHeap allObjectsDo:
		[:o|
		(newHeap isForwarded: o) ifFalse:
			[0 to: (newHeap numPointerSlotsOf: o) - 1 do:
				[:i| | field |
				field := newHeap fetchPointer: i ofObject: o.
				(newHeap isOopForwarded: field) ifTrue:
					[newHeap
						storePointer: i
						ofObject: o
						withValue: (newHeap followForwarded: field)]]]]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/20/2013 15:55'!
freeForwarders
	"Check that all forwarders have been followed.  Then free them."
	| numForwarders numFreed |
	numForwarders := numFreed := 0.
	newHeap allObjectsDo:
		[:o|
		(newHeap isForwarded: o)
			ifTrue: [numForwarders := numForwarders + 1]
			ifFalse:
				[0 to: (newHeap numPointerSlotsOf: o) - 1 do:
					[:i|
					self assert: (newHeap isOopForwarded: (newHeap fetchPointer: i ofObject: o)) not]]].
	Transcript ensureCr;  nextPutAll: 'freeing '; print: numForwarders; nextPutAll: ' forwarders'; cr; flush.
	newHeap allObjectsDo:
		[:o|
		(newHeap isForwarded: o) ifTrue:
			[numFreed := numFreed + 1.
			 newHeap freeObject: o]].
	self assert: numFreed = numForwarders! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/19/2014 14:33'!
headerForOldMethodHeader: methodHeaderOop
	^self isOnSpur
		ifTrue: [self convertOldMethodHeader: methodHeaderOop]
		ifFalse: [oldHeap integerValueOf: methodHeaderOop]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/10/2014 16:26'!
imageTypes: anArray
	imageTypes := anArray! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/9/2014 10:28'!
incrementPCField: fieldIndex ofObject: newObj by: n
	| value |
	value := newHeap fetchPointer: fieldIndex ofObject: newObj.
	(newHeap isIntegerObject: value)
		ifTrue:
			[newHeap
				storePointerUnchecked: fieldIndex
				ofObject: newObj
				withValue: (newHeap integerObjectOf: n + (newHeap integerValueOf: value))]
		ifFalse:
			[self assert: value = newHeap nilObject]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 07/28/2014 07:54'!
indexOfSelector: selectorOop in: methodDict
	SelectorStart to: (oldHeap numSlotsOf: methodDict) - 1 do:
		[:i|
		(oldHeap fetchPointer: i ofObject: methodDict) = selectorOop ifTrue:
			[^i]].
	self error: 'could not find selector in method dict'! !

!SpurBootstrap methodsFor: 'initialize-release' stamp: 'autoboot 8/27/2014 14:40'!
initMaps
	map := Dictionary new: oldHeap memory size // 4.
	reverseMap := Dictionary new: oldHeap memory size // 4.
	classToIndex := Dictionary new: 1024.
	literalMap := IdentityDictionary new.
	methodClasses := Set new.
	installedPrototypes := Set new.
	installedMethodOops := Set new.
	classMetaclass := nil! !

!SpurBootstrap methodsFor: 'initialize-release' stamp: 'eem 8/8/2014 17:21'!
initialize
	super initialize.
	imageTypes := {'squeak'}. "By default, image is Squeak (so Eliot does not kick me :P)"! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/19/2014 15:26'!
initializeClasses
	toBeInitialized ifNil: [^self].
	self withExecutableInterpreter: oldInterpreter
		do: [toBeInitialized do:
				[:class|
				self interpreter: oldInterpreter
					object: (self oldClassOopFor: class)
					perform: (self findSymbol: #initialize)
					withArguments: #()]]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 8/22/2014 11:49'!
installModifiedMethods
	"Install all the methods in the class-side method prototypes protocol in the relevant classes
	 in the new image.  First use the simulator to get the image to intern all symbols and add
	 dummy methods under new selectors.  With that done we can manually replace the relevant
	 methods with the prototypes, mapping selectors and global variables as required."
	self withExecutableInterpreter: oldInterpreter
		do: [self internAllSymbols.
			 self addNewMethods.
			 self removeMethods.
			 self replaceMethods.
			 self modifyCharacterMethods]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 11/25/2014 15:15'!
installableMethodFor: aCompiledMethod selector: selector className: className isMeta: isMeta
	"Create a sourceless method to install in the bootstrapped image.  It will allow the
	 bootstrap to limp along until the relevant transformed Monticello package is loaded."
	| compiledMethodClass methodClassBinding methodClass sourcelessMethod bytes newMethod delta initialPC |
	compiledMethodClass := self findClassNamed: (self findSymbol: #CompiledMethod).
	methodClassBinding := self methodClassBindingForClassName: className isMeta: isMeta.
	methodClass := oldHeap fetchPointer: ValueIndex ofObject: methodClassBinding.
	"the prototypes have source pointers.  the Character methods to be replaced don't."
	sourcelessMethod := aCompiledMethod trailer hasSourcePointer
							ifTrue: [aCompiledMethod copyWithTempsFromMethodNode: aCompiledMethod methodNode]
							ifFalse: [aCompiledMethod].
	initialPC := sourcelessMethod initialPC.
	bytes := sourcelessMethod size - initialPC + 1.
	"Ugh, this is complicated.  We could be running on Spur with the new method format
	 or on non-Spur with the old format.  Make both work."
	delta := (sourcelessMethod primitive > 0
			 and: [(sourcelessMethod at: initialPC) = sourcelessMethod encoderClass callPrimitiveCode])
				ifTrue: [3]
				ifFalse: [0].
	newMethod := self
					interpreter: oldInterpreter
					object: compiledMethodClass
					perform: (self findSymbol: #newMethod:header:)
					withArguments: { oldHeap integerObjectOf: bytes - delta.
									   oldHeap integerObjectOf: (self oldFormatHeaderFor: sourcelessMethod) }.
	1 to: sourcelessMethod numLiterals - 2 do:
		[:i| | literal oop |
		literal := sourcelessMethod literalAt: i.
		oop := (literal isLiteral or: [literal isVariableBinding])
					ifTrue:
						[literal isInteger
							ifTrue: [oldInterpreter signed64BitIntegerFor: literal]
							ifFalse: [literalMap
										at: literal
										ifAbsent: [self findLiteral: literal
														inClass: methodClass]]]
					ifFalse: "should be a VMObjectProxy"
						[literal oop].
		oldHeap storePointer: i ofObject: newMethod withValue: oop].
	oldHeap
		storePointer: sourcelessMethod numLiterals - 1
		ofObject: newMethod
		withValue: (selector isSymbol
						ifTrue: [self findSymbol: selector]
						ifFalse: [selector oop]);
		storePointer: sourcelessMethod numLiterals
		ofObject: newMethod
		withValue: methodClassBinding.
	initialPC to: sourcelessMethod size - delta do:
		[:i|
		oldHeap storeByte: i - 1 ofObject: newMethod withValue: (sourcelessMethod byteAt: i + delta)].
	installedMethodOops add: newMethod.
	^newMethod! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 8/12/2014 12:07'!
internAllSymbols
	"Ensure that all symbols in the method prototypes are interned so that later we can install them.
	 Enter them into the map, this system's symbol -> oldHeap's version.
	 Do this by interpreting Symbol intern: 'aSymbol' for each symbol."
	| internSym all symbolClass |
	internSym := self findSymbol: #intern:.
	symbolClass := self symbolClass.
	all := self allPrototypeMethodSymbols.
	oldHeap allObjectsDo:
		[:objOop| | sz |
		symbolClass = (oldHeap fetchClassOfNonImm: objOop) ifTrue:
			[sz := oldHeap numBytesOf: objOop.
			 (all detect: [:sym| sym size = sz and: [sym = (oldHeap stringOf: objOop)]]
				ifNone: nil) ifNotNil:
					[:sym|
					literalMap at: sym put: objOop.
					all remove: sym]]].
	all do: [:sym|
		(self findSymbol: sym)
			ifNotNil: [:imageSym| literalMap at: sym put: imageSym]
			ifNil:[Transcript cr; nextPutAll: 'interning '; nextPutAll: sym; flush.
				"Interpret Symbol intern: sym to ... intern it :-)"
				literalMap
					at: sym
					put: (self interpreter: oldInterpreter
							object: self symbolClass
							perform: internSym
							withArguments: {self stringFor: sym})]].
	literalMap keysAndValuesDo:
		[:symOrGlobal :imageSymOrGlobal|
		symOrGlobal isSymbol ifTrue:
			[self assert: symOrGlobal = (oldHeap stringOf: imageSymOrGlobal)]]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/21/2014 08:07'!
isOldObjABehavior: oldObj
	| oldObjClass |
	^(classToIndex includesKey: oldObj)
	or: [(oldObjClass := oldHeap fetchClassOfNonImm: oldObj) = self classMetaclass
	or: [(oldHeap fetchClassOfNonImm: oldObjClass) = classMetaclass]]! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 8/19/2014 14:32'!
isOnSpur
	^$c class instSize = 0! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 9/30/2013 15:42'!
launch
	self launch: newHeap
		simulatorClass: StackInterpreterSimulator
		headerFlags: oldInterpreter getImageHeaderFlags! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 2/7/2015 10:26'!
launch: heap simulatorClass: simulatorClass headerFlags: headerFlags
	| sim methodCacheSize |
	sim := simulatorClass onObjectMemory: heap.
	heap coInterpreter: sim.
	(sim class allInstVarNames includes: 'cogCodeSize')
		ifTrue:
			[sim initializeInterpreter: 0.
			 methodCacheSize := sim methodCache size * heap wordSize.
			 sim instVarNamed: 'heapBase' put: heap startOfMemory;
				instVarNamed: 'numStackPages' put: 8;
				instVarNamed: 'cogCodeSize' put: 1024*1024;
				moveMethodCacheToMemoryAt: sim cogCodeSize + sim computeStackZoneSize;
				movePrimTraceLogToMemoryAt: sim cogCodeSize + sim computeStackZoneSize + methodCacheSize;
				"sendTrace: 1+ 2 + 8 + 16;"
			 	initializeCodeGenerator]
		ifFalse:
			[sim initializeInterpreter: 0].
	heap
		initializeNewSpaceVariables;
		bootstrapping: false;
		assimilateNewSegment: (heap segmentManager segments at: 0).
	sim
		setImageHeaderFlagsFrom: headerFlags;
		imageName: ImageName;
		flushExternalPrimitives;
		openAsMorph;
		transcript: Transcript. "deep copy copies this"
	"sim
		instVarNamed: 'printSends' put: true;
		instVarNamed: 'printReturns' put: true;
		instVarNamed: 'methodDictLinearSearchLimit' put: SmallInteger maxVal." "for now"
	heap
		setCheckForLeaks: 0;
		runLeakCheckerForFullGC.

	sim halt; run! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 9/30/2013 15:41'!
launchSaved
	self launch: TransformedImage veryDeepCopy
		simulatorClass: StackInterpreterSimulator
		headerFlags: ImageHeaderFlags! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 9/30/2013 16:05'!
launchSavedWithJIT
	self launch: (self coHeapFrom: TransformedImage veryDeepCopy)
		simulatorClass: CogVMSimulator
		headerFlags: ImageHeaderFlags! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 2/10/2014 17:25'!
mapOldBehavior: oldObj toNewBehavior: newObj
	"Map the old format inst var's value to the new value.
	 In addition, for Character, make it immediate and remove its instance variable."
	newHeap
		storePointerUnchecked: InstanceSpecificationIndex
		ofObject: newObj
		withValue: (self newClassFormatFor: oldObj).
	oldObj = oldHeap classCharacter ifTrue:
		[InstanceSpecificationIndex + 1 to: (oldHeap numSlotsOf: oldObj) do:
			[:i| | var field |
			var := oldHeap fetchPointer: i ofObject: oldObj.
			((oldHeap fetchClassOf: var) = oldHeap classArray
			 and: [(oldHeap numSlotsOf: var) = 1
			 and: [field := oldHeap fetchPointer: 0 ofObject: var.
				(oldHeap fetchClassOf: field) = oldHeap classString
			 and: [(oldHeap lengthOf: field) = 5
			 and: [(oldHeap str: 'value'  n: (oldHeap firstIndexableField: field) cmp: 5) = 0]]]]) ifTrue:
				[newHeap
					storePointerUnchecked: i
					ofObject: newObj
					withValue: newHeap nilObject.
				 ^self]]]! !

!SpurBootstrap methodsFor: 'stats' stamp: 'eem 1/12/2014 16:38'!
measureNewHeapPostInitPostBootstrap
	| savedEndOfMemory |
	"need to hack around the fact that newHeap isn't all there yet.
	 In particular, it has no freeList so can't free space from
	 freeOldSpaceStart to endOfMemory to make oldSpace enumerable."
	newHeapNumObjs := 0.
	savedEndOfMemory := newHeap endOfMemory.
	newHeap setEndOfMemory: newHeap freeOldSpaceStart.
	newHeap allObjectsDo: [:o| newHeapNumObjs := newHeapNumObjs + 1].
	newHeap setEndOfMemory: savedEndOfMemory! !

!SpurBootstrap methodsFor: 'stats' stamp: 'eem 1/12/2014 16:35'!
measureOldHeapPostGC
	oldHeapSize := oldHeap freeStart.
	oldHeapNumObjs := 0.
	oldHeap allObjectsDo: [:o| oldHeapNumObjs := oldHeapNumObjs + 1]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 8/8/2014 11:07'!
methodClassBindingForClassName: classNameSymbol isMeta: isMeta 
	| class |
	class := self findClassNamed: (literalMap at: classNameSymbol).
	isMeta ifTrue: [class := oldHeap fetchClassOfNonImm: class].
	^self interpreter: oldInterpreter
		object: class
		perform: (self findSymbol: #binding)
		withArguments: #()! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 07/28/2014 07:54'!
modifyCharacterMethods
	| cc md mda |
	cc := oldHeap classCharacter.
	md := oldHeap fetchPointer: MethodDictionaryIndex ofObject: cc.
	mda := oldHeap fetchPointer: MethodArrayIndex ofObject: md..
	0 to: (oldHeap numSlotsOf: mda) - 1 do:
		[:i| | method |
		method := oldHeap fetchPointer: i ofObject: mda.
		method ~= oldHeap nilObject ifTrue:
			[(self replacementForCharacterMethod: method) ifNotNil:
				[:replacement|
				Transcript
					cr;
					nextPutAll: 'replacing Character>>#';
					nextPutAll: (oldHeap stringOf: (oldHeap fetchPointer: i + SelectorStart ofObject: md));
					flush. 
				oldHeap
					storePointer: i
					ofObject: mda
					withValue: replacement]]]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 11/25/2014 15:06'!
newClassFormatFor: oldClassObj
	"OLD: 		<2 bits=instSize//64><5 bits=cClass><4 bits=instSpec><6 bits=instSize\\64><1 bit=0>
	 NEW: 		<5 bits inst spec><16 bits inst size>"
	| oldFormat instSize newInstSpec |
	((oldInterpreter classNameOf: oldClassObj Is: 'SmallInteger')
	 or: [(oldInterpreter classNameOf: oldClassObj Is: 'Character')
	 or: [oldInterpreter classNameOf: oldClassObj Is: 'SmallFloat64']]) ifTrue:
		[^newHeap integerObjectOf: newHeap instSpecForImmediateClasses << 16].
	oldFormat := oldHeap formatOfClass: oldClassObj. "N.B. SmallInteger with tag bit cleared"
	oldFormat := oldFormat >> 1.
	instSize := ((oldFormat bitShift: -10) bitAnd: 16rC0) + ((oldFormat bitShift: -1) bitAnd: 16r3F) - 1.
	newInstSpec := #(0 1 2 3 4 nil 10 9 16 16 16 16 24 24 24 24) at: ((oldFormat bitShift: -7) bitAnd: 16rF) + 1.
	^newHeap integerObjectOf: newInstSpec << 16 + instSize! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/10/2014 18:31'!
newFormatFor: oldObj numBytes: numBytesIfBits
	"OLD:
	 0	no fields
	 1	fixed fields only (all containing pointers)
	 2	indexable fields only (all containing pointers)
	 3	both fixed and indexable fields (all containing pointers)
	 4	both fixed and indexable weak fields (all containing pointers).

	 5	unused
	 6	indexable word fields only (no pointers)
	 7	indexable long (64-bit) fields (only in 64-bit images)
 
	 8-11	indexable byte fields only (no pointers) (low 2 bits are low 2 bits of size)
	 12-15	compiled methods:
	 	    # of literal oops specified in method header,
	 	    followed by indexable bytes (same interpretation of low 2 bits as above)"

	"NEW:
	 0 = 0 sized objects (UndefinedObject True False et al)
	 1 = non-indexable objects with inst vars (Point et al)
	 2 = indexable objects with no inst vars (Array et al)
	 3 = indexable objects with inst vars (MethodContext AdditionalMethodState et al)
	 4 = weak indexable objects with inst vars (WeakArray et al)
	 5 = weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
	 6 = reserved
	 7 = forwarder format (also immediate class format)
	 9          64-bit indexable
	 10 - 11 32-bit indexable
	 12 - 15 16-bit indexable
	 16 - 23 byte indexable
	 24 - 31 compiled method"
	| oldFormat |
	oldFormat := oldHeap formatOf: oldObj.
	oldFormat <= 4 ifTrue:
		[^oldFormat].
	oldFormat >= 12 ifTrue: "CompiledMethod"
		[^24 + (self wordSize - numBytesIfBits bitAnd: self wordSizeMask)].
	oldFormat >= 8 ifTrue: "ByteArray et al"
		[^16 + (self wordSize - numBytesIfBits bitAnd: self wordSizeMask)].
	oldFormat = 6 ifTrue: "32-bit indexable"
		[^10 + (numBytesIfBits bitAnd: self wordSizeMask) sign].
	oldFormat = 7 ifTrue: "64-bit indexable"
		[^9].
	self error: 'illegal old format'! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/12/2014 11:35'!
oldClassOopFor: aClass
	^oldHeap fetchPointer: ValueIndex ofObject: (literalMap at: aClass binding).! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 8/10/2014 12:37'!
oldFormatHeaderFor: method
	| primBits primitive |
	primitive := method primitive.
	primBits := primitive <= 16r1FF
					ifTrue: [primitive]
					ifFalse: [(primitive bitAnd: 16r1FF) + ((primitive bitAnd: 16r200) bitShift: 19)].
	^(method numArgs bitShift: 24)
	+ (method numTemps bitShift: 18)
	+ (method frameSize > method class smallFrameSize ifTrue: [1 << 17] ifFalse: [0])
	+ (method numLiterals bitShift: 9)
	+ primBits! !

!SpurBootstrap methodsFor: 'initialize-release' stamp: 'eem 7/31/2014 21:09'!
on: imageName
	StackInterpreter initializeWithOptions: Dictionary new.
	(oldInterpreter := StackInterpreterSimulator new)
		openOn: imageName extraMemory: 0;
		assertValidExecutionPointersAtEachStep: false.
	oldHeap := oldInterpreter objectMemory.
	newHeap := Spur32BitMMLESimulator new.
	newHeap
		allocateMemoryOfSize: (oldHeap youngStart * 3 / 2 roundUpTo: 1024 * 1024)
		newSpaceSize: 4 * 1024 * 1024
		stackSize: 16 * 1024
		codeSize: 0.
	newHeap setCheckForLeaks: 15 - 6. "don't check become; or newSpace; soooo many rehashes in bootstrap"
	newHeap bootstrapping: true.
	self initMaps! !

!SpurBootstrap methodsFor: 'method prototypes' stamp: 'eem 11/7/2014 14:40'!
prototypeClassNameMetaSelectorMethodDo: quaternaryBlock
	"Evaluate aBlock with class name, class is meta, method and selector.
	 For now find methods in class-side category #'method prototypes'.
	 Scheme could be extended to have different protocols for different
	 Squeak/Pharo versions."
	self allMethodPrototypes do:
		[:methodArg| | method className isMeta |
		className := self classNameForPrototypeMethod: (method := methodArg).
		(isMeta := className endsWith: 'class') ifTrue:
			[className := (className allButLast: 5) asSymbol].
		(method pragmaAt: #indirect) ifNotNil:
			[method := (isMeta
							ifTrue: [(Smalltalk classNamed: className) class]
							ifFalse: [Smalltalk classNamed: className]) >> method selector].
		quaternaryBlock
			value: className
			value: isMeta
			value: (self selectorForPrototypeMethod: method)
			value: method]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 7/17/2014 14:17'!
recreateSpecialObjectsArray
	"This is tricky.  We want to recreate the specialObjectsArray according to
	 the class side SmalltalkImagePROTOTYPErecreateSpecialObjectsArray.
	 But that version destroys the CompactClassesArray upon which the V3
	 image depends.  The bootstrap will get rid of it later.  So save it before
	 the recreation and restore it."
	self withExecutableInterpreter: oldInterpreter
		do: [| compactClassesArray |
			compactClassesArray := oldHeap splObj: CompactClasses.
			self
				interpreter: oldInterpreter
				object: (oldHeap splObj: 8)
				perform: (self findSymbol: #recreateSpecialObjectsArray)
				withArguments: #().
			oldHeap splObj: CompactClasses put: compactClassesArray]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 5/21/2016 12:14'!
rehashImage
	"Rehash all collections in newHeap.
	 Find out which classes implement rehash, entering a 1 against their classIndex in rehashFlags.
	 Enumerate all objects, rehashing those whose class has a bit set in rehashFlags."
	| n sim rehashFlags dotDate rehashSym sizeSym |
	rehashSym := map at: (self findSymbol: #rehash).
	sizeSym := map at: (self findSymbol: #size).
	sim := StackInterpreterSimulator 
				onObjectMemory: newHeap 
				options: #(ObjectMemory #Spur32BitMemoryManager).
	sim 
		setImageHeaderFlagsFrom: oldInterpreter getImageHeaderFlags;
		imageName: 'spur image';
		assertValidExecutionPointersAtEachStep: false..
	newHeap coInterpreter: sim.
	sim bootstrapping: true.
	sim initializeInterpreter: 0.
	sim instVarNamed: 'methodDictLinearSearchLimit' put: SmallInteger maxVal.
	(imageTypes includes: 'cuis') ifTrue:
		[newHeap scavenger growRememberedSet]. "Rehashing a 4.2 Cuis image overflows the 768 element high tide."
	
	sim redirectTranscriptToHost.

	newHeap
		setHashBitsOf: newHeap nilObject to: 1;
		setHashBitsOf: newHeap falseObject to: 2;
		setHashBitsOf: newHeap trueObject to: 3.

	rehashFlags := ByteArray new: newHeap numClassTablePages * newHeap classTablePageSize.
	n := 0.
	newHeap classTableObjectsDo:
		[:class| | classIndex |
		sim messageSelector: rehashSym.
		"Lookup rehash but don't be fooled by ProtoObject>>rehash, which is just ^self."
		((sim lookupOrdinaryNoMNUEtcInClass: class) = 0
		 and: [(sim isQuickPrimitiveIndex: (sim primitiveIndexOf: (sim instVarNamed: 'newMethod'))) not]) ifTrue:
			[n := n + 1.
			 classIndex := newHeap rawHashBitsOf: class.
			 rehashFlags
				at: classIndex >> 3 + 1
				put: ((rehashFlags at: classIndex >> 3 + 1)
						bitOr: (1 << (classIndex bitAnd: 7)))]].
	Transcript cr; print: n; nextPutAll: ' classes understand rehash. rehashing instances...'; flush.
	dotDate := Time now asSeconds.
	n := 0.
	self withExecutableInterpreter: sim
		do: [sim setBreakSelector: 'error:'.
			 "don't rehash twice (actually without limit), so don't rehash any new objects created."
			 newHeap allExistingOldSpaceObjectsDo:
				[:o| | classIndex |
				classIndex := newHeap classIndexOf: o.
				((rehashFlags at: classIndex >> 3 + 1) anyMask: 1 << (classIndex bitAnd: 7)) ifTrue:
					[Time now asSeconds > dotDate ifTrue:
					 	[Transcript nextPut: $.; flush.
						 dotDate := Time now asSeconds].
					 "2845 = n ifTrue: [self halt]."
					 "Rehash an object if its size is > 0.
					  Symbol implements rehash, but let's not waste time rehashing it; in Squeak
					  up to 2013 symbols are kept in a set which will get reashed anyway..
					  Don't rehash empty collections; they may be large for a reason and rehashing will shrink them."
					 ((sim addressCouldBeClassObj: o)
					   or: [(self interpreter: sim
							object: o
							perform: sizeSym
							withArguments: #()) = (newHeap integerObjectOf: 0)]) ifFalse:
						[self interpreter: sim
							object: o
							perform: rehashSym
							withArguments: #()]]]]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 8/23/2014 12:22'!
removeMethods
	"Get the simulator to remove any methods marked with <remove>."
	| removeSym |
	removeSym := self findSymbol: #removeSelectorSilently:.
	removeSym ifNil:
		[removeSym := self findSymbol: #removeSelector:].
	self prototypeClassNameMetaSelectorMethodDo:
		[:className :isMeta :selector :method| | class |
		(method pragmaAt: #remove) ifNotNil:
			[(self findClassNamed: (literalMap at: className)) ifNotNil:
				[:theClass|
				 class := isMeta ifTrue: [oldHeap fetchClassOfNonImm: theClass] ifFalse: [theClass].
				 Transcript
					cr;
					nextPutAll: 'removing ';
					nextPutAll: className;
					nextPutAll: (isMeta ifTrue: [' class>>'] ifFalse: ['>>']);
					store: selector;
					flush.
				 self interpreter: oldInterpreter
					object: class
					perform: removeSym
					withArguments: {literalMap at: selector}]]]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 8/23/2014 16:40'!
replaceMethods
	"Replace all the modified method prototypes."
	self allPrototypeClassNamesDo:
		[:sym :symIsMeta|
		(self findClassNamed: (literalMap at: sym))
			ifNil: [Transcript
					cr;
					nextPutAll: 'not replacing any methods for ';
					nextPutAll: sym;
					nextPutAll: '; class not found in image';
					flush.]
			ifNotNil:
				[:theClass| | class |
				class := symIsMeta ifTrue: [oldHeap fetchClassOfNonImm: theClass] ifFalse: [theClass].
				self prototypeClassNameMetaSelectorMethodDo:
					[:className :isMeta :selector :method| | replacement methodDict index |
					(className = sym
					 and: [symIsMeta = isMeta
					 and: [(method pragmaAt: #remove) isNil]]) ifTrue:
						[(installedPrototypes includes: method selector) ifFalse:
							["probe method dictionary of the class for each method, installing a dummy if not found."
							Transcript
								cr;
								nextPutAll: 'replacing ';
								nextPutAll: className;
								nextPutAll: (isMeta ifTrue: [' class>>'] ifFalse: ['>>']);
								store: selector;
								flush.
							replacement := self installableMethodFor: method
												selector: selector
												className: className
												isMeta: isMeta.
							methodDict := oldHeap fetchPointer: MethodDictionaryIndex ofObject: class.
							index := self indexOfSelector: (literalMap at: selector) in: methodDict.
							oldHeap
								storePointer: index - SelectorStart
								ofObject: (oldHeap fetchPointer: MethodArrayIndex ofObject: methodDict)
								withValue: replacement.
							installedPrototypes add: method selector]]]]]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'autoboot 8/27/2014 14:44'!
replacementForCharacterMethod: characterMethodOop
	"Answer a replacement method for the argument if it refers
	 to Character's old inst var value.  Otherwise answer nil."
	| proxy asIntegerProxy clone assembly newInsts newMethod |
	"(oldHeap stringOf: (oldHeap longAt: characterMethodOop + (oldHeap lastPointerOf: characterMethodOop) - 4)) = 'isOctetCharacter' ifTrue:
		[self halt]."
	"Don't replace something already installed."
	(installedMethodOops includes: characterMethodOop) ifTrue:
		[^nil].
	proxy := VMCompiledMethodProxy new
				for: characterMethodOop
				coInterpreter: oldInterpreter
				objectMemory: oldHeap.
	self assert: (oldHeap literalCountOf: characterMethodOop) = proxy numLiterals.
	clone := self cloneMethodProxy: proxy.
	self assert: proxy numLiterals = clone numLiterals.
	clone isReturnSpecial ifTrue:
		[^nil].
	"Quick methods accessing value should have been replaced.  The halt will fire if there
	 is a missing prototype for such a method on the class side of SpurBootstrap.  The
	 relevant Character prototypes there so far are Character>>asInteger, Character>>
	 asciiValue, Character>>hash & Character>>identityHash.  Conceivably the bootstrap
	 could be applied to an image that has others; hence the halt."
	clone isReturnField ifTrue: [self halt].
	clone hasInstVarRef ifFalse:
		[^nil].
	clone setSourcePointer: 0.
	asIntegerProxy := VMObjectProxy new
							for: (literalMap at: #asInteger)
							coInterpreter: oldInterpreter
							objectMemory: oldHeap.
	assembly := BytecodeDisassembler new disassemble: clone.
	assembly literals: (assembly literals allButLast: 2), {asIntegerProxy}, (assembly literals last: 2).
		"Do this by looking for index of pushReceiverVariable: and replacing it by pushSelf, send asInteger"
	newInsts := (assembly instructions piecesCutWhere:
					[:msgOrLabelAssoc :nextInst|
					 msgOrLabelAssoc isVariableBinding not
					 and: [msgOrLabelAssoc selector == #pushReceiverVariable:]]) fold:
				[:a :b|
				 a allButLast,
				 {	Message selector: #pushReceiver.
					Message
						selector: #send:super:numArgs:
						arguments: {asIntegerProxy. false. 0}},
				 b].
	assembly instructions: newInsts.
	newMethod := assembly assemble.
	self assert: clone numLiterals + 1 = newMethod numLiterals.
	^self
		installableMethodFor: newMethod
		selector: clone selector
		className: #Character
		isMeta: false! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 7/31/2014 22:23'!
reportSizes
	| change oldAvgBytes newAvgBytes |
	change := newHeapSize - oldHeapSize / oldHeapSize.
	oldAvgBytes := oldHeapSize asFloat / oldHeapNumObjs.
	Transcript
		nextPutAll: 'done.'; cr;
		nextPutAll: 'old heap size: '; nextPutAll: oldHeapSize asStringWithCommas; tab;
		nextPutAll: ' (avg obj bytes '; print: oldAvgBytes maxDecimalPlaces: 2; nextPutAll: ' words '; print: oldAvgBytes / self wordSize maxDecimalPlaces: 2; nextPut: $); cr;
		nextPutAll: 'initial new heap size: '; nextPutAll: newHeapSize asStringWithCommas; cr;
		nextPutAll: 'change: '; print: change * 100.0 maxDecimalPlaces: 2; nextPut: $%; cr;
		flush.
	newHeapSize := newHeap endOfMemory
					- newHeap scavenger eden limit
					- newHeap totalFreeListBytes.
	change := newHeapSize - oldHeapSize / oldHeapSize.
	newAvgBytes := newHeapSize asFloat / newHeapNumObjs.
	Transcript
		nextPutAll: 'final new heap size: '; nextPutAll: newHeapSize asStringWithCommas; tab;
		nextPutAll: ' (avg obj bytes '; print: newAvgBytes maxDecimalPlaces: 2; nextPutAll: ' words '; print: newAvgBytes / self wordSize maxDecimalPlaces: 2; nextPut: $); cr;
		nextPutAll: 'change: '; print: change * 100.0 maxDecimalPlaces: 2; nextPut: $%; cr;
		flush! !

!SpurBootstrap methodsFor: 'development support' stamp: 'eem 10/11/2013 09:57'!
saveTransformedImage
	ImageHeaderFlags := oldInterpreter getImageHeaderFlags.
	ImageScreenSize := oldInterpreter savedWindowSize.
	ImageName := oldInterpreter imageName.
	newHeap coInterpreter: nil.
	(newHeap class allInstVarNames select: [:ivn| ivn beginsWith: 'stat']) do:
		[:ivn| newHeap instVarNamed: ivn put: 0].
	TransformedImage := newHeap veryDeepCopy! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 12/11/2013 09:14'!
scavengeImage
	"Scavenge the image to get it into a simpler state."
	newHeap coInterpreter voidVMStateForSnapshotFlushingExternalPrimitivesIf: false.
	newHeap flushNewSpace! !

!SpurBootstrap methodsFor: 'method prototypes' stamp: 'eem 10/11/2013 12:58'!
selectorForPrototypeMethod: protoMethod
	| protoSelector |
	protoSelector := protoMethod selector.
	protoSelector := protoSelector last: protoSelector size
						- (protoSelector indexOfSubCollection: 'PROTOTYPE')
						- 'PROTOTYPE' size
						+ 1.
	(protoSelector beginsWith: 'Dollar') ifTrue:
		[protoSelector := (Dictionary newFromPairs: #('DollarEquals:' #=))
							at: protoSelector].
	^protoSelector asSymbol! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 12/14/2015 15:27'!
silenceImage
	"Turn off change notifications via SystemChangeNotifier"
	(self allInstancesOf: (self findClassNamed: (self findSymbol: #SystemChangeNotifier))) do:
		[:obj | oldHeap storePointer: 1 ofObject: obj withValue: (oldHeap integerObjectOf: 1)]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/7/2013 14:01'!
stringFor: aString
	| string |
	string := oldHeap instantiateClass: (oldHeap splObj: ClassByteString) indexableSize: aString size.
	1 to: aString size do:
		[:i| oldHeap storeByte: i - 1 ofObject: string withValue: (aString at: i) asInteger].
	^string
! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/6/2013 13:17'!
symbolClass
	^oldHeap fetchClassOfNonImm: (oldHeap splObj: SelectorDoesNotUnderstand)! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 12/14/2015 15:24'!
transform
      self silenceImage.
	self findRequiredGlobals.
	self installModifiedMethods.
	self recreateSpecialObjectsArray.
	self initializeClasses.
	self bootstrapImage.
	self validate.
	self rehashImage.
	self followForwardingPointers.
	self scavengeImage.
	self freeForwarders.
	self compactImage.
	self reportSizes! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'EstebanLorenzano 12/10/2014 21:35'!
validate
	| p n duplicates maxClassIndex savedEndOfMemory |
	self assert: (reverseMap at: newHeap specialObjectsOop) = oldHeap specialObjectsOop.
	self assert: (map at: oldHeap specialObjectsOop) = newHeap specialObjectsOop.
	self assert: (reverseMap at: newHeap classTableRootObj ifAbsent: []) isNil.

	duplicates := { 3. newHeap arrayClassIndexPun. newHeap weakArrayClassIndexPun }.
	maxClassIndex := classToIndex inject: 0 into: [:a :b| a max: b].
	self assert: ((newHeap arrayClassIndexPun to: maxClassIndex) select:
					[:idx| | classObj |
					(classObj := newHeap classOrNilAtIndex: idx) ~= newHeap nilObject
					and: [(newHeap classIndexOf: classObj) = (newHeap rawHashBitsOf: classObj)]]) isEmpty.
	0 to: maxClassIndex do:
		[:index| | classObj |
		(index <= newHeap tagMask
		 and: [index > newHeap isForwardedObjectClassIndexPun]) ifTrue:
			[(classObj := newHeap classOrNilAtIndex: index) = newHeap nilObject
				ifTrue:
					[self assert: (classToIndex keyAtValue: index ifAbsent: []) isNil]
				ifFalse:
					[self assert: (newHeap classIndexOf: classObj) ~= (newHeap rawHashBitsOf: classObj).
					(duplicates includes: index) ifFalse:
						[self assert: (newHeap rawHashBitsOf: classObj) = index]]]].
	classToIndex keysAndValuesDo:
		[:oldClass :idx|
		self assert: (newHeap rawHashBitsOf: (map at: oldClass)) = idx. 
		self assert: oldClass = (reverseMap at: (newHeap classAtIndex: idx))].
	n := 0.
	savedEndOfMemory := newHeap endOfMemory.
	newHeap setEndOfMemory: newHeap freeOldSpaceStart.
	newHeap allObjectsDo:
		[:o|
		(o <= newHeap trueObject
		 or: [o > lastClassTablePage]) ifTrue:
			[self assert: (reverseMap includesKey: o).
			 self assert: (newHeap fetchClassOfNonImm: o) = (map at: (oldHeap fetchClassOfNonImm: (reverseMap at: o)))].
		n := n + 1.
		p := o].
	newHeap setEndOfMemory: savedEndOfMemory.
	self touch: p.
	self assert: (n between: map size and: map size + ((imageTypes includes: 'squeak')
														ifTrue: [6]
														ifFalse: [10])). "+ 6 or 10 is room for freelists & classTable"

	"check some class properties to ensure the format changes are correct"
	self assert: (newHeap fixedFieldsOfClassFormat: (newHeap formatOfClass: newHeap classArray)) = 0.
	self assert: (newHeap instSpecOfClassFormat: (newHeap formatOfClass: newHeap classArray)) = newHeap arrayFormat! !

!SpurBootstrap methodsFor: 'word size' stamp: 'eem 8/30/2013 10:59'!
wordSize
	^self subclassResponsibility! !

!SpurBootstrap methodsFor: 'word size' stamp: 'eem 8/30/2013 10:59'!
wordSizeMask
	^self subclassResponsibility! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 1/10/2016 08:33'!
writeSnapshot: imageFileName ofTransformedImage: spurHeap headerFlags: headerFlags screenSize: screenSizeInteger
	"The bootstrapped image typically contains a few big free chunks and one huge free chunk.
	 Test snapshot writing and loading by turning the largest non-huge chunks into segment bridges
	 and saving."
	| penultimate ultimate sim |
	sim := StackInterpreterSimulator onObjectMemory: spurHeap.
	sim bootstrapping: true.
	spurHeap
		coInterpreter: sim;
		setEndOfMemory: spurHeap endOfMemory + spurHeap bridgeSize. "hack; initializeInterpreter: cuts it back by bridgeSize"
	sim initializeInterpreter: 0;
		setImageHeaderFlagsFrom: headerFlags;
		setSavedWindowSize: screenSizeInteger;
		setDisplayForm: nil.
	spurHeap allOldSpaceEntitiesDo: [:e| penultimate := ultimate. ultimate := e].
	"Check that we've left behind the old, pre-pigCompact segmented save"
	self assert: (spurHeap isFreeObject: penultimate) not.
	spurHeap checkFreeSpace.
	spurHeap runLeakCheckerForFullGC.
	sim bereaveAllMarriedContextsForSnapshotFlushingExternalPrimitivesIf: true.
	sim imageName: imageFileName.
	sim writeImageFileIO.
	Transcript cr; show: 'Done!!'! !

SpurBootstrap subclass: #SpurBootstrap32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Bootstrapping'!

!SpurBootstrap32 methodsFor: 'bootstrap' stamp: 'eem 7/28/2014 07:49'!
fillInBitsObject: newObj from: oldObj
	0 to: (oldHeap numSlotsOf: oldObj) - 1 do:
		[:i|
		newHeap
			storeLong32: i
			ofObject: newObj
			withValue: (oldHeap fetchLong32: i ofObject: oldObj)]! !

!SpurBootstrap32 methodsFor: 'word size' stamp: 'eem 8/30/2013 10:34'!
wordSize
	^4! !

!SpurBootstrap32 methodsFor: 'word size' stamp: 'eem 8/30/2013 10:34'!
wordSizeMask
	^3! !

SimulatorHarness subclass: #SpurOldToNewMethodFormatMunger
	instanceVariableNames: 'interpreter heap prototypes replacements symbolOops'
	classVariableNames: ''
	poolDictionaries: 'VMObjectIndices'
	category: 'Cog-Bootstrapping'!

!SpurOldToNewMethodFormatMunger commentStamp: 'eem 11/17/2014 10:36' prior: 0!
A SpurOldToNewMethodFormatMunger is a one-off for mirating a Spur image prior to the two formats to single format CompiledMethod header putsch.
!

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 8/9/2014 20:25'!
cloneArrayLiteral: anArray
	"Currently serves only to clone the #(0 0) literal in SpaceTallyPROTOTYPEspaceForInstancesOf:"
	| array |
	array := heap instantiateClass: (heap splObj: ClassArray) indexableSize: anArray size.
	1 to: anArray size do:
		[:i| | lit |
		lit := anArray at: i.
		lit class caseOf: {
			[SmallInteger] -> [heap
									storePointerUnchecked: i - 1
									ofObject: array
									withValue: (heap integerObjectOf: lit)].
			[ByteSymbol] -> [heap
									storePointer: i - 1
									ofObject: array
									withValue: (symbolOops at: lit)].
			[UndefinedObject] -> [heap
									storePointerUnchecked: i - 1
									ofObject: array
									withValue: heap nilObject] }].
	^array
! !

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 8/9/2014 13:03'!
convertOldMethodHeader: methodHeader
	^heap integerObjectOf:
		   ((interpreter argumentCountOfMethodHeader: methodHeader) << 24)
		+ ((interpreter temporaryCountOfMethodHeader: methodHeader) << 18)
		+ ((interpreter methodHeaderIndicatesLargeFrame: methodHeader) ifTrue: [1 << 17] ifFalse: [0])
		+ ((heap primitiveIndexOfMethodHeader: methodHeader) > 0 ifTrue: [1 << 16] ifFalse: [0])
		+ (heap literalCountOfMethodHeader: methodHeader)! !

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 8/9/2014 12:00'!
incrementPCField: fieldIndex ofObject: newObj by: n
	| value |
	value := heap fetchPointer: fieldIndex ofObject: newObj.
	(heap isIntegerObject: value)
		ifTrue:
			[heap
				storePointerUnchecked: fieldIndex
				ofObject: newObj
				withValue: (heap integerObjectOf: n + (heap integerValueOf: value))]
		ifFalse:
			[self assert: value = heap nilObject]! !

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 8/9/2014 18:09'!
indexOfSelector: selectorOop in: methodDict
	SelectorStart to: (heap numSlotsOf: methodDict) - 1 do:
		[:i|
		(heap fetchPointer: i ofObject: methodDict) = selectorOop ifTrue:
			[^i]].
	self error: 'could not find selector in method dict'! !

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 8/9/2014 21:26'!
installableMethodFor: methodWithSource selector: selectorOop siblingMethod: sibling 
	| method classOop clone delta numBytes |
	method := methodWithSource copyWithTempsFromMethodNode: methodWithSource methodNode.
	delta := (method primitive > 0
			  and: [(method at: method initialPC) ~= method methodClass callPrimitiveCode])
				ifTrue: [3]
				ifFalse: [0].
	clone := heap
				allocateSlots: (heap numSlotsForBytes: (numBytes := method size) + delta)
				format: (heap compiledMethodFormatForNumBytes: numBytes + delta)
				classIndex: (heap classIndexOf: sibling).
	classOop := interpreter methodClassOf: sibling.
	method methodClass isMeta ifTrue:
		[classOop := heap fetchPointer: interpreter thisClassIndex ofObject: classOop].
	heap storePointer: 0
		ofObject: clone
		withValue: (self methodHeaderForMethod: method).
	1 to: method numLiterals - 2 do:
		[:i|
		heap storePointer: i
			ofObject: clone
			withValue: (self literalFor: (method literalAt: i) inClass: classOop)].
	heap
		storePointer: method numLiterals - 1
			ofObject: clone
				withValue: selectorOop;
		storePointer: method numLiterals
			ofObject: clone
				withValue: (interpreter methodClassAssociationOf: sibling).

	delta > 0 ifTrue:
		[heap
			storeByte: method initialPC - 1 ofObject: clone 	withValue: 139;
			storeByte: method initialPC + 0 ofObject: clone withValue: (method primitive bitAnd: 255);
			storeByte: method initialPC + 1 ofObject: clone withValue: (method primitive bitShift: -8)].
	method initialPC to: method size do:
		[:i|
		 heap storeByte: i - 1 + delta ofObject: clone withValue: (method at: i)].

	^clone! !

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 11/21/2014 16:20'!
literalFor: aLiteral inClass: classOop
	| bindingOrNil |
	aLiteral isSymbol ifTrue:
		[^symbolOops at: aLiteral].
	aLiteral isString ifTrue:
		[^heap stringForCString: aLiteral].
	(aLiteral isInteger and: [aLiteral class == SmallInteger]) ifTrue:
		[^heap integerObjectOf: aLiteral].
	aLiteral isFloat ifTrue:
		[^heap floatObjectOf: aLiteral].
	aLiteral isArray ifTrue:
		[^self cloneArrayLiteral: aLiteral].
	self assert: aLiteral isVariableBinding.
	"interpreter
		ensureDebugAtEachStepBlock;
		instVarNamed: 'printBytecodeAtEachStep' put: true;
		instVarNamed: 'printFrameAtEachStep' put: true."
	bindingOrNil := self interpreter: interpreter
						object: classOop
						perform: (symbolOops at: #bindingOf:)
						withArguments: {symbolOops at: aLiteral key}.
	bindingOrNil ~= heap nilObject ifTrue:
		[^bindingOrNil].
	self error: 'couldn''t find literal ', aLiteral printString! !

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 8/9/2014 12:00'!
mapPCs
	| cbc cmc |
	cmc := 36.
	cbc := 37.
	heap allObjectsDo:
		[:obj| | ci |
		ci := heap classIndexOf: obj.
		(ci <= 37 and: [ci >= 36]) ifTrue:
			[ci = 37 ifTrue: [self mungeClosure: obj].
			 ci = 36 ifTrue: [self mungeContext: obj]]]! !

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 8/9/2014 19:00'!
methodHeaderForMethod: method
	^heap integerObjectOf:
		   (method numArgs << 24)
		+ (method numTemps << 18)
		+ (method frameSize > method class smallFrameSize ifTrue: [1 << 17] ifFalse: [0])
		+ (method primitive > 0 ifTrue: [1 << 16] ifFalse: [0])
		+ method numLiterals! !

!SpurOldToNewMethodFormatMunger methodsFor: 'public access' stamp: 'eem 8/9/2014 17:54'!
munge: imageName
	interpreter := StackInterpreterSimulator newWithOptions: #(ObjectMemory Spur32BitMemoryManager).
	interpreter desiredNumStackPages: 4; initStackPages.
	heap := interpreter objectMemory.
	self assert: heap class == Spur32BitMMLESimulator.
	SpurOldFormat32BitMMLESimulator adoptInstance: heap.
	interpreter openOn: imageName extraMemory: 0.
	self mapPCs.
	self preparePrototypes.
	self updateAndForwardMethods.
	self snapshot! !

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 8/9/2014 12:03'!
mungeClosure: obj
	| method |
	method := heap
					fetchPointer: MethodIndex
					ofObject: (heap
								fetchPointer: ClosureOuterContextIndex
								ofObject: obj).
	(heap primitiveIndexOfMethodHeader: (heap methodHeaderOf: method)) > 0 ifTrue:
		[self incrementPCField: ClosureStartPCIndex ofObject: obj by: 3]! !

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 8/9/2014 12:04'!
mungeContext: obj
	| method |
	method := heap fetchPointer: MethodIndex ofObject: obj.
	(heap primitiveIndexOfMethodHeader: (heap methodHeaderOf: method)) > 0 ifTrue:
		[self incrementPCField: InstructionPointerIndex ofObject: obj by: 3]! !

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 8/9/2014 13:25'!
mungePrimitiveMethod: obj
	| numBytes copy firstByteIndex primIndex numPointerSlots header |
	numBytes := heap byteSizeOf: obj.
	copy := heap allocateSlotsInOldSpace: (heap numSlotsForBytes: numBytes + 3)
				format: (heap compiledMethodFormatForNumBytes: numBytes + 3)
				classIndex: (heap classIndexOf: obj).
	header := heap methodHeaderOf: obj.
	numPointerSlots := (heap literalCountOfMethodHeader: header) + LiteralStart.
	heap
		storePointerUnchecked: 0
		ofObject: copy
		withValue: (self convertOldMethodHeader: header).
	1 to: numPointerSlots - 1 do:
		[:i|
		heap storePointer: i
			ofObject: copy
			withValue: (heap fetchPointer: i ofObject: obj)].
	primIndex := heap primitiveIndexOfMethodHeader: header.
	firstByteIndex := numPointerSlots * heap bytesPerOop.
	heap
		storeByte: firstByteIndex + 0 ofObject: copy withValue: 139;
		storeByte: firstByteIndex + 1 ofObject: copy withValue: (primIndex bitAnd: 255);
		storeByte: firstByteIndex + 2 ofObject: copy withValue: (primIndex bitShift: -8).
	firstByteIndex to: numBytes - 1 do:
		[:i|
		heap storeByte: i + 3 ofObject: copy withValue: (heap fetchByte: i ofObject: obj)].
	heap forward: obj to: copy.
	^copy! !

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 8/9/2014 20:03'!
preparePrototypes
	replacements := OrderedCollection new.
	heap classTableObjectsDo:
		[:class| | name isMeta |
		name := heap
					fetchPointer: interpreter classNameIndex
					ofObject: ((isMeta := (heap numSlotsOf: class) = interpreter metaclassNumSlots)
								ifTrue: [heap fetchPointer: interpreter thisClassIndex ofObject: class]
								ifFalse: [class]).
		name := interpreter stringOf: name.
		self prototypeClassNameMetaSelectorMethodDo:
			[:protoClassName :protoIsMeta :selector :method|
			 (protoClassName = name
			  and: [protoIsMeta = isMeta]) ifTrue:
				[replacements addLast: {class. selector. method}]]]! !

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 8/9/2014 17:40'!
prototypeClassNameMetaSelectorMethodDo: quaternaryBlock
	prototypes ifNil:
		[prototypes := OrderedCollection new.
		SpurBootstrap new prototypeClassNameMetaSelectorMethodDo:
			[:className :isMeta :selector :method| 
			(#(BytecodeEncoder CompiledMethod EncoderForSqueakV4PlusClosures
				InstructionClient InstructionStream MethodNode) includes: className) ifTrue:
					[prototypes addLast: {className. isMeta. selector. method}]]].
	prototypes do: [:tuple| quaternaryBlock valueWithArguments: tuple]! !

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 8/9/2014 21:20'!
replaceMethods
	| byteSymbolClassIndex symbols symbolSizes |
	byteSymbolClassIndex := heap classIndexOf: (heap splObj: SelectorDoesNotUnderstand).
	symbols := Set with: #bindingOf:.
	replacements do:
		[:tuple| | method adder |
		symbols add: tuple second.
		method := tuple last.
		adder := [:lit|
				   (lit isSymbol and: [lit ~~ method selector]) ifTrue: [symbols add: lit].
				   (lit isVariableBinding and: [lit key isSymbol]) ifTrue: [symbols add: lit key].
				   lit isArray ifTrue: [lit do: adder]].
		method literals do: adder].
	symbolSizes := symbols collect: [:ea| ea size].
	symbolOops := Dictionary new.
	heap allObjectsDo:
		[:obj| | sz |
		((heap classIndexOf: obj) = byteSymbolClassIndex
		 and: [symbolSizes includes: (sz := heap numBytesOf: obj)]) ifTrue:
			[symbols do:
				[:s|
				 (sz = s size
				  and: [(interpreter stringOf: obj) = s]) ifTrue:
					[symbolOops at: s put: obj]]]].
	replacements do:
		[:tuple|
		[:classOop :selector :method| | replacement methodDict methodArray index |
		methodDict := heap fetchPointer: MethodDictionaryIndex ofObject: classOop.
		methodArray := heap fetchPointer: MethodArrayIndex ofObject: methodDict.
		index := (0 to: (heap numSlotsOf: methodArray) - 1) detect: [:i| (heap fetchPointer: i ofObject: methodArray) ~= heap nilObject].
		replacement := self installableMethodFor: method
							selector: (symbolOops at: selector)
							siblingMethod: (heap fetchPointer: index ofObject: methodArray).
		index := self indexOfSelector: (symbolOops at: selector) in: methodDict.
		heap
			storePointer: index - SelectorStart
			ofObject: methodArray
			withValue: replacement] valueWithArguments: tuple]! !

!SpurOldToNewMethodFormatMunger methodsFor: 'saving' stamp: 'eem 8/10/2014 14:42'!
snapshot
	Spur32BitMMLESimulator adoptInstance: heap.
	interpreter imageName: 'munged-', (FileDirectory default localNameFor: interpreter imageName).
	[heap parent: heap; setCheckForLeaks: 15; garbageCollectForSnapshot]
		on: Halt
		do: [:ex|
			"suppress halts from the usual suspects (development time halts)"
			(#(fullGC globalGarbageCollect) includes: ex signalerContext sender selector)
				ifTrue: [ex resume]
				ifFalse: [ex pass]].
	interpreter
		setDisplayForm: nil; "gets it to use savedWindowSize"
		writeImageFileIO.
	Transcript cr; show: 'Done!!'! !

!SpurOldToNewMethodFormatMunger methodsFor: 'munging' stamp: 'eem 8/9/2014 21:20'!
updateAndForwardMethods
	| new now lastDotTime |
	new := Set new: 1000.
	lastDotTime := Time now asSeconds.
	heap allObjectsDo:
		[:obj|
		((heap isCompiledMethod: obj)
		 and: [(new includes: obj) not]) ifTrue:
			[| header |
			 (heap primitiveIndexOfMethodHeader: (header := heap methodHeaderOf: obj)) > 0
				ifTrue:
					[new add: (self mungePrimitiveMethod: obj).
					 (now := Time now asSeconds) > lastDotTime ifTrue:
						[Transcript nextPut: $.; flush.
						 lastDotTime := now]]
				ifFalse:
					[heap
						storePointerUnchecked: 0
						ofObject: obj
						withValue: (self convertOldMethodHeader: header)]]].
	Spur32BitMMLESimulator adoptInstance: interpreter objectMemory.
	self withExecutableInterpreter: interpreter
		do: [self replaceMethods]! !

SimulatorHarness subclass: #Spur32BitPreen
	instanceVariableNames: 'oldHeap newHeap map reverseMap oldInterpreter newInterpreter imageHeaderFlags savedWindowSize'
	classVariableNames: ''
	poolDictionaries: 'VMObjectIndices'
	category: 'Cog-Bootstrapping'!

!Spur32BitPreen commentStamp: 'eem 8/15/2016 19:49' prior: 0!
A Spur32BitPreen is a simple image rewriter for 32-bit Spru images that eliminates free space and hence shrinks the preened image.  Use via
	Spur32BitPreen new preenImage: 'spur'
which will produce spur-preen.image and spur-preen.changes from spur.image and spur.changes.

Instance Variables
	imageHeaderFlags:		<Integer>
	map:					<Dictionary>
	newHeap:				<Spur32BitMMLESimulator>
	newInterpreter:			<StackInterpreterSimulatorLSB>
	oldHeap:				<Spur32BitMMLESimulator>
	oldInterpreter:			<StackInterpreterSimulatorLSB>
	reverseMap:			<Dictionary>
	savedWindowSize:		<Integer>

imageHeaderFlags
	- flags word in image header

map
	- map from oops in old image to oops in new image

newHeap
	- the preened heap

newInterpreter
	- the interpreter wrapping the preened heap

oldHeap
	- the heap to be preened

oldInterpreter
	- the interpreter wrapping the heap to be preened

reverseMap
	- map from oops in new image to oops in old image

savedWindowSize
	- screen size word in mage header
!

SimulatorHarness subclass: #SpurBootstrap
	instanceVariableNames: 'oldHeap newHeap oldHeapSize newHeapSize oldHeapNumObjs newHeapNumObjs map reverseMap classToIndex oldInterpreter lastClassTablePage literalMap methodClasses installedPrototypes installedMethodOops classMetaclass imageTypes classMethodContextIndex classBlockClosureIndex toBeInitialized'
	classVariableNames: 'ImageHeaderFlags ImageName ImageScreenSize TransformedImage'
	poolDictionaries: 'VMObjectIndices'
	category: 'Cog-Bootstrapping'!

!SpurBootstrap commentStamp: 'eem 9/11/2013 05:45' prior: 0!
SpurBootstrap bootstraps an image in SpurMemoryManager format from a Squeak V3 + closures format.

e.g.
	(SpurBootstrap32 new on: '/Users/eliot/Cog/startreader.image')
		transform;
		launch

Bootstrap issues:
- should it implement a deterministic Symbol identityHash? This means set a Symbol's identityHash at instance creation time
  based on its string hash so that e.g. MethodDIctionary instances have a deterministic order and don't need to be rehashed on load.
- should it collapse ContextPart and MethodContext down onto Context (and perhaps eliminate BlockContext)?

Instance Variables
	classToIndex:			<Dictionary>
	lastClassTablePage:	<Integer>
	map:					<Dictionary>
	methodClasses:		<Set>
	newHeap:				<SpurMemoryManager>
	oldHeap:				<NewObjectMemory>
	oldInterpreter:			<StackInterpreterSimulator>
	reverseMap:			<Dictionary>
	symbolMap:				<Dictionary>

classToIndex
	- oldClass to new classIndex map

lastClassTablePage
	- oop in newHeap of last classTable page.  U<sed in validation to filter-out class table.

methodClasses
	- cache of methodClassAssociations for classes in which modified methods are installed

map
	- oldObject to newObject map

newHeap
	- the output, bootstrapped image

oldHeap
	- the input, image

oldInterpreter
	- the interpreter associated with oldHeap, needed for a hack to grab WeakArray

reverseMap
	- newObject to oldObject map

symbolMap
	- symbol toi symbol oop in oldHeap, used to map prototype methdos to methods in oldHeap!

SimulatorHarness subclass: #SpurOldToNewMethodFormatMunger
	instanceVariableNames: 'interpreter heap prototypes replacements symbolOops'
	classVariableNames: ''
	poolDictionaries: 'VMObjectIndices'
	category: 'Cog-Bootstrapping'!

!SpurOldToNewMethodFormatMunger commentStamp: 'eem 11/17/2014 10:36' prior: 0!
A SpurOldToNewMethodFormatMunger is a one-off for mirating a Spur image prior to the two formats to single format CompiledMethod header putsch.
!

!Decompiler methodsFor: '*Cog-method prototypes squeak 4.3' stamp: 'eem 8/10/2014 16:05'!
DecompilerPROTOTYPEdecompile: aSelector in: aClass method: aMethod using: aConstructor

	| block node |
	constructor := aConstructor.
	method := aMethod.
	self initSymbols: aClass.  "create symbol tables"
	method isQuick
		ifTrue: [block := self quickMethod]
		ifFalse: 
			[stack := OrderedCollection new: method frameSize.
			lastJumpIfPcStack := OrderedCollection new.
			caseExits := OrderedCollection new.
			statements := OrderedCollection new: 20.
			numLocalTemps := 0.
			super method: method pc: method initialPC.
			"skip primitive error code store if necessary"
			(method primitive ~= 0 and: [self skipCallPrimitive; willStore]) ifTrue:
				[pc := pc + (method encoderClass bytecodeSize: self firstByte).
				 tempVars := tempVars asOrderedCollection].
			block := self blockTo: method endPC + 1.
			stack isEmpty ifFalse: [self error: 'stack not empty']].
	node := constructor
				codeMethod: aSelector
				block: block
				tempVars: tempVars
				primitive: method primitive
				class: aClass.
	method primitive > 0 ifTrue:
		[node removeAndRenameLastTempIfErrorCode].
	^node preen! !

InstructionClient subclass: #ETC
	instanceVariableNames: 'scanner blockEnd joinOffsets sends contextStack currentContext blockEndStack topIsVector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Scripts'!

!ETC commentStamp: '<historical>' prior: 0!
I am a quick-hack type-checker (Eliot's Type Checker) that answers a dictionary of receiver to selector sets for a given method.!

!ETC class methodsFor: 'utilities' stamp: 'eem 10/12/2009 09:22'!
sendsForMethod: aMethod
	^(self new setMethod: aMethod) sends! !

!ETC class methodsFor: 'utilities' stamp: 'eem 8/16/2010 16:07'!
sendsToInstVar: instVarName in: class
	"Answer all selectors sent to instVarName in class's methods"
	| idx ref selectors |
	idx := class instVarIndexFor: instVarName ifAbsent: [^Set new].
	ref := {#inst. idx}.
	selectors := Set new.
	class methodsDo:
		[:m| selectors addAll: ((self sendsForMethod: m) at: ref ifAbsent: [#()])].
	^selectors! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:32'!
blockReturnTop
	"Return Top Of Stack bytecode."
	currentContext pop.
	scanner pc < blockEnd
		ifTrue: [self doJoin]
		ifFalse: [currentContext := contextStack removeLast.
				blockEnd := blockEndStack removeLast]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 13:51'!
doDup
	currentContext doDup! !

!ETC methodsFor: 'private' stamp: 'eem 9/11/2009 14:23'!
doJoin
	scanner pc < blockEnd ifTrue:
		[currentContext instVarNamed: 'stackp' put: (joinOffsets at: scanner pc)]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 13:51'!
doPop
	currentContext doPop! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 13:58'!
jump: offset
	"Unconditional Jump bytecode."
	offset > 0 ifTrue:
		[joinOffsets at: scanner pc + offset put: currentContext stackPtr.
		 self doJoin]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:32'!
jump: offset if: condition 
	"Conditional Jump bytecode."
	currentContext pop.
	offset > 0 ifTrue:
		[joinOffsets at: scanner pc + offset put: currentContext stackPtr]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:54'!
methodReturnConstant: value
	currentContext isExecutingBlock
		ifTrue: [currentContext push: value.
				self blockReturnTop]
		ifFalse: [self doJoin]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:56'!
methodReturnReceiver
	currentContext isExecutingBlock
		ifTrue: [self pushReceiver.
				self blockReturnTop]
		ifFalse: [self doJoin]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:57'!
methodReturnTop
	currentContext isExecutingBlock
		ifTrue: [self blockReturnTop]
		ifFalse: [currentContext pop.
				self doJoin]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:32'!
popIntoLiteralVariable: anAssociation
	currentContext pop! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:32'!
popIntoReceiverVariable: offset
	currentContext pop! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:33'!
popIntoRemoteTemp: remoteTempIndex inVectorAt: tempVectorIndex
	currentContext pop! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:33'!
popIntoTemporaryVariable: offset
	| vector |
	topIsVector
		ifTrue:
			[vector := currentContext top.
			 1 to: vector size do:
				[:i|
				vector
					at: i
					put: 'remote ', i printString,
						' @ ', (offset + 1) printString,
						' in ', currentContext startpc printString].
			 currentContext popIntoTemporaryVariable: offset]
		ifFalse:
			[currentContext pop]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 14:00'!
pushActiveContext
	currentContext pushActiveContext! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 11/6/2012 10:58'!
pushClosureCopyNumCopiedValues: numCopied numArgs: numArgs blockSize: blockSize
	"Push Closure bytecode.  Either compute the end of the block if this is
	 the block we're analysing, or skip it, adjusting the stack as appropriate."
	| blockClosure j |
	blockEndStack addLast: blockEnd.
	blockEnd := scanner pc + blockSize.
	contextStack addLast: currentContext.
	currentContext
		pc: scanner pc;
		pushClosureCopyNumCopiedValues: numCopied numArgs: numArgs blockSize: blockSize.
	blockClosure := currentContext top.
	currentContext := blockClosure asContext.
	1 to: numArgs do:
		[:i| currentContext push: 'blkarg', i printString].
	1 to: numCopied do:
		[:i| currentContext push: (blockClosure at: i)].
	j := numArgs + numCopied.
	[scanner willPushNil] whileTrue:
		[scanner interpretNextInstructionFor: self.
		 currentContext at: currentContext stackPtr put: 'blktmp', (j := j + 1) printString]

	"ETC sendsForMethod: (ETC compiledMethodAt: #pushClosureCopyNumCopiedValues:numArgs:blockSize:)"! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 15:38'!
pushConsArrayWithElements: numElements
	currentContext pushConsArrayWithElements: numElements! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 14:07'!
pushConstant: value
	currentContext pushConstant: value! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 14:08'!
pushLiteralVariable: anAssociation
	currentContext push: anAssociation! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 15:38'!
pushNewArrayOfSize: numElements
	currentContext pushNewArrayOfSize: numElements.
	scanner willStorePop ifTrue:
		[topIsVector := true.
		 scanner interpretNextInstructionFor: self.
		 topIsVector := false]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 14:08'!
pushReceiver
	currentContext push: #self! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:29'!
pushReceiverVariable: offset
	currentContext push: {#inst. offset + 1}! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 14:09'!
pushRemoteTemp: remoteTempIndex inVectorAt: tempVectorIndex
	currentContext pushRemoteTemp: remoteTempIndex inVectorAt: tempVectorIndex! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 14:10'!
pushTemporaryVariable: offset
	currentContext pushTemporaryVariable: offset! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:36'!
send: selector super: supered numArgs: numArgs
	numArgs timesRepeat: [currentContext pop].
	currentContext pop ifNotNil:
		[:top|
		((top isArray and: [top size = 2 and: [top first == #inst]])
		 or: [top == #self]) ifTrue:
			[(sends at: top ifAbsentPut: [Set new]) add: selector]].
	currentContext push: 'send ', selector! !

!ETC methodsFor: 'results' stamp: 'eem 10/12/2009 09:22'!
sends
	[scanner atEnd] whileFalse:
		[scanner interpretNextInstructionFor: self].
	^sends! !

!ETC methodsFor: 'initialize-release' stamp: 'eem 10/12/2009 09:35'!
setMethod: aCompiledMethod
	scanner := InstructionStream new method: aCompiledMethod pc: aCompiledMethod initialPC.
	contextStack := OrderedCollection new.
	currentContext := MethodContext
						sender: nil
						receiver: nil
						method: aCompiledMethod
						arguments: ((1 to: aCompiledMethod numArgs) collect:
										[:i| 'arg', i printString]).
	aCompiledMethod numArgs + 1 to: aCompiledMethod numTemps do:
		[:i| currentContext at: i put: 'tmp', (i - aCompiledMethod numArgs) printString].
	sends := Dictionary new.
	joinOffsets := Dictionary new.
	blockEndStack := OrderedCollection new.
	blockEnd := aCompiledMethod endPC.
	topIsVector := false! !

!ContextPart methodsFor: '*Cog-method prototypes' stamp: 'eem 8/11/2014 13:38'!
ContextPartPROTOTYPEdoPrimitive: primitiveIndex method: meth receiver: receiver args: arguments 
	"Simulate a primitive method whose index is primitiveIndex.  The simulated receiver and
	 arguments are given as arguments to this message. If successful, push result and return
	 resuming context, else ^ {errCode, PrimitiveFailToken}. Any primitive which provokes
	 execution needs to be intercepted and simulated to avoid execution running away."

	| value |
	"Judicious use of primitive 19 (a null primitive that doesn't do anything) prevents
	 the debugger from entering various run-away activities such as spawning a new
	 process, etc.  Injudicious use results in the debugger not being able to debug
	 interesting code, such as the debugger itself.  hence use primitive 19 with care :-)"
	"SystemNavigation new browseAllSelect: [:m| m primitive = 19]"
	primitiveIndex = 19 ifTrue:
		[ToolSet 
			debugContext: self
			label:'Code simulation error'
			contents: nil].

	((primitiveIndex between: 201 and: 222)
	 and: [(self objectClass: receiver) includesBehavior: BlockClosure]) ifTrue:
		[((primitiveIndex between: 201 and: 205)			 "BlockClosure>>value[:value:...]"
		  or: [primitiveIndex between: 221 and: 222]) ifTrue: "BlockClosure>>valueNoContextSwitch[:]"
			[^receiver simulateValueWithArguments: arguments caller: self].
		 primitiveIndex = 206 ifTrue:						"BlockClosure>>valueWithArguments:"
			[^receiver simulateValueWithArguments: arguments first caller: self]].

	primitiveIndex = 83 ifTrue: "afr 9/11/1998 19:50" "Object>>perform:[with:...]"
		[^self send: arguments first to: receiver with: arguments allButFirst super: false].
	primitiveIndex = 84 ifTrue: "afr 9/11/1998 19:50 & eem 8/18/2009 17:04" "Object>>perform:withArguments:"
		[^self send: arguments first to: receiver with: (arguments at: 2) lookupIn: (self objectClass: receiver)].
	primitiveIndex = 100 ifTrue: "eem 8/18/2009 16:57" "Object>>perform:withArguments:inSuperclass:"
		[^self send: arguments first to: receiver with: (arguments at: 2) lookupIn: (arguments at: 3)].

	"Mutex>>primitiveEnterCriticalSection
	 Mutex>>primitiveTestAndSetOwnershipOfCriticalSection"
	(primitiveIndex = 186 or: [primitiveIndex = 187]) ifTrue:
		[| active effective |
		 active := Processor activeProcess.
		 effective := active effectiveProcess.
		 "active == effective"
		 value := primitiveIndex = 186
					ifTrue: [receiver primitiveEnterCriticalSectionOnBehalfOf: effective]
					ifFalse: [receiver primitiveTestAndSetOwnershipOfCriticalSectionOnBehalfOf: effective].
		 ^(self isPrimFailToken: value)
			ifTrue: [value]
			ifFalse: [self push: value]].

	primitiveIndex = 188 ifTrue: "eem 5/27/2008 11:10 Object>>withArgs:executeMethod:"
		[^MethodContext
			sender: self
			receiver: receiver
			method: (arguments at: 2)
			arguments: (arguments at: 1)].

	"Closure primitives"
	(primitiveIndex = 200 and: [self == receiver]) ifTrue:
		"ContextPart>>closureCopy:copiedValues:; simulated to get startpc right"
		[^self push: (BlockClosure
						outerContext: receiver
						startpc: pc + 2
						numArgs: arguments first
						copiedValues: arguments last)].

	primitiveIndex = 118 ifTrue: "tryPrimitive:withArgs:; avoid recursing in the VM"
		[(arguments size = 2
		 and: [arguments first isInteger
		 and: [(self objectClass: arguments last) == Array]]) ifFalse:
			[^ContextPart primitiveFailTokenFor: nil].
		 ^self doPrimitive: arguments first method: meth receiver: receiver args: arguments last].

	value := primitiveIndex = 120 "FFI method"
				ifTrue: [(meth literalAt: 1) tryInvokeWithArguments: arguments]
				ifFalse:
					[primitiveIndex = 117 "named primitives"
						ifTrue: [self tryNamedPrimitiveIn: meth for: receiver withArgs: arguments]
						ifFalse: [receiver tryPrimitive: primitiveIndex withArgs: arguments]].

	^(self isPrimFailToken: value)
		ifTrue: [value]
		ifFalse: [self push: value]! !

!ContextPart methodsFor: '*Cog-method prototypes' stamp: 'eem 8/11/2014 12:57'!
ContextPartPROTOTYPEisPrimFailToken: anObject
	^(self objectClass: anObject) == Array
	  and: [anObject size = 2
	  and: [anObject first == PrimitiveFailToken]]! !

!Behavior methodsFor: '*Cog-method prototypes' stamp: 'eem 9/5/2013 15:53'!
BehaviorPROTOTYPEinstSize
	"Answer the number of named instance variables
	(as opposed to indexed variables) of the receiver.
	 Above Cog Spur the class format is
		<5 bits inst spec><16 bits inst size>"
	^format bitAnd: 16rFFFF! !

!Behavior methodsFor: '*Cog-method prototypes' stamp: 'eem 2/25/2014 11:24'!
BehaviorPROTOTYPEinstSpec
	"Answer the instance specification part of the format that defines what kind of object
	 an instance of the receiver is.  The formats are
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	^(format bitShift: -16) bitAnd: 16r1F! !

!Context methodsFor: '*Cog-method prototypes' stamp: 'EstebanLorenzano 1/22/2015 14:20'!
ContextPROTOTYPEdoPrimitive: primitiveIndex method: meth receiver: aReceiver args: arguments 
	"Simulate a primitive method whose index is primitiveIndex.  The simulated receiver and
	 arguments are given as arguments to this message. If successful, push result and return
	 resuming context, else ^ {errCode, PrimitiveFailToken}. Any primitive which provokes
	 execution needs to be intercepted and simulated to avoid execution running away."

	| value |
	"Judicious use of primitive 19 (a null primitive that doesn't do anything) prevents
	 the debugger from entering various run-away activities such as spawning a new
	 process, etc.  Injudicious use results in the debugger not being able to debug
	 interesting code, such as the debugger itself.  hence use primitive 19 with care :-)"
	"SystemNavigation new browseAllSelect: [:m| m primitive = 19]"
	primitiveIndex = 19 ifTrue:
		[ Smalltalk tools debugger 
			openContext: self
			label:'Code simulation error'
			contents: nil].

	((primitiveIndex between: 201 and: 222)
	 and: [(self objectClass: aReceiver) includesBehavior: BlockClosure]) ifTrue:
		[((primitiveIndex between: 201 and: 205)			 "BlockClosure>>value[:value:...]"
		  or: [primitiveIndex between: 221 and: 222]) ifTrue: "BlockClosure>>valueNoContextSwitch[:]"
			[^aReceiver simulateValueWithArguments: arguments caller: self].
		 primitiveIndex = 206 ifTrue:						"BlockClosure>>valueWithArguments:"
			[^aReceiver simulateValueWithArguments: arguments first caller: self]].

	primitiveIndex = 83 ifTrue: "afr 9/11/1998 19:50" "Object>>perform:[with:...]"
		[^self send: arguments first to: aReceiver with: arguments allButFirst super: false].
	primitiveIndex = 84 ifTrue: "afr 9/11/1998 19:50 & eem 8/18/2009 17:04" "Object>>perform:withArguments:"
		[^self send: arguments first to: aReceiver with: (arguments at: 2) lookupIn: (self objectClass: aReceiver)].
	primitiveIndex = 100 ifTrue: "eem 8/18/2009 16:57" "Object>>perform:withArguments:inSuperclass:"
		[^self send: arguments first to: aReceiver with: (arguments at: 2) lookupIn: (arguments at: 3)].

	"Mutex>>primitiveEnterCriticalSection
	 Mutex>>primitiveTestAndSetOwnershipOfCriticalSection"
	(primitiveIndex = 186 or: [primitiveIndex = 187]) ifTrue:
		[| active effective |
		 active := Processor activeProcess.
		 effective := active effectiveProcess.
		 "active == effective"
		 value := primitiveIndex = 186
					ifTrue: [aReceiver primitiveEnterCriticalSectionOnBehalfOf: effective]
					ifFalse: [aReceiver primitiveTestAndSetOwnershipOfCriticalSectionOnBehalfOf: effective].
		 ^(self isPrimFailToken: value)
			ifTrue: [value]
			ifFalse: [self push: value]].

	primitiveIndex = 188 ifTrue: "eem 5/27/2008 11:10 Object>>withArgs:executeMethod:"
		[^Context
			sender: self
			receiver: aReceiver
			method: (arguments at: 2)
			arguments: (arguments at: 1)].

	"Closure primitives"
	(primitiveIndex = 200 and: [self == aReceiver]) ifTrue:
		"ContextPart>>closureCopy:copiedValues:; simulated to get startpc right"
		[^self push: (BlockClosure
						outerContext: aReceiver
						startpc: pc + 2
						numArgs: arguments first
						copiedValues: arguments last)].

	primitiveIndex = 118 ifTrue: "tryPrimitive:withArgs:; avoid recursing in the VM"
		[(arguments size = 2
		 and: [arguments first isInteger
		 and: [(self objectClass: arguments last) == Array]]) ifFalse:
			[^Context primitiveFailTokenFor: nil].
		 ^self doPrimitive: arguments first method: meth receiver: aReceiver args: arguments last].

	value := primitiveIndex = 120 "FFI method"
				ifTrue: [(meth literalAt: 1) tryInvokeWithArguments: arguments]
				ifFalse:
					[primitiveIndex = 117 "named primitives"
						ifTrue: [self tryNamedPrimitiveIn: meth for: aReceiver withArgs: arguments]
						ifFalse: [aReceiver tryPrimitive: primitiveIndex withArgs: arguments]].

	^(self isPrimFailToken: value)
		ifTrue: [value]
		ifFalse: [self push: value]! !

!Context methodsFor: '*Cog-method prototypes' stamp: 'EstebanLorenzano 8/27/2014 16:42'!
ContextPROTOTYPEfailPrimitiveWith: maybePrimFailToken
	"The receiver is a freshly-created context on a primitive method.  Skip the callPrimitive:
	 bytecode and store the primitive fail code if there is one and the method consumes it."
	self skipCallPrimitive.
	((self isPrimFailToken: maybePrimFailToken)
	  and: [method encoderClass isStoreAt: pc in: method]) ifTrue:
		[self at: stackp put: maybePrimFailToken last]! !

!Context methodsFor: '*Cog-method prototypes' stamp: 'EstebanLorenzano 8/27/2014 16:43'!
ContextPROTOTYPEisPrimFailToken: anObject
	^ anObject class == Array
	  and: [anObject size = 2
	  and: [anObject first == PrimitiveFailToken]]! !

!Context methodsFor: '*Cog-method prototypes' stamp: 'EstebanLorenzano 10/31/2014 14:26'!
ContextPROTOTYPEobjectClass: aReceiver
	<primitive: 111>
	self primitiveFailed! !

!Context methodsFor: '*Cog-Tests-xrays' stamp: 'EstebanLorenzano 8/26/2014 14:42'!
xray
	"Lift the veil from a context and answer an integer describing its interior state.
	 Used for e.g. VM tests so they can verify they're testing what they think they're testing.
	 0 implies a vanilla heap context.
	 Bit 0 = is or was married to a frame
	 Bit 1 = is still married to a frame
	 Bit 2 = frame is executing machine code
	 Bit 3 = has machine code pc (as opposed to nil or a bytecode pc)
	 Bit 4 = method is currently compiled to machine code"
	<primitive: 213>
	^0 "Can only fail if unimplemented; therefore simply answer 0"! !

!Context methodsFor: '*Cog-Tests-xrays' stamp: 'EstebanLorenzano 8/26/2014 14:42'!
xrayIsDivorced
	^(self xray bitAnd: 3) = 1! !

!Context methodsFor: '*Cog-Tests-xrays' stamp: 'EstebanLorenzano 8/26/2014 14:42'!
xrayIsExecutingMachineCode
	^self xray anyMask: 4! !

!Context methodsFor: '*Cog-Tests-xrays' stamp: 'EstebanLorenzano 8/26/2014 14:42'!
xrayIsMarried
	^self xray anyMask: 2! !

!Context methodsFor: '*Cog-Tests-xrays' stamp: 'EstebanLorenzano 8/26/2014 14:42'!
xrayLastExecutedMachineCode
	^self xray anyMask: 8! !

!Context methodsFor: '*Cog-Tests-xrays' stamp: 'EstebanLorenzano 8/26/2014 14:42'!
xrayMethodIsCompiledToMachineCode
	^self xray anyMask: 16! !

!MethodNode methodsFor: '*Cog-method prototypes' stamp: 'eem 8/12/2014 09:34'!
MethodNodePROTOTYPEgenerate: trailer using: aCompiledMethodClass
	"The receiver is the root of a parse tree. Answer an instance of aCompiledMethodClass.
	 The argument, trailer, is arbitrary but is typically either the reference to the source code
	 that is stored with every CompiledMethod, or an encoding of the method's temporary names."

	| primErrNode blkSize nLits locals literals stack header method |
	self generate: trailer
		using: aCompiledMethodClass
		ifQuick:
			[:m |
			 encoder noteBlockExtent: (0 to: 2) hasLocals: arguments.
			 m	literalAt: 2 put: encoder associationForClass;
				properties: properties.
			 ^m].
	primErrNode := self primitiveErrorVariableName ifNotNil:
						[encoder fixTemp: self primitiveErrorVariableName].
	self ensureClosureAnalysisDone.
	encoder rootNode: self. "this is for BlockNode>>sizeCodeForClosureValue:"
	blkSize := (block sizeCodeForEvaluatedValue: encoder)
				+ (primitive > 0
					ifTrue: [encoder sizeCallPrimitive: primitive]
					ifFalse: [0])
				+ (primErrNode
					ifNil: [0]
					ifNotNil:
						[primErrNode
							index: arguments size + temporaries size;
							sizeCodeForStore: encoder "The VM relies on storeIntoTemp: (129)"]).
	locals := arguments, temporaries, (primErrNode ifNil: [#()] ifNotNil: [{primErrNode}]).
	encoder noteBlockExtent: block blockExtent hasLocals: locals.
	header := encoder computeMethodHeaderForNumArgs: arguments size
					numTemps: locals size
					numLits: (nLits := (literals := encoder allLiterals) size)
					primitive: primitive.
	method := trailer
					createMethod: blkSize
					class: aCompiledMethodClass
					header: header.
	1 to: nLits do: [:lit | method literalAt: lit put: (literals at: lit)].
	encoder streamToMethod: method.
	stack := ParseStack new init.
	primitive > 0 ifTrue:
		[encoder genCallPrimitive: primitive.
		 primErrNode ifNotNil:
			[primErrNode emitCodeForStore: stack encoder: encoder]].
	stack position: method numTemps.
	[block emitCodeForEvaluatedValue: stack encoder: encoder]
		on: Error "If an attempt is made to write too much code the method will be asked"
		do: [:ex|  "to grow, and the grow attempt will fail in CompiledMethod class>>#new:"
			ex signalerContext sender method = (CompiledMethod class>>#new:)
				ifTrue: [^self error: 'Compiler code size discrepancy']
				ifFalse: [ex pass]].
	stack position ~= (method numTemps + 1) ifTrue:
		[^self error: 'Compiler stack discrepancy'].
	encoder methodStreamPosition ~= (method size - trailer size) ifTrue:
		[^self error: 'Compiler code size discrepancy'].
	method needsFrameSize: stack size - method numTemps.
	method properties: properties.
	^method! !

!MethodNode methodsFor: '*Cog-method prototypes' stamp: 'eem 5/19/2016 17:33'!
MethodNodePROTOTYPEgenerate: trailer using: aCompiledMethodClass ifQuick: methodBlock
	| v |
	(primitive = 0 and: [arguments size = 0 and: [block isQuick]]) ifFalse:
		[^self].
	v := block code.
	v < 0 ifTrue:
		[^self].
	v = LdSelf ifTrue:
		[^methodBlock value: (aCompiledMethodClass toReturnSelfTrailerBytes: trailer)].
	(v between: LdTrue and: LdMinus1 + 3) ifTrue:
		[^methodBlock value: (aCompiledMethodClass toReturnConstant: v - LdSelf trailerBytes: trailer)].
	v < ((CodeBases at: LdInstType) + (CodeLimits at: LdInstType)) ifTrue:
		[^methodBlock value: (aCompiledMethodClass toReturnField: v trailerBytes: trailer)].
	v // 256 = 1 ifTrue:
		[^methodBlock value: (aCompiledMethodClass toReturnField: v \\ 256 trailerBytes: trailer)]! !

!MethodNode methodsFor: '*Cog-method prototypes' stamp: 'eem 12/1/2008 14:25'!
MethodNodePROTOTYPEprintPropertiesOn: aStream
	properties ifNil: [^self].
	properties propertyKeysAndValuesDo:
		[:prop :val|
		aStream crtab; nextPut: $<.
		prop = #on:in:
			ifTrue:
				[prop keywords with: val do:
					[:k :v | aStream nextPutAll: k; space; nextPutAll: v; space]]
			ifFalse:
				[prop = #on
					ifTrue: [aStream nextPutAll: prop; nextPutAll:': '; nextPutAll: val] 
					ifFalse: [aStream nextPutAll: prop; nextPutAll:': '; print: val]]. 
		aStream nextPut: $>]! !

SimulatorHarness subclass: #Spur32to64BitBootstrap
	instanceVariableNames: 'heap32 heap64 map reverseMap interpreter32 interpreter64 imageHeaderFlags savedWindowSize literalMap'
	classVariableNames: ''
	poolDictionaries: 'VMObjectIndices VMSqueakClassIndices'
	category: 'Cog-Bootstrapping'!

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 3/8/2016 15:00'!
alterSystem
	self ensureSmallFloatInClassTable.
	self nilWordSize! !

!Spur32to64BitBootstrap methodsFor: 'public access' stamp: 'eem 11/19/2014 11:14'!
bootstrapImage
	self cloneObjects.
	self fillInObjects.
	self fillInHeap.
	self alterSystem! !

!Spur32to64BitBootstrap methodsFor: 'public access' stamp: 'eem 11/17/2014 13:26'!
bootstrapImage: imageName
	(Smalltalk classNamed: #FileReference) ifNotNil:
		[^self bootstrapImageUsingFileReference: imageName].
	(Smalltalk classNamed: #FileDirectory) ifNotNil:
		[^self bootstrapImageUsingFileDirectory: imageName].
	self error: 'at a loss as to what file system support to use'! !

!Spur32to64BitBootstrap methodsFor: 'public access' stamp: 'eem 11/18/2014 08:40'!
bootstrapImageUsingFileDirectory: imageName
	| dirName baseName dir |
	dirName := FileDirectory dirPathFor: imageName.
	baseName := (imageName endsWith: '.image')
					ifTrue: [FileDirectory baseNameFor: imageName]
					ifFalse: [FileDirectory localNameFor: imageName].
	dir := dirName isEmpty ifTrue: [FileDirectory default] ifFalse: [FileDirectory default on: dirName].
	self on: (dir fullNameFor: baseName, '.image').
	[self bootstrapImage]
		on: Halt
		do: [:ex|
			"suppress halts from the usual suspects (development time halts)"
			(#(fullGC compactImage) includes: ex signalerContext sender selector)
				ifTrue: [ex resume]
				ifFalse: [ex pass]].
	self writeSnapshot: (dir fullNameFor: baseName, '-64.image')
		headerFlags: imageHeaderFlags
		screenSize: savedWindowSize.
	dir deleteFileNamed: baseName, '-64.changes';
		copyFileNamed: baseName, '.changes' toFileNamed: baseName, '-64.changes'! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 12/25/2014 15:22'!
clone: obj32
	| obj64 format numSlots numBytes hash |
	format := heap32 formatOf: obj32.
	numSlots := heap32 numSlotsOf: obj32.
	format > heap32 lastPointerFormat ifTrue:
		[format < heap32 firstByteFormat
			ifTrue:
				[format = heap32 firstLongFormat
					ifTrue:
						[numSlots := heap32 numSlotsOf: obj32.
						 numSlots odd ifTrue:
							[format := format + 1].
						 numSlots := numSlots + 1 // 2]
					ifFalse: [self error: 'bad format']]
			ifFalse:
				[numBytes := heap32 numBytesOf: obj32.
				 format < heap32 firstCompiledMethodFormat
					ifTrue:
						[format := heap64 byteFormatForNumBytes: numBytes.
						 numSlots := numSlots + 1 // 2]
					ifFalse:
						[numSlots := heap32 numPointerSlotsOf: obj32.
						 numBytes := numBytes - (numSlots * heap32 bytesPerOop).
						 format := (heap64 byteFormatForNumBytes: numBytes) + heap32 firstCompiledMethodFormat - heap32 firstByteFormat.
						 numSlots := numSlots + (heap64 numSlotsForBytes: numBytes)]]].
	obj64 := heap64
				allocateSlots: numSlots
				format: format
				classIndex: (heap32 classIndexOf: obj32).
	(hash := heap32 rawHashBitsOf: obj32) ~= 0 ifTrue:
		[heap64 setHashBitsOf: obj64 to: hash].
	(heap32 isImmutable: obj32) ifTrue:
		[heap64 setIsImmutableOf: obj64 to: true].
	(heap32 isPinned: obj32) ifTrue:
		[heap64 setIsPinnedOf: obj64 to: true].
	self deny: (heap32 isRemembered: obj32).
	self deny: (heap32 isMarked: obj32).
	self deny: (heap32 isGrey: obj32).
	reverseMap at: obj64 put: obj32.
	^map at: obj32 put: obj64! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/15/2016 17:22'!
cloneFreeLists: obj32
	| obj64 |
	obj64 := heap64
				allocateSlots: heap64 numFreeLists
				format: heap64 wordIndexableFormat
				classIndex: heap64 wordSizeClassIndexPun.
	reverseMap at: obj64 put: obj32.
	^map at: obj32 put: obj64! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 12/16/2014 11:34'!
cloneObjects
	"Clone all normal objects.  Of hidden objects only clone the freeLists object and
	 the classTableRoot and class table pages. In particular, dont clone objStacks.
	 The refs to the objStacks are nilled out in fillInHeap."
	| i freeListsObject |
	i := 0.
	freeListsObject := heap32 freeListsObject.
	heap32 allOldSpaceObjectsDo:
		[:obj32|
		(i := i + 1) >= 100000 ifTrue:
			[Transcript nextPut: $:; flush. i := 0].
		 obj32 = freeListsObject
			ifTrue:
				[self cloneFreeLists: obj32]
			ifFalse:
				[(self shouldClone: obj32) ifTrue:
					[self clone: obj32]]]! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 3/8/2016 15:03'!
ensureSmallFloatInClassTable
	| firstClassTablePage smallFloatClass |
	firstClassTablePage := heap64 fetchPointer: 0 ofObject: heap64 classTableRootObj.
	smallFloatClass := self smallFloatClass.
	(heap64 hashBitsOf: smallFloatClass) = heap64 smallFloatTag
		ifTrue:
			[self assert: (heap64 fetchPointer: heap64 smallFloatTag ofObject: firstClassTablePage)
						= smallFloatClass]
		ifFalse:
			[self assert: (heap64 hashBitsOf: smallFloatClass) = 0.
			 heap64
				storePointer: heap64 smallFloatTag ofObject: firstClassTablePage withValue: smallFloatClass;
				setHashBitsOf: smallFloatClass to: heap64 smallFloatTag]! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 11/17/2014 19:22'!
fillInBitsObject: obj64 from: obj32
	0 to: (heap32 numBytesOf: obj32) - 1 do:
		[:i|
		heap64
			storeByte: i
			ofObject: obj64
			withValue: (heap32 fetchByte: i ofObject: obj32)]! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 11/19/2014 09:13'!
fillInCompiledMethod: obj64 from: obj32
	| offset |
	"interpreter32 printOop: oop32"
	"interpreter64 printOop: oop64"
	0 to: (heap32 numPointerSlotsOf: obj32) - 1 do:
		[:i| | oop32 oop64 |
		 oop32 := heap32 fetchPointer: i ofObject: obj32.
		 oop64 := self map32BitOop: oop32.
		 heap64
			storePointerUnchecked: i
			ofObject: obj64
			withValue: oop64.
		 (heap64 isIntegerObject: oop64) ifTrue:
			[interpreter32 initPrimCall.
			 self assert: (interpreter32 signed64BitValueOf: oop32) = (heap64 integerValueOf: oop64)]].
	offset := (interpreter64 startPCOfMethod: obj64)
			- (interpreter32 startPCOfMethod: obj32).
	(interpreter32 startPCOfMethod: obj32)
		to: (heap32 numBytesOf: obj32) - 1
		do: [:j|
			heap64
				storeByte: offset + j 
				ofObject: obj64
				withValue: (heap32 fetchByte: j ofObject: obj32)]! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 11/19/2014 12:50'!
fillInHeap
	| heapEnd freeListsObj |
	heapEnd := heap64 freeStart.
	heap64
		nilObject: (map at: heap32 nilObject);
		falseObject: (map at: heap32 falseObject);
		trueObject: (map at: heap32 trueObject);
		specialObjectsOop: (map at: heap32 specialObjectsOop);
		lastHash: heap32 lastHash;
		setHiddenRootsObj: (map at: heap32 classTableRootObj).
	heap64 segmentManager
		initSegmentForInImageCompilationFrom: heap64 nilObject
		to: heapEnd + heap64 bridgeSize.
	freeListsObj := heap64 objectAfter: heap64 trueObject.
	"Nil-out the free lists."
	heap64
		fillObj: freeListsObj numSlots: (heap64 numSlotsOf: freeListsObj) with: 0;
		initializeFreeSpacePostLoad: freeListsObj;
		initializePostBootstrap;
		setEndOfMemory: (heap64 segmentManager bridgeAt: 0) + heap64 baseHeaderSize! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/31/2015 10:45'!
fillInObjects
	"interpreter32 printOop: obj32"
	| i |
	{heap32 markStack. heap32 weaklingStack. heap32 mournQueue} do:
		[:obj|
		obj ~= heap32 nilObject ifTrue:
			[map at: obj put: (map at: heap32 nilObject)]].
	i := 0.
	heap32 allObjectsDo:
		[:obj32|
		(i := i + 1) >= 10000 ifTrue:
			[Transcript nextPut: $.; flush. i := 0].
		(map at: obj32 ifAbsent: nil)
			ifNotNil:
				[:obj64| | format classIndex |
				(heap64 numSlotsOf: obj64) > 0 ifTrue: "filter-out filtered objStack pages"
					[format := heap32 formatOf: obj32.
					 (heap64 isPointersFormat: format)
						ifTrue:
							[((heap64 isIndexableFormat: format)
								and: [(classIndex := heap64 classIndexOf: obj64) <= ClassBlockClosureCompactIndex
								and: [classIndex >= ClassMethodContextCompactIndex]])
								ifTrue: [self fillInPointerObjectWithPC: obj64 from: obj32]
								ifFalse: [self fillInPointerObject: obj64 from: obj32]]
						ifFalse:
							[(heap64 isCompiledMethodFormat: format)
								ifTrue: [self fillInCompiledMethod: obj64 from: obj32]
								ifFalse: [self fillInBitsObject: obj64 from: obj32]]]]
			ifNil: [self assert: (self isUnmappedObject: obj32)]]! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 11/17/2014 19:42'!
fillInPointerObject: obj64 from: obj32 
	0 to: (heap64 numSlotsOf: obj64) - 1 do:
		[:i|
		 heap64
			storePointerUnchecked: i
			ofObject: obj64
			withValue: (self map32BitOop: (heap32 fetchPointer: i ofObject: obj32))]! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 11/17/2014 20:09'!
fillInPointerObjectWithPC: obj64 from: obj32
	| method |
	self fillInPointerObject: obj64 from: obj32.
	(heap64 classIndexOf: obj64) = ClassBlockClosureCompactIndex ifTrue:
		[method := heap32
						fetchPointer: MethodIndex
						ofObject: (heap32
									fetchPointer: ClosureOuterContextIndex
									ofObject: obj32).
		self incrementPCField: ClosureStartPCIndex ofObject: obj64 for: method].
	(heap64 classIndexOf: obj64) = ClassMethodContextCompactIndex ifTrue:
		[method := heap32
						fetchPointer: MethodIndex
						ofObject: obj32.
		 self incrementPCField: InstructionPointerIndex ofObject: obj64 for: method]! !

!Spur32to64BitBootstrap methodsFor: 'public access' stamp: 'eem 11/19/2014 11:15'!
findSymbol: aString
	"Find the Symbol equal to aString in oldHeap."
	| symbolClass |
	(literalMap at: aString ifAbsent: nil) ifNotNil:
		[:oop| ^oop].
	symbolClass := self symbolClass.
	heap64 allObjectsDo:
		[:obj|
		(symbolClass = (heap64 fetchClassOfNonImm: obj)
		 and: [(heap64 numBytesOf: obj) = aString size
		 and: [aString = (heap64 stringOf: obj)]]) ifTrue:
			[aString isSymbol ifTrue:
				[literalMap at: aString asSymbol put: obj].
			 ^obj]].
	Transcript cr; nextPutAll: 'Warning, could not find '; store: aString; flush.
	^nil! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 11/17/2014 20:15'!
incrementPCField: fieldIndex ofObject: obj64 for: method32
	| value nLits |
	value := heap64 fetchPointer: fieldIndex ofObject: obj64.
	(heap64 isIntegerObject: value)
		ifTrue:
			[nLits := heap32 literalCountOf: method32.
			 heap64
				storePointerUnchecked: fieldIndex
				ofObject: obj64
				withValue: (heap64 integerObjectOf: nLits + LiteralStart * 4 + (heap64 integerValueOf: value))]
		ifFalse:
			[self assert: (reverseMap at: value) = heap32 nilObject]! !

!Spur32to64BitBootstrap methodsFor: 'initialize-release' stamp: 'eem 11/19/2014 11:16'!
initMaps
	map := Dictionary new: heap32 memory size // 32.
	reverseMap := Dictionary new: heap32 memory size // 32.
	literalMap := IdentityDictionary new! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 12/16/2014 11:28'!
isUnmappedObject: obj32
	"Answer if obj32 is an object that is not cloned by the bootstrap."
	^((heap32 classIndexOf: obj32)
			between: ClassLargeNegativeIntegerCompactIndex
			and: ClassFloatCompactIndex)
	  or: [obj32 = heap32 freeListsObject
	  or: [(heap32 isValidObjStackPage: obj32)]]! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 12/16/2014 11:30'!
map32BitOop: obj32
	"interpreter32 printOop: obj32"
	^map
		at: obj32
		ifAbsent:
			[(heap32 isImmediate: obj32)
				ifTrue:
					[(heap32 isImmediateCharacter: obj32)
						ifTrue: [heap64 characterObjectOf: (heap32 characterValueOf: obj32)]
						ifFalse: [heap64 integerObjectOf: (heap32 integerValueOf: obj32)]]
				ifFalse:
					[| value |
					 self assert: (self isUnmappedObject: obj32).
					 (heap32 isFloatInstance: obj32)
						ifTrue:
							[heap64 smallFloatObjectOf: (heap32 floatValueOf: obj32)]
						ifFalse:
							[interpreter32 initPrimCall.
							 value := interpreter32 signed64BitValueOf: obj32.
							 self deny: interpreter32 failed.
							 heap64 integerObjectOf: value]]]! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 11/19/2014 11:21'!
nilWordSize
	| wordSizeSym |
	wordSizeSym := self findSymbol: #WordSize.
	heap64 allOldSpaceObjectsDo:
		[:o|
		((heap64 numSlotsOf: o) > ValueIndex
		and: [(heap64 isPointersNonImm: o)
		and: [(heap64 fetchPointer: KeyIndex ofObject: o) = wordSizeSym
		and: [(heap64 fetchPointer: ValueIndex ofObject: o) = (heap64 integerObjectOf: 4)]]]) ifTrue:
			[heap64 storePointer: ValueIndex ofObject: o withValue: heap64 nilObject]]! !

!Spur32to64BitBootstrap methodsFor: 'public access' stamp: 'eem 11/17/2014 18:10'!
on: imageName
	(interpreter32 := StackInterpreterSimulator newWithOptions: #(ObjectMemory Spur32BitMemoryManager))
		openOn: imageName extraMemory: 0.
	heap32 := interpreter32 objectMemory.
	imageHeaderFlags := interpreter32 getImageHeaderFlags.
	savedWindowSize := interpreter32 savedWindowSize.
	interpreter64 := StackInterpreterSimulator newWithOptions: #(ObjectMemory Spur64BitMemoryManager).
	heap64 := interpreter64 objectMemory.
	heap64
		allocateMemoryOfSize: heap32 oldSpaceSize * 2
		newSpaceSize: 8 * 1024 * 1024
		stackSize: 16 * 1024
		codeSize: 0.
	heap64 bootstrapping: true.
	self initMaps! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 12/16/2014 11:21'!
shouldClone: obj32
	| classIndex value |
	(heap32 isValidObjStackPage: obj32) ifTrue:
		[^false].

	classIndex := heap32 classIndexOf: obj32.

	((classIndex between: ClassLargeNegativeIntegerCompactIndex and: ClassLargePositiveIntegerCompactIndex)
	 and: [interpreter32 initPrimCall.
		   value := interpreter32 signed64BitValueOf: obj32.
		   interpreter32 failed not
		   and: [heap64 isIntegerValue: value]]) ifTrue:
		[^false].

	(classIndex = ClassFloatCompactIndex
	and: [value := heap32 floatValueOf: obj32.
		heap64 isSmallFloatValue: value]) ifTrue:
		[^false].

	^true! !

!Spur32to64BitBootstrap methodsFor: 'bootstrap image' stamp: 'eem 12/1/2014 18:06'!
smallFloatClass
	| sf64sym |
	sf64sym := self findSymbol: #SmallFloat64.
	heap64 allObjectsDo:
		[:o|
		((heap64 isPointersNonImm: o)
		 and: [(heap64 numSlotsOf: o) > interpreter32 classNameIndex
		 and: [(interpreter64 addressCouldBeClassObj: o)
		 and: [(heap64 fetchPointer: interpreter32 classNameIndex ofObject: o) = sf64sym]]]) ifTrue:
			[^o]].
	^nil! !

!Spur32to64BitBootstrap methodsFor: 'public access' stamp: 'eem 11/19/2014 11:15'!
symbolClass
	^heap64 fetchClassOfNonImm: (heap64 splObj: SelectorDoesNotUnderstand)! !

!Spur32to64BitBootstrap methodsFor: 'snapshot' stamp: 'eem 7/18/2015 09:00'!
writeSnapshot: imageFileName headerFlags: headerFlags screenSize: screenSizeInteger
	heap64
		checkFreeSpace;
		runLeakCheckerForFullGC.
	interpreter64
		setImageHeaderFlagsFrom: headerFlags;
		setDisplayForm: nil;
		setSavedWindowSize: savedWindowSize;
		imageName: imageFileName;
		writeImageFileIO.
	Transcript cr; show: 'Done!!'! !

SmartSyntaxInterpreterPlugin subclass: #BochsPlugin
	instanceVariableNames: 'prevInterruptCheckChain'
	classVariableNames: ''
	poolDictionaries: 'VMBasicConstants'
	category: 'Cog-ProcessorPlugins'!

!BochsPlugin commentStamp: 'eem 9/14/2015 16:30' prior: 0!
BochsPlugin is the abstract superclass for plugins that interface to the Bochs C++ IA32/x64 processor emulator..

Instance Variables
	prevInterruptCheckChain:		<Symbol/function pointer>

prevInterruptCheckChain
	- the previous value of the interruptCheckChain function pointer
!

BochsPlugin subclass: #BochsIA32Plugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-ProcessorPlugins'!

!BochsIA32Plugin commentStamp: '<historical>' prior: 0!
I provide access to the Bochs C++ IA32 processor emulator.!

!BochsPlugin class methodsFor: 'translation' stamp: 'eem 9/14/2015 17:59'!
declareCVarsIn: aCCodeGenerator
	"prevInterruptCheckChain lives in sqBochsIA32|X64Plugin.c"
	self ~~ BochsPlugin ifTrue:
		[super declareCVarsIn: aCCodeGenerator.
		 aCCodeGenerator removeVariable: 'prevInterruptCheckChain']! !

!BochsPlugin class methodsFor: 'translation' stamp: 'eem 12/3/2008 10:25'!
hasHeaderFile
	"We need a header to declare newcpu and pull in bochs.h & cpu.h"
	^true! !

!BochsPlugin class methodsFor: 'translation' stamp: 'eem 9/14/2015 18:14'!
shouldBeTranslated
	"Is this class intended to be translated as a plugin, perhaps specific to a platform?
	 Most subclasses should answer true, but some such as simulation-only versions
	 should answer false for various reasons."
	^super shouldBeTranslated and: [self ~~ BochsPlugin]! !

!BochsPlugin methodsFor: 'interruption' stamp: 'eem 9/15/2015 11:21'!
forceStopOnInterrupt
	<returnTypeC: #void>
	interpreterProxy getInterruptPending ifTrue:
		[self forceStopRunning]! !

!BochsPlugin methodsFor: 'primitives' stamp: 'eem 9/15/2015 12:07'!
"cpuAlien <BochsIA32|X86Alien>" primitiveDisassembleAt: address "<Integer>" InMemory: memory "<Bitmap|ByteArray|WordArray>"
	"Return an Array of the instruction length and its decompilation as a string for the instruction at address in memory."
	| cpuAlien cpu instrLenOrErr resultObj log logLen logObj logObjData |
	<var: #cpu type: #'void *'>
	<var: #log type: #'char *'>
	<var: #logLen type: #long>
	<var: #logObjData type: #'char *'>
	cpuAlien := self primitive: #primitiveDisassembleAtInMemory
					parameters: #(Unsigned WordsOrBytes)
					receiver: #Oop.
	(cpu := self cCoerceSimple: (self startOfData: cpuAlien) to: #'void *') = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	instrLenOrErr := self disassembleFor: cpu
						At: address
						In: memory
						Size: (interpreterProxy byteSizeOf: memory cPtrAsOop).
	instrLenOrErr < 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	log := self getlog: (self cCode: [self addressOf: logLen] inSmalltalk: [logLen := 0]).
	resultObj := interpreterProxy instantiateClass: interpreterProxy classArray indexableSize: 2.
	resultObj = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrNoMemory].

	"Easier keeping the damn thing on the stack than using pushRemappableOop:/popRemappableOop.
	 Where is topRemappableOop when you need it?"
	interpreterProxy pushRemappableOop: resultObj.
	logObj := interpreterProxy
				instantiateClass: interpreterProxy classString
				indexableSize: logLen.
	interpreterProxy failed ifTrue:
		[interpreterProxy popRemappableOop.
		 ^interpreterProxy primitiveFailFor: PrimErrNoMemory].
	logObjData := interpreterProxy arrayValueOf: logObj.
	self mem: logObjData cp: log y: logLen.
	resultObj := interpreterProxy popRemappableOop.
	interpreterProxy
		storePointer: 0
		ofObject: resultObj
		withValue: (interpreterProxy integerObjectOf: instrLenOrErr).
	interpreterProxy storePointer: 1 ofObject: resultObj withValue: logObj.

	^resultObj! !

!BochsPlugin methodsFor: 'primitives' stamp: 'eem 9/15/2015 12:07'!
primitiveErrorAndLog
	| log logLen resultObj logObj logObjData |
	<var: #log type: #'char *'>
	<var: #logLen type: #long>
	<var: #logObjData type: #'char *'>
	self primitive: #primitiveErrorAndLog parameters: #().

	log := self getlog: (self cCode: [self addressOf: logLen] inSmalltalk: [logLen := 0]).
	resultObj := interpreterProxy instantiateClass: interpreterProxy classArray indexableSize: 2.
	resultObj = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrNoMemory].

	interpreterProxy
		storePointer: 0
		ofObject: resultObj
		withValue: (interpreterProxy integerObjectOf: self errorAcorn).

	logLen > 0 ifTrue:
		[interpreterProxy pushRemappableOop: resultObj.
		logObj := interpreterProxy
					instantiateClass: interpreterProxy classString
					indexableSize: logLen.
		interpreterProxy failed ifTrue:
			[interpreterProxy popRemappableOop.
			 ^interpreterProxy primitiveFailFor: PrimErrNoMemory].

		resultObj := interpreterProxy popRemappableOop.
		logObjData := interpreterProxy arrayValueOf: logObj.
		self mem: logObjData cp: log y: logLen.
		interpreterProxy storePointer: 1 ofObject: resultObj withValue: logObj].
	interpreterProxy pop: 1 thenPush: resultObj! !

!BochsPlugin methodsFor: 'primitives' stamp: 'eem 9/15/2015 11:46'!
"cpuAlien <BochsIA32|X86Alien>" primitiveFlushICacheFrom: startAddress "<Integer>" To: endAddress "<Integer>"
	"Flush the icache in the requested range"
	| cpuAlien cpu |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveFlushICacheFromTo
					parameters: #(Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self cCoerceSimple: (self startOfData: cpuAlien) to: #'void *') = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	self flushICache: cpu From: startAddress To: endAddress! !

!BochsPlugin methodsFor: 'primitives' stamp: 'eem 11/17/2016 15:46'!
primitiveNewCPU
	| cpu |
	<var: #cpu type: #'void *'>
	self primitive: #primitiveNewCPU parameters: #().

	cpu := self newCPU.
	cpu = 0 ifTrue:
		[^interpreterProxy primitiveFail].
	interpreterProxy
		pop: 1
		thenPush: (interpreterProxy positiveMachineIntegerFor:
										(self cCoerceSimple: cpu
											to: 'usqIntptr_t'))! !

!BochsPlugin methodsFor: 'primitives' stamp: 'eem 9/15/2015 11:47'!
primitiveResetCPU
	| cpuAlien cpu maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveResetCPU parameters: #() receiver: #Oop.
	(cpu := self cCoerceSimple: (self startOfData: cpuAlien) to: #'void *') = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	maybeErr := self resetCPU: cpu.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!BochsPlugin methodsFor: 'primitives' stamp: 'eem 9/15/2015 11:47'!
"cpuAlien <BochsIA32|X86Alien>" primitiveRunInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>" maximumAddress: maxAddress "<Integer>" readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Run the cpu using the first argument as the memory and the following arguments defining valid addresses, running until it halts or hits an exception."
	| cpuAlien cpu memorySize maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveRunInMemoryMinAddressMaxAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self cCoerceSimple: (self startOfData: cpuAlien) to: #'void *') = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	prevInterruptCheckChain := interpreterProxy setInterruptCheckChain: #forceStopOnInterrupt asSymbol.
	prevInterruptCheckChain = #forceStopOnInterrupt asSymbol ifTrue:
		[prevInterruptCheckChain = 0].
	memorySize := interpreterProxy byteSizeOf: memory cPtrAsOop.
	maybeErr := self runCPU: cpu
					In: memory
					Size: (memorySize min: maxAddress)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	interpreterProxy setInterruptCheckChain: prevInterruptCheckChain.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!BochsPlugin methodsFor: 'primitives' stamp: 'eem 9/15/2015 11:47'!
"cpuAlien <BochsIA32|X86Alien>" primitiveRunInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>" readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Run the cpu using the first argument as the memory and the following arguments defining valid addresses, running until it halts or hits an exception."
	| cpuAlien cpu maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveRunInMemoryMinimumAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self cCoerceSimple: (self startOfData: cpuAlien) to: #'void *') = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	prevInterruptCheckChain := interpreterProxy setInterruptCheckChain: #forceStopOnInterrupt asSymbol.
	prevInterruptCheckChain = #forceStopOnInterrupt asSymbol ifTrue:
		[prevInterruptCheckChain = 0].
	maybeErr := self runCPU: cpu
					In: memory
					Size: (interpreterProxy byteSizeOf: memory cPtrAsOop)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	interpreterProxy setInterruptCheckChain: prevInterruptCheckChain.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!BochsPlugin methodsFor: 'primitives' stamp: 'eem 9/15/2015 11:47'!
"cpuAlien <BochsIA32|X86Alien>" primitiveSingleStepInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>" maximumAddress: maxAddress "<Integer>" readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Single-step the cpu using the first argument as the memory and the following arguments defining valid addresses."
	| cpuAlien cpu memorySize maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveSingleStepInMemoryMinAddressMaxAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self cCoerceSimple: (self startOfData: cpuAlien) to: #'void *') = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	memorySize := interpreterProxy byteSizeOf: memory cPtrAsOop.
	maybeErr := self singleStepCPU: cpu
					In: memory
					Size: (memorySize min: maxAddress)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!BochsPlugin methodsFor: 'primitives' stamp: 'eem 9/15/2015 11:47'!
"cpuAlien <BochsIA32|X86Alien>" primitiveSingleStepInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>"  readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Single-step the cpu using the first argument as the memory and the following arguments defining valid addresses."
	| cpuAlien cpu maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveSingleStepInMemoryMinimumAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self cCoerceSimple: (self startOfData: cpuAlien) to: #'void *') = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	maybeErr := self singleStepCPU: cpu
					In: memory
					Size: (interpreterProxy byteSizeOf: memory cPtrAsOop)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!BochsPlugin methodsFor: 'alien support' stamp: 'eem (const to msg rewrite) 11/5/2014 18:19'!
sizeField: rcvr
	"Answer the first field of rcvr which is assumed to be an Alien of at least 8 bytes"
	<inline: true>
	^self longAt: rcvr + interpreterProxy baseHeaderSize! !

!BochsPlugin methodsFor: 'alien support' stamp: 'eem (const to msg rewrite) 11/5/2014 18:19'!
startOfData: rcvr "<Alien oop> ^<Integer>"
	"Answer the start of rcvr's data.  For direct aliens this is the address of
	 the second field.  For indirect and pointer aliens it is what the second field points to."
	<inline: true>
	^(self sizeField: rcvr) > 0
	 	ifTrue: [rcvr + interpreterProxy baseHeaderSize + interpreterProxy bytesPerOop]
		ifFalse: [self longAt: rcvr + interpreterProxy baseHeaderSize + interpreterProxy bytesPerOop]! !

BochsPlugin subclass: #BochsX64Plugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-ProcessorPlugins'!

SmartSyntaxInterpreterPlugin subclass: #GdbARMPlugin
	instanceVariableNames: 'prevInterruptCheckChain'
	classVariableNames: ''
	poolDictionaries: 'VMBasicConstants'
	category: 'Cog-ProcessorPlugins'!

!GdbARMPlugin commentStamp: '<historical>' prior: 0!
I provide access to the ARMulator ARM emulator and the libopcodes ARM disassembler.!

!GdbARMPlugin class methodsFor: 'translation' stamp: 'eem 1/15/2009 15:23'!
declareCVarsIn: aCCodeGenerator
	"prevInterruptCheckChain lives in sqGdbARMPlugin.c"
	super declareCVarsIn: aCCodeGenerator.
	aCCodeGenerator removeVariable: 'prevInterruptCheckChain'! !

!GdbARMPlugin class methodsFor: 'translation' stamp: 'eem 12/3/2008 10:25'!
hasHeaderFile
	"We need a header to declare newcpu and pull in bochs.h & cpu.h"
	^true! !

!GdbARMPlugin methodsFor: 'interruption' stamp: 'eem 9/15/2015 11:22'!
forceStopOnInterrupt
	<returnTypeC: #void>
	interpreterProxy getInterruptPending ifTrue:
		[self forceStopRunning]! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 9/15/2015 11:53'!
"cpuAlien <GdbARMAlien>" primitiveDisassembleAt: address "<Integer>" InMemory: memory "<Bitmap|ByteArray|WordArray>"
	"Return an Array of the instruction length and its decompilation as a string for the instruction at address in memory."
	| cpuAlien cpu instrLenOrErr resultObj log logLen logObj logObjData |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveDisassembleAtInMemory
					parameters: #(Unsigned WordsOrBytes)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	instrLenOrErr := self disassembleFor: cpu
						At: address
						In: memory
						Size: (interpreterProxy byteSizeOf: memory cPtrAsOop).
	instrLenOrErr < 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	log := self getlog: (self cCode: [self addressOf: logLen] inSmalltalk: [logLen := 0]).
	resultObj := interpreterProxy instantiateClass: interpreterProxy classArray indexableSize: 2.
	resultObj = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrNoMemory].

	"Easier keeping the damn thing on the stack than using pushRemappableOop:/popRemappableOop.
	 Where is topRemappableOop when you need it?"
	interpreterProxy pushRemappableOop: resultObj.
	logObj := interpreterProxy
				instantiateClass: interpreterProxy classString
				indexableSize: logLen.
	interpreterProxy failed ifTrue:
		[interpreterProxy popRemappableOop.
		 ^interpreterProxy primitiveFailFor: PrimErrNoMemory].
	logObjData := interpreterProxy arrayValueOf: logObj.
	self mem: logObjData cp: log y: logLen.
	resultObj := interpreterProxy popRemappableOop.
	interpreterProxy
		storePointer: 0
		ofObject: resultObj
		withValue: (interpreterProxy integerObjectOf: instrLenOrErr).
	interpreterProxy storePointer: 1 ofObject: resultObj withValue: logObj.

	^resultObj! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 9/15/2015 11:53'!
primitiveErrorAndLog
	| log logLen resultObj logObj logObjData |
	<var: #log type: #'char *'>
	<var: #logObjData type: #'char *'>
	self primitive: #primitiveErrorAndLog parameters: #().

	log := self getlog: (self cCode: [self addressOf: logLen] inSmalltalk: [logLen := 0]).
	resultObj := interpreterProxy instantiateClass: interpreterProxy classArray indexableSize: 2.
	resultObj = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrNoMemory].

	interpreterProxy
		storePointer: 0
		ofObject: resultObj
		withValue: (interpreterProxy integerObjectOf: self errorAcorn).

	logLen > 0 ifTrue:
		[interpreterProxy pushRemappableOop: resultObj.
		logObj := interpreterProxy
					instantiateClass: interpreterProxy classString
					indexableSize: logLen.
		interpreterProxy failed ifTrue:
			[interpreterProxy popRemappableOop.
			 ^interpreterProxy primitiveFailFor: PrimErrNoMemory].

		resultObj := interpreterProxy popRemappableOop.
		logObjData := interpreterProxy arrayValueOf: logObj.
		self mem: logObjData cp: log y: logLen.
		interpreterProxy storePointer: 1 ofObject: resultObj withValue: logObj].
	interpreterProxy pop: 1 thenPush: resultObj! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 1/15/2009 09:57'!
"cpuAlien <GdbARMAlien>" primitiveFlushICacheFrom: startAddress "<Integer>" To: endAddress "<Integer>"
	"Flush the icache in the requested range"
	| cpuAlien cpu |
	<var: #cpu type: 'void *'>
	cpuAlien := self primitive: #primitiveFlushICacheFromTo
					parameters: #(Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	self flushICache: cpu From: startAddress To: endAddress! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 11/17/2016 15:45'!
primitiveNewCPU
	| cpu |
	<var: #cpu type: 'void *'>
	self primitive: #primitiveNewCPU parameters: #().

	cpu := self cCode: 'newCPU()' inSmalltalk: [0].
	cpu = 0 ifTrue:
		[^interpreterProxy primitiveFail].
	interpreterProxy
		pop: 1
		thenPush: (interpreterProxy positiveMachineIntegerFor:
										(self cCoerceSimple: cpu
											to: 'usqIntptr_t'))! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 1/14/2009 15:28'!
primitiveResetCPU
	| cpuAlien cpu maybeErr |
	<var: #cpu type: 'void *'>
	cpuAlien := self primitive: #primitiveResetCPU parameters: #() receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	maybeErr := self resetCPU: cpu.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:40'!
"cpuAlien <GdbARMAlien>" primitiveRunInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>" maximumAddress: maxAddress "<Integer>" readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Run the cpu using the first argument as the memory and the following arguments defining valid addresses, running until it halts or hits an exception."
	| cpuAlien cpu memorySize maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveRunInMemoryMinAddressMaxAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	prevInterruptCheckChain := interpreterProxy setInterruptCheckChain: #forceStopOnInterrupt asSymbol.
	prevInterruptCheckChain = #forceStopOnInterrupt asSymbol ifTrue:
		[prevInterruptCheckChain = 0].
	memorySize := interpreterProxy byteSizeOf: memory cPtrAsOop.
	maybeErr := self runCPU: cpu
					In: memory
					Size: (memorySize min: maxAddress)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	interpreterProxy setInterruptCheckChain: prevInterruptCheckChain.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'tpr 5/8/2014 08:23'!
"cpuAlien <GdbARMAlien>" primitiveRunInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>" readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Run the cpu using the first argument as the memory and the following arguments defining valid addresses, running until it halts or hits an exception.
	Note that minWriteMaxExecAddress is both the minimum writeable address AND the maximum executable address"
	| cpuAlien cpu maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveRunInMemoryMinimumAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	prevInterruptCheckChain := interpreterProxy setInterruptCheckChain: #forceStopOnInterrupt asSymbol.
	prevInterruptCheckChain = #forceStopOnInterrupt asSymbol ifTrue:
		[prevInterruptCheckChain = 0].
	maybeErr := self runCPU: cpu
					In: memory
					Size: (interpreterProxy byteSizeOf: memory cPtrAsOop)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	interpreterProxy setInterruptCheckChain: prevInterruptCheckChain.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:37'!
"cpuAlien <GdbARMAlien>" primitiveSingleStepInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>" maximumAddress: maxAddress "<Integer>" readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Single-step the cpu using the first argument as the memory and the following arguments defining valid addresses, running until it halts or hits an exception."
	| cpuAlien cpu memorySize maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveSingleStepInMemoryMinAddressMaxAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	prevInterruptCheckChain := interpreterProxy setInterruptCheckChain: #forceStopOnInterrupt asSymbol.
	prevInterruptCheckChain = #forceStopOnInterrupt asSymbol ifTrue:
		[prevInterruptCheckChain = 0].
	memorySize := interpreterProxy byteSizeOf: memory cPtrAsOop.
	maybeErr := self singleStepCPU: cpu
					In: memory
					Size: (memorySize min: maxAddress)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	interpreterProxy setInterruptCheckChain: prevInterruptCheckChain.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 10/20/2010 16:08'!
"cpuAlien <GdbARMAlien>" primitiveSingleStepInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>"  readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Single-step the cpu using the first argument as the memory and the following arguments defining valid addresses."
	| cpuAlien cpu maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveSingleStepInMemoryMinimumAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	maybeErr := self singleStepCPU: cpu
					In: memory
					Size: (interpreterProxy byteSizeOf: memory cPtrAsOop)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!GdbARMPlugin methodsFor: 'alien support' stamp: 'eem (const to msg rewrite) 11/5/2014 18:19'!
sizeField: rcvr
	"Answer the first field of rcvr which is assumed to be an Alien of at least 8 bytes"
	<inline: true>
	^self longAt: rcvr + interpreterProxy baseHeaderSize! !

!GdbARMPlugin methodsFor: 'alien support' stamp: 'eem (const to msg rewrite) 11/5/2014 18:19'!
startOfData: rcvr "<Alien oop> ^<Integer>"
	"Answer the start of rcvr's data.  For direct aliens this is the address of
	 the second field.  For indirect and pointer aliens it is what the second field points to."
	<inline: true>
	^(self sizeField: rcvr) > 0
	 	ifTrue: [rcvr + interpreterProxy baseHeaderSize + interpreterProxy bytesPerOop]
		ifFalse: [self longAt: rcvr + interpreterProxy baseHeaderSize + interpreterProxy bytesPerOop]! !

!MethodContext methodsFor: '*Cog-method prototypes' stamp: 'eem 8/11/2014 13:18'!
MethodContextPROTOTYPEfailPrimitiveWith: maybePrimFailToken
	"The receiver is a freshly-created context on a primitive method.  Skip the callPrimitive:
	 bytecode and store the primitive fail code if there is one and the method consumes it."
	self skipCallPrimitive.
	((self isPrimFailToken: maybePrimFailToken)
	  and: [method encoderClass isStoreAt: pc in: method]) ifTrue:
		[self at: stackp put: maybePrimFailToken last]! !

!MethodContext methodsFor: '*Cog-Tests-xrays' stamp: 'eem 6/16/2009 18:52'!
xray
	"Lift the veil from a context and answer an integer describing its interior state.
	 Used for e.g. VM tests so they can verify they're testing what they think they're testing.
	 0 implies a vanilla heap context.
	 Bit 0 = is or was married to a frame
	 Bit 1 = is still married to a frame
	 Bit 2 = frame is executing machine code
	 Bit 3 = has machine code pc (as opposed to nil or a bytecode pc)
	 Bit 4 = method is currently compiled to machine code"
	<primitive: 213>
	^0 "Can only fail if unimplemented; therefore simply answer 0"! !

!MethodContext methodsFor: '*Cog-Tests-xrays' stamp: 'eem 6/16/2009 18:44'!
xrayIsDivorced
	^(self xray bitAnd: 3) = 1! !

!MethodContext methodsFor: '*Cog-Tests-xrays' stamp: 'eem 6/16/2009 18:52'!
xrayIsExecutingMachineCode
	^self xray anyMask: 4! !

!MethodContext methodsFor: '*Cog-Tests-xrays' stamp: 'eem 6/16/2009 18:43'!
xrayIsMarried
	^self xray anyMask: 2! !

!MethodContext methodsFor: '*Cog-Tests-xrays' stamp: 'eem 6/16/2009 18:52'!
xrayLastExecutedMachineCode
	^self xray anyMask: 8! !

!MethodContext methodsFor: '*Cog-Tests-xrays' stamp: 'eem 6/16/2009 18:53'!
xrayMethodIsCompiledToMachineCode
	^self xray anyMask: 16! !

AbstractLauncher subclass: #CommandLineLauncher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Scripting'!

!CommandLineLauncher class methodsFor: 'activation' stamp: 'eem 10/23/2008 13:41'!
activate
	"Register this launcher with the auto start class"

	self autoStarter addLauncherFirst: self! !

!CommandLineLauncher class methodsFor: 'accessing' stamp: 'eem 10/23/2008 13:56'!
extractParameters

	| pName value index globals |
	globals := Dictionary new.
	index := 2.
	[pName := Smalltalk getSystemAttribute: index.
	pName isEmptyOrNil] whileFalse:[
		index := index + 1.
		value := Smalltalk getSystemAttribute: index.
		value ifNil: [value := ''].
 		globals at: pName asLowercase put: value.
		index := index + 1].
	^globals! !

!CommandLineLauncher class methodsFor: 'class initialization' stamp: 'eem 10/23/2008 13:45'!
initialize
	self activate! !

!CommandLineLauncher methodsFor: 'running' stamp: 'eem 10/23/2008 14:05'!
parameters: startupParameters
	"AnstractLauncher class>>extractParameters extracts from the wrong index for Mac OS"
	super parameters: self class extractParameters! !

!CommandLineLauncher methodsFor: 'running' stamp: 'eem 10/23/2008 14:09'!
startUp
	"UnixProcess stdOut print: parameters; nl."
	(parameters includesKey: '-doit') ifTrue:
		[Compiler evaluate: (parameters at: '-doit').
		 Smalltalk quitPrimitive]! !

Object subclass: #CrashReportsMailer
	instanceVariableNames: 'mailDirectory destination startDate endDate rs causes soloTime meetingTime'
	classVariableNames: ''
	poolDictionaries: 'ChronologyConstants'
	category: 'Cog-Scripts'!

!CrashReportsMailer commentStamp: '<historical>' prior: 0!
This class generates an almost complete crash report that still needs editing for categories and then posts it after editing.!

!CrashReportsMailer class methodsFor: 'instance creation' stamp: 'eem 6/25/2010 14:16'!
mailDirectory: aFileDirectoryOrString destination: anEmailAddress week: startDate
	^self new
		mailDirectory: aFileDirectoryOrString
		destination: anEmailAddress
		startDate: (TimeStamp fromSeconds: startDate asDate asSeconds)
		endDate:  (TimeStamp fromSeconds: (startDate asDate addDays: 7) asSeconds)

	"(self mailDirectory: '/Users/eliot/Library/Mail/IMAP-emiranda@ussc9-mail01.qwaq.com/INBOX.imapmbox/Messages'
		destination: 'eng@teleplace.com'
		week: '05/15/2010') generateReport"! !

!CrashReportsMailer class methodsFor: 'instance creation' stamp: 'eem 6/28/2010 14:05'!
mailDirectory: aFileDirectoryOrString destination: anEmailAddress week: startDateString soloTime: soloDurationOrString meetingTime: meetingDurationOrString
	| startDate |
	startDate := ((startDateString includes: $-)
					ifTrue: [(#(2 3 1) collect: [:i| (startDateString subStrings: '-') at: i]) fold: [:a :b| a,'/',b]]
					ifFalse: [startDateString]) asDate.
	^self new
		mailDirectory: aFileDirectoryOrString
		destination: anEmailAddress
		startDate: (TimeStamp fromSeconds: startDate asSeconds)
		endDate:  (TimeStamp fromSeconds: (startDate addDays: 7) asSeconds - 1)
		soloTime: soloDurationOrString asDuration
		meetingTime: meetingDurationOrString asDuration

	"(self mailDirectory: '/Users/eliot/Library/Mail/IMAP-emiranda@ussc9-mail01.qwaq.com/INBOX.imapmbox/Messages'
		destination: 'eng@teleplace.com'
		week: '05/15/2010'
		soloTime: '20:19:38:55'
		meetingTime: '7:23:44:45') generateReport"! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/25/2010 20:41'!
addReportFor: lines
	rs	resetContents;
		tab;
		nextPutAll: ((lines detect: [:l| l beginsWith: 'Subject:']) ifNotNil:
							[:l| l allButFirst: (l indexOfSubCollection: ' Teleplace Bug')]);
		crtab: 2;
		nextPutAll: (lines detect: [:l| l beginsWith: 'Date:']);
		cr.
	((lines anySatisfy: [:l| (l beginsWith: 'OS Version') and: [l includesSubString: 'Mac OS X']])
		ifTrue: [self reportForMacOS: lines]
		ifFalse: [(lines anySatisfy: [:l| l beginsWith: 'Module:'])
					ifTrue: [self reportForOldWin32: lines]
					ifFalse: [self reportForNewWin32: lines]]) ifNotNil:
			[:cause|
			(causes at: cause ifAbsentPut: [OrderedCollection new])
				addLast: rs contents]! !

!CrashReportsMailer methodsFor: 'parsing' stamp: 'eem 6/28/2010 12:07'!
breakIntoLines: aString
	^self pruneBogusEmptyLines:
		(Array streamContents:
			[:os| | is ss char |
			is := aString readStream.
			ss := ReadWriteStream on: String new.
			[is atEnd] whileFalse:
				[(char := is next) = Character lf
					ifTrue:
						[os nextPut: ss contents.
						 ss resetContents]
					ifFalse: [ss nextPut: char]].
			ss position > 0 ifTrue:
				[os nextPut: ss contents]])! !

!CrashReportsMailer methodsFor: 'parsing' stamp: 'eem 8/9/2010 13:42'!
candidateMessagesDo: aBlock
	"Evaluate aBlock with the file names of every file newer than the start date minus some slop"
	| start |
	start := (startDate minusDays: 7) asSeconds.
	mailDirectory entries do:
		[:dirEntry|
		((dirEntry name endsWith: '.emlx')
		 and: [dirEntry creationTime > start]) ifTrue:
			[aBlock value: dirEntry name]]! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/25/2010 14:15'!
collectReportSummaries
	self candidateMessagesDo:
		[:fn|
		self ifCrashReport: fn do:
			[:lines|
			self addReportFor: lines]]! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 8/9/2010 11:36'!
generateFinalReport
	| count numMac ws |
	count := causes inject: 0 into: [:sum :collection| sum + collection size].
	rs reset.
	rs print: count; nextPutAll: ' VM Crashes. ? OpenGL. ? Audio plugin. ? Video plugin. ? Python plugin.  ? core VM. ? unknown.'; cr.
	numMac := (causes keys select: [:k| k beginsWith: 'Mac:']) size.
	rs nextPutAll: 'win: '; print: count- numMac; cr.
	rs nextPutAll: 'mac: '; print: numMac; cr; cr.
	self reportCrashRates: count.
	causes keys asSortedCollection do:
		[:k|
		(causes at: k) do:
			[:report| rs nextPutAll: report].
		rs nextPutAll: k; cr; cr].
	(ws := Workspace new contents: rs contents)
		acceptAction: [:s| (UIManager default confirm: 'Sure you want to send?') ifTrue:
							[self mailReport: s.
							 ws acceptAction:
								[(UIManager default confirm: 'You''ve already sent this. Sure you want to send again?') ifTrue:
										[self mailReport: s]]]];
		openLabel: 'Customer VM Crashes ', startDate date printString, ' to ', endDate date printString;
		shouldStyle: false! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/25/2010 14:15'!
generateReport
	causes := Dictionary new.
	self collectReportSummaries.
	self generateFinalReport! !

!CrashReportsMailer methodsFor: 'parsing' stamp: 'eem 8/9/2010 11:33'!
ifCrashReport: fileName do: aBlock
	"Answer the evaluation of aBlock with the lines for fileName if it is a crash report, or nil if not."
	| file lines subject |
	file := mailDirectory oldFileNamed: fileName.
	lines := [file contentsOfEntireFile]
				on: Error
				do: [:ex|
					file close.
					Transcript nextPutAll: fileName; nextPutAll: ': '; nextPutAll: ex messageText; flush.
					^nil].
	lines := self breakIntoLines: lines.
	subject := lines detect: [:l| l beginsWith: 'Subject:'] ifNone: [^nil].
	(subject includesSubString: 'Teleplace Bug Report: ') ifFalse: [^nil].
	#('@qwaq.com' '@teleplace.com' '@chonkaa.com' 'craig@netjam.org' 'skysound@mac.com') do:
		[:localEmail| (subject includesSubstring: localEmail caseSensitive: false) ifTrue: [^nil]].
	(lines anySatisfy:
		[:l|
		((l beginsWith: 'OS Version') and: [l includesSubString: 'Mac OS X'])
		or: [l beginsWith: 'Operating System:']]) ifFalse: [^nil].
	^aBlock value: lines! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/25/2010 20:03'!
macOSDateFor: dateString 
	| tokens |
	tokens := dateString subStrings: ' -.+'.
	^TimeStamp
		date: (Date year: tokens first asInteger month: tokens second asInteger day: tokens third asInteger)
		time: tokens fourth asTime! !

!CrashReportsMailer methodsFor: 'initialize-release' stamp: 'eem 6/25/2010 20:38'!
mailDirectory: aFileDirectoryOrString destination: anEmailAddress startDate: startTimestamp endDate: endTimestamp
	mailDirectory := aFileDirectoryOrString isString
						ifTrue: [FileDirectory on: aFileDirectoryOrString]
						ifFalse: [aFileDirectoryOrString].
	destination := anEmailAddress.
	startDate := startTimestamp.
	endDate := endTimestamp.
	rs := ReadWriteStream on: (String new: 256)! !

!CrashReportsMailer methodsFor: 'initialize-release' stamp: 'eem 6/28/2010 09:46'!
mailDirectory: aFileDirectoryOrString destination: anEmailAddress startDate: startTimestamp endDate: endTimestamp soloTime: soloDuration meetingTime: meetingDuration
	mailDirectory := aFileDirectoryOrString isString
						ifTrue: [FileDirectory on: aFileDirectoryOrString]
						ifFalse: [aFileDirectoryOrString].
	destination := anEmailAddress.
	startDate := startTimestamp.
	endDate := endTimestamp.
	soloTime := soloDuration.
	meetingTime := meetingDuration.
	rs := ReadWriteStream on: (String new: 256)! !

!CrashReportsMailer methodsFor: 'mailing' stamp: 'eem 6/28/2010 12:46'!
mailReport: aText
	| msg |
	msg := MailMessage new
			setField: 'from' toString: 'eliot@teleplace.com';
			setField: 'to' toString: destination;
			setField: 'subject' toString:	'Customer VM Crashes ',
										(startDate date printFormat: #(3 2 1 $/ 1 2)),
										' - ',
										((endDate - 1 seconds) date printFormat: #(3 2 1 $/ 1 2));
			body: (MIMEDocument contentType: 'text/plain' content: aText asString).
	SMTPClient
		deliverMailFrom: msg from
		to: (Array with: msg to)
		text: msg text
		usingServer: MailComposition new smtpServer! !

!CrashReportsMailer methodsFor: 'parsing' stamp: 'eem 6/28/2010 11:31'!
pruneBogusEmptyLines: lines
	"Eliminate duplicate empty lines from broken CR-LF to LF-LF conversions."
	| firstEmpty lastEmpty |
	(firstEmpty := lines findFirst: [:l| l isEmpty]) = 0 ifTrue:
		[^lines].
	lastEmpty := firstEmpty.
	[(lines at: lastEmpty + 2) isEmpty] whileTrue:
		[lastEmpty := lastEmpty + 2].
	^(lines copyFrom: 1 to: firstEmpty - 1),
	   ((firstEmpty + 1 to: lastEmpty - 1 by: 2) collect: [:i| lines at: i]),
	   (lines copyFrom: lastEmpty + 1 to: lines size)! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/28/2010 14:15'!
reportCrashRates: count
	{ soloTime. meetingTime }
		with: #('solo hours: ' 'meeting hours: ')
		do: [:time :label|
			rs	nextPutAll: label; print: (time asSeconds / SecondsInHour) rounded;
				space; nextPut: $(; print: time; nextPut: $); cr].
	rs cr.
	{ soloTime. meetingTime }
		with: #('solo' 'meeting')
		do: [:time :label|
			{ SecondsInHour. SecondsInDay }
				with: #('hour' 'day')
				do: [:period :periodLabel| | rate |
					rate := count / (time asSeconds / period).
					rs	print: (rate roundTo: (rate >= 1 ifTrue: [0.1] ifFalse: [0.001]));
						nextPutAll: ' crashes per '; nextPutAll: label; space; nextPutAll: periodLabel; cr]].
	rs cr; cr! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/28/2010 12:18'!
reportForMacOS: lines
	| thread dateAndTime cStackTop cstIdx |

	thread := Integer readFrom: ((lines detect: [:l| l beginsWith: 'Crashed Thread: ']) allButFirst: 15) readStream skipSeparators.
	thread := 'Thread ', thread printString, ' Crashed'.
	lines withIndexDo:
		[:l :i|
		(l beginsWith: 'Date/Time:') ifTrue:
			[dateAndTime := l allButFirst: 11].
		((l beginsWith: thread)
		and: [i < lines size]) ifTrue:
			[cStackTop := lines at: (cstIdx := i + 1)]].
	[cstIdx <= lines size
	 and: [(lines at: cstIdx) notEmpty]] whileTrue:
		[(((lines at: cstIdx) includesSubString: ' _sigtramp ')
		 and: [((lines at: cstIdx + 1) includesSubString: ' ??? ')
		 and: [((lines at: cstIdx + 1) includesSubString: '0xffffffff 0 + 4294967295')]]) ifTrue:
			[cStackTop := lines at: cstIdx + 2.
			 cstIdx := lines size].
		 cstIdx := cstIdx + 1].
	dateAndTime := self macOSDateFor: dateAndTime.
	(dateAndTime between: startDate and: endDate) ifFalse:
		[^nil].
	^'Mac:', (cStackTop allButFirst: (cStackTop indexOf: Character space))! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 7/20/2010 15:22'!
reportForNewWin32: lines
	| dateAndTime reason stStackTop cStackTop |

	lines withIndexDo:
		[:l :i|
		(l beginsWith: 'Session Summary:') ifTrue:
			[^nil]. "Not a VM bug report, ignore it."
		(dateAndTime isNil
		and: [(l beginsWith: '--------------------')
		and: [i < lines size]]) ifTrue:
			[dateAndTime := lines at: i + 1].
		((l beginsWith: 'Smalltalk stack dump:')
		and: [i < lines size]) ifTrue:
			[stStackTop := lines at: i + 1].
		((l beginsWith: 'Stack backtrace:')
		and: [i < lines size]) ifTrue:
			[cStackTop := lines at: i + 1]].
	dateAndTime isNil ifTrue:
		[^nil].
	dateAndTime := self win32DateFor: dateAndTime.
	(dateAndTime between: startDate and: endDate) ifFalse:
		[^nil].
	reason := (lines detect: [:l| l beginsWith: 'Reason: '] ifNone: []) ifNotNil: [:rl| rl allButFirst: 8].
	"a stack entry looks like
		 0x9c2490 I NetNameResolver class>localHostAddress 271185968: a(n) NetNameResolver class
		t293325136 s BlockClosure>on:do:"
	stStackTop ifNotNil:
		[stStackTop := (stStackTop subStrings: ' ') allButFirst: 2.
		 stStackTop := stStackTop first: (stStackTop findFirst: [:t| t first isDigit]) - 1.
		 stStackTop := stStackTop fold: [:a :b| a, ' ', b]].
	^String streamContents:
		[:s|
		reason ifNotNil: [s nextPutAll: reason; cr].
	 	stStackTop ifNotNil: [s nextPutAll: stStackTop; cr].
		cStackTop ifNotNil: [s nextPutAll: cStackTop]]! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/28/2010 11:54'!
reportForOldWin32: lines
	| dateAndTime module idx stackTop |

	lines withIndexDo:
		[:l :i|
		(dateAndTime isNil
		and: [(l beginsWith: '--------------------')
		and: [i < lines size]]) ifTrue:
			[dateAndTime := lines at: i + 1].
		((l beginsWith: 'Stack dump:')
		and: [i < lines size]) ifTrue:
			 "Occasionally there is a bogus blank line between the label and the first entry"
			[(stackTop := (lines at: i + 1) isEmpty) ifTrue:
				[stackTop := lines at: i + 2]]].
	dateAndTime := self win32DateFor: dateAndTime.
	(dateAndTime between: startDate and: endDate) ifFalse:
		[^nil].
	module := (lines detect: [:l| l beginsWith: 'Module: ']) allButFirst: 8.
	(idx := module indexOfSubCollection: '\Teleplace') > 0 ifTrue:
		[module := module copyFrom: idx to: module size].
	(module first isLetter and: [module second = $:]) ifTrue:
		[module := module allButFirst: 2].
	"a stack entry looks like
		 0x9c2490 I NetNameResolver class>localHostAddress 271185968: a(n) NetNameResolver class
		293325136 s BlockClosure>on:do:
	 but if there is no stack there may be any old crap after Stack dump: so squash errors."
	[stackTop := (stackTop subStrings: ' ') allButFirst: 2.
	 stackTop := stackTop first: (stackTop findFirst: [:t| t first isDigit]) - 1.
	 stackTop := stackTop fold: [:a :b| a, ' ', b]]
		on: Error
		do: [:ex| stackTop := '?'].
	^stackTop, ' in ', module! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/25/2010 14:10'!
win32DateFor: dateAndTimeString 
	"transform 'Thu Jun 24 14:11:18 2010' to 'Jun 24 2010 14:11:18' to allow parsing"
	| tokens |
	tokens := dateAndTimeString subStrings: ' '.
	^({ tokens second. tokens third. tokens fifth. tokens fourth } fold: [:a :b| a, ' ', b]) asTimeStamp! !

!MCClassDefinition methodsFor: '*Cog-method prototypes squeak 4.3' stamp: 'eem 3/3/2014 17:12'!
MCClassDefinitionPROTOTYPEkindOfSubclass
	type = #normal ifTrue: [^' subclass: '].
	type = #variable ifTrue: [^' variableSubclass: '].
	type = #bytes ifTrue: [^' variableByteSubclass: '].
	type = #compiledMethod ifTrue: [^' variableByteSubclass: ' ].
	type = #words ifTrue: [^' variableWordSubclass: '].
	type = #weak ifTrue: [^' weakSubclass: ' ].
	type = #ephemeron ifTrue: [^' ephemeronSubclass: ' ].
	type = #immediate ifTrue: [^' immediateSubclass: ' ].
	self error: 'Unrecognized class type'! !

!ProtoObject methodsFor: '*Cog-Tests-xrays' stamp: 'eem 9/14/2015 14:43'!
hasIdentityHash
	<primitive: 161>
	self primitiveFailed! !

Alien variableByteSubclass: #CogProcessorAlien
	instanceVariableNames: ''
	classVariableNames: 'SavedState'
	poolDictionaries: ''
	category: 'Cog-Processors'!

!CogProcessorAlien commentStamp: 'lw 8/23/2012 19:15' prior: 0!
I am the superclass for the Simulation CPU instance wrappers. I ensure that methods used in both/all of them need not be copied.!

CogProcessorAlien variableByteSubclass: #BochsIA32Alien
	instanceVariableNames: ''
	classVariableNames: 'ExtendedOpcodeExceptionMap OpcodeExceptionMap PostBuildStackDelta'
	poolDictionaries: ''
	category: 'Cog-Processors'!

!BochsIA32Alien commentStamp: '<historical>' prior: 0!
I am a wrapper around the Bochs C++ IA32 CPU emulator.  Note that currently I provide no access to the x87/mmx FPU state, only providing access to the SSE/xmm registers.

Here is the configure script for the configuration this code assumes.  Offsets of fields will change with different configurations so they must agree.

----8<---- conf.COG ----8<----
#!!/bin/sh

# this sets up the compile for Cog.  Disable as much inessential stuff
# as possible leaving only the cpu/fpu & memory interface

set echo
# CFLAGS="-pipe -O3 -fomit-frame-pointer -finline-functions -falign-loops=16 -falign-jumps=16 -falign-functions=16 -falign-labels=16 -falign-loops-max-skip=15 -falign-jumps-max-skip=15 -fprefetch-loop-arrays $CFLAGS"
CFLAGS="-m32 $CFLAGS"
CFLAGS="-Dlongjmp=_longjmp -Dsetjmp=_setjmp $CFLAGS"
CFLAGS="-pipe -O3 -fomit-frame-pointer -finline-functions $CFLAGS"
CFLAGS="-g $CFLAGS"
CPATH="/sw/include"
CPPFLAGS=""
CXXFLAGS="$CFLAGS"
LDFLAGS="-L/sw/lib"

export CFLAGS
export CPATH
export CPPFLAGS
export CXXFLAGS
export LDFLAGS

./configure --enable-Cog \
	--enable-cpu-level=6 \
	--enable-sse=2 \
	--enable-assert-checks \
	--with-nogui \
		--disable-x86-64 \
		--disable-pae \
		--disable-large-pages \
		--disable-global-pages \
		--disable-mtrr \
		--disable-sb16 \
		--disable-ne2000 \
		--disable-pci \
		--disable-acpi \
		--disable-apic \
		--disable-clgd54xx \
		--disable-usb \
		--disable-plugins \
	${CONFIGURE_ARGS}

# apic == Advanced programmable Interrupt Controller
# acpi == Advanced Configuration and Power Interface
# pci == Peripheral Component Interconnect local bus
# clgd54xx == Cirrus Logic GD54xx video card
----8<---- conf.COG ----8<----!

!BochsIA32Alien class methodsFor: 'instance creation' stamp: 'eem 11/13/2011 11:13'!
dataSize
	^18096! !

!BochsIA32Alien class methodsFor: 'class initialization' stamp: 'eem 11/3/2015 08:53:44'!
initialize
	"BochsIA32Alien initialize"
	| it |
	it := self basicNew.
	PostBuildStackDelta := 0.
	OpcodeExceptionMap := Array new: 256 withAll: #handleExecutionPrimitiveFailureAt:in:.
	OpcodeExceptionMap
		at: 1 + it callOpcode			put: #handleCallFailureAt:in:;
		at: 1 + it jmpOpcode			put: #handleJmpFailureAt:in:;
		at: 1 + it retOpcode			put: #handleRetFailureAt:in:;
		at: 1 + it movALObOpcode	put: #handleMovALObFailureAt:in:;
		at: 1 + it movAXOvOpcode	put: #handleMovAXOvFailureAt:in:;
		at: 1 + it movObALOpcode	put: #handleMovObALFailureAt:in:;
		at: 1 + it movOvAXOpcode	put: #handleMovOvAXFailureAt:in:;
		at: 1 + it movGvEvOpcode	put: #handleMovGvEvFailureAt:in:;
		at: 1 + it movEvGvOpcode	put: #handleMovEvGvFailureAt:in:;
		at: 1 + it movGbEbOpcode	put: #handleMovGbEbFailureAt:in:;
		at: 1 + it movEbGbOpcode	put: #handleMovEbGbFailureAt:in:.
	ExtendedOpcodeExceptionMap := Array new: 256 withAll: #handleExecutionPrimitiveFailureAt:in:.
	ExtendedOpcodeExceptionMap
		at: 1 + it movGvEbOpcode put: #handleMovGvEbFailureAt:in:! !

!BochsIA32Alien class methodsFor: 'primitives' stamp: 'eem 12/11/2008 13:33'!
primitiveNewCPU
	"Answer the address of a new Bochs C++ class bx_cpu_c/BX_CPU_C x86 CPU emulator instance."
	<primitive: 'primitiveNewCPU' module: 'BochsIA32Plugin'>
	^self primitiveFailed! !

!BochsIA32Alien methodsFor: 'Cog API' stamp: 'eem 12/20/2008 10:55'!
abstractInstructionCompilerClass
	^CogIA32Compiler! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
al
	^self unsignedByteAt: 469! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
al: anUnsignedInteger
	^self unsignedByteAt: 469 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'Cog API' stamp: 'eem 1/21/2009 15:49'!
bitsInWord
	^32! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
bl
	^self unsignedByteAt: 481! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
bl: anUnsignedInteger
	^self unsignedByteAt: 481 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
bpl
	^self unsignedByteAt: 489! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
bpl: anUnsignedInteger
	^self unsignedByteAt: 489 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 1/17/2009 15:52'!
cResultRegister
	^self eax! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 1/17/2009 15:52'!
cResultRegister: aValue
	^self eax: aValue! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 12/30/2008 09:14'!
callOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA8"
	^16rE8! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
cl
	^self unsignedByteAt: 473! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
cl: anUnsignedInteger
	^self unsignedByteAt: 473 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr0
	^self unsignedLongLongAt: 1009! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr0: anUnsignedInteger
	^self unsignedLongLongAt: 1009 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr1
	^self unsignedLongLongAt: 1013! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr1: anUnsignedInteger
	^self unsignedLongLongAt: 1013 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr2
	^self unsignedLongLongAt: 1017! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr2: anUnsignedInteger
	^self unsignedLongLongAt: 1017 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr3
	^self unsignedLongLongAt: 1021! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr3: anUnsignedInteger
	^self unsignedLongLongAt: 1021 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr4
	^self unsignedLongLongAt: 1029! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr4: anUnsignedInteger
	^self unsignedLongLongAt: 1029 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'disassembly' stamp: 'eem 12/17/2015 08:38'!
decorateDisassembly: anInstructionString for: aSymbolManager "<Cogit>" fromAddress: address
	| string i1 i2 v |
	string := anInstructionString.
	aSymbolManager relativeBaseForDisassemblyInto:
		[:baseAddress :baseName|
		string := baseName, '+', (address - baseAddress printStringBase: 16 length: 4 padded: true), (string copyFrom: (string indexOf: $:) + 1 to: string size)].
	(i1 := string indexOfSubCollection: '%ds:0x') > 0 ifTrue:
		[i2 := i1 + 6.
		 ['0123456789abcdef' includes: (string at: i2)] whileTrue: [i2 := i2 + 1].
		 string := string
					copyReplaceFrom: i1 + 4
					to: i2 - 1
					with: (aSymbolManager lookupCHexString: (string copyFrom: i1 + 4 to: i2 - 1))].
	(i1 := string indexOfSubCollection: '%ss:0x') > 0 ifTrue:
		[i2 := i1 + 6.
		 ['0123456789abcdef' includes: (string at: i2)] whileTrue: [i2 := i2 + 1].
		 ((string at: i2) = $(
		 and: [(string at: i2 + 1) = $%]) ifTrue:
			[v := Integer readFrom: (ReadStream on: string from: i1 + 6 to: i2 - 1) base: 16.
			string := string
						copyReplaceFrom: i1
						to: i2 - 1
						with: ((v bitAnd: (1 bitShift: 31) - 1) - (v bitAnd: (1 bitShift: 31))) printString]].
	(i1 := string indexOfSubCollection: '$0x') > 0 ifTrue:
		[i2 := i1 + 3.
		 ['0123456789abcdef' includes: (string at: i2)] whileTrue: [i2 := i2 + 1].
		 string := string
					copyReplaceFrom: i1 + 1
					to: i2 - 1
					with: (aSymbolManager lookupCHexString: (string copyFrom: i1 + 1 to: i2 - 1))].
	((i1 := string indexOf: $() > 1
	 and: [(string at: i1 + 1) isDigit
	 and: [i1 < (i2 := string indexOf: $))]]) ifTrue:
		[string := string
					copyReplaceFrom: i1 + 1
					to: i2 - 1
					with: (aSymbolManager lookupCHexString: (string copyFrom: i1 + 1 to: i2 - 1))].
	^string! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
dil
	^self unsignedByteAt: 497! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
dil: anUnsignedInteger
	^self unsignedByteAt: 497 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
dl
	^self unsignedByteAt: 477! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
dl: anUnsignedInteger
	^self unsignedByteAt: 477 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
eax
	^self unsignedLongAt: 469! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
eax: anUnsignedInteger
	^self unsignedLongAt: 469 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
ebp
	^self unsignedLongAt: 489! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
ebp: anUnsignedInteger
	^self unsignedLongAt: 489 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 18:3'!
ebx
	^self unsignedLongAt: 481! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 18:3'!
ebx: anUnsignedInteger
	^self unsignedLongAt: 481 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 18:3'!
ecx
	^self unsignedLongAt: 473! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 18:3'!
ecx: anUnsignedInteger
	^self unsignedLongAt: 473 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
edi
	^self unsignedLongAt: 497! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
edi: anUnsignedInteger
	^self unsignedLongAt: 497 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 18:3'!
edx
	^self unsignedLongAt: 477! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 18:3'!
edx: anUnsignedInteger
	^self unsignedLongAt: 477 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
eflags
	^self unsignedLongAt: 513! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 9/18/2009 10:31'!
eflags: anUnsignedInteger
	^self unsignedLongAt: 513 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
eip
	^self unsignedLongAt: 501! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
eip: anUnsignedInteger
	^self unsignedLongAt: 501 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/28/2008 16:20'!
endianness
	^#little! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
esi
	^self unsignedLongAt: 493! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
esi: anUnsignedInteger
	^self unsignedLongAt: 493 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
esp
	^self unsignedLongAt: 485! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
esp: anUnsignedInteger
	^self unsignedLongAt: 485 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 1/15/2009 16:09'!
flushICacheFrom: startAddress "<Integer>" to: endAddress "<Integer>"
	self primitiveFlushICacheFrom: startAddress To: endAddress! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 1/9/2009 09:20'!
fp
	^self ebp! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/6/2010 18:17'!
fp: anAddress
	"Set whatever the processor considers its frame pointer to anAddress."
	self ebp: anAddress! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 2/13/2009 16:00'!
frameBuildDeltaBytes
	"Answer how many words are pushed when a frame is built.  This is for the Cogit's stack alignment checking code."
	^4 "4 bytes pushed for $ebp"! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:14'!
handleCallFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a call into a ProcessorSimulationTrap signal."
	|  relativeJump |
	relativeJump := memoryArray longAt: pc + 2 bigEndian: false.
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 5
			address: (pc + 5 + relativeJump) signedIntToLong
			type: #call)
		signal! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:15'!
handleExecutionPrimitiveFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Handle an execution primitive failure for an unhandled opcode."
	^self reportPrimitiveFailure! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 4/10/2015 18:44'!
handleExecutionPrimitiveFailureIn: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress
	"Handle an execution primitive failure.  Convert out-of-range call and absolute
	 memory read into register instructions into ProcessorSimulationTrap signals."
	"self printIntegerRegistersOn: Transcript"
	"self printRegistersOn: Transcript"
	| pc opcode |
	((pc := self eip) between: minimumAddress and: memoryArray byteSize - 1) ifTrue:
		[opcode := memoryArray byteAt: pc + 1.
		 opcode ~= 16r0f ifTrue:
			[^self
				perform: (OpcodeExceptionMap at: opcode + 1)
				with: pc
				with: memoryArray].
		 opcode := memoryArray byteAt: pc + 2.
		 ^self
				perform: (ExtendedOpcodeExceptionMap at: opcode + 1)
				with: pc
				with: memoryArray].
	^self reportPrimitiveFailure! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/22/2013 12:15'!
handleJmpFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a jmp into a ProcessorSimulationTrap signal."
	|  relativeJump |
	relativeJump := memoryArray longAt: pc + 2 bigEndian: false.
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 5
			address: (pc + 5 + relativeJump) signedIntToLong
			type: #jump)
		signal! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/3/2015 08:48:14'!
handleMovALObFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a read into al into a ProcessorSimulationTrap signal."
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 5
			address: (memoryArray unsignedLongAt: pc + 2 bigEndian: false)
			type: #read
			accessor: #al:)
		signal! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/3/2015 08:53:08'!
handleMovAXOvFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a read into eax into a ProcessorSimulationTrap signal."
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 5
			address: (memoryArray unsignedLongAt: pc + 2 bigEndian: false)
			type: #read
			accessor: #eax:)
		signal! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/3/2015 08:43:18'!
handleMovEbGbFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a byte register write into a ProcessorSimulationTrap signal."
	| modrmByte address |
	modrmByte := memoryArray byteAt: pc + 2.
	(modrmByte bitAnd: 7) ~= 4 ifTrue: "MoveRMbr with r = ESP requires an SIB byte"
		[address := (modrmByte bitAnd: 16rC0)
					caseOf: {
						[0 "ModRegInd"]
						->	[memoryArray unsignedLongAt: pc + 3 bigEndian: false].
						[16r80 "ModRegRegDisp32"]
						->	[(self perform: (#(eax ecx edx ebx esp ebp esi edi) at: (modrmByte bitAnd: 7) + 1))
								+ (memoryArray unsignedLongAt: pc + 3 bigEndian: false)
								bitAnd: 16rFFFFFFFF] }
					otherwise: [^self reportPrimitiveFailure].
		^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 6
				address: address
				type: #write
				accessor: (#(al cl dl bl ah ch dh bh) at: ((modrmByte >> 3 bitAnd: 7) + 1)))
			signal].
	^self reportPrimitiveFailure! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:21'!
handleMovEvGvFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a register write into a ProcessorSimulationTrap signal."
	| modrmByte |
	^((modrmByte := memoryArray byteAt: pc + 2) bitAnd: 16rC7) = 16r5 "ModRegInd & disp32"
		ifTrue:
			[(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + 6
					address: (memoryArray unsignedLongAt: pc + 3 bigEndian: false)
					type: #write
					accessor: (#(eax ecx edx ebx esp ebp esi edi) at: ((modrmByte >> 3 bitAnd: 7) + 1)))
				signal]
		ifFalse:
			[self reportPrimitiveFailure]! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/2/2015 23:37:05'!
handleMovGbEbFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a byte register load into a ProcessorSimulationTrap signal."
	| modrmByte address |
	modrmByte := memoryArray byteAt: pc + 2.
	address := (modrmByte bitAnd: 16rC0)
					caseOf: {
						[0 "ModRegInd"]
						->	[memoryArray unsignedLongAt: pc + 3 bigEndian: false].
						[16r80 "ModRegRegDisp32"]
						->	[(self perform: (#(eax ecx edx ebx esp ebp esi edi) at: (modrmByte bitAnd: 7) + 1))
								+ (memoryArray unsignedLongAt: pc + 3 bigEndian: false)
								bitAnd: 16rFFFFFFFF] }
					otherwise: [^self reportPrimitiveFailure].
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 6
			address: address
			type: #read
			accessor: (#(al: cl: dl: bl: ah: ch: dh: bh:) at: ((modrmByte >> 3 bitAnd: 7) + 1)))
		signal! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/3/2015 13:26:34'!
handleMovGvEbFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a register load into a ProcessorSimulationTrap signal."
	| modrmByte mode srcIsSP srcVal dst offset |
	modrmByte := memoryArray byteAt: pc + 3.
	mode := modrmByte >> 6 bitAnd: 3.
	dst := #(eax: ecx: edx: ebx: esp: ebp: esi: edi:) at: ((modrmByte >> 3 bitAnd: 7) + 1).
	mode = 0 ifTrue: "ModRegInd"
		[offset := memoryArray unsignedLongAt: pc + 4. "1-relative"
		 ^(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + 7
					address: offset
					type: #read
					accessor: dst)
				signal].
	srcIsSP := (modrmByte bitAnd: 7) = 4.
	srcVal := self perform: (#(eax ecx edx ebx esp ebp esi edi) at: (modrmByte bitAnd: 7) + 1).
	mode = 1 ifTrue: "ModRegRegDisp8"
		[offset := memoryArray byteAt: pc + (srcIsSP ifTrue: [5] ifFalse: [4]). "1-relative"
		 offset > 127 ifTrue: [offset := offset - 256].
		 ^(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + (srcIsSP ifTrue: [5] ifFalse: [4])
					address: (srcVal + offset bitAnd: 16rFFFFFFFF)
					type: #read
					accessor: dst)
				signal].
	mode = 2 ifTrue: "ModRegRegDisp32"
		[offset := memoryArray unsignedLongAt: pc + (srcIsSP ifTrue: [5] ifFalse: [4]). "1-relative"
		 ^(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + (srcIsSP ifTrue: [8] ifFalse: [7])
					address: (srcVal + offset bitAnd: 16rFFFFFFFF)
					type: #read
					accessor: dst)
				signal].
	^self reportPrimitiveFailure! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:21'!
handleMovGvEvFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a register load into a ProcessorSimulationTrap signal."
	| modrmByte |
	^(((modrmByte := memoryArray byteAt: pc + 2) bitAnd: 16rC7) = 16r5) "ModRegInd & disp32"
		ifTrue:
			[(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + 6
					address: (memoryArray unsignedLongAt: pc + 3 bigEndian: false)
					type: #read
					accessor: (#(eax: ecx: edx: ebx: esp: ebp: esi: edi:) at: ((modrmByte >> 3 bitAnd: 7) + 1)))
				signal]
		ifFalse:
			[self reportPrimitiveFailure]! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/3/2015 08:56:27'!
handleMovObALFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a byte write of al into a ProcessorSimulationTrap signal."
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 5
			address: (memoryArray unsignedLongAt: pc + 2 bigEndian: false)
			type: #write
			accessor: #al)
		signal! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/3/2015 08:55:48'!
handleMovOvAXFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a write of eax into a ProcessorSimulationTrap signal."
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 5
			address: (memoryArray unsignedLongAt: pc + 2 bigEndian: false)
			type: #write
			accessor: #eax)
		signal! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:21'!
handleRetFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a ret into a ProcessorSimulationTrap signal."
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 1
			address: (memoryArray unsignedLongAt: self esp + 1)
			type: #return
			accessor: #eip:)
		signal! !

!BochsIA32Alien methodsFor: 'processor setup' stamp: 'eem 10/22/2015 14:42:23'!
initializeStackFor: aCogit
"Different cpus need different stack alignment etc, so handle the details here."
	"This is for testing.  On many OS's the stack must remain aligned;
	 e.g. IA32 using SSE requires 16 byte alignment."
	| stackAlignment |
	stackAlignment := 16.
	aCogit setStackAlignment: stackAlignment expectedSPOffset: 0 expectedFPOffset: 8.
	PostBuildStackDelta := stackAlignment > 8
								ifTrue: [stackAlignment - 8]
								ifFalse: [0]! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/9/2009 21:27'!
integerRegisterState
	^{	self eax. self ebx. self ecx. self edx. self esp. self ebp. self esi. self edi.
		self eip. self eflags }! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 12/30/2008 09:15'!
jmpOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA8"
	^16rE9! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 10/20/2010 17:12'!
leafRetpcIn: aMemory
	^aMemory unsignedLongAt: self esp + 1 bigEndian: false! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 9/9/2009 21:24'!
lockPrefix
	^16rF0! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 11/3/2015 08:45:58'!
movALObOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA7"
	^16rA0! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 11/3/2015 08:52:38'!
movAXOvOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA7"
	^16rA1! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 5/7/2010 11:51'!
movEbGbOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2"
	^16r88! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 1/1/2009 22:26'!
movEvGvOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA8"
	^16r89! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 5/7/2010 11:50'!
movGbEbOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2"
	^16r8A! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 4/10/2015 18:46'!
movGvEbOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A3, pA14"
	^16rB6! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 12/30/2008 09:14'!
movGvEvOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA8"
	^16r8B! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 11/3/2015 08:51:22'!
movObALOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA7"
	^16rA2! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 11/3/2015 08:52:52'!
movOvAXOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA7"
	^16rA3! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 12/12/2008 15:52'!
nopOpcode
	^16r90! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 1/4/2009 13:08'!
pc
	"Return whatever the processor considers its program counter."
	^self eip! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 1/5/2009 14:20'!
pc: anAddress
	"Set whatever the processor considers its program counter to anAddress."
	self eip: anAddress! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 10/20/2010 17:14'!
popWordIn: aMemory 
	| sp word |
	word := aMemory unsignedLongAt: (sp := self esp) + 1 bigEndian: false.
	self esp: sp + 4.
	^word! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 3/30/2009 12:35'!
postCallArgumentsNumArgs: numArgs "<Integer>" in: memory "<ByteArray|Bitmap>"
	"Answer an argument vector of the requested size after a vanilla
	 ABI call.  On IA32 this typically means accessing stacked arguments
	 beyond the pushed return address and saved frame pointer.
	 For compatibility with Cog/Slang we answer unsigned values."
	^(9 to: numArgs * 4 + 5 by: 4) collect:
		[:i|
		memory unsignedLongAt: self ebp + i bigEndian: false]! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 1/14/2009 15:26'!
primitiveDisassembleAt: address inMemory: memoryArray "<Bitmap|ByteArray>"
	"Answer an Array of the size and the disassembled code string for the instruction at the current instruction pointer in memory."
	<primitive: 'primitiveDisassembleAtInMemory' module: 'BochsIA32Plugin'>
	^self primitiveFailed! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 12/12/2008 13:02'!
primitiveErrorAndLog
	"Answer an array of the current error code and log contents"
	<primitive: 'primitiveErrorAndLog' module: 'BochsIA32Plugin'>
	^self primitiveFailed! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 1/15/2009 09:58'!
primitiveFlushICacheFrom: startAddress "<Integer>" To: endAddress "<Integer>"
	"Flush the icache in the requested range"
	<primitive: 'primitiveFlushICacheFromTo' module: 'BochsIA32Plugin'>
	^self primitiveFailed! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 12/12/2008 13:29'!
primitiveResetCPU
	"Reset the receiver to registers all zero, and protected 32-bit mode."
	<primitive: 'primitiveResetCPU' module: 'BochsIA32Plugin'>
	^self reportPrimitiveFailure! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:19'!
primitiveRunInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" maximumAddress: maximimAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Run the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveRunInMemoryMinAddressMaxAddressReadWrite' module: 'BochsIA32Plugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]

	"self printRegistersOn: Transcript"! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:19'!
primitiveRunInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Run the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveRunInMemoryMinimumAddressReadWrite' module: 'BochsIA32Plugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]

	"self printRegistersOn: Transcript"! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:19'!
primitiveSingleStepInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" maximumAddress: maximimAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Single-step the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveSingleStepInMemoryMinAddressMaxAddressReadWrite' module: 'BochsIA32Plugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:20'!
primitiveSingleStepInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Single-step the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveSingleStepInMemoryMinimumAddressReadWrite' module: 'BochsIA32Plugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]! !

!BochsIA32Alien methodsFor: 'printing' stamp: 'eem 12/9/2013 09:26'!
printFields: fields inRegisterState: registerStateVector on: aStream
	| rsvs |
	aStream ensureCr.
	rsvs := registerStateVector readStream.
	fields withIndexDo:
		[:sym :index| | val |
		sym = #cr
			ifTrue: [aStream cr]
			ifFalse:
				[(val := rsvs next) isNil ifTrue: [^self].
				(sym beginsWith: 'xmm')
					ifTrue:
						[aStream nextPutAll: sym; nextPut: $:; space.
						 val printOn: aStream base: 16 length: 16 padded: true.
						 aStream space; nextPut: $(.
						 "At the image level Float is apparently in big-endian format"
						 ((Float basicNew: 2)
						 	at: 2 put: (val bitAnd: 16rFFFFFFFF);
							at: 1 put: (val bitShift: -32);
							yourself)
								printOn: aStream.
						 aStream nextPut: $)]
					ifFalse:
						[aStream nextPutAll: sym; nextPut: $:; space.
						 val printOn: aStream base: 16 length: 8 padded: true.
						 #eflags == sym
							ifTrue:
								[aStream space.
								 'C-P-A-ZS---O' withIndexDo:
									[:flag :bitIndex|
									flag ~= $- ifTrue:
										[aStream nextPut: flag; nextPutAll: 'F='; print: (val bitAnd: 1 << (bitIndex - 1)) >> (bitIndex - 1); space]]]
							ifFalse:
								[val > 16 ifTrue:
									[aStream space; nextPut: $(.
									 val printOn: aStream base: 10 length: 1 padded: false.
									 aStream nextPut: $)]]].
						(fields at: index + 1) ~~ #cr ifTrue:
							[aStream tab]]]! !

!BochsIA32Alien methodsFor: 'printing' stamp: 'eem 9/9/2009 21:27'!
printIntegerRegistersOn: aStream
	self printRegisterState: self integerRegisterState on: aStream.
	aStream flush! !

!BochsIA32Alien methodsFor: 'printing' stamp: 'eem 12/9/2015 16:59'!
printRegisterState: registerStateVector on: aStream
	"Print the registers, somewhat nicely formatted"
	| lastIndex |
	"First find out what floating point registers are used, and only print the ones up through the last non-zero one."
	lastIndex := (registerStateVector size to: 11 by: -1) detect: [:i| (registerStateVector at: i) ~= 0] ifNone: [0].
	 lastIndex := lastIndex > 0
					ifTrue: [lastIndex - 10 + 1 // 2 * 3 + 13]
					ifFalse: [13].
	self printFields:
			(#(	eax ebx ecx edx cr
				esp ebp esi edi cr
				eip eflags cr
				xmm0low xmm1low cr
				xmm2low xmm3low cr
				xmm4low xmm5low cr
				xmm6low xmm7low cr )
					copyFrom: 1 to: lastIndex)
		inRegisterState: registerStateVector
		on: aStream! !

!BochsIA32Alien methodsFor: 'printing' stamp: 'eem 12/9/2013 09:30'!
printRegisterStateExceptPC: registerStateVector on: aStream
	self printFields:
			((registerStateVector size < 18
			  or: [(11 to: 18) allSatisfy: [:i| (registerStateVector at: i) isZero]])
				ifTrue:
					[#(	eax ebx ecx edx cr
						esp ebp esi edi cr)]
				ifFalse:
					[#(	eax ebx ecx edx cr
						esp ebp esi edi cr
						xmm0low xmm1low cr
						xmm2low xmm3low cr
						xmm4low xmm5low cr
						xmm6low xmm7low cr )])
		inRegisterState: registerStateVector
		on: aStream! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 1/22/2009 15:43'!
pushWord: aValue in: aMemory
	| sp |
	sp := (self esp: self esp - 4).
	aMemory longAt: sp + 1 put: aValue bigEndian: false! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/6/2010 09:29'!
registerAt: index 
	^self perform: (#(eax ecx edx ebx esp ebp esi edi) at: index + 1)! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 4/17/2009 13:48'!
registerState
	^{	self eax. self ebx. self ecx. self edx. self esp. self ebp. self esi. self edi.
		self eip. self eflags.
		self xmm0low. self xmm1low. self xmm2low. self xmm3low.
		self xmm4low. self xmm5low. self xmm6low. self xmm7low }! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 10/21/2015 10:41:10'!
registerStateGetters
	^#(	eax ecx edx ebx esp ebp esi edi eip eflags
		xmm0low xmm1low xmm2low xmm3low
		xmm4low xmm5low xmm6low xmm7low )! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/5/2010 11:40'!
registerStatePCIndex
	^9! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 10/21/2015 10:41:56'!
registerStateSetters
	^#(	eax: ecx: edx: ebx: esp: ebp: esi: edi: eip: eflags:
		xmm0low: xmm1low: xmm2low: xmm3low:
		xmm4low: xmm5low: xmm6low: xmm7low: )! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 4/16/2009 17:56'!
reset
	self primitiveResetCPU.
	"Enable SSE extensions by setting the OSFXSR (Operating System FXSAVE/FXRSTOR Support) bit"
	self cr4: (self cr4 bitOr: 1 << 9)! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 4/16/2009 13:42'!
retOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA7"
	^16rC3! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 10/20/2010 17:14'!
retpcIn: aMemory
	^aMemory unsignedLongAt: self ebp + 5 bigEndian: false! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 9/30/2009 13:16'!
saveEip
	^self unsignedLongAt: 1533! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 9/30/2009 13:16'!
saveEsp
	^self unsignedLongAt: 1537! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 1/4/2009 10:57'!
setFramePointer: framePointer stackPointer: stackPointer
	"Initialize the processor's frame and stack pointers"
	self ebp: framePointer.
	self esp: stackPointer! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/22/2009 13:24'!
setRegisterState: aRegisterStateArray
	"N.B. keep in sync with voidRegisterState"
	self eax: (aRegisterStateArray at: 1).
	self ebx: (aRegisterStateArray at: 2).
	self ecx: (aRegisterStateArray at: 3).
	self edx: (aRegisterStateArray at: 4).
	self esp: (aRegisterStateArray at: 5).
	self ebp: (aRegisterStateArray at: 6).
	self esi: (aRegisterStateArray at: 7).
	self edi: (aRegisterStateArray at: 8).
	self eip: (aRegisterStateArray at: 9).
	self eflags: (aRegisterStateArray at: 10).
	self xmm0low: (aRegisterStateArray at: 11).
	self xmm1low: (aRegisterStateArray at: 12).
	self xmm2low: (aRegisterStateArray at: 13).
	self xmm3low: (aRegisterStateArray at: 14).
	self xmm4low: (aRegisterStateArray at: 15).
	self xmm5low: (aRegisterStateArray at: 16).
	self xmm6low: (aRegisterStateArray at: 17).
	self xmm7low: (aRegisterStateArray at: 18)! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
sil
	^self unsignedByteAt: 493! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
sil: anUnsignedInteger
	^self unsignedByteAt: 493 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 5/6/2009 13:09'!
simulateCallOf: address nextpc: nextpc memory: aMemory
	"Simulate a frame-building call of address.  Build a frame since
	a) this is used for calls into the run-time which are unlikely to be leaf-calls, and
	b) stack alignment needs to be realistic for assert checking for platforms such as Mac OS X"
	self pushWord: nextpc in: aMemory.
	self pushWord: self ebp in: aMemory.
	self ebp: self esp.
	PostBuildStackDelta ~= 0 ifTrue:
		[self esp: self esp - PostBuildStackDelta].
	self eip: address! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 5/6/2009 13:10'!
simulateJumpCallOf: address memory: aMemory
	"Simulate a frame-building jump call of address (i.e. do not push the return pc
	 as this has already been done).  Build a frame since
	a) this is used for calls into the run-time which are unlikely to be leaf-calls, and
	b) stack alignment needs to be realistic for assert checking for platforms such as Mac OS X"
	self pushWord: self ebp in: aMemory.
	self ebp: self esp.
	PostBuildStackDelta ~= 0 ifTrue:
		[self esp: self esp - PostBuildStackDelta].
	self eip: address! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 3/30/2009 11:55'!
simulateLeafCallOf: address nextpc: nextpc memory: aMemory
	self pushWord: nextpc in: aMemory.
	self eip: address! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 3/30/2009 12:38'!
simulateLeafReturnIn: aMemory
	self eip: (self popWordIn: aMemory)! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 3/30/2009 11:27'!
simulateReturnIn: aMemory
	PostBuildStackDelta ~= 0 ifTrue:
		[self esp: self esp + PostBuildStackDelta].
	self ebp: (self popWordIn: aMemory).
	self eip: (self popWordIn: aMemory)! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/13/2010 09:26'!
smashCallerSavedRegistersWithValuesFrom: base by: step
	#(eax: ecx: edx:)
	   withIndexDo:
		[:accessor :index|
		self perform: accessor with: index - 1 * step + base]! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'lw 8/8/2012 11:51'!
smashRegisterAccessors
	^#(eax: ebx: ecx: edx: esi: edi:)! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 1/9/2009 09:20'!
sp
	^self esp! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/6/2010 18:18'!
sp: anAddress
	"Set whatever the processor considers its stack pointer to anAddress."
	self esp: anAddress! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
spl
	^self unsignedByteAt: 485! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 14:57'!
spl: anUnsignedInteger
	^self unsignedByteAt: 485 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 9/30/2009 13:16'!
stopReason
	^self unsignedByteAt: 1577! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/22/2009 13:23'!
voidRegisterState
	"N.B. keep in sync with setRegisterState:"
	self setRegisterState: (Array new: 18 withAll: 0)! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/22/2009 16:31'!
withStackPointersInRegisterState: registerState do: aBinaryBlock
	^aBinaryBlock value: (registerState at: 5) value: (registerState at: 6)! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm0high
	^self unsignedLongLongAt: 1185! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm0high: anUnsignedInteger
	^self unsignedLongLongAt: 1185 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm0low
	^self unsignedLongLongAt: 1177! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm0low: anUnsignedInteger
	^self unsignedLongLongAt: 1177 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm1high
	^self unsignedLongLongAt: 1201! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm1high: anUnsignedInteger
	^self unsignedLongLongAt: 1201 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm1low
	^self unsignedLongLongAt: 1193! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm1low: anUnsignedInteger
	^self unsignedLongLongAt: 1193 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm2high
	^self unsignedLongLongAt: 1217! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm2high: anUnsignedInteger
	^self unsignedLongLongAt: 1217 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm2low
	^self unsignedLongLongAt: 1209! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm2low: anUnsignedInteger
	^self unsignedLongLongAt: 1209 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm3high
	^self unsignedLongLongAt: 1233! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm3high: anUnsignedInteger
	^self unsignedLongLongAt: 1233 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm3low
	^self unsignedLongLongAt: 1225! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm3low: anUnsignedInteger
	^self unsignedLongLongAt: 1225 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm4high
	^self unsignedLongLongAt: 1249! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm4high: anUnsignedInteger
	^self unsignedLongLongAt: 1249 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm4low
	^self unsignedLongLongAt: 1241! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm4low: anUnsignedInteger
	^self unsignedLongLongAt: 1241 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm5high
	^self unsignedLongLongAt: 1265! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm5high: anUnsignedInteger
	^self unsignedLongLongAt: 1265 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm5low
	^self unsignedLongLongAt: 1257! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm5low: anUnsignedInteger
	^self unsignedLongLongAt: 1257 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm6high
	^self unsignedLongLongAt: 1281! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm6high: anUnsignedInteger
	^self unsignedLongLongAt: 1281 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm6low
	^self unsignedLongLongAt: 1273! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm6low: anUnsignedInteger
	^self unsignedLongLongAt: 1273 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm7high
	^self unsignedLongLongAt: 1297! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm7high: anUnsignedInteger
	^self unsignedLongLongAt: 1297 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm7low
	^self unsignedLongLongAt: 1289! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm7low: anUnsignedInteger
	^self unsignedLongLongAt: 1289 put: anUnsignedInteger! !

CogProcessorAlien variableByteSubclass: #BochsX64Alien
	instanceVariableNames: ''
	classVariableNames: 'ExtendedOpcodeExceptionMap OpcodeExceptionMap PostBuildStackDelta'
	poolDictionaries: ''
	category: 'Cog-Processors'!

!BochsX64Alien class methodsFor: 'instance creation' stamp: 'eem 9/10/2015 10:16'!
dataSize
	^22672! !

!BochsX64Alien class methodsFor: 'class initialization' stamp: 'eem 1/14/2016 13:22'!
initialize
	"BochsX64Alien initialize"
	| it |
	it := self basicNew.
	OpcodeExceptionMap := Array new: 256 withAll: #handleExecutionPrimitiveFailureAt:in:rex:.
	OpcodeExceptionMap
		at: 1 + it twoByteEscape				put: #handleTwoByteEscapeFailureAt:in:rex:;
		at: 1 + it operandSizeOverridePrefix	put: #handleOperandSizeOverridePrefixFailureAt:in:rex:;
		at: 1 + it callOpcode		put: #handleCallFailureAt:in:rex:;
		at: 1 + it jmpOpcode		put: #handleJmpFailureAt:in:rex:;
		at: 1 + it retOpcode		put: #handleRetFailureAt:in:rex:;
		at: 1 + it movALObOpcode	put: #handleMovALObFailureAt:in:rex:;
		at: 1 + it movAXOvOpcode	put: #handleMovAXOvFailureAt:in:rex:;
		at: 1 + it movObALOpcode	put: #handleMovObALFailureAt:in:rex:;
		at: 1 + it movOvAXOpcode	put: #handleMovOvAXFailureAt:in:rex:;
		at: 1 + it movGvEvOpcode	put: #handleMovGvEvFailureAt:in:rex:;
		at: 1 + it movEvGvOpcode	put: #handleMovEvGvFailureAt:in:rex:;
		at: 1 + it movGbEbOpcode	put: #handleMovGbEbFailureAt:in:rex:;
		at: 1 + it movEbGbOpcode	put: #handleMovEbGbFailureAt:in:rex:;
		at: 1 + 16rFE				put: #handleGroup4FailureAt:in:rex:; "Table A6 One-Byte and Two-Byte Opcode ModRM Extensions"
		at: 1 + 16rFF				put: #handleGroup5FailureAt:in:rex:. "Table A6 One-Byte and Two-Byte Opcode ModRM Extensions"
	ExtendedOpcodeExceptionMap := Array new: 256 withAll: #handleExecutionPrimitiveFailureAt:in:rex:.
	ExtendedOpcodeExceptionMap
		at: 1 + it movGvEbOpcode put: #handleMovGvEbFailureAt:in:rex:! !

!BochsX64Alien class methodsFor: 'instance creation' stamp: 'eem 9/17/2015 15:44'!
primitiveNewCPU
	"Answer the address of a new Bochs C++ class bx_cpu_c/BX_CPU_C x64 (x86-64) CPU emulator instance."
	<primitive: 'primitiveNewCPU' module: 'BochsX64Plugin'>
	^self primitiveFailed! !

!BochsX64Alien methodsFor: 'Cog API' stamp: 'eem 9/14/2015 16:26'!
abstractInstructionCompilerClass
	^CogX64Compiler! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
al
	^self unsignedByteAt: 469! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
al: anUnsignedInteger
	^self unsignedByteAt: 469 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'Cog API' stamp: 'eem 9/14/2015 16:24'!
bitsInWord
	^64! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
bl
	^self unsignedByteAt: 493! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
bl: anUnsignedInteger
	^self unsignedByteAt: 493 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
bpl
	^self unsignedByteAt: 509! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
bpl: anUnsignedInteger
	^self unsignedByteAt: 509 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 10/23/2015 18:59:38'!
cResultRegister: aValue
	^self rax: aValue! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 9/22/2015 15:35'!
callOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA8"
	^16rE8! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
cl
	^self unsignedByteAt: 477! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
cl: anUnsignedInteger
	^self unsignedByteAt: 477 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'tests support' stamp: 'eem 9/21/2015 11:34'!
convertIntegerToInternal: anInteger
	"Conversion for 64-bit processors."
	^anInteger signedIntToLong64! !

!BochsX64Alien methodsFor: 'tests support' stamp: 'eem 9/21/2015 11:35'!
convertInternalToInteger: unsigned
	"Conversion for 64-bit processors."
	^unsigned signedIntFromLong64! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
cr0
	^self unsignedLongLongAt: 1225! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
cr0: anUnsignedInteger
	^self unsignedLongLongAt: 1225 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
cr1
	^self unsignedLongLongAt: 1229! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
cr1: anUnsignedInteger
	^self unsignedLongLongAt: 1229 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
cr2
	^self unsignedLongLongAt: 1233! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
cr2: anUnsignedInteger
	^self unsignedLongLongAt: 1233 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
cr3
	^self unsignedLongLongAt: 1241! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
cr3: anUnsignedInteger
	^self unsignedLongLongAt: 1241 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
cr4
	^self unsignedLongLongAt: 1253! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
cr4: anUnsignedInteger
	^self unsignedLongLongAt: 1253 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'disassembly' stamp: 'eem 12/11/2015 10:28'!
decorateDisassembly: anInstructionString for: aSymbolManager "<Cogit>" fromAddress: address
	| string i1 i2 v extra |
	string := anInstructionString.
	aSymbolManager relativeBaseForDisassemblyInto:
		[:baseAddress :baseName|
		string := baseName, '+', (address - baseAddress printStringBase: 16 length: 4 padded: true), (string copyFrom: (string indexOf: $:) + 1 to: string size)].
	((i1 := string indexOfSubCollection: '%ds:(') > 0
	or: [(i1 := string indexOfSubCollection: '%ss:(') > 0]) ifTrue:
		[string := string copyReplaceFrom: i1 to: i1 + 3 with: ''].
	(i1 := string indexOfSubCollection: '%ds:0x') > 0 ifTrue:
		[i2 := i1 + 6.
		 ['0123456789abcdef' includes: (string at: i2)] whileTrue: [i2 := i2 + 1].
		 (v := string copyFrom: i2 to: (i2 + 5 min: string size)) = '(%rbx)' ifTrue:
			[v := Integer readFrom: (ReadStream on: string from: i1 + 6 to: i2 - 1) base: 16.
		 	 (aSymbolManager lookupAddress: aSymbolManager varBaseAddress + v) ifNotNil:
				[:varName| extra := ' = ', varName]].
		 v = '(%rip)' ifTrue:
			[v := string size - (string indexOf: $: startingAt: i2 + 5) - 1 / 3. "Count number of instruction bytes to find size of instruction"
			 v := v + address. "Add address of instruction"
			 v := v + (Integer readFrom: (ReadStream on: string from: i1 + 6 to: i2 - 1) base: 16) signedIntFromLong64. "Add offset to yield pc-relative address"
		 	 (aSymbolManager lookupAddress: v) ifNotNil:
				[:methodName| extra := ' = ', methodName]].
		 string := string
					copyReplaceFrom: i1
					to: i2 - 1
					with: (aSymbolManager lookupCHexString: (string copyFrom: i1 + 4 to: i2 - 1))].
	(i1 := string indexOfSubCollection: '%ss:0x') > 0 ifTrue:
		[i2 := i1 + 6.
		 ['0123456789abcdef' includes: (string at: i2)] whileTrue: [i2 := i2 + 1].
		 ((string at: i2) = $(
		 and: [(string at: i2 + 1) = $%]) ifTrue:
			[v := Integer readFrom: (ReadStream on: string from: i1 + 6 to: i2 - 1) base: 16.
			string := string
						copyReplaceFrom: i1
						to: i2 - 1
						with: ((v bitAnd: (1 bitShift: 31) - 1) - (v bitAnd: (1 bitShift: 31))) printString]].
	(i1 := string indexOfSubCollection: '$0x') > 0 ifTrue:
		[i2 := i1 + 3.
		 ['0123456789abcdef' includes: (string at: i2)] whileTrue: [i2 := i2 + 1].
		 string := string
					copyReplaceFrom: i1 + 1
					to: i2 - 1
					with: (aSymbolManager lookupCHexString: (string copyFrom: i1 + 1 to: i2 - 1))].
	((i1 := string indexOf: $() > 1
	 and: [(string at: i1 + 1) isDigit
	 and: [i1 < (i2 := string indexOf: $))]]) ifTrue:
		[string := string
					copyReplaceFrom: i1 + 1
					to: i2 - 1
					with: (aSymbolManager lookupCHexString: (string copyFrom: i1 + 1 to: i2 - 1)).
		 i1 := string indexOfSubCollection: '+0x'. "calls & jumps"
		 i1 > 0 ifTrue:
			[v := Integer readFrom: (i2 := ReadStream on: string from: i1 + 3 to: string size) base: 16.
			 v := ((v bitAnd: (1 bitShift: 63) - 1) - (v bitAnd: (1 bitShift: 63))) printStringRadix: 16.
			 v := v first = $1
					ifTrue: [v copyReplaceFrom: 1 to: 3 with: '+0x']
					ifFalse: [v copyReplaceFrom: 2 to: 4 with: '0x'].
			 string := string copyReplaceFrom: i1 to: i2 position with: v]].
	^extra
		ifNil: [string]
		ifNotNil: [i1 := string lastIndexOf: $:. string copyReplaceFrom: i1 - 1 to: i1 - 2 with: extra]! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
dil
	^self unsignedByteAt: 525! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
dil: anUnsignedInteger
	^self unsignedByteAt: 525 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
dl
	^self unsignedByteAt: 485! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
dl: anUnsignedInteger
	^self unsignedByteAt: 485 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 10/6/2015 19:51'!
endianness
	^#little! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/9/2015 10:43'!
floatingPointRegisterStateSetters
	^#(	xmm0low: xmm1low: xmm2low: xmm3low:
		xmm4low: xmm5low: xmm6low: xmm7low:
		xmm9low: xmm9low: xmm10low: xmm11low:
		xmm12low: xmm13low: xmm14low: xmm15low:)! !

!BochsX64Alien methodsFor: 'execution' stamp: 'eem 9/23/2015 17:27'!
flushICacheFrom: startAddress "<Integer>" to: endAddress "<Integer>"
	self primitiveFlushICacheFrom: startAddress To: endAddress! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/21/2015 11:15'!
fp
	^self rbp! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/21/2015 11:14'!
fp: anAddress
	"Set whatever the processor considers its frame pointer to anAddress."
	self rbp: anAddress! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 10/21/2015 14:27:31'!
handleCallFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil "<Integer|nil>"
	"Convert an execution primitive failure for a call into a ProcessorSimulationTrap signal."
	| relativeJump |
	self assert: rexByteOrNil isNil.
	relativeJump := memoryArray longAt: pc + 2 bigEndian: false.
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 5
			address: (pc + 5 + relativeJump) signedIntToLong64
			type: #call)
		signal! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 10/21/2015 15:43:39'!
handleExecutionPrimitiveFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil "<Integer|nil>"
	"Handle an execution primitive failure for an unhandled opcode."
	^self reportPrimitiveFailure! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 1/14/2016 13:32'!
handleExecutionPrimitiveFailureIn: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress
	"Handle an execution primitive failure.  Convert out-of-range call and absolute
	 memory read into register instructions into ProcessorSimulationTrap signals."
	"self printIntegerRegistersOn: Transcript"
	"self printRegistersOn: Transcript"
	| pc opcode rexByteOrNil offset |
	((pc := self rip) between: minimumAddress and: memoryArray byteSize - 1) ifTrue:
		[opcode := memoryArray byteAt: pc + (offset := 1).
		 (opcode bitAnd: 16rF8) = self rexPrefix ifTrue: "skip rex prefix if present"
			[rexByteOrNil := opcode.
			 opcode := memoryArray byteAt: pc + (offset := 2)].
		 ^self
			perform: (OpcodeExceptionMap at: opcode + 1)
			with: pc
			with: memoryArray
			with: rexByteOrNil].
	^self reportPrimitiveFailure! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 12/4/2015 23:06'!
handleGroup5FailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil "<Integer|nil>"
	"Convert an execution primitive failure for a group 5 instruction into the relevant ProcessorSimulationTrap signal."
	| modrmByte getter |
	self assert: rexByteOrNil isNil.
	modrmByte := memoryArray byteAt: pc + 2.
	(modrmByte >> 3 bitAnd: 7)
		caseOf: {
			[2 "Call Ev"]	->	[getter := self registerStateGetters at: (modrmByte bitAnd: 7) + 1.
							^(ProcessorSimulationTrap
									pc: pc
									nextpc: pc + 2
									address: (self perform: getter)
									type: #call)
								signal].
			[4 "Jump Ev"]	->	[getter := self registerStateGetters at: (modrmByte bitAnd: 7) + 1.
							^(ProcessorSimulationTrap
									pc: pc
									nextpc: pc + 2
									address: (self perform: getter)
									type: #jump)
								signal] }! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 10/21/2015 14:27:25'!
handleJmpFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil "<Integer|nil>"
	"Convert an execution primitive failure for a jmp into a ProcessorSimulationTrap signal."
	|  relativeJump |
	self assert: rexByteOrNil isNil.
	relativeJump := memoryArray longAt: pc + 2 bigEndian: false.
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 5
			address: (pc + 5 + relativeJump) signedIntToLong64
			type: #jump)
		signal! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 12/17/2015 00:00'!
handleMovALObFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil "<Integer|nil>"
	"Convert an execution primitive failure for a read into al into a ProcessorSimulationTrap signal."
	rexByteOrNil ifNotNil:
		[self assert: rexByteOrNil = 16r48.
		 ^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 10
				address: (memoryArray unsignedLong64At: pc + 3)
				type: #read
				accessor: #al:)
			signal].
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 5
			address: (memoryArray unsignedLongAt: pc + 2)
			type: #read
			accessor: #al:)
		signal! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 12/17/2015 00:00'!
handleMovAXOvFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil "<Integer|nil>"
	"Convert an execution primitive failure for a read into rax/eax into a ProcessorSimulationTrap signal."
	rexByteOrNil ifNotNil:
		[self assert: rexByteOrNil = 16r48.
		 ^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 10
				address: (memoryArray unsignedLong64At: pc + 3)
				type: #read
				accessor: #rax:)
			signal].
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 5
			address: (memoryArray unsignedLongAt: pc + 2)
			type: #read
			accessor: #eax:)
		signal! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 1/12/2016 08:44'!
handleMovEbGbFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil "<Integer|nil>"
	"Convert an execution primitive failure for a byte register write into a ProcessorSimulationTrap signal."
	| modrmByte offset size baseReg srcReg |
	modrmByte := memoryArray byteAt: pc + 3.
	(modrmByte bitAnd: 16rC0) caseOf: {
		[16r80 "ModRegRegDisp32"] -> [offset := memoryArray unsignedLongAt: pc + 4 bigEndian: false.
										 size := 7].
		[16r40 "ModRegRegDisp8"] -> [offset := memoryArray byteAt: pc + 4.
										offset > 127 ifTrue: [offset := offset - 256].
										 size := 4].
		[16r0 "ModRegInd"] -> [offset := 0.
								size := 3]}
		otherwise: [self reportPrimitiveFailure].
	srcReg := (modrmByte >> 3 bitAnd: 7) + ((rexByteOrNil bitAnd: 4) bitShift: 1).
	baseReg := (modrmByte bitAnd: 7) + ((rexByteOrNil bitAnd: 1) bitShift: 3).
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + size
			address: (((self perform: (self registerStateGetters at: baseReg + 1))
					+ offset)
						bitAnd: 16rFFFFFFFFFFFFFFFF)
			type: #write
			accessor: (#(al cl dl bl spl bpl sil dil r8l r9l r10l r11l r12l r13l r14l r15l) at: srcReg + 1))
		signal! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 12/3/2015 15:34'!
handleMovEvGvFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil "<Integer|nil>"
	"Convert an execution primitive failure for a register write into a ProcessorSimulationTrap signal."
	| modrmByte getter base offset |
	self assert: rexByteOrNil notNil.
	modrmByte := memoryArray byteAt: pc + 3.
	getter := self registerStateGetters at: ((modrmByte >> 3 bitAnd: 7) + ((rexByteOrNil bitAnd: 4) << 1) + 1).
	(modrmByte bitAnd: 16rC7) = 16r5 ifTrue: "ModRegInd & disp32"
		[^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 7
				address: (memoryArray unsignedLongAt: pc + 4 bigEndian: false)
				type: #write
				accessor: getter)
			signal].
	(modrmByte bitAnd: 16rC0) = 16r80 ifTrue: "ModRegRegDisp32"
		[offset := memoryArray longAt: pc + 4 bigEndian: false.
		 base := self registerStateGetters at: ((modrmByte bitAnd: 7) + ((rexByteOrNil bitAnd: 1) << 3) + 1).
		 ^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 7
				address: (self perform: base) + offset
				type: #write
				accessor: getter)
			signal].
	(modrmByte bitAnd: 16rC0) = 16r40 ifTrue: "ModRegRegDisp8"
		[offset := memoryArray unsignedByteAt: pc + 4.
		 offset > 127 ifTrue: [offset := offset - 256].
		 base := self registerStateGetters at: ((modrmByte bitAnd: 7) + ((rexByteOrNil bitAnd: 1) << 3) + 1).
		 ^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 4
				address: (self perform: base) + offset
				type: #write
				accessor: getter)
			signal].
	^self reportPrimitiveFailure! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 12/3/2015 14:21'!
handleMovGbEbFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil "<Integer|nil>"
	"Convert an execution primitive failure for a byte register load into a ProcessorSimulationTrap signal."
	| modrmByte offset size |
	modrmByte := memoryArray byteAt: pc + 3.
	(modrmByte bitAnd: 16rC0) caseOf: {
		[16r80 "ModRegRegDisp32"] -> [offset := memoryArray unsignedLongAt: pc + 4 bigEndian: false.
										 size := 7].
		[16r40 "ModRegRegDisp8"] -> [offset := memoryArray byteAt: pc + 4.
										offset > 127 ifTrue: [offset := offset - 256].
										 size := 4] }
		otherwise: [self reportPrimitiveFailure].
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + size
			address: (((self perform: (self registerStateGetters at: (modrmByte bitAnd: 7) + ((rexByteOrNil bitAnd: 1) bitShift: 3) + 1))
					+ offset)
						bitAnd: 16rFFFFFFFFFFFFFFFF)
			type: #read
			accessor: (#(al: cl: dl: bl: spl: bpl: sil: dil: r8l: r9l: r10l: r11l: r12l: r13l: r14l: r15l:) at: ((modrmByte >> 3 bitAnd: 7) + ((rexByteOrNil bitAnd: 4) bitShift: 1) + 1)))
		signal! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 10/20/2015 20:10'!
handleMovGvEbFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil "<Integer|nil>"
	"Convert an execution primitive failure for a register load into a ProcessorSimulationTrap signal."
	| modrmByte mode srcIsSP srcVal dst offset |
	self shouldBeImplemented.
	modrmByte := memoryArray byteAt: pc + 3.
	mode := modrmByte >> 6 bitAnd: 3.
	srcIsSP := (modrmByte bitAnd: 7) = 4.
	srcVal := self perform: (#(eax ecx edx ebx esp ebp esi edi) at: (modrmByte bitAnd: 7) + 1).
	dst := #(eax: ecx: edx: ebx: esp: ebp: esi: edi:) at: ((modrmByte >> 3 bitAnd: 7) + 1).
	mode = 1 ifTrue: "ModRegRegDisp8"
		[offset := memoryArray byteAt: pc + (srcIsSP ifTrue: [5] ifFalse: [4]). "1-relative"
		 offset > 127 ifTrue: [offset := offset - 256].
		 ^(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + (srcIsSP ifTrue: [5] ifFalse: [4])
					address: ((srcVal + offset) bitAnd: 16rFFFFFFFF)
					type: #read
					accessor: dst)
				signal].
	mode = 2 ifTrue: "ModRegRegDisp32"
		[offset := memoryArray unsignedLongAt: pc + (srcIsSP ifTrue: [5] ifFalse: [4]). "1-relative"
		 ^(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + (srcIsSP ifTrue: [8] ifFalse: [7])
					address: ((srcVal + offset) bitAnd: 16rFFFFFFFF)
					type: #read
					accessor: dst)
				signal].
	^self reportPrimitiveFailure! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 10/23/2015 19:29:20'!
handleMovGvEvFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil "<Integer|nil>"
	"Convert an execution primitive failure for a register load into a ProcessorSimulationTrap signal."
	| modrmByte getter setter offset |
	self assert: rexByteOrNil notNil.
	modrmByte := memoryArray byteAt: pc + 3.
	setter := self registerStateSetters at: ((modrmByte >> 3 bitAnd: 7) + ((rexByteOrNil bitAnd: 4) << 1) + 1).
	(modrmByte bitAnd: 16rC7) = 16r5 ifTrue: "ModRegInd & disp32"
		[^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 7
				address: (memoryArray unsignedLongAt: pc + 4 bigEndian: false)
				type: #read
				accessor: setter)
			signal].
	getter := self registerStateGetters at: ((modrmByte bitAnd: 7) + ((rexByteOrNil bitAnd: 1) << 3) + 1).
	(modrmByte bitAnd: 16rC0) = 16r80 ifTrue: "ModRegRegDisp32"
		[offset := memoryArray longAt: pc + 4 bigEndian: false.
		 ^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 7
				address: (self perform: getter) + offset
				type: #read
				accessor: setter)
			signal].
	(modrmByte bitAnd: 16rC0) = 16r40 ifTrue: "ModRegRegDisp8"
		[offset := memoryArray byteAt: pc + 4.
		 offset > 16r7F ifTrue:
			[offset := offset - 16r100].
		 ^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 4
				address: (self perform: getter) + offset
				type: #read
				accessor: setter)
			signal].
	^self reportPrimitiveFailure! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 12/17/2015 00:01'!
handleMovObALFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil "<Integer|nil>"
	"Convert an execution primitive failure for a write of al into a ProcessorSimulationTrap signal."
	self assert: rexByteOrNil = 16r48.
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 10
			address: (memoryArray unsignedLong64At: pc + 3)
			type: #write
			accessor: #al)
		signal! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 12/17/2015 00:02'!
handleMovOvAXFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil "<Integer|nil>"
	"Convert an execution primitive failure for a write of rax into a ProcessorSimulationTrap signal."
	self assert: rexByteOrNil = 16r48.
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 10
			address: (memoryArray unsignedLong64At: pc + 3)
			type: #write
			accessor: #rax)
		signal! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 12/3/2015 11:45'!
handleRetFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil "<Integer|nil>"
	"Convert an execution primitive failure for a ret into a ProcessorSimulationTrap signal."
	self shouldBeImplemented.
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 1
			address: (memoryArray unsignedLong64At: self rsp + 1)
			type: #return
			accessor: #rip:)
		signal! !

!BochsX64Alien methodsFor: 'error handling' stamp: 'eem 1/14/2016 13:31'!
handleTwoByteEscapeFailureAt: pc in: memoryArray "<Bitmap|ByteArray>" rex: rexByteOrNil
	"Handle an execution primitive failure for the 0f prefix.  Convert failures into ProcessorSimulationTrap signals."
	"self printIntegerRegistersOn: Transcript"
	"self printRegistersOn: Transcript"
	| opcode offset |
	"assume 0fh opcode or 0fh rex opcode"
	offset := rexByteOrNil ifNil: [1] ifNotNil: [2].
	opcode := memoryArray byteAt: pc + offset + 1.
	 ^self
			perform: (ExtendedOpcodeExceptionMap at: opcode + 1)
			with: pc
			with: memoryArray
			with: rexByteOrNil! !

!BochsX64Alien methodsFor: 'processor setup' stamp: 'eem 1/10/2016 08:16'!
initializeStackFor: aCogit
	"Different cpus need different stack alignment etc, so handle the details here."
	"From the System V ABI:
	 3.2.2 The Stack Frame
	 ...	The end of the input argument area shall be aligned on a 16 (32, if __m256 is
		passed on stack) byte boundary. In other words, the value (%rsp + 8) is always
		a multiple of 16 (32) when control is transferred to the function entry point."
	| stackAlignment |
	stackAlignment := 32.
	aCogit setStackAlignment: stackAlignment expectedSPOffset: 0 expectedFPOffset: 16.
	PostBuildStackDelta := stackAlignment > 16
								ifTrue: [stackAlignment - 16]
								ifFalse: [0]! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/22/2015 15:22'!
integerRegisterState
	^{	self rax. self rbx. self rcx. self rdx. self rsp. self rbp. self rsi. self rdi.
		self r8. self r9. self r10. self r11. self r12. self r13. self r14. self r15.
		self rip. self rflags }! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 9/22/2015 15:35'!
jmpOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA8"
	^16rE9! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 9/9/2009 21:24'!
lockPrefix
	^16rF0! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 11/3/2015 08:45:58'!
movALObOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA7"
	^16rA0! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 11/3/2015 08:52:38'!
movAXOvOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA7"
	^16rA1! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 9/22/2015 15:35'!
movEbGbOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2"
	^16r88! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 9/22/2015 15:35'!
movEvGvOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA8"
	^16r89! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 9/22/2015 15:35'!
movGbEbOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2"
	^16r8A! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 9/22/2015 15:35'!
movGvEbOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A3, pA14"
	^16rB6! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 9/22/2015 15:35'!
movGvEvOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA8"
	^16r8B! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 11/3/2015 08:51:22'!
movObALOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA7"
	^16rA2! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 11/3/2015 08:52:52'!
movOvAXOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA7"
	^16rA3! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 12/12/2008 15:52'!
nopOpcode
	^16r90! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 1/14/2016 13:15'!
operandSizeOverridePrefix
	^16r66! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/18/2015 12:33'!
pc
	^self rip! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/18/2015 13:12'!
pc: anAddress
	"Set whatever the processor considers its program counter to anAddress."
	self rip: anAddress! !

!BochsX64Alien methodsFor: 'execution' stamp: 'eem 12/3/2015 12:13'!
popWordIn: aMemory 
	| sp word |
	word := aMemory long64At: (sp := self rsp) + 1.
	self rsp: sp + 8.
	^word! !

!BochsX64Alien methodsFor: 'execution' stamp: 'eem 11/28/2016 18:45'!
postCallArgumentsNumArgs: numArgs "<Integer>" in: memory "<ByteArray|Bitmap>"
	"Answer an argument vector of the requested size after a Win64 or SysV
	 ABI call.  On X64 this simply means accessing register arguments.
	 For compatibility with Cog/Slang we answer unsigned values."
	self assert: numArgs <= 4.
	^((CogX64Compiler isSysV
				ifTrue: [#(rdi rsi rdx rcx r8 r9)]
				ifFalse: [#(rcx rdx r8 r9)]) copyFrom: 1 to: numArgs) collect:
		[:getter|
		self perform: getter]! !

!BochsX64Alien methodsFor: 'primitives' stamp: 'eem 1/14/2009 15:26'!
primitiveDisassembleAt: address inMemory: memoryArray "<Bitmap|ByteArray>"
	"Answer an Array of the size and the disassembled code string for the instruction at the current instruction pointer in memory."
	<primitive: 'primitiveDisassembleAtInMemory' module: 'BochsX64Plugin'>
	^self primitiveFailed! !

!BochsX64Alien methodsFor: 'primitives' stamp: 'eem 12/12/2008 13:02'!
primitiveErrorAndLog
	"Answer an array of the current error code and log contents"
	<primitive: 'primitiveErrorAndLog' module: 'BochsX64Plugin'>
	^self primitiveFailed! !

!BochsX64Alien methodsFor: 'primitives' stamp: 'eem 1/15/2009 09:58'!
primitiveFlushICacheFrom: startAddress "<Integer>" To: endAddress "<Integer>"
	"Flush the icache in the requested range"
	<primitive: 'primitiveFlushICacheFromTo' module: 'BochsX64Plugin'>
	^self primitiveFailed! !

!BochsX64Alien methodsFor: 'primitives' stamp: 'eem 12/12/2008 13:29'!
primitiveResetCPU
	"Reset the receiver to registers all zero, and protected 32-bit mode."
	<primitive: 'primitiveResetCPU' module: 'BochsX64Plugin'>
	^self reportPrimitiveFailure! !

!BochsX64Alien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:19'!
primitiveRunInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Run the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveRunInMemoryMinimumAddressReadWrite' module: 'BochsX64Plugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]

	"self printRegistersOn: Transcript"! !

!BochsX64Alien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:20'!
primitiveSingleStepInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Single-step the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveSingleStepInMemoryMinimumAddressReadWrite' module: 'BochsX64Plugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]! !

!BochsX64Alien methodsFor: 'printing' stamp: 'eem 9/21/2015 11:53'!
printFields: fields inRegisterState: registerStateVector on: aStream
	| rsvs |
	aStream ensureCr.
	rsvs := registerStateVector readStream.
	fields withIndexDo:
		[:sym :index| | val |
		sym = #cr
			ifTrue: [aStream cr]
			ifFalse:
				[(val := rsvs next) isNil ifTrue: [^self].
				(sym beginsWith: 'xmm')
					ifTrue:
						[aStream nextPutAll: sym; nextPut: $:; space.
						 val printOn: aStream base: 16 length: 16 padded: true.
						 aStream space; nextPut: $(.
						 "At the image level Float is apparently in big-endian format"
						 ((Float basicNew: 2)
						 	at: 2 put: (val bitAnd: 16rFFFFFFFF);
							at: 1 put: (val bitShift: -32);
							yourself)
								printOn: aStream.
						 aStream nextPut: $)]
					ifFalse:
						[aStream nextPutAll: sym; nextPut: $:; space.
						 val printOn: aStream base: 16 length: 8 padded: true.
						 #eflags == sym
							ifTrue:
								[aStream space.
								 'C-P-A-ZS---O' withIndexDo:
									[:flag :bitIndex|
									flag ~= $- ifTrue:
										[aStream nextPut: flag; nextPutAll: 'F='; print: (val bitAnd: 1 << (bitIndex - 1)) >> (bitIndex - 1); space]]]
							ifFalse:
								[val > 16 ifTrue:
									[aStream space; nextPut: $(.
									 val printOn: aStream base: 10 length: 1 padded: false.
									 aStream nextPut: $)]]].
						(fields at: index + 1) ~~ #cr ifTrue:
							[aStream tab]]]! !

!BochsX64Alien methodsFor: 'printing' stamp: 'eem 9/22/2015 15:22'!
printIntegerRegistersOn: aStream
	self printRegisterState: self integerRegisterState on: aStream.
	aStream flush! !

!BochsX64Alien methodsFor: 'printing' stamp: 'eem 12/9/2015 17:00'!
printRegisterState: registerStateVector on: aStream
	"Print the registers, somewhat nicely formatted"
	| lastIndex |
	"First find out what floating point registers are used, and only print the ones up through the last non-zero one."
	lastIndex := (registerStateVector size to: 19 by: -1) detect: [:i| (registerStateVector at: i) ~= 0] ifNone: [0].
	lastIndex := lastIndex > 0
					ifTrue: [lastIndex - 18 + 1 // 2 * 3 + 23]
					ifFalse: [23].
	self printFields:
			(#(	rax rbx rcx rdx cr
				rsp rbp rsi rdi cr
				r8 r9 r10 r11 cr
				r12 r13 r14 r15 cr
				rip rflags cr
				xmm0low xmm1low cr
				xmm2low xmm3low cr
				xmm4low xmm5low cr
				xmm6low xmm7low cr
				xmm8low xmm9low cr
				xmm10low xmm11low cr
				xmm12low xmm13low cr
				xmm14low xmm15low cr )
					copyFrom: 1 to: lastIndex)
		inRegisterState: registerStateVector
		on: aStream! !

!BochsX64Alien methodsFor: 'printing' stamp: 'eem 10/21/2015 15:38:07'!
printRegisterStateExceptPC: registerStateVector on: aStream
	self printFields:
			((registerStateVector size < 34
			  or: [(19 to: 34) allSatisfy: [:i| (registerStateVector at: i) isZero]])
				ifTrue:
					[#(	rax rbx rcx rdx cr
						rsp rbp rsi rdi cr
						r8 r9 r10 r11 cr
						r12 r13 r14 r15 cr)]
				ifFalse:
					[#(	rax rbx rcx rdx cr
						rsp rbp rsi rdi cr
						r8 r9 r10 r11 cr
						r12 r13 r14 r15 cr
						xmm0low xmm1low cr
						xmm2low xmm3low cr
						xmm4low xmm5low cr
						xmm6low xmm7low cr )])
		inRegisterState: registerStateVector
		on: aStream! !

!BochsX64Alien methodsFor: 'execution' stamp: 'eem 10/18/2015 10:00'!
pushWord: aValue in: aMemory
	| sp |
	sp := (self rsp: self rsp - 8).
	aMemory long64At: sp + 1 put: aValue! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r10
	^self unsignedLongLongAt: 549! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r10: anUnsignedInteger
	^self unsignedLongLongAt: 549 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r10l
	^self unsignedByteAt: 549! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r10l: anUnsignedInteger
	^self unsignedByteAt: 549 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r11
	^self unsignedLongLongAt: 557! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r11: anUnsignedInteger
	^self unsignedLongLongAt: 557 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r11l
	^self unsignedByteAt: 557! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r11l: anUnsignedInteger
	^self unsignedByteAt: 557 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r12
	^self unsignedLongLongAt: 565! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r12: anUnsignedInteger
	^self unsignedLongLongAt: 565 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r12l
	^self unsignedByteAt: 565! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r12l: anUnsignedInteger
	^self unsignedByteAt: 565 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r13
	^self unsignedLongLongAt: 573! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r13: anUnsignedInteger
	^self unsignedLongLongAt: 573 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r13l
	^self unsignedByteAt: 573! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r13l: anUnsignedInteger
	^self unsignedByteAt: 573 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r14
	^self unsignedLongLongAt: 581! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r14: anUnsignedInteger
	^self unsignedLongLongAt: 581 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r14l
	^self unsignedByteAt: 581! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r14l: anUnsignedInteger
	^self unsignedByteAt: 581 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r15
	^self unsignedLongLongAt: 589! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r15: anUnsignedInteger
	^self unsignedLongLongAt: 589 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r15l
	^self unsignedByteAt: 589! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r15l: anUnsignedInteger
	^self unsignedByteAt: 589 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r8
	^self unsignedLongLongAt: 533! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r8: anUnsignedInteger
	^self unsignedLongLongAt: 533 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r8l
	^self unsignedByteAt: 533! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r8l: anUnsignedInteger
	^self unsignedByteAt: 533 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r9
	^self unsignedLongLongAt: 541! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
r9: anUnsignedInteger
	^self unsignedLongLongAt: 541 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r9l
	^self unsignedByteAt: 541! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
r9l: anUnsignedInteger
	^self unsignedByteAt: 541 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rax
	^self unsignedLongLongAt: 469! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rax: anUnsignedInteger
	^self unsignedLongLongAt: 469 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rbp
	^self unsignedLongLongAt: 509! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rbp: anUnsignedInteger
	^self unsignedLongLongAt: 509 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rbx
	^self unsignedLongLongAt: 493! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rbx: anUnsignedInteger
	^self unsignedLongLongAt: 493 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rcx
	^self unsignedLongLongAt: 477! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rcx: anUnsignedInteger
	^self unsignedLongLongAt: 477 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rdi
	^self unsignedLongLongAt: 525! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rdi: anUnsignedInteger
	^self unsignedLongLongAt: 525 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rdx
	^self unsignedLongLongAt: 485! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rdx: anUnsignedInteger
	^self unsignedLongLongAt: 485 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/9/2015 16:51'!
registerState
	^{	self rax. self rbx. self rcx. self rdx. self rsp. self rbp. self rsi. self rdi.
		self r8. self r9. self r10. self r11. self r12. self r13. self r14. self r15.
		self rip. self rflags.
		self xmm0low. self xmm1low. self xmm2low. self xmm3low.
		self xmm4low. self xmm5low. self xmm6low. self xmm7low.
		self xmm8low. self xmm9low. self xmm10low. self xmm11low.
		self xmm12low. self xmm13low. self xmm14low. self xmm5low }! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/9/2015 10:50'!
registerStateGetters
	^#(	rax rcx rdx rbx rsp rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15
		rip rflags
		xmm0low xmm1low xmm2low xmm3low
		xmm4low xmm5low xmm6low xmm7low
		xmm9low xmm9low xmm10low xmm11low
		xmm12low xmm13low xmm14low xmm15low)! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 10/21/2015 15:35:18'!
registerStatePCIndex
	^17! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/9/2015 10:50'!
registerStateSetters
	^#(	rax: rcx: rdx: rbx: rsp: rbp: rsi: rdi: r8: r9: r10: r11: r12: r13: r14: r15:
		rip: rflags:
		xmm0low: xmm1low: xmm2low: xmm3low:
		xmm4low: xmm5low: xmm6low: xmm7low:
		xmm9low: xmm9low: xmm10low: xmm11low:
		xmm12low: xmm13low: xmm14low: xmm15low:)! !

!BochsX64Alien methodsFor: 'primitives' stamp: 'eem 9/17/2015 15:50'!
reset
	self primitiveResetCPU.
	"Enable SSE extensions by setting the OSFXSR (Operating System FXSAVE/FXRSTOR Support) bit"
	self cr4: (self cr4 bitOr: 1 << 9)! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 9/22/2015 15:34'!
retOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA7"
	^16rC3! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/3/2015 12:13'!
retpcIn: aMemory
	^aMemory long64At: self rbp + 9! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 9/22/2015 15:38'!
rexPrefix
	^16r48! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rflags
	^self unsignedLongLongAt: 621! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/17/2015 17:12'!
rflags: anUnsignedInteger
	^self unsignedLongLongAt: 621 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rip
	^self unsignedLongLongAt: 597! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rip: anUnsignedInteger
	^self unsignedLongLongAt: 597 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rsi
	^self unsignedLongLongAt: 517! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rsi: anUnsignedInteger
	^self unsignedLongLongAt: 517 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rsp
	^self unsignedLongLongAt: 501! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
rsp: anUnsignedInteger
	^self unsignedLongLongAt: 501 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
saveRip
	^self unsignedLongAt: 1913! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
saveRip: anUnsignedInteger
	^self unsignedLongAt: 1913 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
saveRsp
	^self unsignedLongAt: 1921! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
saveRsp: anUnsignedInteger
	^self unsignedLongAt: 1921 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/23/2015 08:47'!
setFramePointer: framePointer stackPointer: stackPointer
	"Initialize the processor's frame and stack pointers"
	self rbp: framePointer.
	self rsp: stackPointer! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
sil
	^self unsignedByteAt: 517! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
sil: anUnsignedInteger
	^self unsignedByteAt: 517 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'execution' stamp: 'eem 12/3/2015 12:26'!
simulateCallOf: address nextpc: nextpc memory: aMemory
	"Simulate a frame-building call of address.  Build a frame since
	a) this is used for calls into the run-time which are unlikely to be leaf-calls, and
	b) stack alignment needs to be realistic for assert checking

	From the System V ABI:
	 3.2.2 The Stack Frame
	 ...	The end of the input argument area shall be aligned on a 16 (32, if __m256 is
		passed on stack) byte boundary. In other words, the value (%rsp + 8) is always
		a multiple of 16 (32) when control is transferred to the function entry point."
	self pushWord: nextpc in: aMemory.
	self pushWord: self rbp in: aMemory.
	self rbp: self rsp.
	PostBuildStackDelta ~= 0 ifTrue:
		[self rsp: self rsp - PostBuildStackDelta].
	self rip: address! !

!BochsX64Alien methodsFor: 'execution' stamp: 'eem 12/4/2015 23:09'!
simulateJumpCallOf: address memory: aMemory
	"Simulate a frame-building jump call of address (i.e. do not push the return pc
	 as this has already been done).  Build a frame since
	a) this is used for calls into the run-time which are unlikely to be leaf-calls, and
	b) stack alignment needs to be realistic for assert checking for platforms such as Mac OS X"
	self pushWord: self rbp in: aMemory.
	self rbp: self rsp.
	PostBuildStackDelta ~= 0 ifTrue:
		[self rsp: self rsp - PostBuildStackDelta].
	self rip: address! !

!BochsX64Alien methodsFor: 'execution' stamp: 'eem 10/18/2015 09:59'!
simulateLeafCallOf: address nextpc: nextpc memory: aMemory
	self pushWord: nextpc in: aMemory.
	self rip: address! !

!BochsX64Alien methodsFor: 'execution' stamp: 'eem 12/3/2015 11:42'!
simulateReturnIn: aMemory
	PostBuildStackDelta ~= 0 ifTrue:
		[self rsp: self rsp + PostBuildStackDelta].
	self rbp: (self popWordIn: aMemory).
	self rip: (self popWordIn: aMemory)! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/3/2015 11:41'!
smashCallerSavedRegistersWithValuesFrom: base by: step
	#(rax: rcx: rdx: rsi: rdi: r8: r9: r10: r11:)
	   withIndexDo:
		[:accessor :index|
		self perform: accessor with: index - 1 * step + base]! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 10/18/2015 09:58'!
smashRegisterAccessors
	^#(rax: rbx: rcx: rdx: rsi: rdi: r8: r9: r10: r11: r12: r13: r14: r15:)! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/21/2015 11:15'!
sp
	^self rsp! !

!BochsX64Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/21/2015 11:14'!
sp: anAddress
	"Set whatever the processor considers its stack pointer to anAddress."
	self rsp: anAddress! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
spl
	^self unsignedByteAt: 501! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/3/2015 15:07'!
spl: anUnsignedInteger
	^self unsignedByteAt: 501 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
stopReason
	^self unsignedByteAt: 1973! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
stopReason: anUnsignedInteger
	^self unsignedByteAt: 1973 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'opcodes' stamp: 'eem 1/14/2016 13:18'!
twoByteEscape
	^16r0f! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm0high
	^self unsignedLongLongAt: 1421! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm0high: anUnsignedInteger
	^self unsignedLongLongAt: 1421 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm0low
	^self unsignedLongLongAt: 1413! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm0low: anUnsignedInteger
	^self unsignedLongLongAt: 1413 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm10high
	^self unsignedLongLongAt: 1581! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm10high: anUnsignedInteger
	^self unsignedLongLongAt: 1581 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm10low
	^self unsignedLongLongAt: 1573! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm10low: anUnsignedInteger
	^self unsignedLongLongAt: 1573 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm11high
	^self unsignedLongLongAt: 1597! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm11high: anUnsignedInteger
	^self unsignedLongLongAt: 1597 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm11low
	^self unsignedLongLongAt: 1589! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm11low: anUnsignedInteger
	^self unsignedLongLongAt: 1589 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm12high
	^self unsignedLongLongAt: 1613! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm12high: anUnsignedInteger
	^self unsignedLongLongAt: 1613 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm12low
	^self unsignedLongLongAt: 1605! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm12low: anUnsignedInteger
	^self unsignedLongLongAt: 1605 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm13high
	^self unsignedLongLongAt: 1629! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm13high: anUnsignedInteger
	^self unsignedLongLongAt: 1629 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm13low
	^self unsignedLongLongAt: 1621! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm13low: anUnsignedInteger
	^self unsignedLongLongAt: 1621 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm14high
	^self unsignedLongLongAt: 1645! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm14high: anUnsignedInteger
	^self unsignedLongLongAt: 1645 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm14low
	^self unsignedLongLongAt: 1637! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm14low: anUnsignedInteger
	^self unsignedLongLongAt: 1637 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm15high
	^self unsignedLongLongAt: 1661! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm15high: anUnsignedInteger
	^self unsignedLongLongAt: 1661 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm15low
	^self unsignedLongLongAt: 1653! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm15low: anUnsignedInteger
	^self unsignedLongLongAt: 1653 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm1high
	^self unsignedLongLongAt: 1437! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm1high: anUnsignedInteger
	^self unsignedLongLongAt: 1437 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm1low
	^self unsignedLongLongAt: 1429! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm1low: anUnsignedInteger
	^self unsignedLongLongAt: 1429 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm2high
	^self unsignedLongLongAt: 1453! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm2high: anUnsignedInteger
	^self unsignedLongLongAt: 1453 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm2low
	^self unsignedLongLongAt: 1445! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm2low: anUnsignedInteger
	^self unsignedLongLongAt: 1445 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm3high
	^self unsignedLongLongAt: 1469! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm3high: anUnsignedInteger
	^self unsignedLongLongAt: 1469 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm3low
	^self unsignedLongLongAt: 1461! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm3low: anUnsignedInteger
	^self unsignedLongLongAt: 1461 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm4high
	^self unsignedLongLongAt: 1485! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm4high: anUnsignedInteger
	^self unsignedLongLongAt: 1485 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm4low
	^self unsignedLongLongAt: 1477! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm4low: anUnsignedInteger
	^self unsignedLongLongAt: 1477 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm5high
	^self unsignedLongLongAt: 1501! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm5high: anUnsignedInteger
	^self unsignedLongLongAt: 1501 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm5low
	^self unsignedLongLongAt: 1493! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm5low: anUnsignedInteger
	^self unsignedLongLongAt: 1493 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm6high
	^self unsignedLongLongAt: 1517! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm6high: anUnsignedInteger
	^self unsignedLongLongAt: 1517 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm6low
	^self unsignedLongLongAt: 1509! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm6low: anUnsignedInteger
	^self unsignedLongLongAt: 1509 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm7high
	^self unsignedLongLongAt: 1533! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm7high: anUnsignedInteger
	^self unsignedLongLongAt: 1533 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm7low
	^self unsignedLongLongAt: 1525! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 9/10/2015 10:16'!
xmm7low: anUnsignedInteger
	^self unsignedLongLongAt: 1525 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm8high
	^self unsignedLongLongAt: 1549! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm8high: anUnsignedInteger
	^self unsignedLongLongAt: 1549 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm8low
	^self unsignedLongLongAt: 1541! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm8low: anUnsignedInteger
	^self unsignedLongLongAt: 1541 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm9high
	^self unsignedLongLongAt: 1565! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm9high: anUnsignedInteger
	^self unsignedLongLongAt: 1565 put: anUnsignedInteger! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm9low
	^self unsignedLongLongAt: 1557! !

!BochsX64Alien methodsFor: 'accessing' stamp: 'eem 12/9/2015 10:49'!
xmm9low: anUnsignedInteger
	^self unsignedLongLongAt: 1557 put: anUnsignedInteger! !

!CogProcessorAlien class methodsFor: 'debugger' stamp: 'eem 10/21/2015 11:50:22'!
defaultIntegerBaseInDebugger
	^16! !

!CogProcessorAlien class methodsFor: 'class initialization' stamp: 'eem 3/18/2014 09:56'!
initialize
	SavedState := WeakIdentityKeyDictionary new.
	Smalltalk
		addToStartUpList: self;
		addToShutDownList: self! !

!CogProcessorAlien class methodsFor: 'instance creation' stamp: 'eem 3/18/2014 11:03'!
new
	^(self atAddress: self primitiveNewCPU) reset! !

!CogProcessorAlien class methodsFor: 'system startup' stamp: 'eem 3/18/2014 10:00'!
shutDown: quitting
	self allSubInstancesDo:
		[:processor|
		SavedState at: processor put: processor registerState]! !

!CogProcessorAlien class methodsFor: 'system startup' stamp: 'eem 3/18/2014 11:06'!
startUp: resuming
	resuming ifTrue:
		[SavedState keysAndValuesDo:
			[:processorOrNil :state|
			 processorOrNil ifNotNil:
				[processorOrNil addressFieldPut: processorOrNil class primitiveNewCPU.
				 state with: processorOrNil registerStateSetters do:
					[:value :setter|
					processorOrNil perform: setter with: value]]]].
	SavedState removeAll! !

!CogProcessorAlien methodsFor: 'Cog API' stamp: 'lw 7/10/2012 16:26'!
abstractInstructionCompilerClass
	self subclassResponsibility! !

!CogProcessorAlien methodsFor: 'accessing-abstract' stamp: 'lw 11/17/2012 21:38'!
cResultRegister
	^self subclassResponsibility! !

!CogProcessorAlien methodsFor: 'accessing-abstract' stamp: 'lw 11/17/2012 21:38'!
cResultRegister: aValue
	^self subclassResponsibility! !

!CogProcessorAlien methodsFor: 'opcodes' stamp: 'lw 7/11/2012 14:36'!
callOpcode
	self subclassResponsibility.! !

!CogProcessorAlien methodsFor: 'tests support' stamp: 'eem 9/21/2015 11:34'!
convertIntegerToInternal: anInteger
	"Default conversion for 32-bit processors.  64-bit processors override."
	^anInteger signedIntToLong! !

!CogProcessorAlien methodsFor: 'tests support' stamp: 'eem 9/21/2015 11:35'!
convertInternalToInteger: unsigned
	"Default conversion for 32-bit processors.  64-bit processors override."
	^unsigned signedIntFromLong! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'eem 1/13/2016 16:56'!
decorateDisassembly: anInstructionString for: aSymbolManager "<Cogit>" fromAddress: address
	^self subclassResponsibility! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'eem 9/6/2016 11:56'!
disassembleFrom: startAddress to: endAddress in: memory for: aSymbolManager "<Cogit>" labels: labelDictionary on: aStream
	| address |
	address := startAddress.
	[address <= endAddress] whileTrue:
		[[:sizeArg :stringArg| | size string |
		  size := sizeArg.
		  string := stringArg.
		  (aSymbolManager labelForPC: address) ifNotNil:
			[:label| aStream nextPutAll: label; nextPut: $:; cr].
		  (labelDictionary at: address ifAbsent: []) ifNotNil:
			[:label|
			self printLabel: label on: aStream at: address for: aSymbolManager.
			label isArray ifTrue:
				[string := nil.
				 size := label third]].
		  string ifNotNil:
			[aStream nextPutAll: (self decorateDisassembly: string for: aSymbolManager fromAddress: address)].
		  aStream cr; flush.
		  address := address + size]
			valueWithArguments: (self
									primitiveDisassembleAt: address
									inMemory: memory)].
	(labelDictionary at: address ifAbsent: []) ifNotNil:
		[:label| self printLabel: label on: aStream at: address for: aSymbolManager]! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'lw 8/9/2012 13:32'!
disassembleFrom: startAddress to: endAddress in: memory on: aStream
	| address |
	address := startAddress.
	[address < endAddress] whileTrue:
		[[:size :string|
		aStream nextPutAll: (address printStringBase: 16 length: 8 padded: true); nextPut: $:; tab; tab; nextPutAll: string; cr; flush.
		address := address + size]
			valueWithArguments: (self
									primitiveDisassembleAt: address
									inMemory: memory)]! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'eem 1/20/2009 12:39'!
disassembleInstructionAt: pc In: memory
	^(self primitiveDisassembleAt: pc inMemory: memory) last! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'eem 1/14/2009 15:27'!
disassembleInstructionAt: ip In: memory into: aBlock
	| lenAndDi |
	lenAndDi := self primitiveDisassembleAt: ip inMemory: memory.
	^aBlock value: lenAndDi last value: lenAndDi first! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'lw 7/11/2012 13:40'!
disassembleNextInstructionIn: memory
	^(self primitiveDisassembleAt: self pc inMemory: memory) last! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'eem 12/4/2015 09:45'!
disassembleNextInstructionIn: memory for: aSymbolManager "<Cogit|nil>"
	| arrayOfLengthAndString |
	self pc >= memory size ifTrue:
		[| string |
		 string := aSymbolManager ifNotNil:
									[aSymbolManager lookupAddress: self pc].
		 ^self pc hex, ' : ', (string ifNil: ['Invalid address'])].
	arrayOfLengthAndString := self primitiveDisassembleAt: self pc inMemory: memory.
	(arrayOfLengthAndString isArray
	and: [arrayOfLengthAndString first isInteger
	and: [arrayOfLengthAndString last isString]]) ifFalse:
		[^'ERROR: ', (arrayOfLengthAndString printString contractTo: 40)].
	^aSymbolManager
		ifNil: [arrayOfLengthAndString last]
		ifNotNil: [self decorateDisassembly: arrayOfLengthAndString last for: aSymbolManager fromAddress: self pc]! !

!CogProcessorAlien methodsFor: 'accessing-abstract' stamp: 'lw 7/12/2012 22:16'!
endianness
	self subclassResponsibility! !

!CogProcessorAlien methodsFor: 'opcodes' stamp: 'lw 7/10/2012 16:23'!
nopOpcode
	self subclassResponsibility.! !

!CogProcessorAlien methodsFor: 'printing' stamp: 'eem 9/6/2016 11:55'!
printLabel: label on: aStream at: address for: aSymbolManager
	"Print label on aStream.  The label is either a triple of {type, printer, size} or a simple string."
	label isArray
		ifTrue: [label first == #literal
					ifTrue:
						[aStream
							nextPutAll: (address printStringBase: 16 length: 8 padded: true) asLowercase;
							nextPut: $:; space;
							nextPutAll: (aSymbolManager lookupAddress: (aSymbolManager objectMemory longAt: address))]
					ifFalse:
						[aStream
							nextPutAll: label first;
							nextPut: $:; cr;
							nextPutAll: (address printStringBase: 16 length: 8 padded: true) asLowercase;
							nextPut: $:; space;
							nextPutAll: (aSymbolManager perform: label second with: address) asString]]
		ifFalse: [aStream nextPutAll: label; nextPut: $:; cr]! !

!CogProcessorAlien methodsFor: 'printing' stamp: 'lw 7/10/2012 16:22'!
printRegisterState: registerStateVector on: aStream

	self subclassResponsibility.! !

!CogProcessorAlien methodsFor: 'printing' stamp: 'eem 4/17/2009 13:59'!
printRegistersOn: aStream
	self printRegisterState: self registerState on: aStream.
	aStream flush! !

!CogProcessorAlien methodsFor: 'accessing-abstract' stamp: 'lw 11/17/2012 18:13'!
registerStatePCIndex
	"Return the index of the PC register among all register, assuming they are copied into a Smalltalk array."
	^self subclassResponsibility! !

!CogProcessorAlien methodsFor: 'error handling' stamp: 'lw 7/11/2012 17:04'!
reportPrimitiveFailure
	| errorAndLog |
	errorAndLog := self primitiveErrorAndLog.
	self error: 'Error ', errorAndLog first printString, (errorAndLog last ifNil: [''] ifNotNil: [:log| ': ', log])! !

!CogProcessorAlien methodsFor: 'execution' stamp: 'eem 1/27/2009 15:20'!
runInMemory: aMemory
	| result |
	result := self primitiveRunInMemory: aMemory minimumAddress: 0 readOnlyBelow: 0.
	result ~~ self ifTrue:
		[self error: 'eek!!']! !

!CogProcessorAlien methodsFor: 'execution' stamp: 'tpr 5/8/2014 08:24'!
runInMemory: aMemory minimumAddress: minimumAddress readOnlyBelow: minimumWritableAddress
"Note that minimumWritableAddress is both the minimum writeable address AND the maximum executable address"
	| result |
	result := self primitiveRunInMemory: aMemory
				minimumAddress: minimumAddress
				readOnlyBelow: minimumWritableAddress.
	result ~~ self ifTrue:
		[self error: 'eek!!']! !

!CogProcessorAlien methodsFor: 'execution' stamp: 'eem 10/21/2010 11:03'!
runInMemory: aMemory readExecuteOnlyBelow: minWriteMaxExecAddr
	| result |
	result := self primitiveRunInMemory: aMemory minimumAddress: 0 readOnlyBelow: minWriteMaxExecAddr.
	result ~~ self ifTrue:
		[self error: 'eek!!']! !

!CogProcessorAlien methodsFor: 'execution' stamp: 'eem 10/21/2010 10:58'!
singleStepIn: aMemory
	| result |
	result := self primitiveSingleStepInMemory: aMemory minimumAddress: 0 readOnlyBelow: aMemory size.
	result ~~ self ifTrue:
		[self error: 'eek!!']! !

!CogProcessorAlien methodsFor: 'execution' stamp: 'eem 1/27/2009 15:17'!
singleStepIn: aMemory minimumAddress: minimumAddress readOnlyBelow: minimumWritableAddress
	| result |
	result := self primitiveSingleStepInMemory: aMemory
				minimumAddress: minimumAddress
				readOnlyBelow: minimumWritableAddress.
	result ~~ self ifTrue:
		[self error: 'eek!!']! !

!CogProcessorAlien methodsFor: 'execution' stamp: 'eem 10/21/2010 11:05'!
singleStepIn: aMemory readExecuteOnlyBelow: minWriteMaxExecAddr
	| result |
	result := self primitiveSingleStepInMemory: aMemory minimumAddress: 0 readOnlyBelow: minWriteMaxExecAddr.
	result ~~ self ifTrue:
		[self error: 'eek!!']! !

!CogProcessorAlien methodsFor: 'accessing-abstract' stamp: 'lw 8/8/2012 11:50'!
smashRegisterAccessors
	self subclassResponsibility! !

!CogProcessorAlien methodsFor: 'accessing-abstract' stamp: 'lw 8/8/2012 11:50'!
smashRegistersWithValuesFrom: base by: step
	self smashRegisterAccessors
	   withIndexDo:
		[:accessor :index|
		self perform: accessor with: index - 1 * step + base]! !

!CogProcessorAlien methodsFor: 'accessing-abstract' stamp: 'eem 12/9/2015 10:51'!
zeroFloatingPointRegisters
	self floatingPointRegisterStateSetters do:
		[:setter| self perform: setter with: 0]! !

CogProcessorAlien variableByteSubclass: #GdbARMAlien
	instanceVariableNames: ''
	classVariableNames: 'BadCPUInstance ExecutionError InstructionPrefetchError LongConstReg LongConstStep LongConstValue MemoryLoadBoundsError MemoryWriteBoundsError NoError PanicError PostBuildStackDelta SomethingLoggedError UnsupportedOperationError'
	poolDictionaries: ''
	category: 'Cog-Processors'!

!GdbARMAlien commentStamp: 'lw 8/23/2012 19:17' prior: 0!
I am a wrapper around the ARMulator CPU instance and emulator routines and I give access to disassembling using libopcodes. My C-part must be compiled with -DMODET, because otherwise my offesets are wrong by one field.!

!GdbARMAlien class methodsFor: 'instance creation' stamp: 'eem 5/23/2016 17:55'!
dataSize
	^1792! !

!GdbARMAlien class methodsFor: 'class initialization' stamp: 'eem 3/26/2015 11:25'!
initialize
	"GdbARMAlien initialize"

	PostBuildStackDelta := 0.

	"Return errors from GdbARMPlugin.h"
	NoError := 0.
	ExecutionError := 1.
	BadCPUInstance := 2.
	MemoryLoadBoundsError := 3.
	MemoryWriteBoundsError := 4.
	InstructionPrefetchError := 5.
	PanicError := 6.
	UnsupportedOperationError := 7.
	SomethingLoggedError := 8! !

!GdbARMAlien class methodsFor: 'primitives' stamp: 'lw 6/25/2012 15:35'!
primitiveNewCPU
	"Answer the address of a new ARMulator C type ARMul_State instance."
	<primitive: 'primitiveNewCPU' module: 'GdbARMPlugin'>
	^self primitiveFailed! !

!GdbARMAlien methodsFor: 'Cog API' stamp: 'lw 7/2/2012 11:50'!
abstractInstructionCompilerClass
	^CogARMCompiler! !

!GdbARMAlien methodsFor: 'Cog API' stamp: 'lw 7/31/2012 14:44'!
bitsInWord
	^32! !

!GdbARMAlien methodsFor: 'opcodes' stamp: 'tpr 5/5/2014 16:35'!
byteSwappedNopOpcode
	"For the Tsts class which keeps filling BitMaps with nop, provide one swapped so it turns out correct when disassembled
	mov r0, r0 swapped -> "
	^ 16r00000A0E1! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 11/17/2012 21:39'!
cResultRegister
	self r0! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 11/17/2012 21:39'!
cResultRegister: aValue
	self r0: aValue! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:21'!
cflag
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 573! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 3/17/2015 15:53'!
cflag: unsignedInteger
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 573 put: unsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d0
	^self unsignedLongLongAt: 1533! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d0: anUnsignedInteger
	^self unsignedLongLongAt: 1533 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d1
	^self unsignedLongLongAt: 1541! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d10
	^self unsignedLongLongAt: 1613! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d10: anUnsignedInteger
	^self unsignedLongLongAt: 1613 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d11
	^self unsignedLongLongAt: 1621! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d11: anUnsignedInteger
	^self unsignedLongLongAt: 1621 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d12
	^self unsignedLongLongAt: 1629! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d12: anUnsignedInteger
	^self unsignedLongLongAt: 1629 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d13
	^self unsignedLongLongAt: 1637! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d13: anUnsignedInteger
	^self unsignedLongLongAt: 1637 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d14
	^self unsignedLongLongAt: 1645! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d14: anUnsignedInteger
	^self unsignedLongLongAt: 1645 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d15
	^self unsignedLongLongAt: 1653! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d15: anUnsignedInteger
	^self unsignedLongLongAt: 1653 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d16
	^self unsignedLongLongAt: 1661! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d16: anUnsignedInteger
	^self unsignedLongLongAt: 1661 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d17
	^self unsignedLongLongAt: 1669! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d17: anUnsignedInteger
	^self unsignedLongLongAt: 1669 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d18
	^self unsignedLongLongAt: 1677! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d18: anUnsignedInteger
	^self unsignedLongLongAt: 1677 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d19
	^self unsignedLongLongAt: 1685! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d19: anUnsignedInteger
	^self unsignedLongLongAt: 1685 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d1: anUnsignedInteger
	^self unsignedLongLongAt: 1541 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d2
	^self unsignedLongLongAt: 1549! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d20
	^self unsignedLongLongAt: 1693! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d20: anUnsignedInteger
	^self unsignedLongLongAt: 1693 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d21
	^self unsignedLongLongAt: 1701! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d21: anUnsignedInteger
	^self unsignedLongLongAt: 1701 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d22
	^self unsignedLongLongAt: 1709! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d22: anUnsignedInteger
	^self unsignedLongLongAt: 1709 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d23
	^self unsignedLongLongAt: 1717! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d23: anUnsignedInteger
	^self unsignedLongLongAt: 1717 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d24
	^self unsignedLongLongAt: 1725! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d24: anUnsignedInteger
	^self unsignedLongLongAt: 1725 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d25
	^self unsignedLongLongAt: 1733! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d25: anUnsignedInteger
	^self unsignedLongLongAt: 1733 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d26
	^self unsignedLongLongAt: 1741! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d26: anUnsignedInteger
	^self unsignedLongLongAt: 1741 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d27
	^self unsignedLongLongAt: 1749! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d27: anUnsignedInteger
	^self unsignedLongLongAt: 1749 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d28
	^self unsignedLongLongAt: 1757! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d28: anUnsignedInteger
	^self unsignedLongLongAt: 1757 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d29
	^self unsignedLongLongAt: 1765! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d29: anUnsignedInteger
	^self unsignedLongLongAt: 1765 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d2: anUnsignedInteger
	^self unsignedLongLongAt: 1549 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d3
	^self unsignedLongLongAt: 1557! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d30
	^self unsignedLongLongAt: 1773! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d30: anUnsignedInteger
	^self unsignedLongLongAt: 1773 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d31
	^self unsignedLongLongAt: 1781! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d31: anUnsignedInteger
	^self unsignedLongLongAt: 1781 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d3: anUnsignedInteger
	^self unsignedLongLongAt: 1557 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d4
	^self unsignedLongLongAt: 1565! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d4: anUnsignedInteger
	^self unsignedLongLongAt: 1565 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d5
	^self unsignedLongLongAt: 1573! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d5: anUnsignedInteger
	^self unsignedLongLongAt: 1573 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d6
	^self unsignedLongLongAt: 1581! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d6: anUnsignedInteger
	^self unsignedLongLongAt: 1581 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d7
	^self unsignedLongLongAt: 1589! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d7: anUnsignedInteger
	^self unsignedLongLongAt: 1589 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d8
	^self unsignedLongLongAt: 1597! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d8: anUnsignedInteger
	^self unsignedLongLongAt: 1597 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d9
	^self unsignedLongLongAt: 1605! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 5/23/2016 17:55'!
d9: anUnsignedInteger
	^self unsignedLongLongAt: 1605 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'disassembly' stamp: 'eem 6/18/2015 14:50'!
decorateDisassembly: anInstructionString for: aSymbolManager fromAddress: address
"Decode what we can of the instruction and decorate it with useful stuff"
	| word opcode rotate mode operand memory addressinatorBlock|
	addressinatorBlock :=
		[:value| | string |
		(value notNil
		 and: [(string := aSymbolManager lookupAddress: value) notNil])
			ifTrue: [ ' = ', value hex, ' = ', string]
			ifFalse: ['']].
	
	word := (memory:= aSymbolManager objectMemory) longAt: address.
	(self instructionIsAnyB: word)
		ifTrue:
			[((self instructionIsB: word) or: [self instructionIsBL: word]) ifTrue:
				["We can extract the offset from a plain B/BL instruction"
				 operand := self extractOffsetFromBL: word..
				 operand := operand + address + 8 bitAnd: aSymbolManager addressSpaceMask].
			"We can't extract the offset from a  BX/BLX instructions register, unless we're at the current pc,
			 because otherwise its current value has nothing to do with the value when this instruction is executed."
			(self pc = address
			 and: [(self instructionIsBX: word) or: [self instructionIsBLX: word]]) ifTrue:
					[operand := (self perform: (self registerStateGetters at: (word bitAnd: 15) + 1))]]
		ifFalse:
			[(self instructionIsAnyLoadStore: word)
				ifTrue:
					[|baseR lit|
					"first see if this is a load via the varBase register - quick access globals. We'll trust
					that nobody makes a nasty instruction that uses this reg in a mean way" 
					operand := (baseR := (word >> 16 bitAnd: 15)) = CogARMCompiler VarBaseReg
									ifTrue: [aSymbolManager varBaseAddress + (word bitAnd: 1 << 12 - 1)]
									ifFalse: [self pc = address ifTrue:
												[(self register: baseR) + (self extractOffsetFromLoadStore: word)]].
					"See if this is a pc-relative literal load"
					baseR = CogARMCompiler PCReg ifTrue:
						[lit := memory longAt: (aSymbolManager backEnd pcRelativeAddressAt: address).
						 ^(aSymbolManager lookupAddress: lit)
							ifNotNil: [:label| anInstructionString, ' ', label]
							ifNil: [anInstructionString, ' ', lit hex]].
					"look for SP operations -pop/push"
					 (self instructionIsPush: word) ifTrue: "push - "
						[|srcR|
						srcR := word >>12 bitAnd: 16rF.
						^ (anInstructionString readStream upTo: $}), '}', (self pc = address ifTrue: ['  (', (self register: srcR) hex, ') to ',  (self sp - 4) hex] ifFalse: [''])].
					(self instructionIsPop: word) ifTrue: "pop - " 
						[^ (anInstructionString readStream upTo: $}), '}', (self pc = address ifTrue: ['  (', (memory longAt: self sp) hex, ') ' , ' from ' , self sp hex] ifFalse: [''])].

					"look for a ld/st of the sp"
					(self instructionIsLDRSP: word) ifTrue:
						[^anInstructionString, '; Load SP from ', (addressinatorBlock value: operand)].
					(self instructionIsSTRSP: word) ifTrue:
						[^anInstructionString, '; Save SP to ', (addressinatorBlock value: operand)]]
				ifFalse:
					["check for SP changers not relating to read/writing data"
					 (self instructionIsAlignSP: word) ifTrue:
						[^anInstructionString, ' ALIGN SP ', (self pc = address ifTrue: [self sp hex] ifFalse: [''])].
					 (self instructionIsAddSP: word) ifTrue:
						[^anInstructionString, ' ADD ', (word bitAnd: 16rFF) asString,' to SP ', (self pc = address ifTrue: ['= ' , self sp hex] ifFalse: [''])].

					 "check for the end of a mov/orr/orr/orr set filling a reg with a const"
					 opcode := word >> 21 bitAnd: 16rF.
					 (opcode ~= CogARMCompiler orOpcode
					  or: [aSymbolManager cogit backEnd literalLoadInstructionBytes = 4]) ifTrue:
						[^anInstructionString].
					 rotate := word >> 8 bitAnd: 16rF.
					 mode := word >> 25 bitAnd: 7.
					 "CogARMCompiler always uses a 0 rotate in the last operand of the final ORR when building long constants."
					 (mode = 1 and: [rotate ~= 0]) ifTrue:
						[^anInstructionString].
					 operand := aSymbolManager backEnd literalBeforeFollowingAddress: address + 4]].
	"is there an interesting address with this?"
	^anInstructionString, (addressinatorBlock value: operand)! !

!GdbARMAlien methodsFor: 'disassembly' stamp: 'eem 9/6/2016 11:58'!
disassembleFrom: startAddress to: endAddress in: memory for: aSymbolManager "<Cogit>" labels: labelDictionary on: aStream
	| address |
	address := startAddress.
	[address <= endAddress] whileTrue:
		[[:sizeArg :stringArg| | size string index offset |
		size := sizeArg.
		string := stringArg.
		(aSymbolManager labelForPC: address) ifNotNil:
			[:label| aStream nextPutAll: label; nextPut: $:; cr].
		(labelDictionary at: address ifAbsent: []) ifNotNil:
			[:label|
			self printLabel: label on: aStream at: address for: aSymbolManager.
			label isArray ifTrue:
				[string := nil.
				 size := label third]].
		string ifNotNil:
			[aStream nextPutAll: (self decorateDisassembly: string for: aSymbolManager fromAddress: address).
			 (string includesSubString: ': ldr	') ifTrue:"i.e. colon space 'ldr' tab" 
				[(index := string indexOfSubCollection: ' [pc, #' startingAt: 1) > 0
					ifTrue:
						[offset := Integer readFrom: (ReadStream on: string from: index + 7 to: (string indexOf: $] startingAt: index + 7) - 1)]
					ifFalse:
						[(string indexOfSubCollection: ' [pc]' startingAt: 1) > 0 ifTrue:
							[offset := 0]].
				 offset ifNotNil:
					[offset := address + 8 + offset.
					 labelDictionary
						at: offset
						ifPresent:
							[:entry|
							entry isString
								ifTrue: [labelDictionary at: offset put: {#literal. offset. 4. entry}]
								ifFalse: [self assert: (entry isArray and: [entry first == #literal])]]
						ifAbsentPut: [{#literal. offset. 4}]]]].
		aStream cr; flush.
		address := address + size]
			valueWithArguments: (self
									primitiveDisassembleAt: address
									inMemory: memory)].
	(labelDictionary at: address ifAbsent: []) ifNotNil:
		[:label| self printLabel: label on: aStream at: address for: aSymbolManager]! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/11/2012 11:09'!
eflags
	
	^ (((self nflag << 5 bitOr: self zflag << 4) 
			bitOr: self cflag << 3) 
				bitOr: self vflag << 2)
					bitOr: self ifflags! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 3/17/2015 18:05'!
eflags: anUnsignedInteger
	"set the processor flags from the integer"
	self nflag: (anUnsignedInteger >> 5 bitAnd: 1).
	self zflag: (anUnsignedInteger >> 4 bitAnd: 1).
	self cflag: (anUnsignedInteger >> 3 bitAnd: 1).
	self vflag: (anUnsignedInteger >> 2 bitAnd: 1).
	self ifflags: (anUnsignedInteger bitAnd: 3)! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 5/6/2014 13:45'!
endCondition
"why did the simulator stop?"
	^self unsignedLongAt: 5! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 7/12/2012 22:16'!
endianness
	^#little! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 5/6/2014 13:45'!
errorCode
"simulator error code"
	^self unsignedLongAt: 9! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/2/2014 15:47'!
extractOffsetFromBL: instr
"we are told this is a BL <offset> instruction, so work out the offset it encodes"
	| relativeJump |
	relativeJump := instr bitAnd: 16r00FFFFFF.
	relativeJump := (relativeJump bitAt: 24) = 1 
						ifTrue: [((relativeJump bitOr: 16r3F000000) << 2) signedIntFromLong]
						ifFalse: [relativeJump << 2].
	^relativeJump! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'tpr 3/30/2015 21:04'!
extractOffsetFromLoadStore: instr
"work out the address offset implied by instr.
We assume it has been determined it is actually a load store before attaching any meaning to the result.
If it is post-indexed, then the offset must be 0, no matter what else is encoded.
If the instr is immediate-offset, pull the relevent bits out of instr.
If it is register-offset, pull the value from the indicated register."
	|offset shiftAmt shiftType |

	"post-indexed means no offset to the read address"
	(instr bitAnd: 1 << 24) = 0 ifTrue:[^0].
	
	(self instructionIsImmediateOffsetLoadStore: instr)
		ifTrue:["two cases apply - a 12bit immediate for 010 group instructions and an 8bit for 000 group ldrh stuff"
			(instr >> 25 bitAnd: 7) = 2
				ifTrue:[ "immed word or byte op, with 12bit offset"
					offset := instr bitAnd: 16rFFF]
				ifFalse:["halfword 8bit offset"
					offset := (instr bitAnd: 16rF00)>>4 bitOr: (instr bitAnd: 16rF)]].

	(self instructionIsRegisterOffsetLoadStore: instr)
		ifTrue:["both forms use same offset-reg encoding"
			offset := self perform:(self registerStateGetters at:(instr bitAnd: 16rF) + 1).
			(instr >> 25 bitAnd: 7) = 3
				ifTrue:[ "register offset with assorted modifiers"
					"sort out modifiers"
					shiftType := instr >> 5 bitAnd: 3.
					shiftAmt := instr  >>7 bitAnd: 16r1F.
					shiftType = 0"lsl" ifTrue:[offset := offset << shiftAmt.].
					shiftType = 1"lsr" ifTrue:[offset := offset >> shiftAmt].
					shiftType = 2"asr" ifTrue:[offset := offset  >>> shiftAmt].
					"I refuse to countenance using ROR or RRX here. Just Say No" ]
				"halfword stuff register offset uses no modifiers in the form we suport. See ARM DDI0406A p. A8-156"].

	"all forms have the bit 23 up/down flag to account for"
	(instr bitAnd: 1<<23) = 0
						ifTrue:["-ve offset" ^offset negated]
						ifFalse:["+ve offset" ^offset]	! !

!GdbARMAlien methodsFor: 'execution' stamp: 'lw 7/31/2012 11:52'!
flushICacheFrom: startAddress "<Integer>" to: endAddress "<Integer>"
	self primitiveFlushICacheFrom: startAddress To: endAddress! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 5/31/2014 12:02'!
fp
"fp is r11"
	^self r11! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 5/31/2014 12:06'!
fp: anUnsignedInteger

	^self r11: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 5/23/2016 17:56'!
fpCPSR
"The VFP cpsr flags are kept as a single word in the Alien structure. Return just the top 4 bits, the actual flags"
	^(self unsignedLongAt: 1789) >>28! !

!GdbARMAlien methodsFor: 'floating-point emulation' stamp: 'tpr 5/20/2016 10:35'!
handleBasicDoubleArithmetic: instr at: pc
	"Emulate a basic math - add/sub/mul/div -  VFP instruction."
	| rn rd rm vn vm |
	rn := instr >> 16 bitAnd: 15.
	rd := instr >> 12 bitAnd: 15.
	rm := instr bitAnd: 15.
	vn := Float fromIEEE64BitWord: (self perform: (self registerStateGetters at: rn + 18)). "Assume accesses fp regs"
	vm := Float fromIEEE64BitWord: (self perform: (self registerStateGetters at: rm + 18)). "Assume accesses fp regs"

	"simplest to match the entire instruction pattern rather than mess around shifting and masking and merging"
	(instr  bitAnd: 16rFF00FF0)
		caseOf: {
		[16rE200B00 "FMULD"]	->
			[| r |
			 r := vn * vm.
			 self perform: (self registerStateSetters at: rd + 18) with: r asIEEE64BitWord].
		[16rE300B00 "FADDD"]	->
			[| r |
			 r := vn + vm.
			 self perform: (self registerStateSetters at: rd + 18) with: r asIEEE64BitWord].
		[16rE300B40 "FSUBD"]	->
			[| r |
			 r := vn - vm.
			 self perform: (self registerStateSetters at: rd + 18) with: r asIEEE64BitWord].
		[16rE800B00"FDIVD"]	->
			[| r |
			 r := vn / vm.
			 self perform: (self registerStateSetters at: rd + 18) with: r asIEEE64BitWord].}
		otherwise: [self reportPrimitiveFailure].
	self pc: pc + 4! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'tpr 5/6/2014 14:18'!
handleExecutionPrimitiveFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Handle an execution primitive failure for an otherwise unhandled opcode."
	^self reportPrimitiveFailure! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'eem 5/9/2016 15:33'!
handleExecutionPrimitiveFailureIn: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>"
	"Handle an execution primitive failure.  Convert out-of-range call and absolute
	 memory read into register instructions into ProcessorSimulationTrap signals."
	"self printRegistersOn: Transcript"
	| pcOnEntry pc instr |
	pc := pcOnEntry := self pc.
	self endCondition = InstructionPrefetchError ifTrue:
		[pc := self pc: self priorPc].

	(pc between: minimumAddress and: memoryArray byteSize - 1) ifTrue:
		[instr := memoryArray unsignedLongAt:  pc + 1 bigEndian: false.

		 (self endCondition = InstructionPrefetchError) ifTrue:
			[^self handleFailingBranch: instr to: pcOnEntry at: pc].

		 (self instructionIsAnyLoadStore: instr) ifTrue:
			[^self handleFailingLoadStore: instr at: pc].

		 (self instructionIsAnyFPArithmetic: instr) ifTrue:
			[^self handleFailingFPArithmetic: instr at: pc].

		 ^self handleExecutionPrimitiveFailureAt: pc in: memoryArray].

	^self reportPrimitiveFailure! !

!GdbARMAlien methodsFor: 'floating-point emulation' stamp: 'tpr 5/20/2016 11:04'!
handleExtendedDoubleArithmetic: instr at: pc
	"Emulate an extended math - cmp/sqrt/sitod -  VFP instruction."
	| rn rd rm vn vm vd |
	rn := instr >> 16 bitAnd: 15.
	rd := instr >> 12 bitAnd: 15.
	rm := instr bitAnd: 15.
	vn := Float fromIEEE64BitWord: (self perform: (self registerStateGetters at: rn + 18)). "Assume accesses fp regs"
	vm := Float fromIEEE64BitWord: (self perform: (self registerStateGetters at: rm + 18)). "Assume accesses fp regs"

	"simplest to match the entire instruction pattern rather than mess around shifting and masking and merging"
	(instr  bitAnd: 16rFF00FF0)
		caseOf: {
		[16rEB80B80 "FCMPD"]	->
			["read rd, compare with rm (ignore rn) and set FPSCR NZCV flags. Sigh"
				vd := Float fromIEEE64BitWord: (self perform: (self registerStateGetters at: rd + 18)).
				self break].
		[16rEB80BC0 "FSITOD"]	->
			[| r |
			 r := vm asFloat.
			 self perform: (self registerStateSetters at: rd + 18) with: r asIEEE64BitWord].
		[16rEB10BC0 "FSQRTD"]	->
			[| r |
			 r := vm sqrt.
			 self perform: (self registerStateSetters at: rd + 18) with: r asIEEE64BitWord].
		}
		otherwise: [self reportPrimitiveFailure].
	self pc: pc + 4! !

!GdbARMAlien methodsFor: 'floating-point emulation' stamp: 'tpr 5/20/2016 17:29'!
handleFPLoadStore: instr at: pc
	"Emulate a VFP load/store instruction."
	| rn rd offset |
	rn := instr >> 16 bitAnd: 15.
	rd := instr >> 12 bitAnd: 15.
	offset := instr bitAnd: 16rFF.

	"examine the U and Lbits"
	(instr >>20  bitAnd: 16rF)
		caseOf: {
		[0"Store neg"]	->
			[| r addr|
			addr := (self register: rn) - (offset<<2).
			 r := self perform: (self registerStateGetters at: rd + 18).
			 self unsignedLongLongAt: addr put: r].
		[1"Load neg"]	->
			[| r addr|
			addr := (self register: rn) - (offset<<2).
			r := self unsignedLongLongAt: addr.
			 self perform: (self registerStateSetters at: rd + 18) with: r ].
		[8"Store pos"]	->
			[| r addr|
			addr := (self register: rn) + (offset<<2).
			 r := self perform: (self registerStateGetters at: rd + 18).
			 self unsignedLongLongAt: addr put: r].
		[9"Load pos"]	->
			[| r addr|
			addr := (self register: rn) + (offset<<2).
			r := self unsignedLongLongAt: addr.
			 self perform: (self registerStateSetters at: rd + 18) with: r ].}
		otherwise: [self reportPrimitiveFailure].
	self pc: pc + 4! !

!GdbARMAlien methodsFor: 'floating-point emulation' stamp: 'tpr 5/20/2016 16:48'!
handleFPStatus: instr at: pc
	"Emulate transferring the FP status to the ARM CPSR."
	| fpcpsr |
	fpcpsr := self fpCPSR.
	self vflag: (fpcpsr bitAnd: 1).
	self cflag: ((fpcpsr >>1) bitAnd: 1).
	self zflag: ((fpcpsr >>2) bitAnd: 1).
	self nflag: ((fpcpsr >>3) bitAnd: 1).
	self pc: pc + 4! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'eem 3/28/2015 10:28'!
handleFailingBranch: instr to: address at: pc
	(self instructionIsBL: instr) ifTrue:
		[self assert: address = (pc + 8 + (self extractOffsetFromBL: instr)) signedIntToLong.
		 ^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 4
				address: (pc + 8 + (self extractOffsetFromBL: instr)) signedIntToLong
				type: #call)
			signal].
	(self instructionIsBLX: instr) ifTrue:
		[self assert: address = (self perform: (self registerStateGetters at: (instr bitAnd: 15) + 1)).
		 ^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 4
				address: (self perform: (self registerStateGetters at: (instr bitAnd: 15) + 1))
				type: #call)
			signal].
	(self instructionIsBX: instr) ifTrue:
		[self assert: address = (self perform: (self registerStateGetters at: (instr bitAnd: 15) + 1)).
		 ^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 4
				address: (self perform: (self registerStateGetters at: (instr bitAnd: 15) + 1))
				type: #jump)
			signal].
	(self instructionIsB: instr) ifTrue:
		[self assert: address = (pc + 8 + (self extractOffsetFromBL: instr)) signedIntToLong.
		 ^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 4
				address: (pc + 8 + (self extractOffsetFromBL: instr)) signedIntToLong
				type: #jump)
			signal].
	(self instructionIsReturnViaLR: instr) ifTrue:
		[^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 4
				address: self lr
				type: #return)
			signal].
	^self reportPrimitiveFailure! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'tpr 5/20/2016 17:52'!
handleFailingFPArithmetic: instr at: pc
	
	"basic arithmetic"
	(instr bitAnd: 16rF400FB0) = 16rE000B00 ifTrue:
		[^self handleBasicDoubleArithmetic: instr at: pc].
	
	"extension instructions sqrt/cmp/sitod"
	(instr bitAnd: 16rFF00F70) = 16rEB00B40 ifTrue:
		[^self handleExtendedDoubleArithmetic: instr at: pc].
	
	"move ARM reg to coproc reg. "
	(instr bitAnd: 16rFF00FFF) = 16rE000A10 ifTrue:
		[^self handleRegToDoubleTransfer: instr at: pc].

	"move FPSCR reg to ARM CPSR"
	(instr bitAnd: 16rFFFFFFF) = 16rEF1FA10 ifTrue:
		[^self handleFPStatus: instr at: pc].

	"load and store ops. All doubles; we only use FLDD & FSTD"
	(instr bitAnd: 16rF600F00) = 16rD000B00 ifTrue:
		[^self handleFPLoadStore: instr at: pc].
	
	
	^self reportPrimitiveFailure! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'tpr 3/31/2015 13:00'!
handleFailingLoadStore: instr at: pc
	"See e.g. ARM DDI0406A pp. A8-120, 124, 128, 132, 152, 156, etc. etc"
	| baseReg destReg srcReg offset |

	"find the register used as the base of the address and the register to load into or store from"
	baseReg := self registerStateGetters at: (instr >> 16 bitAnd: 15)+ 1.
	srcReg :=  self registerStateGetters at: (instr >> 12 bitAnd: 15)+ 1.
	destReg := self registerStateSetters at: (instr >> 12 bitAnd: 15) + 1.

	"work out the relevant offset, whether an immediate or register value"
	offset := self extractOffsetFromLoadStore: instr.
	
	(self instructionIsLDR: instr) ifTrue:
		[^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 4 
				address: (self perform: baseReg) + offset
				type: #read
				accessor: destReg)
			signal].
	(self instructionIsLDRB: instr) ifTrue:
		[^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 4 
				address: (self perform: baseReg) + offset
				type: #read
				accessor: destReg)
			signal].
	(self instructionIsLDRH: instr) ifTrue:
		[^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 4 
				address: (self perform: baseReg) + offset
				type: #read
				accessor: destReg)
			signal].
	(self instructionIsSTR: instr) ifTrue:
		[^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 4 
				address: (self perform: baseReg) + offset
				type: #write
				accessor: srcReg)
			signal].
	(self instructionIsSTRB: instr) ifTrue:
		[^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 4 
				address: (self perform: baseReg) + offset
				type: #write
				accessor: srcReg)
			signal].
	(self instructionIsSTRH: instr) ifTrue:
		[^(ProcessorSimulationTrap
				pc: pc
				nextpc: pc + 4 
				address: (self perform: baseReg) + offset
				type: #write
				accessor: srcReg)
			signal].

	self error: 'handleFailingLoadStore:at: invoked for non-load/store?'! !

!GdbARMAlien methodsFor: 'floating-point emulation' stamp: 'eem 5/10/2016 11:47'!
handleOneRegTransferDoubleArithmetic: instr at: pc
	"Emulate a one-register transfer VFP instruction."
	| rn rd rm vn vm |
	rn := instr >> 16 bitAnd: 15.
	rd := instr >> 12 bitAnd: 15.
	rm := instr bitAnd: 15.
	vn := Float fromIEEE64BitWord: (self perform: (self registerStateGetters at: rn + 18)). "Assume accesses fp regs"
	vm := Float fromIEEE64BitWord: (self perform: (self registerStateGetters at: rm + 18)). "Assume accesses fp regs"
	(instr >> 18 bitAnd: 31)
		caseOf: {
		[8 "FMULD"]	->
			[| r |
			 r := vn * vm.
			 self perform: (self registerStateSetters at: rd + 18) with: r asIEEE64BitWord].
		[12"FADDD/FSUBD"]	->
			[self shouldBeImplemented].
		[32"FDIVD"]	->
			[self shouldBeImplemented].
		[45"FCMPD"]	->
			[self shouldBeImplemented]. }
		otherwise: [self reportPrimitiveFailure].
	self pc: pc + 4! !

!GdbARMAlien methodsFor: 'floating-point emulation' stamp: 'tpr 5/20/2016 16:24'!
handleRegToDoubleTransfer: instr at: pc
	"Emulate an ARM to VFP instruction."
	| rn rd vn |
	rn := (instr >> 16 bitAnd: 15) << 1 bitOr: (instr >>6 bitAnd: 1).
	rd := instr >> 12 bitAnd: 15.
	vn := self register: rn.

	self perform: (self registerStateSetters at: rd + 18) with: vn.
	self pc: pc + 4! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:22'!
ifflags
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 581! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 3/17/2015 15:56'!
ifflags: unsignedInteger
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 581 put: unsignedInteger! !

!GdbARMAlien methodsFor: 'processor setup' stamp: 'eem 10/22/2015 14:56:07'!
initializeStackFor: aCogit
	"Different cpus need different stack alignment etc, so handle the details here."
	aCogit setStackAlignment: 8 expectedSPOffset: 0 expectedFPOffset: 0.
	PostBuildStackDelta := 0! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/30/2015 17:24'!
instructionIsAddSP: instr
"is this an add sp, sp, #? -  instruction?"
	^instr >> 28 < 16rF "test for allowed condcode - 0xF is extension" and: [(instr bitAnd: (16rFFFFF00)) = (16r28DD000)]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/30/2015 17:24'!
instructionIsAlignSP: instr
"is this a subs sp, sp, #4 -  instruction?"
	^instr >> 28 < 16rF "test for allowed condcode - 0xF is extension" and: [(instr bitAnd: (16rFFFFFFF)) = (16r2DDD004)]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/30/2015 16:13'!
instructionIsAnyB: instr 
	"is this any of the B BX BL or BLX <offset> instructions?"
	^ (self instructionIsB: instr)
		or: [self instructionIsBL: instr]
		or: [self instructionIsBLX: instr]
		or: [self instructionIsBX: instr]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/20/2016 17:44'!
instructionIsAnyFPArithmetic: instr
	"Identify VFP instructions.
	 See C3.1 - C3.4 in the ARM ARM v5 DDI01001."
	| cp isFP |
	
	"All FP instructions are coprocessor instructions on coproc 10 or 11"
	cp := instr>>8 bitAnd: 16rF.
	isFP := cp = 10 or:[cp = 11].
	(isFP and: [(instr>>25 bitAnd: 7) = 6]) ifTrue: [^true].
	(isFP and: [(instr>>24 bitAnd: 16rF) = 16rE]) ifTrue: [^true].
	
	"nope"
	^false! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/30/2015 16:15'!
instructionIsAnyLoadStore: instr
	"is this any of the LDR,STR instructions?
	We handle byte, word, and halfword versions but NOT NOT signed extend, double or privileged versions"
	
	^(self instructionIsImmediateOffsetLoadStore: instr) or:[self instructionIsRegisterOffsetLoadStore: instr]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/30/2015 16:09'!
instructionIsB: instr
"is this a B <offset> instruction?"
	"first test for non-NV condition code; some important instructions use it"
	instr >> 28 = 16rF ifTrue:[^false].
	"See ARM DDI0406A p. A8-44"
	^ (instr bitAnd: (16rF<<24)) = (16rA<<24)! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/30/2015 16:10'!
instructionIsBL: instr
"is this a BL <offset> instruction?"
	"first test for non-NV condition code; some important instructions use it"
	instr >> 28 = 16rF ifTrue:[^false].
	"see ARM DDI0406A p. A8-58"
	^(instr bitAnd: (16rF<<24)) = (16rB<<24)! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/30/2015 16:08'!
instructionIsBLX: instr
"is this a BLX <targetReg> instruction? We DO NOT support the BLX immed version"
	"first test for non-NV condition code; some important instructions use it"
	instr >> 28 = 16rF ifTrue:[^false].
	"See ARM DDI0406A p A8-60"
 	^(instr bitAnd: 16r0FFFFFF0) = 16r12FFF30! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/30/2015 16:11'!
instructionIsBX: instr
"is this a BX <targetReg> instruction?"
	"first test for non-NV condition code; some important instructions use it"
	instr >> 28 = 16rF ifTrue:[^false].
	"See ARM DDI0406A p. A8-62"
 	^(instr bitAnd: 16r0FFFFFF0) = 16r12FFF10! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/31/2015 13:07'!
instructionIsImmediateOffsetLoadStore: instr
	"is this any of the immediate offset LDR,STR instructions?"
	| op1 |
	"first test for non-NV condition code; some important instructions use it"
	instr >> 28 = 16rF ifTrue:[^false].
	"test for 010 group of load/stores"
	op1 := instr >>25 bitAnd: 7.
	op1 = 2 ifTrue:[^true].

	"test for the ridiculously muddled 000 group"
	op1 > 0 ifTrue:[^false].
	"bit 21 must not be 1 and bit 22 must be 1"
	(instr bitAnd: 3 <<21) = (2<<21) ifFalse:[^false].
	"bits 4:7need to be 16rB for our purpose"
	^(instr bitAnd: 16rF0) = 16rB0
	
	! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/30/2015 16:42'!
instructionIsLDR: instr
"is this a LDR instruction?"
	| foo |
	"first test for non-NV condition code; some important instructions use it"
	instr >> 28 = 16rF ifTrue:[^false].
	"See ARM DDI0406A p. A8-120"
	foo := (instr >> 20 bitAnd: 16rE5).
	^foo = 16r41 "ldr r1, [r2, #+/-imm]"
		or:[foo = 16r61 "ldr r1, [r2, r3]"]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/30/2015 16:42'!
instructionIsLDRB: instr
"is this a LDRB instruction?"
	| foo |
	"first test for non-NV condition code; some important instructions use it"
	instr >> 28 = 16rF ifTrue:[^false].
	"See ARM DDI0406A p. A8-128"
	foo := (instr >> 20 bitAnd: 16rE5).
	^foo = 16r45 "ldrb r1, [r2, #+/-imm]"
		or:[foo = 16r65 "ldrb r1, [r2, r3]"]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/30/2015 16:49'!
instructionIsLDRH: instr
"is this a LDRH instruction?"
	| foo |
	"first test for non-NV condition code; some important instructions use it"
	instr >> 28 = 16rF ifTrue:[^false].
	"See ARM DDI0406A p. A8-154"
	(instr bitAnd: 16rF0) = 16rB0 ifFalse:[^false].
	foo := (instr >> 20 bitAnd: 16rE3).
	^foo = 16r3 "ldrh r1, [r2, #+/-imm]"
		or:[foo = 16r1 "ldrh r1, [r2, r3]"]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/29/2014 16:22'!
instructionIsLDRSP: instr
"is this a LDR sp, [??] instruction? Special case to detect LDR sp, [] affecting stack pointer"
	^(self instructionIsLDR: instr)  and:[(instr >>12 bitAnd: 16rF) = 13]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/29/2014 03:06'!
instructionIsPop: instr
"is this a pop - ldr r??, [sp], #4 -  instruction?"
	^instr >> 28 < 16rF "test for allowed condcode - 0xF is extension" and: [(instr bitAnd: (16rFFF0FFF)) = (16r49D0004)]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/29/2014 03:08'!
instructionIsPush: instr
"is this a push -str r??, [sp, #-4] -  instruction?"
	^instr >> 28 < 16rF "test for allowed condcode - 0xF is extension" and: [(instr bitAnd: (16rFFF0FFF)) = (16r52D0004)]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/30/2015 16:15'!
instructionIsRegisterOffsetLoadStore: instr
	"is this any of the register offset LDR,STR instructions?"
	| op1 |
	"first test for non-NV condition code; some important instructions use it"
	instr >> 28 = 16rF ifTrue:[^false].
	
	op1 := instr >>25 bitAnd: 7.
	"test for the 011 group - check bit 4 as well"
	(op1 = 3 and:[(instr bitAnd: 16r10) = 0]) ifTrue:[^true].
	"test for the ridiculously muddled 000 group"
	op1 > 0 ifTrue:[^false].
	"bit 21 & 22 must not be 1"
	(instr bitAnd: 3 <<21) = 0 ifFalse:[^false].
	"bits 4:7need to be 16rB for our purpose"
	^(instr bitAnd: 16rF0) = 16rB0
	
	! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/28/2014 03:45'!
instructionIsReturnViaLR: instr
"is this a MOV pc, lr instruction?"
	^instr =  16rE1A0F00E! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/31/2015 13:10'!
instructionIsSTR: instr
"is this a STR instruction?"
	| foo |
	"first test for non-NV condition code; some important instructions use it"
	instr >> 28 = 16rF ifTrue:[^false].
	"See ARM DDI0406A p. A8-382"
 	foo := (instr >> 20 bitAnd: 16rE5). 
	^foo = 16r40 "str r1, [r2, #+/-imm]" 
		or:[foo = 16r60] "str r1, [r2, #-imm]"! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/31/2015 13:10'!
instructionIsSTRB: instr
"is this a STRB instruction?"
	| foo |
	"first test for non-NV condition code; some important instructions use it"
	instr >> 28 = 16rF ifTrue:[^false].
	"See ARM DDI0406A p. A8-388"
 	foo := (instr >> 20 bitAnd: 16rE5). 
	^foo = 16r44 "strb r1, [r2, #+/-imm]" 
		or:[foo = 16r64] "strb r1, [r2, #-imm]"! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 3/30/2015 16:50'!
instructionIsSTRH: instr
"is this a STRH instruction?"
	| foo |
	"first test for non-NV condition code; some important instructions use it"
	instr >> 28 = 16rF ifTrue:[^false].
	"See ARM DDI0406A p. A8-154"
	(instr bitAnd: 16rF0) = 16rB0 ifFalse:[^false].
	foo := (instr >> 20 bitAnd: 16rE3).
	^foo = 16r4 "strh r1, [r2, #+/-imm]"
		or:[foo = 16r0 "strh r1, [r2, r3]"]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/29/2014 16:23'!
instructionIsSTRSP: instr
"is this a STR sp, [??] instruction? Special case to detect STR sp, [] affecting stack pointer"
	^(self instructionIsSTR: instr)  and:[(instr >>12 bitAnd: 16rF) = 13]! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'tpr 3/20/2015 13:05'!
integerRegisterState
	^{	self r0. self r1. self r2. self r3. self r4. self r5. self r6. self r7. self r8. 
		self r9. self sl. self fp. self r12. self sp. self lr. self pc}! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
lr
	^self unsignedLongAt: 69! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
lr: anUnsignedInteger

	^self unsignedLongAt: 69 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:22'!
nflag
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 565! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 3/17/2015 15:54'!
nflag: unsignedInteger
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 565 put: unsignedInteger! !

!GdbARMAlien methodsFor: 'opcodes' stamp: 'lw 8/8/2012 13:55'!
nopOpcode
	"mov r0, r0"
	^ 16rE1A00000! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
pc
	^self unsignedLongAt: 73! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
pc: anUnsignedInteger

	^self unsignedLongAt: 73 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'opcodes' stamp: 'tpr 5/2/2014 16:29'!
popPcOpcode
"See also CogARMCompiler>concretizePopR"
	^16rE49DF004! !

!GdbARMAlien methodsFor: 'execution' stamp: 'tpr 5/31/2014 14:23'!
popWordIn: aMemory 
	| sp word |
	word := aMemory unsignedLongAt: (sp := self sp) + 1 bigEndian: false.
	self sp: sp + 4.
	^word! !

!GdbARMAlien methodsFor: 'execution' stamp: 'eem 3/28/2015 12:12'!
postCallArgumentsNumArgs: numArgs "<Integer>" in: memory "<ByteArray|Bitmap>"
	"Answer an argument vector of the requested size after a vanilla
	 ABI call. For ARM the Procedure Calling Specification can be found in IHI0042D_aapcs.pdf.
	On ARM this typically means accessing r0 through r3 and fetching additional arguments from the stack, acording to pages 20f. aapcs.
	We assume that all arguments are single word arguments, which can not be supplied on co-processor-registers.
	 For compatibility with Cog/Slang we answer unsigned values."
	^(1 to: numArgs) collect: [:i |
		i < 5 
			ifTrue: [self perform: (self registerStateGetters at: i)]
			"ARM uses a full descending stack. Directly after calling a procedure, nothing but the arguments are pushed."
			ifFalse: [memory unsignedLongAt: self sp + (i-5)*4 bigEndian: false]].! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'lw 8/24/2012 19:10'!
primitiveDisassembleAt: address inMemory: memoryArray "<Bitmap|ByteArray>"
	"Answer an Array of the size and the disassembled code string for the instruction at the current instruction pointer in memory."
	<primitive: 'primitiveDisassembleAtInMemory' module: 'GdbARMPlugin'>
	^self primitiveFailed! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'lw 7/9/2012 20:27'!
primitiveErrorAndLog
	"Answer an array of the current error code and log contents"
	<primitive: 'primitiveErrorAndLog' module: 'GdbARMPlugin'>
	^self primitiveFailed! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'lw 7/31/2012 11:53'!
primitiveFlushICacheFrom: startAddress "<Integer>" To: endAddress "<Integer>"
	"Flush the icache in the requested range"
	<primitive: 'primitiveFlushICacheFromTo' module: 'GdbARMPlugin'>
	^self primitiveFailed! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'lw 7/2/2012 11:16'!
primitiveResetCPU
	"Reset the receiver to registers all zero, and protected 32-bit mode."
	<primitive: 'primitiveResetCPU' module: 'GdbARMPlugin'>
	^self reportPrimitiveFailure! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:22'!
primitiveRunInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" maximumAddress: maximimAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Run the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveRunInMemoryMinAddressMaxAddressReadWrite' module: 'GdbARMPlugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]

	"self printRegistersOn: Transcript"! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'tpr 5/8/2014 08:23'!
primitiveRunInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Run the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals.
	Note that minWriteMaxExecAddress is both the minimum writeable address AND the maximum executable address"
	<primitive: 'primitiveRunInMemoryMinimumAddressReadWrite' module: 'GdbARMPlugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]

	"self printRegistersOn: Transcript"! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:23'!
primitiveSingleStepInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" maximumAddress: maximimAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Single-step the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveSingleStepInMemoryMinAddressMaxAddressReadWrite' module: 'GdbARMPlugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:23'!
primitiveSingleStepInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Single-step the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveSingleStepInMemoryMinimumAddressReadWrite' module: 'GdbARMPlugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]! !

!GdbARMAlien methodsFor: 'printing' stamp: 'eem 12/9/2013 09:28'!
printFields: fields inRegisterState: registerStateVector on: aStream
	| rsvs |
	aStream ensureCr.
	rsvs := registerStateVector readStream.
	fields withIndexDo:
		[:sym :index| | val |
		sym = #cr
			ifTrue: [aStream cr]
			ifFalse:
				[(val := rsvs next) isNil ifTrue: [^self].
				aStream nextPutAll: sym; nextPut: $:; space.
				val printOn: aStream base: 16 length: 8 padded: true.
				#eflags == sym
					ifTrue:
						[aStream space.
						 "'FIVCZN'"'--VCZN' withIndexDo:
							[:flag :bitIndex|
							flag ~= $- ifTrue:
								[aStream nextPut: flag; nextPutAll: 'F='; print: (val bitAnd: 1 << (bitIndex - 1)) >> (bitIndex - 1); space]]]
					ifFalse:
						[val > 16 ifTrue:
							[aStream space; nextPut: $(.
							 val printOn: aStream base: 10 length: 1 padded: false.
							 aStream nextPut: $)]].
				(fields at: index + 1) ~~ #cr ifTrue:
					[aStream tab]]]! !

!GdbARMAlien methodsFor: 'printing' stamp: 'eem 9/6/2016 11:57'!
printLabel: label on: aStream at: address for: aSymbolManager
	"Print label on aStream.  The label is either a triple of {type, printer, size} or a simple string."
	label isArray
		ifTrue: [label first == #literal
					ifTrue:
						[label size = 4 ifTrue:
							[aStream nextPutAll: label last; nextPut: $:; cr].
						 aStream
							nextPutAll: (address printStringBase: 16 length: 8 padded: true) asLowercase;
							nextPut: $:; space;
							nextPutAll: ((aSymbolManager objectMemory longAt: address) printStringBase: 16 length: 8 padded: true) asLowercase.
						 (aSymbolManager lookupAddress: (aSymbolManager objectMemory longAt: address)) ifNotNil:
							[:name| aStream space; nextPutAll: name]]
					ifFalse:
						[aStream
							nextPutAll: label first;
							nextPut: $:; cr;
							nextPutAll: (address printStringBase: 16 length: 8 padded: true) asLowercase;
							nextPut: $:; space;
							nextPutAll: (aSymbolManager perform: label second with: address) asString]]
		ifFalse: [aStream nextPutAll: label; nextPut: $:; cr]! !

!GdbARMAlien methodsFor: 'printing' stamp: 'eem 5/10/2016 11:25'!
printOn: aStream
	| first |
	first := true.
	aStream nextPutAll: 'an ARMAlien ('.
	self registerState with: self registerStateGetters do: [ :state :getter |
		first
			ifTrue: [first := false]
			ifFalse: [aStream << ', '].
		getter first = $d
			ifTrue:
				[aStream
					<< getter << ': '
					<< (Float fromIEEE64BitWord: state)]
			ifFalse:
				[getter == #eflags
					ifTrue:
						[aStream
							<< 'NZCVIF: '
							<< (state printStringBase: 2 length: 6 padded: true)]
					ifFalse:
						[aStream
							<< getter << ': '
							<< (state printStringBase: 16)]]]! !

!GdbARMAlien methodsFor: 'printing' stamp: 'tpr 3/20/2015 13:06'!
printRegisterState: registerStateVector on: aStream
	self printFields: #(	r0 r1 r2 r3 cr
						r4 r5 r6 r7 cr
						r8 r9 sl fp cr
						r12 sp lr pc eflags cr)
		inRegisterState: registerStateVector
		on: aStream! !

!GdbARMAlien methodsFor: 'printing' stamp: 'tpr 3/20/2015 13:06'!
printRegisterStateExceptPC: registerStateVector on: aStream
	self printFields: #(	r0 r1 r2 r3 cr
						r4 r5 r6 r7 cr
						r8 r9 sl fp cr
						r12 sp lr eflags cr)
		inRegisterState: registerStateVector
		on: aStream! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 5/11/2014 02:53'!
priorPc
"where did the simulator stop just before a prefetch abort?"
	^self unsignedLongAt: 609! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 3/24/2015 15:27'!
priorPc: val
"set the priorPC cached pc so it isn't random nonsense"
	^self unsignedLongAt: 609 put: val! !

!GdbARMAlien methodsFor: 'execution' stamp: 'lw 2/1/2013 23:17'!
pushWord: aValue in: aMemory
	aMemory longAt: (self sp: self sp - 4) + 1 put: aValue bigEndian: false! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r0
	^self unsignedLongAt: 13! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r0: anUnsignedInteger

	^self unsignedLongAt: 13 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r1
	^self unsignedLongAt: 17! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r10
	^self unsignedLongAt: 53! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r10: anUnsignedInteger

	^self unsignedLongAt: 53 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r11
	^self unsignedLongAt: 57! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r11: anUnsignedInteger

	^self unsignedLongAt: 57 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r12
	^self unsignedLongAt: 61! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r12: anUnsignedInteger

	^self unsignedLongAt: 61 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r1: anUnsignedInteger

	^self unsignedLongAt: 17 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r2
	^self unsignedLongAt: 21! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r2: anUnsignedInteger

	^self unsignedLongAt: 21 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r3
	^self unsignedLongAt: 25! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r3: anUnsignedInteger

	^self unsignedLongAt: 25 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r4
	^self unsignedLongAt: 29! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r4: anUnsignedInteger

	^self unsignedLongAt: 29 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r5
	^self unsignedLongAt: 33! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r5: anUnsignedInteger

	^self unsignedLongAt: 33 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r6
	^self unsignedLongAt: 37! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r6: anUnsignedInteger

	^self unsignedLongAt: 37 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r7
	^self unsignedLongAt: 41! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r7: anUnsignedInteger

	^self unsignedLongAt: 41 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r8
	^self unsignedLongAt: 45! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r8: anUnsignedInteger

	^self unsignedLongAt: 45 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r9
	^self unsignedLongAt: 49! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r9: anUnsignedInteger

	^self unsignedLongAt: 49 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:22'!
rawCPSR
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
"read the raw value of the cpsr from the alien structure"
	^self unsignedLongAt: 533! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 5/29/2014 13:35'!
register: int0to15
"return the value of register"
	self assert:[int0to15 between: 0 and:15].
	^self unsignedLongAt: 13 + (4 * int0to15)! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'eem 3/28/2015 12:13'!
registerAt: index 
	^self perform: (self registerStateGetters at: index + 1)! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'eem 5/10/2016 11:13'!
registerState
	^{	self r0. self r1. self r2. self r3. self r4. self r5. self r6. self r7.
		self r8. self r9. self sl. self fp. self r12. self sp. self lr. self pc. self eflags.
		self d0. self d1. self d2. self d3. self d4. self d5. self d6. self d7.
		self d8. self d9. self d10. self d11. self d12. self d13. self d14. self d15 }! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'eem 5/9/2016 18:24'!
registerStateGetters
	^#(	r0 r1 r2 r3 r4 r5 r6 r7 r8 r9 sl fp r12 sp lr pc eflags
		d0 d1 d2 d3 d4 d5 d6 d7 d8 d9 d10 d11 d12 d13 d14 d15)! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 11/17/2012 18:12'!
registerStatePCIndex
	^16! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'eem 5/9/2016 18:25'!
registerStateSetters
	^#(	r0: r1: r2: r3: r4: r5: r6: r7: r8: r9: sl: fp: r12: sp: lr: pc: eflags:
		d0: d1: d2: d3: d4: d5: d6: d7: d8: d9: d10: d11: d12: d13: d14: d15:)! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 3/24/2015 15:27'!
reset
	self priorPc: 0;
		primitiveResetCPU! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'eem 3/25/2015 23:07'!
retpcIn: aMemory
	"The return address is on the stack, having been pushed by either
	 simulateCallOf:nextpc:memory: or simulateJumpCallOf:memory:"
	^aMemory unsignedLongAt: self fp + 5 bigEndian: false! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 7/12/2012 22:38'!
setFramePointer: framePointer stackPointer: stackPointer
	"Initialize the processor's frame and stack pointers"
	self fp: framePointer.
	self sp: stackPointer! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'tpr 3/17/2015 16:32'!
setRegisterState: aRegisterStateArray
	"N.B. keep in sync with voidRegisterState"

	self r0:  (aRegisterStateArray at: 1).
	self r1: (aRegisterStateArray at: 2).
	self r2: (aRegisterStateArray at: 3).
	self r3: (aRegisterStateArray at: 4).
	self r4: (aRegisterStateArray at: 5).
	self r5: (aRegisterStateArray at: 6).
	self r6: (aRegisterStateArray at: 7).
	self r7: (aRegisterStateArray at: 8).
	self r8: (aRegisterStateArray at: 9).
	self r9: (aRegisterStateArray at: 10).
	self r10: (aRegisterStateArray at: 11).
	self fp: (aRegisterStateArray at: 12).
	self r12: (aRegisterStateArray at: 13).
	self sp: (aRegisterStateArray at: 14).
	self lr: (aRegisterStateArray at: 15).
	self pc: (aRegisterStateArray at: 16).
	self eflags:  (aRegisterStateArray at: 17).! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:22'!
sflag
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 585! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 3/17/2015 15:54'!
sflag: unsignedInteger
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 585 put: unsignedInteger! !

!GdbARMAlien methodsFor: 'execution simulation' stamp: 'tpr 4/14/2015 17:39'!
simulateCallOf: address nextpc: nextpc memory: aMemory
	"Simulate a frame-building call of address.  Build a frame since
	a) this is used for calls into the run-time which are unlikely to be leaf-calls"
	"This method builds a stack frame as expected by the simulator, not as defined by ARM aapcs-abi.
	In ARM aapcs, every method can define for itself, wether it wants to push lr (nextpc), and wether it 
	uses a frame pointer. The standard never mentions a fp. It merely defines r4-r11 to be callee-saved."

	self pushWord: self lr in: aMemory.
	self pushWord: self fp in: aMemory.
	self fp: self sp.
	PostBuildStackDelta ~= 0 ifTrue:
		[self sp: self sp - PostBuildStackDelta]. "In order to satisfy the CStackAlignment check by cogit, which is only valid on IA32 platforms."
	self pc: address! !

!GdbARMAlien methodsFor: 'execution simulation' stamp: 'eem 3/25/2015 22:44'!
simulateJumpCallOf: address memory: aMemory
	"Simulate a frame-building jump of address.  Build a frame since
	a) this is used for calls into the run-time which are unlikely to be leaf-calls"
	"This method builds a stack frame as expected by the simulator, not as defined by ARM aapcs-abi.
	In ARM aapcs, every method can define for itself, wether it wants to push lr (nextpc), and wether it 
	uses a frame pointer. The standard never mentions a fp. It merely defines r4-r11 to be callee-saved."

	self assert: self sp \\ 8 = 0. "This check ensures, that we conform with ARM abi. Before doing anything to the stack, we ensure 2-word alignment."
	self pushWord: self lr in: aMemory.
	self pushWord: self fp in: aMemory.
	self fp: self sp.
	PostBuildStackDelta ~= 0 ifTrue:
		[self sp: self sp - PostBuildStackDelta]. "In order to satisfy the CStackAlignment check by cogit, which is only valid on IA32 platforms."
	self pc: address! !

!GdbARMAlien methodsFor: 'execution simulation' stamp: 'lw 8/8/2012 11:56'!
simulateLeafCallOf: address nextpc: nextpc memory: aMemory
	self lr: nextpc.
	self pc: address! !

!GdbARMAlien methodsFor: 'execution simulation' stamp: 'lw 2/1/2013 22:40'!
simulateLeafReturnIn: aMemory
	self pc: self lr! !

!GdbARMAlien methodsFor: 'execution simulation' stamp: 'eem 3/25/2015 22:54'!
simulateReturnIn: aMemory
	PostBuildStackDelta ~= 0 ifTrue:
		[self sp: self sp + PostBuildStackDelta].
	self fp: (self popWordIn: aMemory).
	"According to tpr, most C compilers implement return by simply
	 popping into the pc, rather than popping through the link register."
	self pc: (self popWordIn: aMemory)! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 3/20/2015 13:03'!
sl
	^self unsignedLongAt: 53! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 3/20/2015 13:04'!
sl: anUnsignedInteger

	^self unsignedLongAt: 53 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'eem 5/31/2016 11:06'!
smashABICallerSavedRegistersWithValuesFrom: base by: step
	"limited list of registers to clear out when simulating an ABI call.
	 Smash neither R0 nor R1 since many abi calls return 2 results or a 64-bit dual-reg value.
	 LR has to be left alone becasue a leaf call doesn't push it."

	#(r2: r3: r9: r12:) withIndexDo:
		[:accessor :index|
		self perform: accessor with: index - 1 * step + base]! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'eem 5/31/2016 08:46'!
smashCallerSavedRegistersWithValuesFrom: base by: step
	#(r0: r1: r2: r3: r9: r12: lr:) withIndexDo:
		[:accessor :index|
		self perform: accessor with: index - 1 * step + base]! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'eem 6/15/2016 09:43'!
smashRegisterAccessors
	^#(r0: r1: r2: r3: r4: r5: r6: r7: r8: r9: r10: "11=FP" r12: "13=SP, 14=LR, 15=PC")! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
sp
	^self unsignedLongAt: 65! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
sp: anUnsignedInteger

	^self unsignedLongAt: 65 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:23'!
tflag
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
"This would be the Thumb flag if we have it -which depends rather oddly on the compiletime flags used to build the ARMulator. Sigh"
	^self unsignedLongAt: 589! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 3/17/2015 15:54'!
tflag: unsignedInteger
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
"This would be the Thumb flag if we have it -which depends rather oddly on the compiletime flags used to build the ARMulator. Sigh"
	^self unsignedLongAt: 589 put: unsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:22'!
vflag
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 577! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 3/17/2015 15:55'!
vflag: unsignedInteger
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 577 put: unsignedInteger! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'tpr 3/17/2015 16:33'!
voidRegisterState
	"N.B. keep in sync with setRegisterState:"
	self setRegisterState: (Array new: 17 withAll: 0)! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:22'!
zflag
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 569! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 3/17/2015 15:55'!
zflag: unsignedInteger
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 569 put: unsignedInteger! !

!ClassDescription methodsFor: '*Cog-method prototypes squeak' stamp: 'eem 5/27/2014 11:08'!
ClassDescriptionPROTOTYPEupdateMethodBindingsTo: aBinding
	"ClassBuilder support for maintaining valid method bindings."
	methodDict do: [:method| method methodClassAssociation: aBinding]! !

!EncoderForV3PlusClosures methodsFor: '*Cog-method prototypes' stamp: 'eem 8/8/2014 08:14'!
EncoderForV3PlusClosuresPROTOTYPEgenCallPrimitive: primitiveIndex
	"139	11101111	iiiiiiii jjjjjjjj	Call Primitive #iiiiiiii + (jjjjjjjj * 256)"
	(primitiveIndex < 1 or: [primitiveIndex > 65535]) ifTrue:
		[self outOfRangeError: 'primitive index' index: primitiveIndex range: 1 to: 65535].
	stream
		nextPut: 139;
		nextPut: (primitiveIndex bitAnd: 255);
		nextPut: (primitiveIndex bitShift: -8)! !

Object subclass: #MIPSDisassembler
	instanceVariableNames: 'pc'
	classVariableNames: ''
	poolDictionaries: 'MIPSConstants'
	category: 'Cog-Processors'!

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:04:27'!
addImmediateUnsigned: instruction
	^'addiu ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(instruction signedImmediate printString)! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:04:31'!
addUnsigned: instruction
	^'addu ', 
	(MIPSConstants nameForRegister: instruction rd), ', ',
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(MIPSConstants nameForRegister: instruction rt)! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:04:36'!
andImmediate: instruction
	^'andi ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(instruction unsignedImmediate printString)! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:04:39'!
bitwiseAnd: instruction
	^'and ', 
	(MIPSConstants nameForRegister: instruction rd), ', ',
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(MIPSConstants nameForRegister: instruction rt)! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:04:42'!
bitwiseOr: instruction
	^'or ', 
	(MIPSConstants nameForRegister: instruction rd), ', ',
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(MIPSConstants nameForRegister: instruction rt)! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:04:46'!
bitwiseXor: instruction
	^'xor ', 
	(MIPSConstants nameForRegister: instruction rd), ', ',
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(MIPSConstants nameForRegister: instruction rt)! !

!MIPSDisassembler methodsFor: 'instructions - control' stamp: 'rmacnak 11/10/2015 21:06:31'!
branchEqual: instruction
	| offset target |
	offset := instruction signedImmediate << 2.
	target := pc + offset + OneInstruction. "Offset is relative to the delay slot"
	^'beq ', 
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(offset > 0 ifTrue: ['+'] ifFalse: ['']), offset printString, ' ; =', (target printStringBase: 16)! !

!MIPSDisassembler methodsFor: 'instructions - control' stamp: 'rmacnak 11/10/2015 21:07:34'!
branchGreaterEqualZero: instruction
	| offset target |
	offset := instruction signedImmediate << 2.
	target := pc + offset + OneInstruction. "Offset is relative to the delay slot"
	^'bgez ', 
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(offset > 0 ifTrue: ['+'] ifFalse: ['']), offset printString, ' ; =', (target printStringBase: 16)! !

!MIPSDisassembler methodsFor: 'instructions - control' stamp: 'rmacnak 11/10/2015 21:07:37'!
branchGreaterThanZero: instruction
	| offset target |
	offset := instruction signedImmediate << 2.
	target := pc + offset + OneInstruction. "Offset is relative to the delay slot"
	^'bgtz ', 
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(offset > 0 ifTrue: ['+'] ifFalse: ['']), offset printString, ' ; =', (target printStringBase: 16)! !

!MIPSDisassembler methodsFor: 'instructions - control' stamp: 'rmacnak 11/10/2015 21:07:42'!
branchLessEqualZero: instruction
	| offset target |
	offset := instruction signedImmediate << 2.
	target := pc + offset + OneInstruction. "Offset is relative to the delay slot"
	^'blez ', 
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(offset > 0 ifTrue: ['+'] ifFalse: ['']), offset printString, ' ; =', (target printStringBase: 16)! !

!MIPSDisassembler methodsFor: 'instructions - control' stamp: 'rmacnak 11/10/2015 21:07:45'!
branchLessThanZero: instruction
	| offset target |
	offset := instruction signedImmediate << 2.
	target := pc + offset + OneInstruction. "Offset is relative to the delay slot"
	^'bltz ', 
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(offset > 0 ifTrue: ['+'] ifFalse: ['']), offset printString, ' ; =', (target printStringBase: 16)! !

!MIPSDisassembler methodsFor: 'instructions - control' stamp: 'rmacnak 11/10/2015 21:07:48'!
branchNotEqual: instruction
	| offset target |
	offset := instruction signedImmediate << 2.
	target := pc + offset + OneInstruction. "Offset is relative to the delay slot"
	^'bne ', 
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(offset > 0 ifTrue: ['+'] ifFalse: ['']), offset printString, ' ; =', (target printStringBase: 16)! !

!MIPSDisassembler methodsFor: 'instructions - control' stamp: 'rmacnak 11/10/2015 21:06:54'!
break: instruction
	^'break'! !

!MIPSDisassembler methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/10/2015 21:21:25'!
disassemble: memory from: startPC to: limitPC
	| stream |
	stream := WriteStream on: ''.
	self disassemble: memory from: startPC to: limitPC for: nil labels: nil on: stream.
	^stream contents! !

!MIPSDisassembler methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/15/2015 16:02:25'!
disassemble: memory from: startPC to: limitPC for: aSymbolManager "<Cogit>" labels: labelDictionary on: aStream
	pc := startPC.
	[pc < limitPC] whileTrue:
		[ | word instruction |
		pc printOn: aStream base: 16 nDigits: 8.
		aStream space; space.
		word := memory unsignedLongAt: pc + 1.
		word printOn: aStream base: 16 nDigits: 8.
		aStream space; space.
		instruction := MIPSInstruction new value: word.
		aStream nextPutAll: (instruction decodeFor: self).

		aSymbolManager ifNotNil: [
			(aSymbolManager labelForPC: pc) ifNotNil:
				[:label | aStream nextPutAll: ' ;'; nextPutAll: label]].
		"aStream print: (aSymbolManager lookupAddress: pc)."

		aStream cr.
		pc := pc + OneInstruction].! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/21/2015 18:18:00'!
divideSigned: instruction
	self assert: instruction rd = 0.
	self assert: instruction sa = 0.
	^'div ', 
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(MIPSConstants nameForRegister: instruction rt)! !

!MIPSDisassembler methodsFor: 'instructions - control' stamp: 'rmacnak 11/10/2015 21:06:59'!
jump: instruction
	| target |
	target := (pc + OneInstruction) bitAnd: 16rF0000000. "Region is that of the delay slot"
	target := target + (instruction target << 2).
	^'j ', (target printStringBase: 16)! !

!MIPSDisassembler methodsFor: 'instructions - control' stamp: 'rmacnak 11/10/2015 21:07:02'!
jumpAndLink: instruction
	| target |
	target := (pc + OneInstruction) bitAnd: 16rF0000000. "Region is that of the delay slot"
	target := target + (instruction target << 2).
	^'jal ', (target printStringBase: 16)! !

!MIPSDisassembler methodsFor: 'instructions - control' stamp: 'rmacnak 11/10/2015 21:13:26'!
jumpAndLinkRegister: instruction
	instruction rd = 31 ifTrue: [^'jalr ', (MIPSConstants nameForRegister: instruction rs)].
	^'jalr ',
	(MIPSConstants nameForRegister: instruction rd), ', ',
	(MIPSConstants nameForRegister: instruction rs)! !

!MIPSDisassembler methodsFor: 'instructions - control' stamp: 'rmacnak 11/10/2015 21:07:11'!
jumpRegister: instruction
	^'jr ', (MIPSConstants nameForRegister: instruction rs)! !

!MIPSDisassembler methodsFor: 'instructions - memory' stamp: 'rmacnak 11/10/2015 21:08:36'!
loadByte: instruction
	^'lb ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(instruction signedImmediate printString), '(',
	(MIPSConstants nameForRegister: instruction rs), ')'! !

!MIPSDisassembler methodsFor: 'instructions - memory' stamp: 'rmacnak 11/10/2015 21:08:38'!
loadByteUnsigned: instruction
	^'lbu ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(instruction signedImmediate printString), '(',
	(MIPSConstants nameForRegister: instruction rs), ')'! !

!MIPSDisassembler methodsFor: 'instructions - memory' stamp: 'rmacnak 11/10/2015 21:08:42'!
loadHalfword: instruction
	^'lh ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(instruction signedImmediate printString), '(',
	(MIPSConstants nameForRegister: instruction rs), ')'! !

!MIPSDisassembler methodsFor: 'instructions - memory' stamp: 'rmacnak 11/10/2015 21:08:46'!
loadHalfwordUnsigned: instruction
	^'lhu ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(instruction signedImmediate printString), '(',
	(MIPSConstants nameForRegister: instruction rs), ')'! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:07:16'!
loadUpperImmediate: instruction
	^'lui ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(instruction signedImmediate printString)! !

!MIPSDisassembler methodsFor: 'instructions - memory' stamp: 'rmacnak 11/10/2015 21:08:49'!
loadWord: instruction
	^'lw ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(instruction signedImmediate printString), '(',
	(MIPSConstants nameForRegister: instruction rs), ')'! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/21/2015 18:20:26'!
moveFromHigh: instruction
	self assert: instruction rs = 0.
	self assert: instruction rt = 0.
	self assert: instruction sa = 0.
	^'mfhi ', (MIPSConstants nameForRegister: instruction rd)! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/21/2015 18:20:34'!
moveFromLow: instruction
	self assert: instruction rs = 0.
	self assert: instruction rt = 0.
	self assert: instruction sa = 0.
	^'mflo ', (MIPSConstants nameForRegister: instruction rd)! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/21/2015 18:18:33'!
multiplySigned: instruction
	self assert: instruction rd = 0.
	self assert: instruction sa = 0.
	^'mult ', 
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(MIPSConstants nameForRegister: instruction rt)! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:04:51'!
orImmediate: instruction
	^'ori ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(instruction unsignedImmediate printString)! !

!MIPSDisassembler methodsFor: 'instructions - memory' stamp: 'rmacnak 11/16/2015 20:48:27'!
prefetch: instruction
	| hintName |
	instruction rt = HintLoad ifTrue: [hintName :=  'load'].
	instruction rt = HintStore ifTrue: [hintName :=  'store'].
	^'pref ', hintName, ', ',
	(instruction signedImmediate printString), '(',
	(MIPSConstants nameForRegister: instruction rs), ')'! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:04:55'!
setOnLessThan: instruction
	^'slt ', 
	(MIPSConstants nameForRegister: instruction rd), ', ',
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(MIPSConstants nameForRegister: instruction rt)! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:04:58'!
setOnLessThanImmediate: instruction
	^'slti ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(instruction signedImmediate printString)! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:05:04'!
setOnLessThanImmediateUnsigned: instruction
	"The immediate is still sign-extended; it is the comparison that is unsigned."
	^'sltiu ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(instruction signedImmediate printString) ! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 23:10:29'!
setOnLessThanUnsigned: instruction
	^'sltu ', 
	(MIPSConstants nameForRegister: instruction rd), ', ',
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(MIPSConstants nameForRegister: instruction rt)! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:05:13'!
shiftLeftLogical: instruction
	instruction value = 0 ifTrue: [^'nop'].
	^'sll ', 
	(MIPSConstants nameForRegister: instruction rd), ', ',
	(MIPSConstants nameForRegister: instruction rt), ', ',
	instruction sa printString! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:05:21'!
shiftLeftLogicalVariable: instruction
	^'sllv ', 
	(MIPSConstants nameForRegister: instruction rd), ', ',
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(MIPSConstants nameForRegister: instruction rs)! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:05:24'!
shiftRightArithmetic: instruction
	^'sra ', 
	(MIPSConstants nameForRegister: instruction rd), ', ',
	(MIPSConstants nameForRegister: instruction rt), ', ',
	instruction sa printString! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:05:26'!
shiftRightArithmeticVariable: instruction
	^'srav ', 
	(MIPSConstants nameForRegister: instruction rd), ', ',
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(MIPSConstants nameForRegister: instruction rs)! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:05:29'!
shiftRightLogical: instruction
	^'srl ', 
	(MIPSConstants nameForRegister: instruction rd), ', ',
	(MIPSConstants nameForRegister: instruction rt), ', ',
	instruction sa printString! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:05:34'!
shiftRightLogicalVariable: instruction
	^'srlv ', 
	(MIPSConstants nameForRegister: instruction rd), ', ',
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(MIPSConstants nameForRegister: instruction rs)! !

!MIPSDisassembler methodsFor: 'instructions - memory' stamp: 'rmacnak 11/10/2015 21:08:52'!
storeByte: instruction
	^'sb ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(instruction signedImmediate printString), '(',
	(MIPSConstants nameForRegister: instruction rs), ')'! !

!MIPSDisassembler methodsFor: 'instructions - memory' stamp: 'rmacnak 11/10/2015 21:08:55'!
storeHalfword: instruction
	^'sh ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(instruction signedImmediate printString), '(',
	(MIPSConstants nameForRegister: instruction rs), ')'! !

!MIPSDisassembler methodsFor: 'instructions - memory' stamp: 'rmacnak 11/10/2015 21:08:58'!
storeWord: instruction
	^'sw ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(instruction signedImmediate printString), '(',
	(MIPSConstants nameForRegister: instruction rs), ')'! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:05:37'!
subtractUnsigned: instruction
	^'subu ', 
	(MIPSConstants nameForRegister: instruction rd), ', ',
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(MIPSConstants nameForRegister: instruction rt)! !

!MIPSDisassembler methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/10/2015 21:05:41'!
xorImmediate: instruction
	^'xori ', 
	(MIPSConstants nameForRegister: instruction rt), ', ',
	(MIPSConstants nameForRegister: instruction rs), ', ',
	(instruction unsignedImmediate printString)! !

TestCase subclass: #MIPSELSimulatorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'MIPSConstants'
	category: 'Cog-Processors-Tests'!

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:28:56'!
testAddiu
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: V0 R: ZR C: 42).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  2402002A  addiu v0, zr, 42
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: 42].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:29:18'!
testAddiuNegative
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: V0 R: ZR C: -42).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  2402FFD6  addiu v0, zr, -42
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: -42].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:29:43'!
testAddiuOverflow
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler luiR: T0 C: 16r7FFF).
			stream nextPut: (compiler oriR: T0 R: T0 C: 16rFFFF).
			stream nextPut: (compiler addiuR: V0 R: T0 C: 1).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  3C087FFF  lui t0, 32767
00000004  3508FFFF  ori t0, t0, 65535
00000008  25020001  addiu v0, t0, 1
0000000C  03E00008  jr ra
00000010  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: -1 << 31].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:30:16'!
testAddiuUnderflow
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler luiR: T0 C: 16r8000).
			stream nextPut: (compiler addiuR: V0 R: T0 C: -1).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  3C088000  lui t0, -32768
00000004  2502FFFF  addiu v0, t0, -1
00000008  03E00008  jr ra
0000000C  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: (1 << 31) - 1].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:30:47'!
testAddu
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler adduR: V0 R: A0 R: A1).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  00851021  addu v0, a0, a1
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 3 with: 4 with: 0 with: 0.
			self assert: result equals: 7.
			result := simulator call: 0 with: 3 with: -4 with: 0 with: 0.
			self assert: result equals: -1.
			result := simulator call: 0 with: -3 with: 4 with: 0 with: 0.
			self assert: result equals: 1.
			result := simulator call: 0 with: 16r7FFFFFFF with: 1 with: 0 with: 0.
			self assert: result equals: (-1 << 31).
			result := simulator call: 0 with: (-1 << 31) with: -1 with: 0 with: 0.
			self assert: result equals: (1 << 31) - 1].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:31:07'!
testAnd
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler andR: V0 R: A0 R: A1).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  00851024  and v0, a0, a1
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 2r1101 with: 2r1011 with: 0 with: 0.
			self assert: result equals: 2r1001.
			result := simulator call: 0 with: -1 with: 42 with: 0 with: 0.
			self assert: result equals: 42].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:32:39'!
testAndi
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler andiR: V0 R: A0 C: 16rFF).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  308200FF  andi v0, a0, 255
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 16r12345678 with: 0 with: 0 with: 0.
			self assert: result equals: 16r78.
			result := simulator call: 0 with: -1 with: 0 with: 0 with: 0.
			self assert: result equals: 16rFF].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:32:53'!
testAndiNegative
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler andiR: V0 R: A0 C: -1). "Immediate is zero-extended, so same as 16rFFFF"
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  3082FFFF  andi v0, a0, 65535
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 16r12345678 with: 0 with: 0 with: 0.
			self assert: result equals: 16r5678.
			result := simulator call: 0 with: -1 with: 0 with: 0 with: 0.
			self assert: result equals: 16rFFFF].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:33:10'!
testBeq
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: V0 R: ZR C: 4).
			stream nextPut: (compiler beqR: A0 R: A1 offset: 8).
			stream nextPut: (compiler nop). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  24020004  addiu v0, zr, 4
00000004  10850002  beq a0, a1, +8 ; =10
00000008  00000000  nop
0000000C  24020003  addiu v0, zr, 3
00000010  03E00008  jr ra
00000014  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 4.
			result := simulator call: 0 with: 1 with: 0 with: 0 with: 0.
			self assert: result equals: 3].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:33:28'!
testBeqDelaySlot
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler beqR: A0 R: A1 offset: 8).
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: V0 C: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  10850002  beq a0, a1, +8 ; =C
00000004  24020003  addiu v0, zr, 3
00000008  24420004  addiu v0, v0, 4
0000000C  03E00008  jr ra
00000010  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 3.
			result := simulator call: 0 with: 1 with: 0 with: 0 with: 0.
			self assert: result equals: 7].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:33:43'!
testBgez
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: V0 R: ZR C: 4).
			stream nextPut: (compiler bgezR: A0 offset: 8).
			stream nextPut: (compiler nop). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  24020004  addiu v0, zr, 4
00000004  04810002  bgez a0, +8 ; =10
00000008  00000000  nop
0000000C  24020003  addiu v0, zr, 3
00000010  03E00008  jr ra
00000014  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: -1 with: 0 with: 0 with: 0.
			self assert: result equals: 3.
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 4.
			result := simulator call: 0 with: 1 with: 0 with: 0 with: 0.
			self assert: result equals: 4].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:34:02'!
testBgezDelaySlot
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler bgezR: A0 offset: 8).
			stream nextPut: (compiler addiuR: V0 R: ZR C: 4). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  04810002  bgez a0, +8 ; =C
00000004  24020004  addiu v0, zr, 4
00000008  24020003  addiu v0, zr, 3
0000000C  03E00008  jr ra
00000010  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: -1 with: 0 with: 0 with: 0.
			self assert: result equals: 3.
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 4.
			result := simulator call: 0 with: 1 with: 0 with: 0 with: 0.
			self assert: result equals: 4].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:34:19'!
testBgtz
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: V0 R: ZR C: 4).
			stream nextPut: (compiler bgtzR: A0 offset: 8).
			stream nextPut: (compiler nop). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  24020004  addiu v0, zr, 4
00000004  1C800002  bgtz a0, +8 ; =10
00000008  00000000  nop
0000000C  24020003  addiu v0, zr, 3
00000010  03E00008  jr ra
00000014  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: -1 with: 0 with: 0 with: 0.
			self assert: result equals: 3.
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 3.
			result := simulator call: 0 with: 1 with: 0 with: 0 with: 0.
			self assert: result equals: 4].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:34:56'!
testBgtzDelaySlot
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler bgtzR: A0 offset: 8).
			stream nextPut: (compiler addiuR: V0 R: ZR C: 4). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  1C800002  bgtz a0, +8 ; =C
00000004  24020004  addiu v0, zr, 4
00000008  24020003  addiu v0, zr, 3
0000000C  03E00008  jr ra
00000010  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: -1 with: 0 with: 0 with: 0.
			self assert: result equals: 3.
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 3.
			result := simulator call: 0 with: 1 with: 0 with: 0 with: 0.
			self assert: result equals: 4].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:35:22'!
testBlez
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: V0 R: ZR C: 4).
			stream nextPut: (compiler blezR: A0 offset: 8).
			stream nextPut: (compiler nop). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  24020004  addiu v0, zr, 4
00000004  18800002  blez a0, +8 ; =10
00000008  00000000  nop
0000000C  24020003  addiu v0, zr, 3
00000010  03E00008  jr ra
00000014  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: -1 with: 0 with: 0 with: 0.
			self assert: result equals: 4.
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 4.
			result := simulator call: 0 with: 1 with: 0 with: 0 with: 0.
			self assert: result equals: 3].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:35:45'!
testBlezDelaySlot
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler blezR: A0 offset: 8).
			stream nextPut: (compiler addiuR: V0 R: ZR C: 4). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  18800002  blez a0, +8 ; =C
00000004  24020004  addiu v0, zr, 4
00000008  24020003  addiu v0, zr, 3
0000000C  03E00008  jr ra
00000010  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: -1 with: 0 with: 0 with: 0.
			self assert: result equals: 4.
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 4.
			result := simulator call: 0 with: 1 with: 0 with: 0 with: 0.
			self assert: result equals: 3].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:37:18'!
testBltz
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: V0 R: ZR C: 4).
			stream nextPut: (compiler bltzR: A0 offset: 8).
			stream nextPut: (compiler nop). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  24020004  addiu v0, zr, 4
00000004  04800002  bltz a0, +8 ; =10
00000008  00000000  nop
0000000C  24020003  addiu v0, zr, 3
00000010  03E00008  jr ra
00000014  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: -1 with: 0 with: 0 with: 0.
			self assert: result equals: 4.
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 3.
			result := simulator call: 0 with: 1 with: 0 with: 0 with: 0.
			self assert: result equals: 3].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:37:55'!
testBltzDelaySlot
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler bltzR: A0 offset: 8).
			stream nextPut: (compiler addiuR: V0 R: ZR C: 4). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  04800002  bltz a0, +8 ; =C
00000004  24020004  addiu v0, zr, 4
00000008  24020003  addiu v0, zr, 3
0000000C  03E00008  jr ra
00000010  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: -1 with: 0 with: 0 with: 0.
			self assert: result equals: 4.
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 3.
			result := simulator call: 0 with: 1 with: 0 with: 0 with: 0.
			self assert: result equals: 3].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:38:14'!
testBne
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: V0 R: ZR C: 4).
			stream nextPut: (compiler bneR: A0 R: A1 offset: 8).
			stream nextPut: (compiler nop). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  24020004  addiu v0, zr, 4
00000004  14850002  bne a0, a1, +8 ; =10
00000008  00000000  nop
0000000C  24020003  addiu v0, zr, 3
00000010  03E00008  jr ra
00000014  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 3.
			result := simulator call: 0 with: 1 with: 0 with: 0 with: 0.
			self assert: result equals: 4].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:38:29'!
testBneDelaySlot
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler bneR: A0 R: A1 offset: 8).
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: V0 C: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  14850002  bne a0, a1, +8 ; =C
00000004  24020003  addiu v0, zr, 3
00000008  24420004  addiu v0, v0, 4
0000000C  03E00008  jr ra
00000010  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 7.
			result := simulator call: 0 with: 1 with: 0 with: 0 with: 0.
			self assert: result equals: 3].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:39:03'!
testBreak
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler break: 0)]
		disassembly:
'00000000  0000000D  break
'		run: 
			[:simulator | 
			self should: [simulator call: 0 with: 0 with: 0 with: 0 with: 0] raise: Error].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/27/2015 12:09:41'!
testDiv
	"Strangely, objdump is unable to disassemble this sequence."	
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler divR: A0 R: A1).
			stream nextPut: (compiler mfloR: V0).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  0085001A  div a0, a1
00000004  00001012  mflo v0
00000008  03E00008  jr ra
0000000C  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 3 with: 7 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -3 with: 7 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: 3 with: -7 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -3 with: -7 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: 7 with: 3 with: 0 with: 0.
			self assert: result equals: 2.
			result := simulator call: 0 with: -7 with: 3 with: 0 with: 0.
			self assert: result equals: -2.
			result := simulator call: 0 with: 7 with: -3 with: 0 with: 0.
			self assert: result equals: -2.
			result := simulator call: 0 with: -7 with: -3 with: 0 with: 0.
			self assert: result equals: 2.
			result := simulator call: 0 with: 42 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -16r80000000 with: -1 with: 0 with: 0.
			self assert: result equals: -16r80000000].	
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler divR: A0 R: A1).
			stream nextPut: (compiler mfhiR: V0).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  0085001A  div a0, a1
00000004  00001010  mfhi v0
00000008  03E00008  jr ra
0000000C  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 3 with: 7 with: 0 with: 0.
			self assert: result equals: 3.
			result := simulator call: 0 with: -3 with: 7 with: 0 with: 0.
			self assert: result equals: -3.
			result := simulator call: 0 with: 3 with: -7 with: 0 with: 0.
			self assert: result equals: 3.
			result := simulator call: 0 with: -3 with: -7 with: 0 with: 0.
			self assert: result equals: -3.
			result := simulator call: 0 with: 7 with: 3 with: 0 with: 0.
			self assert: result equals: 1.
			result := simulator call: 0 with: -7 with: 3 with: 0 with: 0.
			self assert: result equals: -1.
			result := simulator call: 0 with: 7 with: -3 with: 0 with: 0.
			self assert: result equals: 1.
			result := simulator call: 0 with: -7 with: -3 with: 0 with: 0.
			self assert: result equals: -1.
			result := simulator call: 0 with: 42 with: 0 with: 0 with: 0.
			self assert: result equals: 42.
			result := simulator call: 0 with: -16r80000000 with: -1 with: 0 with: 0.
			self assert: result equals: 0].! !

!MIPSELSimulatorTests methodsFor: 'execution' stamp: 'rmacnak 11/10/2015 21:32:19'!
testGenerateInto: generateBlock disassembly: expectedDisassembly run: executeBlock
	| actualDisassembly compiler memory stopInstr instructions simulator |	
	MIPSConstants initialize.
	compiler := CogMIPSELCompiler new.
	
	stopInstr := compiler stop.
	memory := ByteArray new: 1024.
	1 to: 1024 by: 4 do:
		[:i | memory unsignedLongAt: i put: stopInstr bigEndian: false].

	instructions := Array streamContents: [:stream | generateBlock value: stream value: compiler].
	instructions withIndexDo: 
		[:instr :i | memory unsignedLongAt: (4 * (i - 1)) + 1 put: instr bigEndian: false].
	
	actualDisassembly := MIPSDisassembler new disassemble: memory from: 0 to: instructions size * 4.
	self assert: actualDisassembly equals: expectedDisassembly.
	
	simulator := MIPSELSimulator new initializeWithMemory: memory.
	executeBlock value: simulator.! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:39:18'!
testJ
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3).
			stream nextPut: (compiler jA: 16r10).
			stream nextPut: (compiler nop). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: V0 C: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  24020003  addiu v0, zr, 3
00000004  08000004  j 10
00000008  00000000  nop
0000000C  24420004  addiu v0, v0, 4
00000010  03E00008  jr ra
00000014  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: 3].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:39:35'!
testJDelaySlot
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler jA: 16rC).
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: V0 C: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  08000003  j C
00000004  24020003  addiu v0, zr, 3
00000008  24420004  addiu v0, v0, 4
0000000C  03E00008  jr ra
00000010  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: 3].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:40:12'!
testJal
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: T0 R: RA C: 0).
			stream nextPut: (compiler jalA: 16r1C).
			stream nextPut: (compiler nop). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: V0 C: 3).
			stream nextPut: (compiler jR: T0).
			stream nextPut: (compiler nop). "Delay slot"
			stream nextPut: (compiler stop).
			stream nextPut: (compiler addiuR: V0 R: ZR C: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  27E80000  addiu t0, ra, 0
00000004  0C000007  jal 1C
00000008  00000000  nop
0000000C  24420003  addiu v0, v0, 3
00000010  01000008  jr t0
00000014  00000000  nop
00000018  0000000D  break
0000001C  24020004  addiu v0, zr, 4
00000020  03E00008  jr ra
00000024  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: 7].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:40:39'!
testJalDelaySlot
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: T0 R: RA C: 0).
			stream nextPut: (compiler jalA: 16r1C).
			stream nextPut: (compiler addiuR: V0 R: ZR C: 11). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: V0 C: 3).
			stream nextPut: (compiler jR: T0).
			stream nextPut: (compiler nop). "Delay slot"
			stream nextPut: (compiler stop).
			stream nextPut: (compiler addiuR: V0 R: V0 C: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  27E80000  addiu t0, ra, 0
00000004  0C000007  jal 1C
00000008  2402000B  addiu v0, zr, 11
0000000C  24420003  addiu v0, v0, 3
00000010  01000008  jr t0
00000014  00000000  nop
00000018  0000000D  break
0000001C  24420004  addiu v0, v0, 4
00000020  03E00008  jr ra
00000024  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: 18].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:41:00'!
testJalr
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: T0 R: RA C: 0).
			stream nextPut: (compiler addiuR: T9 R: ZR C: 16r20).
			stream nextPut: (compiler jalR: T9).
			stream nextPut: (compiler nop). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: V0 C: 3).
			stream nextPut: (compiler jR: T0).
			stream nextPut: (compiler nop). "Delay slot"
			stream nextPut: (compiler stop).
			stream nextPut: (compiler addiuR: V0 R: ZR C: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  27E80000  addiu t0, ra, 0
00000004  24190020  addiu t9, zr, 32
00000008  0320F809  jalr t9
0000000C  00000000  nop
00000010  24420003  addiu v0, v0, 3
00000014  01000008  jr t0
00000018  00000000  nop
0000001C  0000000D  break
00000020  24020004  addiu v0, zr, 4
00000024  03E00008  jr ra
00000028  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: 7].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:41:26'!
testJalrDelaySlot
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: T0 R: RA C: 0).
			stream nextPut: (compiler addiuR: T9 R: ZR C: 16r20).
			stream nextPut: (compiler jalR: T9).
			stream nextPut: (compiler addiuR: V0 R: ZR C: 11). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: V0 C: 3).
			stream nextPut: (compiler jR: T0).
			stream nextPut: (compiler nop). "Delay slot"
			stream nextPut: (compiler stop).
			stream nextPut: (compiler addiuR: V0 R: V0 C: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  27E80000  addiu t0, ra, 0
00000004  24190020  addiu t9, zr, 32
00000008  0320F809  jalr t9
0000000C  2402000B  addiu v0, zr, 11
00000010  24420003  addiu v0, v0, 3
00000014  01000008  jr t0
00000018  00000000  nop
0000001C  0000000D  break
00000020  24420004  addiu v0, v0, 4
00000024  03E00008  jr ra
00000028  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: 18].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:41:38'!
testJr
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3).
			stream nextPut: (compiler addiuR: T9 R: ZR C: 16r14).
			stream nextPut: (compiler jR: T9).
			stream nextPut: (compiler nop). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: V0 C: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  24020003  addiu v0, zr, 3
00000004  24190014  addiu t9, zr, 20
00000008  03200008  jr t9
0000000C  00000000  nop
00000010  24420004  addiu v0, v0, 4
00000014  03E00008  jr ra
00000018  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: 3].! !

!MIPSELSimulatorTests methodsFor: 'tests - control' stamp: 'rmacnak 11/10/2015 21:41:51'!
testJrDelaySlot
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler addiuR: T9 R: ZR C: 16r10).
			stream nextPut: (compiler jR: T9).
			stream nextPut: (compiler addiuR: V0 R: ZR C: 3). "Delay slot"
			stream nextPut: (compiler addiuR: V0 R: V0 C: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  24190010  addiu t9, zr, 16
00000004  03200008  jr t9
00000008  24020003  addiu v0, zr, 3
0000000C  24420004  addiu v0, v0, 4
00000010  03E00008  jr ra
00000014  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: 3].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 21:42:09'!
testLb
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler lbR: V0 base: A0 offset: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  80820004  lb v0, 4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator memory at: 16rE4 + 1 put: 42.
			simulator memory at: 16rE5 + 1 put: 43.
			simulator memory at: 16rE6 + 1 put: 44.
			simulator memory at: 16rE7 + 1 put: 45.
			simulator memory at: 16rF4 + 1 put: 16r100 - 42.
			simulator memory at: 16rF5 + 1 put: 16r100 - 43.
			simulator memory at: 16rF6 + 1 put: 16r100 - 44.
			simulator memory at: 16rF7 + 1 put: 16r100 - 45.
			result := simulator call: 0 with: 16rE0 with: 0 with: 0 with: 0.
			self assert: result equals: 42.
			result := simulator call: 0 with: 16rE1 with: 0 with: 0 with: 0.
			self assert: result equals: 43.
			result := simulator call: 0 with: 16rE2 with: 0 with: 0 with: 0.
			self assert: result equals: 44.
			result := simulator call: 0 with: 16rE3 with: 0 with: 0 with: 0.
			self assert: result equals: 45.
			result := simulator call: 0 with: 16rF0 with: 0 with: 0 with: 0.
			self assert: result equals: -42.
			result := simulator call: 0 with: 16rF1 with: 0 with: 0 with: 0.
			self assert: result equals: -43.
			result := simulator call: 0 with: 16rF2 with: 0 with: 0 with: 0.
			self assert: result equals: -44.
			result := simulator call: 0 with: 16rF3 with: 0 with: 0 with: 0.
			self assert: result equals: -45].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 21:42:29'!
testLbNegativeOffset
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler lbR: V0 base: A0 offset: -4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  8082FFFC  lb v0, -4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator memory at: 16rE4 + 1 put: 42.
			simulator memory at: 16rE5 + 1 put: 43.
			simulator memory at: 16rE6 + 1 put: 44.
			simulator memory at: 16rE7 + 1 put: 45.
			simulator memory at: 16rF4 + 1 put: 16r100 - 42.
			simulator memory at: 16rF5 + 1 put: 16r100 - 43.
			simulator memory at: 16rF6 + 1 put: 16r100 - 44.
			simulator memory at: 16rF7 + 1 put: 16r100 - 45.
			result := simulator call: 0 with: 16rE8 with: 0 with: 0 with: 0.
			self assert: result equals: 42.
			result := simulator call: 0 with: 16rE9 with: 0 with: 0 with: 0.
			self assert: result equals: 43.
			result := simulator call: 0 with: 16rEA with: 0 with: 0 with: 0.
			self assert: result equals: 44.
			result := simulator call: 0 with: 16rEB with: 0 with: 0 with: 0.
			self assert: result equals: 45.
			result := simulator call: 0 with: 16rF8 with: 0 with: 0 with: 0.
			self assert: result equals: -42.
			result := simulator call: 0 with: 16rF9 with: 0 with: 0 with: 0.
			self assert: result equals: -43.
			result := simulator call: 0 with: 16rFA with: 0 with: 0 with: 0.
			self assert: result equals: -44.
			result := simulator call: 0 with: 16rFB with: 0 with: 0 with: 0.
			self assert: result equals: -45].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 21:42:45'!
testLbu
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler lbuR: V0 base: A0 offset: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  90820004  lbu v0, 4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator memory at: 16rE4 + 1 put: 42.
			simulator memory at: 16rE5 + 1 put: 43.
			simulator memory at: 16rE6 + 1 put: 44.
			simulator memory at: 16rE7 + 1 put: 45.
			simulator memory at: 16rF4 + 1 put: 16r100 - 42.
			simulator memory at: 16rF5 + 1 put: 16r100 - 43.
			simulator memory at: 16rF6 + 1 put: 16r100 - 44.
			simulator memory at: 16rF7 + 1 put: 16r100 - 45.
			result := simulator call: 0 with: 16rE0 with: 0 with: 0 with: 0.
			self assert: result equals: 42.
			result := simulator call: 0 with: 16rE1 with: 0 with: 0 with: 0.
			self assert: result equals: 43.
			result := simulator call: 0 with: 16rE2 with: 0 with: 0 with: 0.
			self assert: result equals: 44.
			result := simulator call: 0 with: 16rE3 with: 0 with: 0 with: 0.
			self assert: result equals: 45.
			result := simulator call: 0 with: 16rF0 with: 0 with: 0 with: 0.
			self assert: result equals: 16r100 - 42.
			result := simulator call: 0 with: 16rF1 with: 0 with: 0 with: 0.
			self assert: result equals: 16r100 - 43.
			result := simulator call: 0 with: 16rF2 with: 0 with: 0 with: 0.
			self assert: result equals: 16r100 - 44.
			result := simulator call: 0 with: 16rF3 with: 0 with: 0 with: 0.
			self assert: result equals: 16r100 - 45].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 21:43:26'!
testLbuNegativeOffset
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler lbuR: V0 base: A0 offset: -4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  9082FFFC  lbu v0, -4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator memory at: 16rE4 + 1 put: 42.
			simulator memory at: 16rE5 + 1 put: 43.
			simulator memory at: 16rE6 + 1 put: 44.
			simulator memory at: 16rE7 + 1 put: 45.
			simulator memory at: 16rF4 + 1 put: 16r100 - 42.
			simulator memory at: 16rF5 + 1 put: 16r100 - 43.
			simulator memory at: 16rF6 + 1 put: 16r100 - 44.
			simulator memory at: 16rF7 + 1 put: 16r100 - 45.
			result := simulator call: 0 with: 16rE8 with: 0 with: 0 with: 0.
			self assert: result equals: 42.
			result := simulator call: 0 with: 16rE9 with: 0 with: 0 with: 0.
			self assert: result equals: 43.
			result := simulator call: 0 with: 16rEA with: 0 with: 0 with: 0.
			self assert: result equals: 44.
			result := simulator call: 0 with: 16rEB with: 0 with: 0 with: 0.
			self assert: result equals: 45.
			result := simulator call: 0 with: 16rF8 with: 0 with: 0 with: 0.
			self assert: result equals: 16r100 - 42.
			result := simulator call: 0 with: 16rF9 with: 0 with: 0 with: 0.
			self assert: result equals: 16r100 - 43.
			result := simulator call: 0 with: 16rFA with: 0 with: 0 with: 0.
			self assert: result equals: 16r100 - 44.
			result := simulator call: 0 with: 16rFB with: 0 with: 0 with: 0.
			self assert: result equals: 16r100 - 45].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 21:43:49'!
testLh
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler lhR: V0 base: A0 offset: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  84820004  lh v0, 4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator memory at: 16rE4 + 1 put: 42.
			simulator memory at: 16rE5 + 1 put: 43.
			simulator memory at: 16rE6 + 1 put: 44.
			simulator memory at: 16rE7 + 1 put: 45.
			simulator memory at: 16rF4 + 1 put: 16r100 - 42.
			simulator memory at: 16rF5 + 1 put: 16r100 - 43.
			simulator memory at: 16rF6 + 1 put: 16r100 - 44.
			simulator memory at: 16rF7 + 1 put: 16r100 - 45.
			result := simulator call: 0 with: 16rE0 with: 0 with: 0 with: 0.
			self assert: result equals: 16r2B2A.
			self should: [simulator call: 0 with: 16rE1 with: 0 with: 0 with: 0] raise: Error.
			result := simulator call: 0 with: 16rE2 with: 0 with: 0 with: 0.
			self assert: result equals: 16r2D2C.
			self should: [simulator call: 0 with: 16rE3 with: 0 with: 0 with: 0] raise: Error.
			result := simulator call: 0 with: 16rF0 with: 0 with: 0 with: 0.
			self assert: result equals:  -16r2A2A.
			self should: [simulator call: 0 with: 16rF1 with: 0 with: 0 with: 0] raise: Error.
			result := simulator call: 0 with: 16rF2 with: 0 with: 0 with: 0.
			self assert: result equals: -16r2C2C.
			self should: [simulator call: 0 with: 16rF3 with: 0 with: 0 with: 0] raise: Error].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 21:44:32'!
testLhNegativeOffset
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler lhR: V0 base: A0 offset: -4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  8482FFFC  lh v0, -4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator memory at: 16rE4 + 1 put: 42.
			simulator memory at: 16rE5 + 1 put: 43.
			simulator memory at: 16rE6 + 1 put: 44.
			simulator memory at: 16rE7 + 1 put: 45.
			simulator memory at: 16rF4 + 1 put: 16r100 - 42.
			simulator memory at: 16rF5 + 1 put: 16r100 - 43.
			simulator memory at: 16rF6 + 1 put: 16r100 - 44.
			simulator memory at: 16rF7 + 1 put: 16r100 - 45.
			result := simulator call: 0 with: 16rE8 with: 0 with: 0 with: 0.
			self assert: result equals: 16r2B2A.
			self should: [simulator call: 0 with: 16rE9 with: 0 with: 0 with: 0] raise: Error.
			result := simulator call: 0 with: 16rEA with: 0 with: 0 with: 0.
			self assert: result equals: 16r2D2C.
			self should: [simulator call: 0 with: 16rEB with: 0 with: 0 with: 0] raise: Error.
			result := simulator call: 0 with: 16rF8 with: 0 with: 0 with: 0.
			self assert: result equals:  -16r2A2A.
			self should: [simulator call: 0 with: 16rF9 with: 0 with: 0 with: 0] raise: Error.
			result := simulator call: 0 with: 16rFA with: 0 with: 0 with: 0.
			self assert: result equals: -16r2C2C.
			self should: [simulator call: 0 with: 16rFB with: 0 with: 0 with: 0] raise: Error].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 21:44:49'!
testLhu
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler lhuR: V0 base: A0 offset: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  94820004  lhu v0, 4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator memory at: 16rE4 + 1 put: 42.
			simulator memory at: 16rE5 + 1 put: 43.
			simulator memory at: 16rE6 + 1 put: 44.
			simulator memory at: 16rE7 + 1 put: 45.
			simulator memory at: 16rF4 + 1 put: 16r100 - 42.
			simulator memory at: 16rF5 + 1 put: 16r100 - 43.
			simulator memory at: 16rF6 + 1 put: 16r100 - 44.
			simulator memory at: 16rF7 + 1 put: 16r100 - 45.
			result := simulator call: 0 with: 16rE0 with: 0 with: 0 with: 0.
			self assert: result equals: 16r2B2A.
			self should: [simulator call: 0 with: 16rE1 with: 0 with: 0 with: 0] raise: Error.
			result := simulator call: 0 with: 16rE2 with: 0 with: 0 with: 0.
			self assert: result equals: 16r2D2C.
			self should: [simulator call: 0 with: 16rE3 with: 0 with: 0 with: 0] raise: Error.
			result := simulator call: 0 with: 16rF0 with: 0 with: 0 with: 0.
			self assert: result equals: 16rD5D6.
			self should: [simulator call: 0 with: 16rF1 with: 0 with: 0 with: 0] raise: Error.
			result := simulator call: 0 with: 16rF2 with: 0 with: 0 with: 0.
			self assert: result equals: 16rD3D4.
			self should: [simulator call: 0 with: 16rF3 with: 0 with: 0 with: 0] raise: Error].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 21:45:43'!
testLhuNegativeOffset
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler lhuR: V0 base: A0 offset: -4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  9482FFFC  lhu v0, -4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator memory at: 16rE4 + 1 put: 42.
			simulator memory at: 16rE5 + 1 put: 43.
			simulator memory at: 16rE6 + 1 put: 44.
			simulator memory at: 16rE7 + 1 put: 45.
			simulator memory at: 16rF4 + 1 put: 16r100 - 42.
			simulator memory at: 16rF5 + 1 put: 16r100 - 43.
			simulator memory at: 16rF6 + 1 put: 16r100 - 44.
			simulator memory at: 16rF7 + 1 put: 16r100 - 45.
			result := simulator call: 0 with: 16rE8 with: 0 with: 0 with: 0.
			self assert: result equals: 16r2B2A.
			self should: [simulator call: 0 with: 16rE9 with: 0 with: 0 with: 0] raise: Error.
			result := simulator call: 0 with: 16rEA with: 0 with: 0 with: 0.
			self assert: result equals: 16r2D2C.
			self should: [simulator call: 0 with: 16rEB with: 0 with: 0 with: 0] raise: Error.
			result := simulator call: 0 with: 16rF8 with: 0 with: 0 with: 0.
			self assert: result equals: 16rD5D6.
			self should: [simulator call: 0 with: 16rF9 with: 0 with: 0 with: 0] raise: Error.
			result := simulator call: 0 with: 16rFA with: 0 with: 0 with: 0.
			self assert: result equals: 16rD3D4.
			self should: [simulator call: 0 with: 16rFB with: 0 with: 0 with: 0] raise: Error].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:45:56'!
testLoadLargeLiteral
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler luiR: V0 C: 16r3FFF).
			stream nextPut: (compiler oriR: V0 R: V0 C: 16rFFFF).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  3C023FFF  lui v0, 16383
00000004  3442FFFF  ori v0, v0, 65535
00000008  03E00008  jr ra
0000000C  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: 16r3FFFFFFF].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:46:18'!
testLui
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler luiR: V0 C: 42).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  3C02002A  lui v0, 42
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: 42 << 16].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:46:35'!
testLuiNegative
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler luiR: V0 C: -42).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  3C02FFD6  lui v0, -42
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: -42 << 16].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 21:46:57'!
testLw
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler lwR: V0 base: A0 offset: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  8C820004  lw v0, 4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator memory at: 16rE4 + 1 put: 42.
			simulator memory at: 16rE5 + 1 put: 43.
			simulator memory at: 16rE6 + 1 put: 44.
			simulator memory at: 16rE7 + 1 put: 45.
			simulator memory at: 16rF4 + 1 put: 16r100 - 42.
			simulator memory at: 16rF5 + 1 put: 16r100 - 43.
			simulator memory at: 16rF6 + 1 put: 16r100 - 44.
			simulator memory at: 16rF7 + 1 put: 16r100 - 45.
			result := simulator call: 0 with: 16rE0 with: 0 with: 0 with: 0.
			self assert: result equals: 16r2D2C2B2A.
			self should: [simulator call: 0 with: 16rE1 with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rE2 with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rE3 with: 0 with: 0 with: 0] raise: Error.
			result := simulator call: 0 with: 16rF0 with: 0 with: 0 with: 0.
			self assert: result equals: -16r2C2B2A2A.
			self should: [simulator call: 0 with: 16rF1 with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rF2 with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rF3 with: 0 with: 0 with: 0] raise: Error].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 21:47:28'!
testLwNegativeOffset
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler lwR: V0 base: A0 offset: -4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  8C82FFFC  lw v0, -4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator memory at: 16rE4 + 1 put: 42.
			simulator memory at: 16rE5 + 1 put: 43.
			simulator memory at: 16rE6 + 1 put: 44.
			simulator memory at: 16rE7 + 1 put: 45.
			simulator memory at: 16rF4 + 1 put: 16r100 - 42.
			simulator memory at: 16rF5 + 1 put: 16r100 - 43.
			simulator memory at: 16rF6 + 1 put: 16r100 - 44.
			simulator memory at: 16rF7 + 1 put: 16r100 - 45.
			result := simulator call: 0 with: 16rE8 with: 0 with: 0 with: 0.
			self assert: result equals: 16r2D2C2B2A.
			self should: [simulator call: 0 with: 16rE9 with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rEA with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rEB with: 0 with: 0 with: 0] raise: Error.
			result := simulator call: 0 with: 16rF8 with: 0 with: 0 with: 0.
			self assert: result equals: -16r2C2B2A2A.
			self should: [simulator call: 0 with: 16rF9 with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rFA with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rFB with: 0 with: 0 with: 0] raise: Error].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/21/2015 21:50:26'!
testMult
	"Strangely, objdump is unable to disassemble this sequence."	
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler multR: A0 R: A1).
			stream nextPut: (compiler mfloR: V0).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  00850018  mult a0, a1
00000004  00001012  mflo v0
00000008  03E00008  jr ra
0000000C  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 3 with: 5 with: 0 with: 0.
			self assert: result equals: 15.
			result := simulator call: 0 with: -3 with: 5 with: 0 with: 0.
			self assert: result equals: -15.
			result := simulator call: 0 with: 3 with: -5 with: 0 with: 0.
			self assert: result equals: -15.
			result := simulator call: 0 with: -3 with: -5 with: 0 with: 0.
			self assert: result equals: 15.
			result := simulator call: 0 with: 5 with: 3 with: 0 with: 0.
			self assert: result equals: 15.
			result := simulator call: 0 with: -5 with: 3 with: 0 with: 0.
			self assert: result equals: -15.
			result := simulator call: 0 with: 5 with: -3 with: 0 with: 0.
			self assert: result equals: -15.
			result := simulator call: 0 with: -5 with: -3 with: 0 with: 0.
			self assert: result equals: 15.
			result := simulator call: 0 with: 16r1000000 with: 16r4567 with: 0 with: 0.
			self assert: result equals: 16r67000000.
			result := simulator call: 0 with: 16r7FFFFFFF with: 16r7FFFFFFF with: 0 with: 0.
			self assert: result equals: 1].	
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler multR: A0 R: A1).
			stream nextPut: (compiler mfhiR: V0).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  00850018  mult a0, a1
00000004  00001010  mfhi v0
00000008  03E00008  jr ra
0000000C  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 3 with: 5 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -3 with: 5 with: 0 with: 0.
			self assert: result equals: -1.
			result := simulator call: 0 with: 3 with: -5 with: 0 with: 0.
			self assert: result equals: -1.
			result := simulator call: 0 with: -3 with: -5 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: 5 with: 3 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -5 with: 3 with: 0 with: 0.
			self assert: result equals: -1.
			result := simulator call: 0 with: 5 with: -3 with: 0 with: 0.
			self assert: result equals: -1.
			result := simulator call: 0 with: -5 with: -3 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: 16r1000000 with: 16r4567 with: 0 with: 0.
			self assert: result equals: 16r45.
			result := simulator call: 0 with: 16r7FFFFFFF with: 16r7FFFFFFF with: 0 with: 0.
			self assert: result equals:  16r3FFFFFFF].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:47:54'!
testOr
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler orR: V0 R: A0 R: A1).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  00851025  or v0, a0, a1
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 2r101 with: 2r011 with: 0 with: 0.
			self assert: result equals: 2r111.
			result := simulator call: 0 with: -1 with: 42 with: 0 with: 0.
			self assert: result equals: -1].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:48:47'!
testOri
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler oriR: V0 R: ZR C: 16rFFFF).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  3402FFFF  ori v0, zr, 65535
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: 16rFFFF].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:49:07'!
testOriNegative
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler oriR: V0 R: ZR C: -42).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  3402FFD6  ori v0, zr, 65494
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0.
			self assert: result equals: 16r10000 - 42].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/17/2015 19:00:07'!
testPref
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler prefR: A0 offset: 0 hint: HintLoad).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  CC800000  pref load, 0(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			"No exception even though the address is not part of memory."
			simulator call: 0 with: -42 with: 0 with: 0 with: 0].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 21:49:22'!
testSb
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler sbR: A1 base: A0 offset: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  A0850004  sb a1, 4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator call: 0 with: 16rE0 with: 42 with: 0 with: 0.
			simulator call: 0 with: 16rE1 with: 43 with: 0 with: 0.
			simulator call: 0 with: 16rE2 with: 44 with: 0 with: 0.
			simulator call: 0 with: 16rE3 with: 45 with: 0 with: 0.
			simulator call: 0 with: 16rF0 with: -42 with: 0 with: 0.
			simulator call: 0 with: 16rF1 with: -43 with: 0 with: 0.
			simulator call: 0 with: 16rF2 with: -44 with: 0 with: 0.
			simulator call: 0 with: 16rF3 with: -45 with: 0 with: 0.
			self assert: (simulator memory at: 16rE4 + 1) equals: 42.
			self assert: (simulator memory at: 16rE5 + 1) equals: 43.
			self assert: (simulator memory at: 16rE6 + 1) equals: 44.
			self assert: (simulator memory at: 16rE7 + 1) equals: 45.
			self assert: (simulator memory at: 16rF4 + 1) equals: 16r100 - 42.
			self assert: (simulator memory at: 16rF5 + 1) equals: 16r100 - 43.
			self assert: (simulator memory at: 16rF6 + 1) equals: 16r100 - 44.
			self assert: (simulator memory at: 16rF7 + 1) equals: 16r100 - 45].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 21:50:14'!
testSbNegativeOffset
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler sbR: A1 base: A0 offset: -4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  A085FFFC  sb a1, -4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator call: 0 with: 16rE8 with: 42 with: 0 with: 0.
			simulator call: 0 with: 16rE9 with: 43 with: 0 with: 0.
			simulator call: 0 with: 16rEA with: 44 with: 0 with: 0.
			simulator call: 0 with: 16rEB with: 45 with: 0 with: 0.
			simulator call: 0 with: 16rF8 with: -42 with: 0 with: 0.
			simulator call: 0 with: 16rF9 with: -43 with: 0 with: 0.
			simulator call: 0 with: 16rFA with: -44 with: 0 with: 0.
			simulator call: 0 with: 16rFB with: -45 with: 0 with: 0.
			self assert: (simulator memory at: 16rE4 + 1) equals: 42.
			self assert: (simulator memory at: 16rE5 + 1) equals: 43.
			self assert: (simulator memory at: 16rE6 + 1) equals: 44.
			self assert: (simulator memory at: 16rE7 + 1) equals: 45.
			self assert: (simulator memory at: 16rF4 + 1) equals: 16r100 - 42.
			self assert: (simulator memory at: 16rF5 + 1) equals: 16r100 - 43.
			self assert: (simulator memory at: 16rF6 + 1) equals: 16r100 - 44.
			self assert: (simulator memory at: 16rF7 + 1) equals: 16r100 - 45].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 21:50:33'!
testSh
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler shR: A1 base: A0 offset: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  A4850004  sh a1, 4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator call: 0 with: 16rE0 with: 16r2B2A with: 0 with: 0.
			self should: [simulator call: 0 with: 16rE1 with: 0 with: 0 with: 0] raise: Error.
			simulator call: 0 with: 16rE2 with: 16r2D2C with: 0 with: 0.
			self should: [simulator call: 0 with: 16rE3 with: 0 with: 0 with: 0] raise: Error.
			simulator call: 0 with: 16rF0 with: -16r2A2A with: 0 with: 0.
			self should: [simulator call: 0 with: 16rF1 with: 0 with: 0 with: 0] raise: Error.
			simulator call: 0 with: 16rF2 with: -16r2C2C with: 0 with: 0.
			self should: [simulator call: 0 with: 16rF3 with: 0 with: 0 with: 0] raise: Error.
			self assert: (simulator memory at: 16rE4 + 1) equals: 42.
			self assert: (simulator memory at: 16rE5 + 1) equals: 43.
			self assert: (simulator memory at: 16rE6 + 1) equals: 44.
			self assert: (simulator memory at: 16rE7 + 1) equals: 45.
			self assert: (simulator memory at: 16rF4 + 1) equals: 16r100 - 42.
			self assert: (simulator memory at: 16rF5 + 1) equals: 16r100 - 43.
			self assert: (simulator memory at: 16rF6 + 1) equals: 16r100 - 44.
			self assert: (simulator memory at: 16rF7 + 1) equals: 16r100 - 45].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 21:51:33'!
testShNegativeOffset
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler shR: A1 base: A0 offset: -4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  A485FFFC  sh a1, -4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator call: 0 with: 16rE8 with: 16r2B2A with: 0 with: 0.
			self should: [simulator call: 0 with: 16rE9 with: 0 with: 0 with: 0] raise: Error.
			simulator call: 0 with: 16rEA with: 16r2D2C with: 0 with: 0.
			self should: [simulator call: 0 with: 16rEB with: 0 with: 0 with: 0] raise: Error.
			simulator call: 0 with: 16rF8 with: -16r2A2A with: 0 with: 0.
			self should: [simulator call: 0 with: 16rF9 with: 0 with: 0 with: 0] raise: Error.
			simulator call: 0 with: 16rFA with: -16r2C2C with: 0 with: 0.
			self should: [simulator call: 0 with: 16rFB with: 0 with: 0 with: 0] raise: Error.
			self assert: (simulator memory at: 16rE4 + 1) equals: 42.
			self assert: (simulator memory at: 16rE5 + 1) equals: 43.
			self assert: (simulator memory at: 16rE6 + 1) equals: 44.
			self assert: (simulator memory at: 16rE7 + 1) equals: 45.
			self assert: (simulator memory at: 16rF4 + 1) equals: 16r100 - 42.
			self assert: (simulator memory at: 16rF5 + 1) equals: 16r100 - 43.
			self assert: (simulator memory at: 16rF6 + 1) equals: 16r100 - 44.
			self assert: (simulator memory at: 16rF7 + 1) equals: 16r100 - 45].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:51:53'!
testSll
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler sllR: V0 R: A0 C: 2).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  00041080  sll v0, a0, 2
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 42 with: 0 with: 0 with: 0.
			self assert: result equals: 42 << 2.
			result := simulator call: 0 with: -42 with: 0 with: 0 with: 0.
			self assert: result equals: -42 << 2].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/30/2015 18:38:30'!
testSllLarge
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler sllR: V0 R: A0 C: 31).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  000417C0  sll v0, a0, 31
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: 42 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -42 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: 1 with: 0 with: 0 with: 0.
			self assert: result equals: -16r80000000.
			result := simulator call: 0 with: -1 with: 0 with: 0 with: 0.
			self assert: result equals: -16r80000000].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:52:08'!
testSllv
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler sllvR: V0 R: A0 R: A1).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  00A41004  sllv v0, a0, a1
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 42 with: 2 with: 0 with: 0.
			self assert: result equals: 42 << 2.
			result := simulator call: 0 with: -42 with: 2 with: 0 with: 0.
			self assert: result equals: -42 << 2].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:52:22'!
testSlt
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler sltR: V0 R: A0 R: A1).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  0085102A  slt v0, a0, a1
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 3 with: 4 with: 0 with: 0.
			self assert: result equals: 1.
			result := simulator call: 0 with: 4 with: 3 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -3 with: 4 with: 0 with: 0.
			self assert: result equals: 1.
			result := simulator call: 0 with: 4 with: -3 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: 5 with: 5 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -5 with: -5 with: 0 with: 0.
			self assert: result equals: 0].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:52:39'!
testSlti
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler sltiR: V0 R: A0 C: 3).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  28820003  slti v0, a0, 3
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 3 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: 4 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -3 with: 0 with: 0 with: 0.
			self assert: result equals: 1].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:53:43'!
testSltiNegative
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler sltiR: V0 R: A0 C: -3).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  2882FFFD  slti v0, a0, -3
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 3 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: 4 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -3 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -4 with: 0 with: 0 with: 0.
			self assert: result equals: 1].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:54:03'!
testSltiu
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler sltiuR: V0 R: A0 C: 3).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  2C820003  sltiu v0, a0, 3
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 2 with: 0 with: 0 with: 0.
			self assert: result equals: 1.
			result := simulator call: 0 with: 3 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: 4 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -3 with: 0 with: 0 with: 0.
			self assert: result equals: 0].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:54:19'!
testSltiuNegative
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler sltiuR: V0 R: A0 C: -3).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  2C82FFFD  sltiu v0, a0, -3
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 2 with: 0 with: 0 with: 0.
			self assert: result equals: 1.
			result := simulator call: 0 with: 3 with: 0 with: 0 with: 0.
			self assert: result equals: 1.
			result := simulator call: 0 with: 4 with: 0 with: 0 with: 0.
			self assert: result equals: 1.
			result := simulator call: 0 with: -2 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -3 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -4 with: 0 with: 0 with: 0.
			self assert: result equals: 1].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/11/2015 19:49:13'!
testSltu
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler sltuR: V0 R: A0 R: A1).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  0085102B  sltu v0, a0, a1
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 3 with: 4 with: 0 with: 0.
			self assert: result equals: 1.
			result := simulator call: 0 with: 4 with: 3 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -3 with: 4 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: 4 with: -3 with: 0 with: 0.
			self assert: result equals: 1.
			result := simulator call: 0 with: 5 with: 5 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -5 with: -5 with: 0 with: 0.
			self assert: result equals: 0].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:54:54'!
testSra
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler sraR: V0 R: A0 C: 2).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  00041083  sra v0, a0, 2
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 42 with: 0 with: 0 with: 0.
			self assert: result equals: 42 >> 2.
			result := simulator call: 0 with: -42 with: 0 with: 0 with: 0.
			self assert: result equals: -42 >> 2].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/30/2015 18:33:32'!
testSraLarge
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler sraR: V0 R: A0 C: 31).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  000417C3  sra v0, a0, 31
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: 42 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -42 with: 0 with: 0 with: 0.
			self assert: result equals: -1].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:58:05'!
testSrav
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler sravR: V0 R: A0 R: A1).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  00A41007  srav v0, a0, a1
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 42 with: 2 with: 0 with: 0.
			self assert: result equals: 42 >> 2.
			result := simulator call: 0 with: -42 with: 2 with: 0 with: 0.
			self assert: result equals: -42 >> 2].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:58:43'!
testSrl
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler srlR: V0 R: A0 C: 2).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  00041082  srl v0, a0, 2
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 42 with: 0 with: 0 with: 0.
			self assert: result equals: 42 >> 2.
			result := simulator call: 0 with: -42 with: 0 with: 0 with: 0.
			self assert: result equals: (16r100000000 - 42) >> 2].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/30/2015 18:34:42'!
testSrlLarge
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler srlR: V0 R: A0 C: 31).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  000417C2  srl v0, a0, 31
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: 42 with: 0 with: 0 with: 0.
			self assert: result equals: 0.
			result := simulator call: 0 with: -42 with: 0 with: 0 with: 0.
			self assert: result equals: 1].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:59:36'!
testSrlv
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler srlvR: V0 R: A0 R: A1).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  00A41006  srlv v0, a0, a1
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 42 with: 2 with: 0 with: 0.
			self assert: result equals: 42 >> 2.
			result := simulator call: 0 with: -42 with: 2 with: 0 with: 0.
			self assert: result equals: (16r100000000 - 42) >> 2].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 21:59:59'!
testSubu
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler subuR: V0 R: A0 R: A1).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  00851023  subu v0, a0, a1
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 3 with: 4 with: 0 with: 0.
			self assert: result equals: -1.
			result := simulator call: 0 with: 3 with: -4 with: 0 with: 0.
			self assert: result equals: 7.
			result := simulator call: 0 with: -3 with: 4 with: 0 with: 0.
			self assert: result equals: -7.
			result := simulator call: 0 with: 16r7FFFFFFF with: -1 with: 0 with: 0.
			self assert: result equals: (-1 << 31).
			result := simulator call: 0 with: (-1 << 31) with: 1 with: 0 with: 0.
			self assert: result equals: (1 << 31) - 1].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 22:00:26'!
testSw
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler swR: A1 base: A0 offset: 4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  AC850004  sw a1, 4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator call: 0 with: 16rE0 with: 16r2D2C2B2A with: 0 with: 0.
			self should: [simulator call: 0 with: 16rE1 with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rE2 with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rE3 with: 0 with: 0 with: 0] raise: Error.
			simulator call: 0 with: 16rF0 with: -16r2C2B2A2A with: 0 with: 0.
			self should: [simulator call: 0 with: 16rF1 with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rF2 with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rF3 with: 0 with: 0 with: 0] raise: Error.
			self assert: (simulator memory at: 16rE4 + 1) equals: 42.
			self assert: (simulator memory at: 16rE5 + 1) equals: 43.
			self assert: (simulator memory at: 16rE6 + 1) equals: 44.
			self assert: (simulator memory at: 16rE7 + 1) equals: 45.
			self assert: (simulator memory at: 16rF4 + 1) equals: 16r100 - 42.
			self assert: (simulator memory at: 16rF5 + 1) equals: 16r100 - 43.
			self assert: (simulator memory at: 16rF6 + 1) equals: 16r100 - 44.
			self assert: (simulator memory at: 16rF7 + 1) equals: 16r100 - 45].! !

!MIPSELSimulatorTests methodsFor: 'tests - memory' stamp: 'rmacnak 11/10/2015 22:00:49'!
testSwNegativeOffset
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler swR: A1 base: A0 offset: -4).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  AC85FFFC  sw a1, -4(a0)
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			simulator call: 0 with: 16rE8 with: 16r2D2C2B2A with: 0 with: 0.
			self should: [simulator call: 0 with: 16rE9 with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rEA with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rEB with: 0 with: 0 with: 0] raise: Error.
			simulator call: 0 with: 16rF8 with: -16r2C2B2A2A with: 0 with: 0.
			self should: [simulator call: 0 with: 16rF9 with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rFA with: 0 with: 0 with: 0] raise: Error.
			self should: [simulator call: 0 with: 16rFB with: 0 with: 0 with: 0] raise: Error.
			self assert: (simulator memory at: 16rE4 + 1) equals: 42.
			self assert: (simulator memory at: 16rE5 + 1) equals: 43.
			self assert: (simulator memory at: 16rE6 + 1) equals: 44.
			self assert: (simulator memory at: 16rE7 + 1) equals: 45.
			self assert: (simulator memory at: 16rF4 + 1) equals: 16r100 - 42.
			self assert: (simulator memory at: 16rF5 + 1) equals: 16r100 - 43.
			self assert: (simulator memory at: 16rF6 + 1) equals: 16r100 - 44.
			self assert: (simulator memory at: 16rF7 + 1) equals: 16r100 - 45].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 22:01:08'!
testXor
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler xorR: V0 R: A0 R: A1).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  00851026  xor v0, a0, a1
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 2r101 with: 2r011 with: 0 with: 0.
			self assert: result equals: 2r110.
			result := simulator call: 0 with: -1 with: 42 with: 0 with: 0.
			self assert: result equals: 42 bitInvert].! !

!MIPSELSimulatorTests methodsFor: 'tests - arithmetic' stamp: 'rmacnak 11/10/2015 22:01:34'!
testXori
	| result |
	self 
		testGenerateInto: 
			[:stream :compiler | 
			stream nextPut: (compiler xoriR: V0 R: A0 C: 16rABCD).
			stream nextPut: (compiler jR: RA).
			stream nextPut: (compiler nop). "Delay slot"]
		disassembly:
'00000000  3882ABCD  xori v0, a0, 43981
00000004  03E00008  jr ra
00000008  00000000  nop
'		run: 
			[:simulator | 
			result := simulator call: 0 with: 0 with: 0 with: 0 with: 0.
			self assert: result equals: 16rABCD.
			result := simulator call: 0 with: -1 with: 0 with: 0 with: 0.
			self assert: result equals: -16rABCE].! !

Object subclass: #MIPSInstruction
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: 'MIPSConstants'
	category: 'Cog-Processors'!

!MIPSInstruction commentStamp: 'rmacnak 11/11/2015 20:31:24' prior: 0!
Wrapper for decoding MIPS instructions.!

!MIPSInstruction methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/16/2015 20:46:10'!
decodeFor: visitor
	| opcode |
	opcode := self opcode.
	opcode = SPECIAL ifTrue: [^self decodeSpecialFor: visitor].
	opcode = REGIMM ifTrue: [^self decodeRegImmFor: visitor].

	opcode = J ifTrue: [^visitor jump: self].
	opcode = JAL ifTrue: [^visitor jumpAndLink: self].
	opcode = BEQ ifTrue: [^visitor branchEqual: self].
	opcode = BNE ifTrue: [^visitor branchNotEqual: self].
	opcode = BLEZ ifTrue: [^visitor branchLessEqualZero: self].
	opcode = BGTZ ifTrue: [^visitor branchGreaterThanZero: self].
	opcode = ADDIU ifTrue: [^visitor addImmediateUnsigned: self].
	opcode = SLTI ifTrue: [^visitor setOnLessThanImmediate: self].
	opcode = SLTIU ifTrue: [^visitor setOnLessThanImmediateUnsigned: self].
	opcode = ANDI ifTrue: [^visitor andImmediate: self].
	opcode = ORI ifTrue: [^visitor orImmediate: self].
	opcode = XORI ifTrue: [^visitor xorImmediate: self].
	opcode = LUI ifTrue: [^visitor loadUpperImmediate: self].
	opcode = LB ifTrue: [^visitor loadByte: self].
	opcode = LH ifTrue: [^visitor loadHalfword: self].
	opcode = LW ifTrue: [^visitor loadWord: self].
	opcode = LBU ifTrue: [^visitor loadByteUnsigned: self].
	opcode = LHU ifTrue: [^visitor loadHalfwordUnsigned: self].
	opcode = SB ifTrue: [^visitor storeByte: self].
	opcode = SH ifTrue: [^visitor storeHalfword: self].
	opcode = SW ifTrue: [^visitor storeWord: self].
	opcode = PREF ifTrue: [^visitor prefetch: self].

	self error: 'Unknown instruction'.! !

!MIPSInstruction methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/6/2015 21:16:43'!
decodeRegImmFor: visitor
	| fn |
	fn := self rt.
	fn = BLTZ ifTrue: [^visitor branchLessThanZero: self].
	fn = BGEZ ifTrue: [^visitor branchGreaterEqualZero: self].
	
	self error: 'Unknown instruction'.! !

!MIPSInstruction methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/21/2015 18:22:02'!
decodeSpecialFor: visitor
	| function |
	function := self function.
	function = SLL ifTrue: [^visitor shiftLeftLogical: self].
	function = SRL ifTrue: [^visitor shiftRightLogical: self].
	function = SRA ifTrue: [^visitor shiftRightArithmetic: self].
	function = SLLV ifTrue: [^visitor shiftLeftLogicalVariable: self].
	function = SRLV ifTrue: [^visitor shiftRightLogicalVariable: self].
	function = SRAV ifTrue: [^visitor shiftRightArithmeticVariable: self].
	function = JR ifTrue: [^visitor jumpRegister: self].
	function = JALR ifTrue: [^visitor jumpAndLinkRegister: self].
	function = BREAK ifTrue: [^visitor break: self].
	function = MFHI ifTrue: [^visitor moveFromHigh: self].
	function = MFLO ifTrue: [^visitor moveFromLow: self].
	function = MULT ifTrue: [^visitor multiplySigned: self].
	function = DIV ifTrue: [^visitor divideSigned: self].
	function = ADDU ifTrue: [^visitor addUnsigned: self].
	function = SUBU ifTrue: [^visitor subtractUnsigned: self].
	function = AND ifTrue: [^visitor bitwiseAnd: self].
	function = OR ifTrue: [^visitor bitwiseOr: self].
	function = XOR ifTrue: [^visitor bitwiseXor: self].
	function = SLT ifTrue: [^visitor setOnLessThan: self].
	function = SLTU ifTrue: [^visitor setOnLessThanUnsigned: self].
	
	self error: 'Unknown instruction'.! !

!MIPSInstruction methodsFor: 'fields' stamp: 'rmacnak 11/5/2015 20:24:42'!
function
	^value bitAnd: 63! !

!MIPSInstruction methodsFor: 'fields' stamp: 'rmacnak 10/27/2015 21:23:07'!
opcode
	^value >> 26! !

!MIPSInstruction methodsFor: 'fields' stamp: 'rmacnak 10/27/2015 21:24:41'!
rd
	^(value >> 11) bitAnd: 31! !

!MIPSInstruction methodsFor: 'fields' stamp: 'rmacnak 10/27/2015 21:23:20'!
rs
	^(value >> 21) bitAnd: 31! !

!MIPSInstruction methodsFor: 'fields' stamp: 'rmacnak 10/27/2015 21:24:36'!
rt
	^(value >> 16) bitAnd: 31! !

!MIPSInstruction methodsFor: 'fields' stamp: 'rmacnak 11/29/2015 16:42:55'!
sa
	^(value >> 6) bitAnd: 31! !

!MIPSInstruction methodsFor: 'fields' stamp: 'rmacnak 11/4/2015 22:10:41'!
signedImmediate
	^self unsigned16ToSigned16: (self unsignedImmediate)! !

!MIPSInstruction methodsFor: 'fields' stamp: 'rmacnak 10/27/2015 21:25:46'!
target
	^value bitAnd: 16r3FFFFFF! !

!MIPSInstruction methodsFor: 'fields' stamp: 'rmacnak 11/4/2015 22:10:20'!
unsigned16ToSigned16: unsignedValue
	self assert: (unsignedValue between: 0 and: 16rFFFF).
	unsignedValue >= 16r8000 ifTrue: [^unsignedValue - 16r10000].
	^unsignedValue! !

!MIPSInstruction methodsFor: 'fields' stamp: 'rmacnak 10/27/2015 21:26:31'!
unsignedImmediate
	^value bitAnd: 16rFFFF! !

!MIPSInstruction methodsFor: 'as yet unclassified' stamp: 'rmacnak 10/27/2015 21:04:27'!
value
	^value! !

!MIPSInstruction methodsFor: 'as yet unclassified' stamp: 'rmacnak 10/27/2015 21:07:11'!
value: anInteger
	self assert: (anInteger between: 0 and: 16rFFFFFFFF).
	value := anInteger! !

Object subclass: #MIPSSimulator
	instanceVariableNames: 'memory registers pc instructionCount inDelaySlot readableBase writableBase exectuableBase readableLimit writableLimit exectuableLimit jumpingPC hi lo'
	classVariableNames: 'EndSimulationPC'
	poolDictionaries: 'MIPSConstants'
	category: 'Cog-Processors'!

!MIPSSimulator commentStamp: 'rmacnak 11/11/2015 20:33:00' prior: 0!
Simulator for 32-bit MIPS, without implementation of memory access.!

MIPSSimulator subclass: #MIPSELSimulator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Processors'!

!MIPSELSimulator commentStamp: 'rmacnak 11/11/2015 20:33:13' prior: 0!
Simulator for little-endian 32-bit MIPS.!

!MIPSELSimulator methodsFor: 'accessing' stamp: 'rmacnak 11/24/2015 21:26:08'!
endianness
	^#little! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/16/2015 19:44:31'!
executeFault: address
	| jumpInstruction type |
	self assert: inDelaySlot not.
	jumpInstruction := MIPSInstruction new value: (self fetchInstruction: jumpingPC).
	jumpInstruction opcode = J ifTrue: [type := #jump].
	jumpInstruction opcode = JAL ifTrue: [type := #call].
	jumpInstruction opcode = SPECIAL ifTrue: 
		[jumpInstruction function = JR ifTrue:
			[jumpInstruction rs = RA
				ifTrue: [type := #return]
				ifFalse: [type := #jump]].
		jumpInstruction function = JALR ifTrue:
			[type := #call]].
	self assert: type ~~ nil.

	^(ProcessorSimulationTrap
			pc: nil
			nextpc: nil
			address: address
			type: type
			accessor: nil)
		signal! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/15/2015 13:00:55'!
fetchInstruction: address
	address < exectuableBase ifTrue: [self executeFault: address].
	address > exectuableLimit ifTrue: [self executeFault: address].
	(address bitAnd: 3) = 0 ifFalse: [self error: 'Unaligned read'].
	^memory unsignedLongAt: address + 1 bigEndian: false! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/15/2015 16:09:39'!
readFault: address
	| destReg |
	self assert: inDelaySlot not. "Or we have to store nextPC somewhere."
	destReg := (MIPSInstruction new value: (self fetchInstruction: pc)) rt.
	
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 4
			address: address
			type: #read
			accessor: (self setterForRegister: destReg))
		signal
! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/15/2015 13:01:17'!
signedByte: address
	address < readableBase ifTrue: [self readFault: address].
	address > readableLimit ifTrue: [self readFault: address].
	^memory signedByteAt: address + 1! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/15/2015 13:02:31'!
signedByte: address put: value
	address < writableBase ifTrue: [self writeFault: address].
	address > writableLimit ifTrue: [self writeFault: address].
	^memory signedByteAt: address + 1 put: value! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/27/2015 12:10:14'!
signedHalfword: address
	(address bitAnd: 1) = 0 ifFalse: [self error: 'Unaligned read'].
	address < readableBase ifTrue: [self readFault: address].
	address > readableLimit ifTrue: [self readFault: address].
	^memory signedShortAt: address + 1! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/15/2015 13:02:27'!
signedHalfword: address put: value
	(address bitAnd: 1) = 0 ifFalse: [self error: 'Unaligned read'].
	address < writableBase ifTrue: [self writeFault: address].
	address > writableLimit ifTrue: [self writeFault: address].
	^memory signedShortAt: address + 1 put: value! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/15/2015 12:33:10'!
signedWord: address
	(address bitAnd: 3) = 0 ifFalse: [self error: 'Unaligned read'].
	address < readableBase ifTrue: [self readFault: address].
	address > readableLimit ifTrue: [self readFault: address].		
	^memory longAt: address + 1! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/16/2015 20:49:01'!
signedWord: address put: value
	(address bitAnd: 3) = 0 ifFalse: [self error: 'Unaligned read'].
	address < writableBase ifTrue: [self writeFault: address].
	address > writableLimit ifTrue: [self writeFault: address].
	^memory longAt: address + 1 put: value! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/21/2015 15:25:44'!
unsignedByte: address
	address < readableBase ifTrue: [self readFault: address].
	address > readableLimit ifTrue: [self readFault: address].
	^memory byteAt: address + 1! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/21/2015 15:26:20'!
unsignedByte: address put: value
	address < writableBase ifTrue: [self writeFault: address].
	address > writableLimit ifTrue: [self writeFault: address].
	^memory byteAt: address + 1 put: value! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/21/2015 15:38:45'!
unsignedHalfword: address
	address < readableBase ifTrue: [self readFault: address].
	address > readableLimit ifTrue: [self readFault: address].
	(address bitAnd: 1) = 0 ifFalse: [self error: 'Unaligned read'].
	^memory unsignedShortAt: address + 1! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/15/2015 13:02:11'!
unsignedHalfword: address put: value
	(address bitAnd: 1) = 0 ifFalse: [self error: 'Unaligned read'].
	address < writableBase ifTrue: [self writeFault: address].
	address > writableLimit ifTrue: [self writeFault: address].
	^memory unsignedShortAt: address + 1 put: value! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/15/2015 13:01:53'!
unsignedWord: address
	address < readableBase ifTrue: [self readFault: address].
	address > readableLimit ifTrue: [self readFault: address].
	(address bitAnd: 3) = 0 ifFalse: [self error: 'Unaligned read'].
	^memory unsignedLongAt: address + 1 bigEndian: false! !

!MIPSELSimulator methodsFor: 'memory' stamp: 'rmacnak 11/15/2015 16:26:16'!
writeFault: address
	| srcReg |
	self assert: inDelaySlot not. "Or we have to store nextPC somewhere."
	srcReg := (MIPSInstruction new value: (self fetchInstruction: pc)) rt.
	
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 4
			address: address
			type: #write
			accessor: (self getterForRegister: srcReg))
		signal
! !

!MIPSSimulator class methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/21/2015 09:46:35'!
defaultIntegerBaseInDebugger
	^16! !

!MIPSSimulator class methodsFor: 'as yet unclassified' stamp: 'rmacnak 10/27/2015 21:06:25'!
initialize
	super initialize.
	EndSimulationPC := 16rABABABAB.
	OneInstruction := 4.
	TwoInstructions := 8.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/4/2015 22:08:49'!
addImmediateUnsigned: instruction
	"Unsigned here means the instruction doesn't generate exceptions,
	 not that the immediate is unsigned."
	| rsValue immediate result |
	rsValue := self unsignedRegister: instruction rs.
	immediate := instruction signedImmediate.
	result := rsValue + immediate bitAnd: 16rFFFFFFFF. "No exception on overflow"
	self unsignedRegister: instruction rt put: result.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/5/2015 20:31:29'!
addUnsigned: instruction
	"Unsigned here means the instruction doesn't generate exceptions."
	| rsValue rtValue result |
	rsValue := self unsignedRegister: instruction rs.
	rtValue := self unsignedRegister: instruction rt.
	result := rsValue + rtValue bitAnd: 16rFFFFFFFF. "No exception on overflow"
	self unsignedRegister: instruction rd put: result.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/5/2015 20:50:37'!
andImmediate: instruction
	| rsValue immediate result |
	rsValue := self unsignedRegister: instruction rs.
	immediate := instruction unsignedImmediate.
	result := rsValue bitAnd: immediate.
	self unsignedRegister: instruction rt put: result.! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/24/2015 18:12:51'!
bitsInWord
	^32! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/5/2015 21:10:29'!
bitwiseAnd: instruction
	| rsValue rtValue result |
	rsValue := self signedRegister: instruction rs.
	rtValue := self signedRegister: instruction rt.
	result := rsValue bitAnd: rtValue.
	self signedRegister: instruction rd put: result.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/5/2015 21:10:34'!
bitwiseOr: instruction
	| rsValue rtValue result |
	rsValue := self signedRegister: instruction rs.
	rtValue := self signedRegister: instruction rt.
	result := rsValue bitOr: rtValue.
	self signedRegister: instruction rd put: result.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/5/2015 23:03:31'!
bitwiseXor: instruction
	| rsValue rtValue result |
	rsValue := self signedRegister: instruction rs.
	rtValue := self signedRegister: instruction rt.
	result := rsValue bitXor: rtValue.
	self signedRegister: instruction rd put: result.! !

!MIPSSimulator methodsFor: 'instructions - control' stamp: 'rmacnak 11/6/2015 20:51:01'!
branchEqual: instruction
	| rsValue rtValue |
	self assert: inDelaySlot not.
	rsValue := self signedRegister: instruction rs.
	rtValue := self signedRegister: instruction rt.
	self doBranch: rsValue = rtValue offset: instruction signedImmediate << 2.! !

!MIPSSimulator methodsFor: 'instructions - control' stamp: 'rmacnak 11/6/2015 20:58:22'!
branchGreaterEqualZero: instruction
	| rsValue |
	self assert: inDelaySlot not.
	rsValue := self signedRegister: instruction rs.
	self doBranch: rsValue >= 0 offset: instruction signedImmediate << 2.! !

!MIPSSimulator methodsFor: 'instructions - control' stamp: 'rmacnak 11/6/2015 21:08:20'!
branchGreaterThanZero: instruction
	| rsValue |
	self assert: inDelaySlot not.
	rsValue := self signedRegister: instruction rs.
	self doBranch: rsValue > 0 offset: instruction signedImmediate << 2.! !

!MIPSSimulator methodsFor: 'instructions - control' stamp: 'rmacnak 11/6/2015 21:14:40'!
branchLessEqualZero: instruction
	| rsValue |
	self assert: inDelaySlot not.
	rsValue := self signedRegister: instruction rs.
	self doBranch: rsValue <= 0 offset: instruction signedImmediate << 2.! !

!MIPSSimulator methodsFor: 'instructions - control' stamp: 'rmacnak 11/6/2015 21:18:00'!
branchLessThanZero: instruction
	| rsValue |
	self assert: inDelaySlot not.
	rsValue := self signedRegister: instruction rs.
	self doBranch: rsValue < 0 offset: instruction signedImmediate << 2.! !

!MIPSSimulator methodsFor: 'instructions - control' stamp: 'rmacnak 11/6/2015 21:21:18'!
branchNotEqual: instruction
	| rsValue rtValue |
	self assert: inDelaySlot not.
	rsValue := self signedRegister: instruction rs.
	rtValue := self signedRegister: instruction rt.
	self doBranch: rsValue ~= rtValue offset: instruction signedImmediate << 2.! !

!MIPSSimulator methodsFor: 'instructions - control' stamp: 'rmacnak 11/6/2015 21:28:13'!
break: instruction
	self error: 'Break!!'! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/16/2015 21:49:53'!
cResultRegister: cResult
	^self unsignedRegister: V0 put: cResult! !

!MIPSSimulator methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/5/2015 20:29:25'!
call: entryPC
	| zapValue |
	zapValue := self unsigned32ToSigned32: 16rBABABABA.
	^self call: entryPC with: zapValue with: zapValue with: zapValue with: zapValue! !

!MIPSSimulator methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/17/2015 19:13:07'!
call: entryPC with: arg0 with: arg1 with: arg2 with: arg3.
	
	pc := entryPC.
	self unsignedRegister: RA put: EndSimulationPC.
	self signedRegister: A0 put: arg0.
	self signedRegister: A1 put: arg1.
	self signedRegister: A2 put: arg2.
	self signedRegister: A3 put: arg3.
	
	self execute.
	
	^self signedRegister: V0.! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/15/2015 12:35:37'!
convertIntegerToInternal: anInteger
	"Default conversion for 32-bit processors.  64-bit processors override."
	^anInteger signedIntToLong! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/24/2015 18:55:10'!
convertInternalToInteger: unsigned
	"Default conversion for 32-bit processors.  64-bit processors override."
	^unsigned signedIntFromLong! !

!MIPSSimulator methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/20/2015 20:34:38'!
currentInstruction
	^[(MIPSDisassembler new disassemble: memory from: pc to: pc + 4)]
		ifError: ['Cannot disassemble', String cr].! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/10/2015 20:58:09'!
disassembleFrom: startAddress to: endAddress in: memory for: aSymbolManager "<Cogit>" labels: labelDictionary on: aStream
	MIPSDisassembler new 
		disassemble: memory
		from: startAddress
		to: endAddress
		for: aSymbolManager
		labels: labelDictionary
		on: aStream.! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/24/2015 19:09:47'!
disassembleFrom: startAddress to: endAddress in: memory on: aStream
	MIPSDisassembler new 
		disassemble: memory
		from: startAddress
		to: endAddress
		for: nil
		labels: nil
		on: aStream.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/27/2015 12:20:32'!
divideSigned: instruction
	"Strangely, the MIPS reference manual does not indicate which division is used, but testing on some hardware shows it is truncated division (rather than floored division or Euclidean division)."	
	| rsValue rtValue |
	rsValue := self signedRegister: instruction rs.
	rtValue := self signedRegister: instruction rt.
	rtValue = 0 ifTrue: 
		["No exception is signalled"
		 lo := rtValue. 
		 hi := rsValue.
		 ^self].
	(rtValue = -1 and: [rsValue = -16r80000000]) ifTrue:
		["Only overflow case"
		 lo := rsValue. 
		 hi := 0.
		 ^self].
	lo := rsValue quo: rtValue.
	hi := rsValue rem: rtValue.
! !

!MIPSSimulator methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/7/2015 10:50:07'!
doBranch: taken offset: offset
	| nextPC |
	pc := pc + OneInstruction.
	nextPC := pc + offset. "Branch target is relative to the delay slot."
	self executeDelaySlot.
	taken ifTrue: [pc := nextPC - OneInstruction "Account for general increment"].! !

!MIPSSimulator methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/24/2015 18:43:24'!
execute
	[pc ~= EndSimulationPC] whileTrue: [self step].! !

!MIPSSimulator methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/24/2015 21:15:22'!
executeDelaySlot
	| instruction |
	self assert: inDelaySlot not.
	inDelaySlot := true.
	instructionCount := instructionCount + 1.
	"Transcript print: instructionCount; nextPutAll: ' D '; nextPutAll: self currentInstruction; flush."
	instruction := MIPSInstruction new value: (self fetchInstruction: pc).
	instruction decodeFor: self.
	inDelaySlot := false.! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/9/2015 20:03:08'!
flushICacheFrom: startAddress "<Integer>" to: endAddress "<Integer>"! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/22/2015 21:01:58'!
fp
	^self unsignedRegister: FP! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/22/2015 21:02:00'!
fp: anInteger
	^self unsignedRegister: FP put: anInteger! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/15/2015 16:28:31'!
getterForRegister: registerNumber
	^#(zr at v0 v1 a0 a1 a2 a3
		t0 t1 t2 t3 t4 t5 t6 t7
		s0 s1 s2 s3 s4 s5 s6 s7
		t8 t9 k0 k1 gp sp fp ra) at: registerNumber + 1! !

!MIPSSimulator methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/24/2015 19:27:28'!
initialize
	registers := Array new: 32 withAll: 0.
	pc := 0.
	hi := 0.
	lo := 0.
	inDelaySlot := false.
	instructionCount := 0.! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/15/2015 11:17:10'!
initializeStackFor: aCogit
	self flag: #OABI.
	aCogit setStackAlignment: 8 expectedSPOffset: 0 expectedFPOffset: 0.
	! !

!MIPSSimulator methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/17/2015 19:12:52'!
initializeWithMemory: aByteArray
	memory := aByteArray.
	readableBase := 0.
	writableBase := 0.
	exectuableBase := 0.
	readableLimit := memory size.
	writableLimit := memory size.
	exectuableLimit := memory size.! !

!MIPSSimulator methodsFor: 'instructions - control' stamp: 'rmacnak 11/16/2015 19:32:34'!
jump: instruction
	| nextPC |
	self assert: inDelaySlot not.
	jumpingPC := pc.
	pc := pc + OneInstruction.
	nextPC := (pc bitAnd: 16rF0000000) + (instruction target << 2). "Region is that of the delay slot."	
	self executeDelaySlot.
	pc := nextPC - OneInstruction. "Account for general increment"! !

!MIPSSimulator methodsFor: 'instructions - control' stamp: 'rmacnak 11/16/2015 19:32:50'!
jumpAndLink: instruction
	| nextPC |
	self assert: inDelaySlot not.
	self unsignedRegister: RA put: pc + TwoInstructions. "Return past delay slot."
	jumpingPC := pc.
	pc := pc + OneInstruction.
	nextPC := (pc bitAnd: 16rF0000000) + (instruction target << 2). "Region is that of the delay slot."	
	self executeDelaySlot.
	pc := nextPC - OneInstruction. "Account for general increment"! !

!MIPSSimulator methodsFor: 'instructions - control' stamp: 'rmacnak 11/24/2015 20:10:21'!
jumpAndLinkRegister: instruction
	| nextPC |
	self assert: inDelaySlot not.
	self unsignedRegister: instruction rd put: pc + TwoInstructions. "Return past delay slot."
	nextPC := self unsignedRegister: instruction rs.
	jumpingPC := pc.
	pc := pc + OneInstruction.
	self executeDelaySlot.
	pc := nextPC.
	pc := pc - OneInstruction. "Account for general increment"! !

!MIPSSimulator methodsFor: 'instructions - control' stamp: 'rmacnak 11/24/2015 20:10:25'!
jumpRegister: instruction
	| nextPC |
	self assert: inDelaySlot not.
	nextPC := self unsignedRegister: instruction rs.
	jumpingPC := pc.
	pc := pc + OneInstruction.
	self executeDelaySlot.
	pc := nextPC.
	pc := pc - OneInstruction. "Account for general increment"! !

!MIPSSimulator methodsFor: 'instructions - memory' stamp: 'rmacnak 11/11/2015 20:21:22'!
loadByte: instruction
	| base address value |
	base := self unsignedRegister: instruction rs.
	address := base + instruction signedImmediate.
	value := self signedByte: address.
	self signedRegister: instruction rt put: value.! !

!MIPSSimulator methodsFor: 'instructions - memory' stamp: 'rmacnak 11/11/2015 20:23:04'!
loadByteUnsigned: instruction
	| base address value |
	base := self unsignedRegister: instruction rs.
	address := base + instruction signedImmediate.
	value := self unsignedByte: address.
	self unsignedRegister: instruction rt put: value.! !

!MIPSSimulator methodsFor: 'instructions - memory' stamp: 'rmacnak 11/11/2015 20:22:47'!
loadHalfword: instruction
	| base address value |
	base := self unsignedRegister: instruction rs.
	address := base + instruction signedImmediate.
	value := self signedHalfword: address.
	self signedRegister: instruction rt put: value.! !

!MIPSSimulator methodsFor: 'instructions - memory' stamp: 'rmacnak 11/11/2015 20:23:15'!
loadHalfwordUnsigned: instruction
	| base address value |
	base := self unsignedRegister: instruction rs.
	address := base + instruction signedImmediate.
	value := self unsignedHalfword: address.
	self unsignedRegister: instruction rt put: value.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/4/2015 22:17:14'!
loadUpperImmediate: instruction
	| result |
	self assert: instruction rs = 0.
	result := instruction signedImmediate << 16.
	self signedRegister: instruction rt put: result.! !

!MIPSSimulator methodsFor: 'instructions - memory' stamp: 'rmacnak 11/11/2015 20:22:54'!
loadWord: instruction
	| base address value |
	base := self unsignedRegister: instruction rs.
	address := base + instruction signedImmediate.
	value := self signedWord: address.
	self signedRegister: instruction rt put: value.! !

!MIPSSimulator methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/7/2015 14:26:40'!
memory
	^memory! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/21/2015 18:35:23'!
moveFromHigh: instruction
	self signedRegister: instruction rd put: hi.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/21/2015 18:35:17'!
moveFromLow: instruction
	self signedRegister: instruction rd put: lo.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/21/2015 22:06:27'!
multiplySigned: instruction
	| rsValue rtValue result |
	rsValue := self signedRegister: instruction rs.
	rtValue := self signedRegister: instruction rt.
	result := rsValue * rtValue.
	result := self signed64ToUnsigned64: result.
	hi := self unsigned32ToSigned32: result >> 32.
	lo := self unsigned32ToSigned32: (result bitAnd: 16rFFFFFFFF).! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/4/2015 22:27:38'!
orImmediate: instruction
	| rsValue immediate result |
	rsValue := self unsignedRegister: instruction rs.
	immediate := instruction unsignedImmediate.
	result := rsValue bitOr: immediate.
	self unsignedRegister: instruction rt put: result.! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/20/2015 18:26:55'!
pc
	^pc! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/15/2015 10:57:17'!
pc: newPC
	pc := newPC.! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/21/2015 22:08:05'!
popWordIn: aMemory 
	| sp word |
	word := aMemory unsignedLongAt: (sp := self sp) + 1 bigEndian: false.
	self sp: sp + 4.
	^word! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/16/2015 20:07:50'!
postCallArgumentsNumArgs: numArgs "<Integer>" in: memory "<ByteArray|Bitmap>"
	"Answer an argument vector of the requested size after a vanilla ABI call. 
	 We assume that all arguments are single word arguments, which can not be
	 supplied on co-processor-registers. For compatibility with Cog/Slang we answer
	 unsigned values."
	self flag: #OABI.
	
	numArgs = 0 ifTrue: 
		[^{}].
	numArgs = 1 ifTrue: 
		[^{self unsignedRegister: A0}].
	numArgs = 2 ifTrue:
		[^{self unsignedRegister: A0. self unsignedRegister: A1}].
	numArgs = 3 ifTrue:
		[^{self unsignedRegister: A0. self unsignedRegister: A1. self unsignedRegister: A2}].
	numArgs = 4 ifTrue:
		[^{self unsignedRegister: A0. self unsignedRegister: A1. self unsignedRegister: A2. self unsignedRegister: A3}].
	self unimplemented.! !

!MIPSSimulator methodsFor: 'instructions - memory' stamp: 'rmacnak 11/17/2015 19:01:56'!
prefetch: instruction
	self assert: (instruction rt = HintLoad or: [instruction rt = HintStore]).! !

!MIPSSimulator methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/24/2015 21:25:05'!
printOn: stream
	stream nextPutAll: self class name; nextPut: $:; cr.
	self printRegistersOn: stream.
	stream nextPutAll: self currentInstruction.! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/24/2015 21:36:23'!
printRegistersOn: stream
	0 to: 31 do:
		[:reg |
		stream space.
		stream nextPutAll: (MIPSConstants nameForRegister: reg).
		stream space.
		(self unsignedRegister: reg) printOn: stream base: 16 nDigits: 8.
		stream space.
		(self signedRegister: reg) printOn: stream.
		stream cr].

	stream nextPutAll: ' hi '.
	hi printOn: stream base: 16 nDigits: 8.
	stream space.
	hi printOn: stream.
	stream cr.
	
	stream nextPutAll: ' lo '.
	lo printOn: stream base: 16 nDigits: 8.
	stream space.
	lo printOn: stream.
	stream cr.
	
	stream nextPutAll: ' pc '.
	pc printOn: stream base: 16 nDigits: 8.
	stream space.
	pc printOn: stream.
	stream cr.! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/16/2015 19:52:53'!
pushWord: aValue in: aMemory
	aMemory longAt: (self sp: self sp - 4) + 1 put: aValue bigEndian: false! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/22/2015 21:02:03'!
ra
	^self unsignedRegister: RA! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/22/2015 21:02:05'!
ra: anInteger
	^self unsignedRegister: RA put: anInteger! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/24/2015 18:38:53'!
reset
	^self initialize! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/21/2015 21:58:31'!
retpcIn: aMemory
	"The return address is on the stack, having been pushed by either
	 simulateCallOf:nextpc:memory: or simulateJumpCallOf:memory:"
	^aMemory unsignedLongAt: self fp + 5 bigEndian: false! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/21/2015 12:37:43'!
runInMemory: aMemory minimumAddress: minimumAddress readOnlyBelow: minimumWritableAddress
	"Note that minimumWritableAddress is both the minimum writeable address AND the maximum executable address"
	memory := aMemory.
	readableBase := minimumAddress.
	writableBase := minimumWritableAddress.
	exectuableBase := minimumAddress.
	readableLimit := aMemory byteSize.
	writableLimit := aMemory byteSize.
	exectuableLimit := minimumWritableAddress.
	self execute.! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/24/2015 18:41:29'!
s0
	^self unsignedRegister: S0! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/23/2015 22:18:26'!
s0: anInteger
	^self unsignedRegister: S0 put: anInteger! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/24/2015 18:41:36'!
s1
	^self unsignedRegister: S1! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/24/2015 18:41:20'!
s1: anInteger
	^self unsignedRegister: S1 put: anInteger! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/24/2015 18:41:42'!
s2
	^self unsignedRegister: S2! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/23/2015 21:10:27'!
s2: anInteger
	^self unsignedRegister: S2 put: anInteger! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/22/2015 21:02:08'!
s3
	^self unsignedRegister: S3! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/24/2015 18:41:50'!
s3: anInteger
	^self unsignedRegister: S3 put: anInteger! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/24/2015 18:41:58'!
s4
	^self unsignedRegister: S4! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/22/2015 21:02:10'!
s4: anInteger
	^self unsignedRegister: S4 put: anInteger! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/22/2015 21:02:12'!
s5
	^self unsignedRegister: S5! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/22/2015 21:02:14'!
s5: anInteger
	^self unsignedRegister: S5 put: anInteger! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/24/2015 19:28:55'!
s6
	^self unsignedRegister: S6! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/24/2015 19:29:01'!
s6: anInteger
	^self unsignedRegister: S6 put: anInteger! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/23/2015 20:36:04'!
setFramePointer: fp stackPointer: sp
	self unsignedRegister: SP put: sp.
	self unsignedRegister: FP put: fp.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/8/2015 15:07:16'!
setOnLessThan: instruction
	| rsValue rtValue result |
	rsValue := self signedRegister: instruction rs.
	rtValue := self signedRegister: instruction rt.
	result := rsValue < rtValue ifTrue: [1] ifFalse: [0].
	self signedRegister: instruction rd put: result.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/8/2015 15:27:32'!
setOnLessThanImmediate: instruction
	| rsValue immediate result |
	rsValue := self signedRegister: instruction rs.
	immediate := instruction signedImmediate.
	result := rsValue < immediate ifTrue: [1] ifFalse: [0].
	self signedRegister: instruction rt put: result.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/8/2015 15:29:48'!
setOnLessThanImmediateUnsigned: instruction
	"The immediate is still sign-extended; it is the comparison that is unsigned."
	| rsValue immediate result |
	rsValue := self unsignedRegister: instruction rs.
	immediate := self signed32ToUnsigned32: instruction signedImmediate.
	result := rsValue < immediate ifTrue: [1] ifFalse: [0].
	self signedRegister: instruction rt put: result.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/8/2015 15:07:25'!
setOnLessThanUnsigned: instruction
	| rsValue rtValue result |
	rsValue := self unsignedRegister: instruction rs.
	rtValue := self unsignedRegister: instruction rt.
	result := rsValue < rtValue ifTrue: [1] ifFalse: [0].
	self signedRegister: instruction rd put: result.! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/15/2015 16:09:14'!
setterForRegister: registerNumber
	^#(zr: at: v0: v1: a0: a1: a2: a3:
		t0: t1: t2: t3: t4: t5: t6: t7:
		s0: s1: s2: s3: s4: s5: s6: s7:
		t8: t9: k0: k1: gp: sp: fp: ra:) at: registerNumber + 1! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 10/27/2015 21:45:20'!
shiftLeftLogical: instruction
	| result rtValue shiftAmount |
	self assert: instruction rs = 0.
	rtValue := self unsignedRegister: instruction rt.
	shiftAmount := instruction sa.
	result := (rtValue << shiftAmount) bitAnd: 16rFFFFFFFF.
	self unsignedRegister: instruction rd put: result.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/6/2015 18:06:51'!
shiftLeftLogicalVariable: instruction
	| result rtValue shiftAmount |
	rtValue := self unsignedRegister: instruction rt.
	shiftAmount := self unsignedRegister: instruction rs.
	(31 allMask: shiftAmount) ifFalse: 
		["MIPS will use only the low 5 bits for this shift, but we probably
		  don't want to generate any code that hits this behavior."
		self error].
	result := (rtValue << shiftAmount) bitAnd: 16rFFFFFFFF.
	self unsignedRegister: instruction rd put: result.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/6/2015 17:37:08'!
shiftRightArithmetic: instruction
	| result rtValue shiftAmount |
	self assert: instruction rs = 0.
	rtValue := self signedRegister: instruction rt.
	shiftAmount := instruction sa.
	result := rtValue >> shiftAmount.
	self signedRegister: instruction rd put: result.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/6/2015 18:07:18'!
shiftRightArithmeticVariable: instruction
	| result rtValue shiftAmount |
	rtValue := self signedRegister: instruction rt.
	shiftAmount := self unsignedRegister: instruction rs.
	(31 allMask: shiftAmount) ifFalse:
		["MIPS will use only the low 5 bits for this shift, but we probably
		  don't want to generate any code that hits this behavior."
		self error].
	result := rtValue >> shiftAmount.
	self signedRegister: instruction rd put: result.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/6/2015 17:36:46'!
shiftRightLogical: instruction
	| result rtValue shiftAmount |
	self assert: instruction rs = 0.
	rtValue := self unsignedRegister: instruction rt.
	shiftAmount := instruction sa.
	result := rtValue >> shiftAmount.
	self unsignedRegister: instruction rd put: result.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/6/2015 18:07:00'!
shiftRightLogicalVariable: instruction
	| result rtValue shiftAmount |
	rtValue := self unsignedRegister: instruction rt.
	shiftAmount := self unsignedRegister: instruction rs.
	(31 allMask: shiftAmount) ifFalse:
		["MIPS will use only the low 5 bits for this shift, but we probably
		  don't want to generate any code that hits this behavior."
		self error].
	result := rtValue >> shiftAmount.
	self unsignedRegister: instruction rd put: result.! !

!MIPSSimulator methodsFor: 'converting' stamp: 'rmacnak 10/27/2015 21:47:22'!
signed32ToUnsigned32: signedValue
	self assert: (signedValue between: -16r80000000 and: 16r7FFFFFFF).
	signedValue < 0 ifTrue: [^signedValue + 16r100000000].
	^signedValue! !

!MIPSSimulator methodsFor: 'converting' stamp: 'rmacnak 11/21/2015 18:46:25'!
signed64ToUnsigned64: signedValue
	self assert: (signedValue between: -16r8000000000000000 and: 16r7FFFFFFFFFFFFFFF).
	signedValue < 0 ifTrue: [^signedValue + 16r10000000000000000].
	^signedValue! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/15/2015 11:19:23'!
signedRegister: registerNumber
	registerNumber == ZR ifTrue: [^0] ifFalse: [^registers at: registerNumber + 1].! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/21/2015 12:36:06'!
signedRegister: registerNumber put: signedValue
	self assert: (signedValue between: -16r80000000 and: 16r7FFFFFFF).
	registerNumber == ZR ifFalse: [^registers at: registerNumber + 1 put: signedValue].! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/17/2015 18:48:29'!
simulateCallOf: address nextpc: nextpc memory: aMemory
	"Simulate a frame-building call of address.  Build a frame since
	a) this is used for calls into the run-time which are unlikely to be leaf-calls"
	
	self flag: #todo. "Why are we building a frame exactly? Frame building is a callee's job, which I'd expect to be done by some code under simulation. --rmacnak"
	
	self pushWord: self ra in: aMemory.
	self pushWord: self fp in: aMemory.
	self fp: self sp.
	pc := address.! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/24/2015 21:06:21'!
simulateJumpCallOf: address memory: aMemory
	"Simulate a frame-building jump of address.  Build a frame since
	a) this is used for calls into the run-time which are unlikely to be leaf-calls"
	"This method builds a stack frame as expected by the simulator, not as defined by ARM aapcs-abi.
	In ARM aapcs, every method can define for itself, wether it wants to push lr (nextpc), and wether it 
	uses a frame pointer. The standard never mentions a fp. It merely defines r4-r11 to be callee-saved."

	self assert: self sp \\ 8 = 0. "This check ensures, that we conform with ARM abi. Before doing anything to the stack, we ensure 2-word alignment."
	self pushWord: self ra in: aMemory.
	self pushWord: self fp in: aMemory.
	self fp: self sp.
	"PostBuildStackDelta ~= 0 ifTrue:
		[self sp: self sp - PostBuildStackDelta]." "In order to satisfy the CStackAlignment check by cogit, which is only valid on IA32 platforms."
	self pc: address! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/24/2015 21:05:16'!
simulateLeafCallOf: address nextpc: nextpc memory: aMemory
	self unsignedRegister: RA put: nextpc.
	pc := address.! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/21/2015 22:06:38'!
simulateReturnIn: aMemory
	"PostBuildStackDelta ~= 0 ifTrue:
		[self sp: self sp + PostBuildStackDelta]."
	self fp: (self popWordIn: aMemory).
	"According to tpr, most C compilers implement return by simply
	 popping into the pc, rather than popping through the link register."
	self pc: (self popWordIn: aMemory)! !

!MIPSSimulator methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/24/2015 18:44:19'!
singleStepIn: aByteArray
	self initializeWithMemory: aByteArray.
	self step.! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/21/2015 22:04:43'!
smashCallerSavedRegistersWithValuesFrom: base by: step
	"i.e., smashVolatileRegisters"
	self flag: #OABI.
	self unsignedRegister: AT put: 0 * step + base.
	self unsignedRegister: V0 put: 0 * step + base.
	self unsignedRegister: V1 put: 0 * step + base.
	self unsignedRegister: A0 put: 0 * step + base.
	self unsignedRegister: A1 put: 0 * step + base.
	self unsignedRegister: A2 put: 0 * step + base.
	self unsignedRegister: A3 put: 0 * step + base.
	self unsignedRegister: T0 put: 0 * step + base.
	self unsignedRegister: T1 put: 0 * step + base.
	self unsignedRegister: T2 put: 0 * step + base.
	self unsignedRegister: T3 put: 0 * step + base.
	self unsignedRegister: T4 put: 0 * step + base.
	self unsignedRegister: T5 put: 0 * step + base.
	self unsignedRegister: T6 put: 0 * step + base.
	self unsignedRegister: T7 put: 0 * step + base.
	self unsignedRegister: T8 put: 0 * step + base.
	self unsignedRegister: T9 put: 0 * step + base.
	self unsignedRegister: GP put: 0 * step + base.
	self unsignedRegister: RA put: 0 * step + base.! !

!MIPSSimulator methodsFor: 'processor api' stamp: 'rmacnak 11/21/2015 10:53:07'!
smashRegistersWithValuesFrom: base by: step
	2 to: 31 do: [:index | self unsignedRegister: index put: index - 1 * step + base].
! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/22/2015 21:02:16'!
sp
	^self unsignedRegister: SP! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/22/2015 21:02:19'!
sp: anInteger
	^self unsignedRegister: SP put: anInteger! !

!MIPSSimulator methodsFor: 'as yet unclassified' stamp: 'rmacnak 11/27/2015 12:23:08'!
step
	"If the next instruction is a branch, its delay slot will also be executed."	
	| instruction |
	"Transcript print: instructionCount; nextPutAll: ' X '; nextPutAll: self currentInstruction; flush"
	instruction := MIPSInstruction new value: (self fetchInstruction: pc).
	instruction decodeFor: self.
	pc := pc + OneInstruction.
	instructionCount := instructionCount + 1.! !

!MIPSSimulator methodsFor: 'instructions - memory' stamp: 'rmacnak 11/8/2015 13:59:29'!
storeByte: instruction
	| base address value |
	base := self unsignedRegister: instruction rs.
	address := base + instruction signedImmediate.
	value := (self signedRegister: instruction rt) bitAnd: 16rFF.
	self unsignedByte: address put: value.! !

!MIPSSimulator methodsFor: 'instructions - memory' stamp: 'rmacnak 11/8/2015 14:21:48'!
storeHalfword: instruction
	| base address value |
	base := self unsignedRegister: instruction rs.
	address := base + instruction signedImmediate.
	value := (self signedRegister: instruction rt) bitAnd: 16rFFFF.
	self unsignedHalfword: address put: value.! !

!MIPSSimulator methodsFor: 'instructions - memory' stamp: 'rmacnak 11/8/2015 13:57:03'!
storeWord: instruction
	| base address value |
	base := self unsignedRegister: instruction rs.
	address := base + instruction signedImmediate.
	value := self signedRegister: instruction rt.
	self signedWord: address put: value.! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/5/2015 23:21:34'!
subtractUnsigned: instruction
	"Unsigned here means the instruction doesn't generate exceptions."
	| rsValue rtValue result |
	rsValue := self unsignedRegister: instruction rs.
	rtValue := self unsignedRegister: instruction rt.
	result := rsValue - rtValue bitAnd: 16rFFFFFFFF. "No exception on overflow"
	self unsignedRegister: instruction rd put: result.! !

!MIPSSimulator methodsFor: 'converting' stamp: 'rmacnak 10/27/2015 21:19:20'!
unsigned32ToSigned32: unsignedValue
	self assert: (unsignedValue between: 0 and: 16rFFFFFFFF).
	unsignedValue >= 16r80000000 ifTrue: [^unsignedValue - 16r100000000].
	^unsignedValue! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/15/2015 11:20:35'!
unsignedRegister: registerNumber
	registerNumber == ZR 
		ifTrue: [^0]
		ifFalse: [^self signed32ToUnsigned32: (registers at: registerNumber + 1)].! !

!MIPSSimulator methodsFor: 'registers' stamp: 'rmacnak 11/16/2015 19:58:14'!
unsignedRegister: registerNumber put: unsignedValue
	registerNumber == ZR ifFalse:
		[^registers at: registerNumber + 1 put: (self unsigned32ToSigned32: unsignedValue)].! !

!MIPSSimulator methodsFor: 'instructions - arithmetic' stamp: 'rmacnak 11/5/2015 22:58:52'!
xorImmediate: instruction
	| rsValue immediate result |
	rsValue := self unsignedRegister: instruction rs.
	immediate := instruction unsignedImmediate.
	result := rsValue bitXor: immediate.
	self unsignedRegister: instruction rt put: result.! !

Spur32BitMMLESimulator subclass: #SpurOldFormat32BitMMLESimulator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Bootstrapping'!

!SpurOldFormat32BitMMLESimulator methodsFor: 'method access' stamp: 'eem 8/9/2014 11:44'!
literalCountOfMethodHeader: header
	self assert: (self isIntegerObject: header).
	^header >> 10 bitAnd: 16rFF! !

!SpurOldFormat32BitMMLESimulator methodsFor: 'method access' stamp: 'eem 8/9/2014 11:47'!
primitiveIndexOfMethodHeader: methodHeader
	| primBits |
	primBits := (self integerValueOf: methodHeader) bitAnd: 16r100001FF.
	^(primBits bitAnd: 16r1FF) + (primBits >> 19)! !

Error subclass: #ProcessorSimulationTrap
	instanceVariableNames: 'pc nextpc address type registerAccessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Processors'!

!ProcessorSimulationTrap commentStamp: 'lw 8/23/2012 19:25' prior: 0!
A ProcessorSimulationTrap is an Error raised by CogProcessorAliens which allow the VMSimulator to fix the problem and resume execution.
I know where the problem occured (pc) and which instruction is next (nextpc), which field of the processor need be read/written and what type of memory access was the source of error.

I am created in #handleExecutionPrimitiveFailureIn:minimumAddress:readOnlyBelow: and associated methods. 
In the IA32 case, the type is managed by the OpcodeExecutionMap, using the first byte of the last instruction as index. 
In the ARM case, we need rely on a case statement, since no byte (sequence) is able to directly tell which type I am of.!

!ProcessorSimulationTrap class methodsFor: 'debugger' stamp: 'eem 10/21/2015 11:49:54'!
defaultIntegerBaseInDebugger
	^16! !

!ProcessorSimulationTrap class methodsFor: 'instance creation' stamp: 'eem 5/7/2010 11:08'!
pc: pc nextpc: nextpc address: address type: type
	^self new
		pc: pc;
		nextpc: nextpc;
		address: address;
		type: type! !

!ProcessorSimulationTrap class methodsFor: 'instance creation' stamp: 'eem 5/7/2010 11:08'!
pc: pc nextpc: nextpc address: address type: type accessor: regAccessorMessage
	^self new
		pc: pc;
		nextpc: nextpc;
		address: address;
		type: type;
		registerAccessor: regAccessorMessage! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/18/2008 15:26'!
address
	"Answer the value of address"

	^ address! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/18/2008 15:26'!
address: anObject
	"Set the value of address"

	address := anObject! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/28/2008 17:56'!
nextpc
	"Answer the value of nextpc"

	^ nextpc! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/28/2008 17:56'!
nextpc: anObject
	"Set the value of nextpc"

	nextpc := anObject! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/18/2008 15:58'!
pc
	"Answer the value of pc"

	^ pc! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/18/2008 15:58'!
pc: anObject
	"Set the value of pc"

	pc := anObject! !

!ProcessorSimulationTrap methodsFor: 'printing' stamp: 'eem 11/22/2013 12:25'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' (pc: '; print: pc; nextPut: $/. pc printOn: aStream base: 16.
	aStream nextPutAll: ' nextpc: '; print: nextpc; nextPut: $/. nextpc printOn: aStream base: 16.
	aStream nextPutAll: ' address: '; print: address; nextPut: $/. address printOn: aStream base: 16.
	aStream nextPutAll: ' type: '; print: type.
	aStream nextPutAll: ' accessor: '; print: registerAccessor; nextPut: $)! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 1/1/2009 22:33'!
registerAccessor
	"Answer the value of registerAccessor"

	^ registerAccessor! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 1/1/2009 22:33'!
registerAccessor: anObject
	"Set the value of registerAccessor"

	registerAccessor := anObject! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/18/2008 15:32'!
type
	"Answer the value of type"

	^ type! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/18/2008 15:32'!
type: anObject
	"Set the value of type"

	type := anObject! !

!MCMethodDefinition methodsFor: '*Cog-method prototypes squeak 4.3' stamp: 'eem 2/4/2014 16:35'!
MCMethodDefinitionPROTOTYPEinitializeWithClassName: classString
classIsMeta: metaBoolean
selector: selectorString
category: catString
timeStamp: timeString
source: sourceString
	className := classString asSymbol.
	selector := selectorString asSymbol.
	category := catString ifNil: [Categorizer default] ifNotNil: [catString asSymbol].
	timeStamp := timeString.
	classIsMeta := metaBoolean.
	source := sourceString withSqueakLineEndings! !
CommandLineLauncher initialize!
BochsIA32Alien initialize!
BochsX64Alien initialize!
CogProcessorAlien initialize!
GdbARMAlien initialize!
MIPSSimulator initialize!
